;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "../data/comic_assets.h.s"
.include "../renderer/renderer.h.s"
.include "sequence.h.s"

.module SEQUENCE_data

_sequence_data::
; PAGE 1a
  SEQUENCE_RESET_TIMER
  SEQUENCE_INIT_LANDSCAPE
  SEQUENCE_CLEAR
  SEQUENCE_PLAY MUSIC_SECTION_A
  SEQUENCE_DRAW_TEXT #25, #64, NARRATION_TEXT_01
  SEQUENCE_FADE_IN
  SEQUENCE_WAIT_UNTIL #1, #7
  SEQUENCE_DRAW_TEXT #47, #64, NARRATION_TEXT_02
  SEQUENCE_WAIT_UNTIL #3, #2
  SEQUENCE_FADE_OUT

  SEQUENCE_CLEAR
  SEQUENCE_INIT_PAGE
  SEQUENCE_ADD_STRIP #32, #0, PAGE1_A_TOP
  SEQUENCE_ADD_STRIP #32, #96, PAGE1_A_BOTTOM

  SEQUENCE_FADE_IN
  SEQUENCE_HIGHLIGHT #32, #0, PAGE1_A_TOP, #22

  SEQUENCE_WAIT_UNTIL #5, #0
  SEQUENCE_DRAW_TEXT #30, #0, PAGE1_A_TEXT_01   ; Oscaaaar!
  SEQUENCE_DRAW_TEXT #30, #10, PAGE1_A_TEXT_02  ; Dinner gets cold
  SEQUENCE_WAIT_UNTIL #6, #2
  SEQUENCE_DRAW_TEXT #54, #36, PAGE1_A_TEXT_03  ; 5 minuts mom!
  SEQUENCE_WAIT_UNTIL #7, #5
  SEQUENCE_DRAW_TEXT #30, #72, PAGE1_A_TEXT_04  ; 5 minutes
  SEQUENCE_DRAW_TEXT #30, #82, PAGE1_A_TEXT_05  ; not one more!

  SEQUENCE_WAIT_UNTIL #10, #0
  SEQUENCE_SCROLL #20
  SEQUENCE_DRAW_STRIP #40, #0, PAGE1_A_TOP, #4, #18

  SEQUENCE_HIGHLIGHT_NEXT #13
  SEQUENCE_WAIT_UNTIL #12, #0
  SEQUENCE_DRAW_TEXT #76, #4, PAGE1_A_TEXT_06   ; Bark!
  SEQUENCE_WAIT_UNTIL #13, #0
  SEQUENCE_DRAW_TEXT #65, #10, PAGE1_A_TEXT_07  ; Shhhh!
  SEQUENCE_DRAW_TEXT #65, #20, PAGE1_A_TEXT_08  ; Quiet Gunter
  SEQUENCE_WAIT_UNTIL #15, #0
  SEQUENCE_DRAW_TEXT #62, #80, PAGE1_A_TEXT_09  ; We must catch
  SEQUENCE_DRAW_TEXT #62, #90, PAGE1_A_TEXT_10  ; that cattle rustler

  SEQUENCE_WAIT_UNTIL #20, #0
  SEQUENCE_SCROLL #15
  SEQUENCE_DRAW_STRIP #68, #0, PAGE1_A_TOP, #18, #17

  SEQUENCE_HIGHLIGHT_NEXT #17
  SEQUENCE_WAIT_UNTIL #22, #0
  SEQUENCE_DRAW_TEXT #103, #0, PAGE1_A_TEXT_11  ; Last time they
  SEQUENCE_DRAW_TEXT #103, #10, PAGE1_A_TEXT_12 ; stole Mizzie.
  SEQUENCE_WAIT_UNTIL #24, #0
  SEQUENCE_DRAW_TEXT #103, #20, PAGE1_A_TEXT_13 ; That took the cake
  SEQUENCE_WAIT_UNTIL #26, #0
  SEQUENCE_DRAW_TEXT #119, #50, PAGE1_A_TEXT_06 ; Bark!
  SEQUENCE_WAIT_UNTIL #30, #0

  SEQUENCE_FADE_OUT
  SEQUENCE_WAIT_UNTIL #32, #0

; PAGE 1b
; _sequence_test::
; SEQUENCE_INIT_LANDSCAPE
  SEQUENCE_UNCOMPRESS_INDIRECT _comic_b_assets, COMIC_B_ASSETS

  SEQUENCE_CLEAR
  SEQUENCE_INIT_PAGE
  SEQUENCE_ADD_STRIP #32, #0, PAGE1_B

  SEQUENCE_FADE_IN
  SEQUENCE_HIGHLIGHT #32, #0, PAGE1_B, #20
  SEQUENCE_RESET_TIMER
  SEQUENCE_WAIT_UNTIL #2, #0

  SEQUENCE_DRAW_TEXT #49, #40, PAGE1_B_TEXT_01  ; But tonight
  SEQUENCE_DRAW_TEXT #49, #50, PAGE1_B_TEXT_02  ; you and I...
  SEQUENCE_WAIT_UNTIL #4, #0
  SEQUENCE_DRAW_TEXT #42, #10 BLIP
  SEQUENCE_WAIT_UNTIL #5, #0
  SEQUENCE_DRAW_TEXT #54, #22, BLIP
  SEQUENCE_WAIT_UNTIL #6, #0
  SEQUENCE_DRAW_TEXT #53, #110, PAGE1_B_TEXT_03 ; Gunter
  SEQUENCE_WAIT_UNTIL #8, #0
  SEQUENCE_DRAW_TEXT #53, #120, PAGE1_B_TEXT_04 ; What
  SEQUENCE_DRAW_TEXT #53, #130, PAGE1_B_TEXT_05 ; happens?

  SEQUENCE_PLAY MUSIC_SECTION_B

  SEQUENCE_WAIT_UNTIL #12, #0
  SEQUENCE_SCROLL #17
  SEQUENCE_DRAW_STRIP #40, #0, PAGE1_B, #4, #16

  SEQUENCE_HIGHLIGHT_NEXT #12
  SEQUENCE_WAIT_UNTIL #14, #0
  SEQUENCE_DRAW_TEXT #72, #0, GRRR
  SEQUENCE_WAIT_UNTIL #16, #0
  SEQUENCE_DRAW_TEXT #69, #140, PAGE1_B_TEXT_06 ; Is it the robber?
  SEQUENCE_WAIT_UNTIL #18, #0
  SEQUENCE_DRAW_TEXT #69, #150, PAGE1_B_TEXT_07 ; Can you hear it?

  SEQUENCE_WAIT_UNTIL #22, #0
  SEQUENCE_SCROLL #15

  SEQUENCE_HIGHLIGHT_NEXT #20

  SEQUENCE_UNCOMPRESS _comic_c_assets, COMIC_C_ASSETS

  SEQUENCE_WAIT_UNTIL #23, #0
  SEQUENCE_DRAW_TEXT #98, #20, PAGE1_B_TEXT_08  ; Wait no!
  SEQUENCE_WAIT_UNTIL #25, #0
  SEQUENCE_DRAW_TEXT #117, #0, BARK
  SEQUENCE_WAIT_UNTIL #26, #0
  SEQUENCE_DRAW_TEXT #117, #22, BARK

  SEQUENCE_WAIT_UNTIL #32, #0
  SEQUENCE_FADE_OUT

  SEQUENCE_WAIT_UNTIL #33, #0
  SEQUENCE_STOP

; PAGE 2
; _sequence_test::
;   SEQUENCE_UNCOMPRESS _comic_c_assets, COMIC_C_ASSETS
  SEQUENCE_INIT_PORTRAIT
  SEQUENCE_CLEAR

  SEQUENCE_DRAW_STRIP #0, #16, PAGE2, #0, PAGE2_WIDTH_IN_TILES
  SEQUENCE_UNCOMPRESS _comic_d_assets, COMIC_D_ASSETS
  SEQUENCE_PLAY MUSIC_SECTION_C
  SEQUENCE_FADE_IN

  SEQUENCE_RESET_TIMER
  SEQUENCE_WAIT_UNTIL #0, #4
  SEQUENCE_DRAW_SPRITE #5, #0, BZZZ
  SEQUENCE_WAIT_UNTIL #1, #0
  SEQUENCE_DRAW_SPRITE #0, #66, EXCLAMATION
  SEQUENCE_WAIT_UNTIL #1, #1
  SEQUENCE_DRAW_SPRITE #4, #61, EXCLAMATION
  SEQUENCE_WAIT_UNTIL #1, #2
  SEQUENCE_DRAW_SPRITE #8, #56 , EXCLAMATION
  SEQUENCE_WAIT_UNTIL #2, #0
  SEQUENCE_DRAW_SPRITE #24, #86, DUCK
  SEQUENCE_WAIT_UNTIL #2, #5
  SEQUENCE_DRAW_SPRITE #33, #116, SHEEP
  SEQUENCE_WAIT_UNTIL #3, #0
  SEQUENCE_DRAW_SPRITE #26, #176, GUNTER
  SEQUENCE_WAIT_UNTIL #5, #0
  SEQUENCE_DRAW_TEXT #10, #240, PAGE2_TEXT_01
  SEQUENCE_WAIT_UNTIL #5, #7
  SEQUENCE_DRAW_TEXT #10, #250, PAGE2_TEXT_02
  SEQUENCE_WAIT_UNTIL #7, #0
  SEQUENCE_DRAW_SPRITE #20, #120, YELP
  SEQUENCE_WAIT_UNTIL #10, #0

  SEQUENCE_FADE_OUT

; PAGE 3a
  SEQUENCE_INIT_LANDSCAPE
  SEQUENCE_CLEAR
  SEQUENCE_INIT_PAGE
  SEQUENCE_ADD_STRIP #16, #0, PAGE3_A_TOP
  SEQUENCE_ADD_STRIP #16, #88, PAGE3_A_BOTTOM
  SEQUENCE_FADE_IN

  SEQUENCE_RESET_TIMER
  SEQUENCE_HIGHLIGHT #16, #0, PAGE3_A_TOP, #16
  SEQUENCE_WAIT_UNTIL #1, #0
  SEQUENCE_DRAW_TEXT #18, #87, PAGE3_A_TEXT_01  ; Gunter, Nooooo!

  SEQUENCE_WAIT_UNTIL #3, #0
  SEQUENCE_HIGHLIGHT_NEXT #16

  SEQUENCE_WAIT_UNTIL #4, #0
  SEQUENCE_DRAW_TEXT #51, #85, PAGE3_A_TEXT_02  ; Well, well, what
  SEQUENCE_DRAW_TEXT #51, #95, PAGE3_A_TEXT_03  ; a nice surprise.

  SEQUENCE_WAIT_UNTIL #10, #0
  SEQUENCE_WAIT_UNTIL #10, #0
  SEQUENCE_FADE_OUT
  SEQUENCE_WAIT_UNTIL #11, #0

; PAGE 3b
; _sequence_test::
; SEQUENCE_UNCOMPRESS _comic_d_assets, COMIC_D_ASSETS
  SEQUENCE_INIT_DEFAULT
  SEQUENCE_UNCOMPRESS _comic_e_assets, COMIC_E_ASSETS

  SEQUENCE_CLEAR
  SEQUENCE_INIT_PAGE
  SEQUENCE_ADD_STRIP #6, #24, PAGE3_B
  SEQUENCE_FADE_IN

  SEQUENCE_HIGHLIGHT #6, #24, PAGE3_B, #11

  SEQUENCE_RESET_TIMER
  SEQUENCE_WAIT_UNTIL #2, #0
  SEQUENCE_DRAW_SLOWLY #7, #24, WHOOOSH

  SEQUENCE_WAIT_FOR_SONG
  SEQUENCE_STOP
  SEQUENCE_RESET_TIMER
  SEQUENCE_WAIT_UNTIL #1, #5
  ; SEQUENCE_BACKGROUND #6, #24, PAGE3_B, #11

  SEQUENCE_RESET_TIMER
  SEQUENCE_PLAY MUSIC_SECTION_D

  SEQUENCE_HIGHLIGHT_NEXT #11
  SEQUENCE_WAIT_UNTIL #3, #0
  SEQUENCE_DRAW_TEXT #26, #84, PAGE3_B_TEXT_01
  SEQUENCE_WAIT_UNTIL #4, #0
  SEQUENCE_DRAW_TEXT #26, #94, PAGE3_B_TEXT_02
  SEQUENCE_WAIT_UNTIL #7, #0
  SEQUENCE_DRAW_TEXT #28, #164, PAGE3_B_TEXT_03

  SEQUENCE_WAIT_UNTIL #8, #3
  SEQUENCE_HIGHLIGHT_NEXT #10
  SEQUENCE_WAIT_UNTIL #9, #7
  SEQUENCE_DRAW_TEXT #54, #54, PAGE3_B_TEXT_03
  SEQUENCE_WAIT_UNTIL #13, #0
  SEQUENCE_DRAW_TEXT #59, #92, INTERROGATION

  SEQUENCE_WAIT_FOR_SONG
  SEQUENCE_STOP

  SEQUENCE_END
