;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "sequence.h.s"
.include "renderer/renderer.h.s"

.globl cpct_waitVSYNC_asm

.module sequence

; u8* sequence_scroll(u8* data) {
;   u8 widthInTiles = *data++;
;
;   while (widthInTiles--) {
;     for (u8 i = 0; i < sequence_stripCount; i++) {
;       Strip* strip = &sequence_strips[i];
;
;       if (strip->widthInTiles) {
;         renderer_drawMaskedTiles(strip->tiles, strip->screen,
;           1, strip->heightInTiles,
;           RENDERER_DARKEN_MASKS_HI_ADDRESS + DARK_PAGE_MASK, 0);
;         strip->tiles += 16 * strip->heightInTiles;
;         strip->widthInTiles--;
;       } else {
;         renderer_drawSpan(strip->screen, BLACK_PATTERN, strip->heightInTiles);
;       }
;
;       strip->screen += 2;
;     }
;
;     cpct_waitVSYNC();
;     renderer_doScroll();
;
;     cpct_waitHalts(2);
;     cpct_waitVSYNC();
;     renderer_doScroll();
;   }
;
;   return data;
; }

; IN:
;   HL <- data address
_sequence_scroll::
  ld b, (hl)
  inc hl
  ld (#RESULT), hl

outer_loop:
  push bc

  ld iy, #_sequence_strips
  ld a, (#_sequence_stripCount)
  ld b, a             ; B <- counter

inner_loop:
  ld e, STRIP_SCREEN_LO (iy)
  ld d, STRIP_SCREEN_HI (iy)
                      ; DE <- strip screen

  ld a, STRIP_WIDTH_IN_TILES (iy)
  or a
  jr z, draw_black_span

  push bc
  push de
    ; renderer_drawMaskedTiles(strip->tiles, strip->screen,
    ;   1, strip->heightInTiles,
    ;   RENDERER_DARKEN_MASKS_HI_ADDRESS + DARK_PAGE_MASK, 0)
    ld bc, #RENDERER_DARKEN_MASKS_HI_ADDRESS + DARK_PAGE_MASK
    push bc           ; PARAMS: RENDERER_DARKEN_MASKS_HI_ADDRESS + DARK_PAGE_MASK, 0
    ld b, STRIP_HEIGHT_IN_TILES (iy)
                      ; B <- widthInTiles
    ld c, #1          ; C <- heightInTiles
    push bc           ; PARAMS: widthInTiles, heightInTiles
    push de           ; PARAM: screen
    ld c, STRIP_TILES_LO (iy)
    ld b, STRIP_TILES_HI (iy)
    push bc           ; PARAM: tiles

    ; strip->tiles += 16 * strip->heightInTiles
    ld l, STRIP_HEIGHT_IN_TILES (iy)
    ld h, #0
    add hl, hl
    add hl, hl
    add hl, hl
    add hl, hl        ; HL <- strip heightInTiles * 16
    add hl, bc        ; BC <- strip tiles + 16 * strip->heightInTiles
    ld STRIP_TILES_LO (iy), l
    ld STRIP_TILES_HI (iy), h

    ; strip->widthInTiles--
    dec STRIP_WIDTH_IN_TILES (iy)

    call _renderer_drawMaskedTiles
  pop de
.equ TILES_INCREMENT, . + 1
  ld bc, #0
  add hl, bc          ; tile += 16 * strip->heightInTiles
  pop bc
  dec c               ; widthInTiles--
  jr next_span

draw_black_span:
  ; renderer_drawSpan(strip->screen, BLACK_PATTERN, strip->heightInTiles);
  push bc
  push de
                      ;  DE <- screen address
    ld b, STRIP_HEIGHT_IN_TILES (iy)
                      ; B <- height in tiles
    ld c, #RENDERER_BLACK_PATTERN
                      ; C <- pattern
    call _renderer_drawSpan_asm
  pop de
  pop bc
  ; jr next_span

next_span:
  inc de
  inc de              ; screen += 2
  ld STRIP_SCREEN_LO (iy), e
  ld STRIP_SCREEN_HI (iy), d
  push de
    ld de, #STRIP_SIZE
    add iy, de        ; strip++
  pop de
  djnz inner_loop

  ; cpct_waitVSYNC();
  ; renderer_doScroll();
  call cpct_waitVSYNC_asm
  call _renderer_doScroll

  ; cpct_waitHalts(2);
  halt
  halt
  ; cpct_waitVSYNC();
  ; renderer_doScroll();
  call cpct_waitVSYNC_asm
  call _renderer_doScroll

  pop bc
  djnz outer_loop

.equ RESULT, . + 1
  ld hl, #0
  ret
