/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include <cpctelera.h>
#include "renderer.h"
#include "../system/crtc.h"

const u8 __at(RENDERER_DARKEN_MASKS_ADDRESS) mask[1024] = {
  0xf0, 0xe0, 0xd0, 0xc0, 0xe0, 0xa5, 0xc0, 0x85, 0xd0, 0xc0, 0x5a, 0x4a, 0xc0, 0x85, 0x4a, 0x0f, 0xb0, 0xe5, 0x90, 0xc5, 0xb4, 0xb5, 0x94, 0x95, 0x90, 0xc5, 0x1a, 0x4f, 0x94, 0x95, 0x1e, 0x1f, 0x70, 0x60, 0xda, 0xca, 0x60, 0x25, 0xca, 0x8f, 0x78, 0x68, 0x7a, 0x6a, 0x68, 0x2d, 0x6a, 0x2f, 0x30, 0x65, 0x9a, 0xcf, 0x34, 0x35, 0x9e, 0x9f, 0x38, 0x6d, 0x3a, 0x6f, 0x3c, 0x3d, 0x3e, 0x3f, 0xe0, 0xe1, 0xc0, 0xc1, 0xe4, 0xe5, 0xc4, 0xc5, 0xc0, 0xc1, 0x4a, 0x4b, 0xc4, 0xc5, 0x4e, 0x4f, 0xf0, 0xf1, 0xd0, 0xd1, 0xf4, 0xb5, 0xd4, 0x95, 0xd0, 0xd1, 0x5a, 0x5b, 0xd4, 0x95, 0x5e, 0x1f, 0x60, 0x61, 0xca, 0xcb, 0x64, 0x65, 0xce, 0xcf, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f, 0x70, 0x71, 0xda, 0xdb, 0x74, 0x35, 0xde, 0x9f, 0x78, 0x79, 0x7a, 0x7b, 0x7c, 0x3d, 0x7e, 0x3f, 0xd0, 0xc0, 0xd2, 0xc2, 0xc0, 0x85, 0xc2, 0x87, 0xd8, 0xc8, 0xda, 0xca, 0xc8, 0x8d, 0xca, 0x8f, 0x90, 0xc5, 0x92, 0xc7, 0x94, 0x95, 0x96, 0x97, 0x98, 0xcd, 0x9a, 0xcf, 0x9c, 0x9d, 0x9e, 0x9f, 0xf0, 0xe0, 0xf2, 0xe2, 0xe0, 0xa5, 0xe2, 0xa7, 0xf8, 0xe8, 0x7a, 0x6a, 0xe8, 0xad, 0x6a, 0x2f, 0xb0, 0xe5, 0xb2, 0xe7, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xed, 0x3a, 0x6f, 0xbc, 0xbd, 0x3e, 0x3f, 0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf, 0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0x95, 0xd6, 0x97, 0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0x9d, 0xde, 0x9f, 0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0x6a, 0x6b, 0xec, 0xed, 0x6e, 0x6f, 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xb5, 0xf6, 0xb7, 0xf8, 0xf9, 0x7a, 0x7b, 0xfc, 0xbd, 0x7e, 0x3f,
  0xf0, 0xe0, 0xd0, 0xc0, 0xe0, 0xa5, 0xc0, 0x85, 0xd0, 0xc0, 0x5a, 0x4a, 0xc0, 0x85, 0x4a, 0x0f, 0xb0, 0xe5, 0x90, 0xc5, 0xb4, 0xe5, 0x94, 0xc5, 0x90, 0xc5, 0x1a, 0x4f, 0x94, 0xc5, 0x1e, 0x4f, 0x70, 0x60, 0xda, 0xca, 0x60, 0x25, 0xca, 0x8f, 0x78, 0x68, 0xda, 0xca, 0x68, 0x2d, 0xca, 0x8f, 0x30, 0x65, 0x9a, 0xcf, 0x34, 0x65, 0x9e, 0xcf, 0x38, 0x6d, 0x9a, 0xcf, 0x3c, 0x6d, 0x9e, 0xcf, 0xe0, 0xe1, 0xc0, 0xc1, 0xe4, 0xe5, 0xc4, 0xc5, 0xc0, 0xc1, 0x4a, 0x4b, 0xc4, 0xc5, 0x4e, 0x4f, 0xf0, 0xe0, 0xd0, 0xc0, 0xf4, 0xe5, 0xd4, 0xc5, 0xd0, 0xc0, 0x5a, 0x4a, 0xd4, 0xc5, 0x5e, 0x4f, 0x60, 0x61, 0xca, 0xcb, 0x64, 0x65, 0xce, 0xcf, 0x68, 0x69, 0xca, 0xcb, 0x6c, 0x6d, 0xce, 0xcf, 0x70, 0x60, 0xda, 0xca, 0x74, 0x65, 0xde, 0xcf, 0x78, 0x68, 0xda, 0xca, 0x7c, 0x6d, 0xde, 0xcf, 0xd0, 0xc0, 0xd2, 0xc2, 0xc0, 0x85, 0xc2, 0x87, 0xd8, 0xc8, 0xda, 0xca, 0xc8, 0x8d, 0xca, 0x8f, 0x90, 0xc5, 0x92, 0xc7, 0x94, 0xc5, 0x96, 0xc7, 0x98, 0xcd, 0x9a, 0xcf, 0x9c, 0xcd, 0x9e, 0xcf, 0xf0, 0xe0, 0xd0, 0xc0, 0xe0, 0xa5, 0xc0, 0x85, 0xf8, 0xe8, 0xda, 0xca, 0xe8, 0xad, 0xca, 0x8f, 0xb0, 0xe5, 0x90, 0xc5, 0xb4, 0xe5, 0x94, 0xc5, 0xb8, 0xed, 0x9a, 0xcf, 0xbc, 0xed, 0x9e, 0xcf, 0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf, 0xd0, 0xc0, 0xd2, 0xc2, 0xd4, 0xc5, 0xd6, 0xc7, 0xd8, 0xc8, 0xda, 0xca, 0xdc, 0xcd, 0xde, 0xcf, 0xe0, 0xe1, 0xc0, 0xc1, 0xe4, 0xe5, 0xc4, 0xc5, 0xe8, 0xe9, 0xca, 0xcb, 0xec, 0xed, 0xce, 0xcf, 0xf0, 0xe0, 0xd0, 0xc0, 0xf4, 0xe5, 0xd4, 0xc5, 0xf8, 0xe8, 0xda, 0xca, 0xfc, 0xed, 0xde, 0xcf,
  0x30, 0x60, 0x90, 0xc0, 0x60, 0x64, 0xc0, 0xc4, 0x90, 0xc0, 0x98, 0xc8, 0xc0, 0xc4, 0xc8, 0xcc, 0x30, 0x61, 0x90, 0xc1, 0x34, 0x61, 0x94, 0xc1, 0x90, 0xc1, 0x98, 0xc9, 0x94, 0xc1, 0x9c, 0xc9, 0x30, 0x60, 0x92, 0xc2, 0x60, 0x64, 0xc2, 0xc6, 0x38, 0x68, 0x92, 0xc2, 0x68, 0x6c, 0xc2, 0xc6, 0x30, 0x61, 0x92, 0xc3, 0x34, 0x61, 0x96, 0xc3, 0x38, 0x69, 0x92, 0xc3, 0x3c, 0x69, 0x96, 0xc3, 0x60, 0x30, 0xc0, 0x90, 0x64, 0x61, 0xc4, 0xc1, 0xc0, 0x90, 0xc8, 0x98, 0xc4, 0xc1, 0xcc, 0xc9, 0x64, 0x60, 0xc4, 0xc0, 0x74, 0x61, 0xd4, 0xc1, 0xc4, 0xc0, 0xcc, 0xc8, 0xd4, 0xc1, 0xdc, 0xc9, 0x60, 0x30, 0xc2, 0x92, 0x64, 0x61, 0xc6, 0xc3, 0x68, 0x38, 0xc2, 0x92, 0x6c, 0x69, 0xc6, 0xc3, 0x64, 0x60, 0xc6, 0xc2, 0x74, 0x61, 0xd6, 0xc3, 0x6c, 0x68, 0xc6, 0xc2, 0x7c, 0x69, 0xd6, 0xc3, 0x90, 0xc0, 0x30, 0x60, 0xc0, 0xc4, 0x60, 0x64, 0x98, 0xc8, 0x92, 0xc2, 0xc8, 0xcc, 0xc2, 0xc6, 0x90, 0xc1, 0x30, 0x61, 0x94, 0xc1, 0x34, 0x61, 0x98, 0xc9, 0x92, 0xc3, 0x9c, 0xc9, 0x96, 0xc3, 0x98, 0xc8, 0x90, 0xc0, 0xc8, 0xcc, 0xc0, 0xc4, 0xb8, 0xe8, 0x92, 0xc2, 0xe8, 0xec, 0xc2, 0xc6, 0x98, 0xc9, 0x90, 0xc1, 0x9c, 0xc9, 0x94, 0xc1, 0xb8, 0xe9, 0x92, 0xc3, 0xbc, 0xe9, 0x96, 0xc3, 0xc0, 0x90, 0x60, 0x30, 0xc4, 0xc1, 0x64, 0x61, 0xc8, 0x98, 0xc2, 0x92, 0xcc, 0xc9, 0xc6, 0xc3, 0xc4, 0xc0, 0x64, 0x60, 0xd4, 0xc1, 0x74, 0x61, 0xcc, 0xc8, 0xc6, 0xc2, 0xdc, 0xc9, 0xd6, 0xc3, 0xc8, 0x98, 0xc0, 0x90, 0xcc, 0xc9, 0xc4, 0xc1, 0xe8, 0xb8, 0xc2, 0x92, 0xec, 0xe9, 0xc6, 0xc3, 0xcc, 0xc8, 0xc4, 0xc0, 0xdc, 0xc9, 0xd4, 0xc1, 0xec, 0xe8, 0xc6, 0xc2, 0xfc, 0xe9, 0xd6, 0xc3,
// 0x30, 0x60, 0x90, 0xc0, 0x60, 0x64, 0xc0, 0xc4, 0x90, 0xc0, 0x98, 0xc8, 0xc0, 0xc4, 0xc8, 0xcc, 0x64, 0x61, 0xc4, 0xc1, 0x34, 0x64, 0x94, 0xc4, 0xc4, 0xc1, 0xcc, 0xc9, 0x94, 0xc4, 0x9c, 0xcc, 0x98, 0xc8, 0x92, 0xc2, 0xc8, 0xcc, 0xc2, 0xc6, 0x38, 0x68, 0x98, 0xc8, 0x68, 0x6c, 0xc8, 0xcc, 0xcc, 0xc9, 0xc6, 0xc3, 0x9c, 0xcc, 0x96, 0xc6, 0x6c, 0x69, 0xcc, 0xc9, 0x3c, 0x6c, 0x9c, 0xcc, 0x34, 0x64, 0x94, 0xc4, 0x64, 0x64, 0xc4, 0xc4, 0x94, 0xc4, 0x9c, 0xcc, 0xc4, 0xc4, 0xcc, 0xcc, 0x64, 0x60, 0xc4, 0xc0, 0x74, 0x61, 0xd4, 0xc1, 0xc4, 0xc0, 0xcc, 0xc8, 0xd4, 0xc1, 0xdc, 0xc9, 0x9c, 0xcc, 0x96, 0xc6, 0xcc, 0xcc, 0xc6, 0xc6, 0x3c, 0x6c, 0x9c, 0xcc, 0x6c, 0x6c, 0xcc, 0xcc, 0xcc, 0xc8, 0xc6, 0xc2, 0xdc, 0xc9, 0xd6, 0xc3, 0x6c, 0x68, 0xcc, 0xc8, 0x7c, 0x69, 0xdc, 0xc9, 0x38, 0x68, 0x98, 0xc8, 0x68, 0x6c, 0xc8, 0xcc, 0x98, 0xc8, 0x98, 0xc8, 0xc8, 0xcc, 0xc8, 0xcc, 0x6c, 0x69, 0xcc, 0xc9, 0x3c, 0x6c, 0x9c, 0xcc, 0xcc, 0xc9, 0xcc, 0xc9, 0x9c, 0xcc, 0x9c, 0xcc, 0x98, 0xc8, 0x90, 0xc0, 0xc8, 0xcc, 0xc0, 0xc4, 0xb8, 0xe8, 0x92, 0xc2, 0xe8, 0xec, 0xc2, 0xc6, 0xcc, 0xc9, 0xc4, 0xc1, 0x9c, 0xcc, 0x94, 0xc4, 0xec, 0xe9, 0xc6, 0xc3, 0xbc, 0xec, 0x96, 0xc6, 0x3c, 0x6c, 0x9c, 0xcc, 0x6c, 0x6c, 0xcc, 0xcc, 0x9c, 0xcc, 0x9c, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0x6c, 0x68, 0xcc, 0xc8, 0x7c, 0x69, 0xdc, 0xc9, 0xcc, 0xc8, 0xcc, 0xc8, 0xdc, 0xc9, 0xdc, 0xc9, 0x9c, 0xcc, 0x94, 0xc4, 0xcc, 0xcc, 0xc4, 0xc4, 0xbc, 0xec, 0x96, 0xc6, 0xec, 0xec, 0xc6, 0xc6, 0xcc, 0xc8, 0xc4, 0xc0, 0xdc, 0xc9, 0xd4, 0xc1, 0xec, 0xe8, 0xc6, 0xc2, 0xfc, 0xe9, 0xd6, 0xc3
  0x30, 0x60, 0x90, 0xc0, 0x60, 0x64, 0xc0, 0xc4, 0x90, 0xc0, 0x98, 0xc8, 0xc0, 0xc4, 0xc8, 0xcc, 0x64, 0x30, 0xc4, 0x90, 0x34, 0x64, 0x94, 0xc4, 0xc4, 0x90, 0xcc, 0x98, 0x94, 0xc4, 0x9c, 0xcc, 0x98, 0xc8, 0x30, 0x60, 0xc8, 0xcc, 0x60, 0x64, 0x38, 0x68, 0x98, 0xc8, 0x68, 0x6c, 0xc8, 0xcc, 0xcc, 0x98, 0x64, 0x30, 0x9c, 0xcc, 0x34, 0x64, 0x6c, 0x38, 0xcc, 0x98, 0x3c, 0x6c, 0x9c, 0xcc, 0x34, 0x64, 0x94, 0xc4, 0x64, 0x64, 0xc4, 0xc4, 0x94, 0xc4, 0x9c, 0xcc, 0xc4, 0xc4, 0xcc, 0xcc, 0x64, 0x60, 0xc4, 0xc0, 0x34, 0x61, 0x94, 0xc1, 0xc4, 0xc0, 0xcc, 0xc8, 0x94, 0xc1, 0x9c, 0xc9, 0x9c, 0xcc, 0x34, 0x64, 0xcc, 0xcc, 0x64, 0x64, 0x3c, 0x6c, 0x9c, 0xcc, 0x6c, 0x6c, 0xcc, 0xcc, 0xcc, 0xc8, 0x64, 0x60, 0x9c, 0xc9, 0x34, 0x61, 0x6c, 0x68, 0xcc, 0xc8, 0x3c, 0x69, 0x9c, 0xc9, 0x38, 0x68, 0x98, 0xc8, 0x68, 0x6c, 0xc8, 0xcc, 0x98, 0xc8, 0x98, 0xc8, 0xc8, 0xcc, 0xc8, 0xcc, 0x6c, 0x38, 0xcc, 0x98, 0x3c, 0x6c, 0x9c, 0xcc, 0xcc, 0x98, 0xcc, 0x98, 0x9c, 0xcc, 0x9c, 0xcc, 0x98, 0xc8, 0x90, 0xc0, 0xc8, 0xcc, 0xc0, 0xc4, 0x38, 0x68, 0x92, 0xc2, 0x68, 0x6c, 0xc2, 0xc6, 0xcc, 0x98, 0xc4, 0x90, 0x9c, 0xcc, 0x94, 0xc4, 0x6c, 0x38, 0xc6, 0x92, 0x3c, 0x6c, 0x96, 0xc6, 0x3c, 0x6c, 0x9c, 0xcc, 0x6c, 0x6c, 0xcc, 0xcc, 0x9c, 0xcc, 0x9c, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0x6c, 0x68, 0xcc, 0xc8, 0x3c, 0x69, 0x9c, 0xc9, 0xcc, 0xc8, 0xcc, 0xc8, 0x9c, 0xc9, 0x9c, 0xc9, 0x9c, 0xcc, 0x94, 0xc4, 0xcc, 0xcc, 0xc4, 0xc4, 0x3c, 0x6c, 0x96, 0xc6, 0x6c, 0x6c, 0xc6, 0xc6, 0xcc, 0xc8, 0xc4, 0xc0, 0x9c, 0xc9, 0x94, 0xc1, 0x6c, 0x68, 0xc6, 0xc2, 0x3c, 0x69, 0x96, 0xc3
};

cpctm_createTransparentMaskTable(renderer_transparent_mask, RENDERER_TRANSPARENT_MASK_ADDRESS, M0, 0);

const u8 renderer_palettes[128] = {
  0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14, 0x14,
  0x04, 0x14, 0x04, 0x14, 0x14, 0x14, 0x14, 0x14, 0x04, 0x14, 0x14, 0x14, 0x04, 0x04, 0x14, 0x04,
  0x18, 0x14, 0x04, 0x14, 0x14, 0x1c, 0x14, 0x14, 0x04, 0x14, 0x1c, 0x1c, 0x18, 0x04, 0x1c, 0x18,
  0x18, 0x04, 0x04, 0x14, 0x04, 0x1c, 0x14, 0x14, 0x04, 0x04, 0x1c, 0x18, 0x18, 0x06, 0x18, 0x00,
  0x18, 0x04, 0x04, 0x1c, 0x18, 0x1c, 0x14, 0x14, 0x04, 0x18, 0x1c, 0x18, 0x18, 0x06, 0x00, 0x00,
  0x1d, 0x04, 0x15, 0x1c, 0x18, 0x1c, 0x14, 0x16, 0x17, 0x00, 0x1e, 0x00, 0x1f, 0x17, 0x00, 0x1f,
  0x0d, 0x04, 0x15, 0x1c, 0x18, 0x0c, 0x14, 0x16, 0x17, 0x00, 0x0e, 0x07, 0x0f, 0x17, 0x07, 0x0f,
  0x0d, 0x04, 0x15, 0x1c, 0x18, 0x0c, 0x14, 0x16, 0x17, 0x00, 0x0e, 0x07, 0x0f, 0x13, 0x03, 0x0b
};

#define RENDERER_BLACK_PATTERN cpctm_px2byteM0(6, 6)

u8 renderer_scroll;

void renderer_fade(u8* palette, i8 displacement);
void renderer_resetScroll();
void renderer_applyScroll();
extern void renderer_patchRenderers(u8 widthInBytes) __z88dk_fastcall;

void renderer_init(u8 orientation) __z88dk_fastcall {
  switch (orientation) {
  case RENDERER_LANDSCAPE_ORIENTATION:
    crtc_setLandscape();
    renderer_patchRenderers(RENDERER_LANDSCAPE_WIDTH_IN_BYTES);
    break;

  case RENDERER_PORTRAIT_ORIENTATION:
    crtc_setPortrait();
    renderer_patchRenderers(RENDERER_PORTRAIT_WIDTH_IN_BYTES);
    break;

  default:
    crtc_setDefault();
    renderer_patchRenderers(RENDERER_DEFAULT_WIDTH_IN_BYTES);
    break;
  }

  renderer_resetScroll();
}

void renderer_clear() {
  cpct_memset((void*)RENDERER_SCREEN_ADDRESS, RENDERER_BLACK_PATTERN, 0x4000);

  renderer_resetScroll();
}

void renderer_setBlackPalette() {
  cpct_setPalette(renderer_palettes, 16);
}

void renderer_fadeIn() {
  renderer_fade(renderer_palettes, 16);
}

void renderer_fadeOut() {
  renderer_fade(renderer_palettes + 112, -16);
}

void renderer_fade(u8* palette, i8 displacement) {
  for (u8 index = 0; index < 8; index++) {
    cpct_setPalette(palette, 16);
    __asm__("halt");
    cpct_waitVSYNC();
    palette += displacement;
  }
}

void renderer_resetScroll() {
  renderer_scroll = 0;
  renderer_applyScroll();
}

void renderer_doScroll() {
  renderer_scroll++;
  renderer_applyScroll();
}

void renderer_applyScroll() {
  if (renderer_scroll & 1) {
    crtc_setR30();
  } else {
    crtc_setR31();
  }

  cpct_setVideoMemoryOffset(renderer_scroll >> 1);
}

void end_mark() {
  __asm__("halt");
}
