/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#ifndef _RENDERER_H_
#define _RENDERER_H_

#include <types.h>

#define RENDERER_DARKEN_MASKS_ADDRESS       0x0500
#define RENDERER_DARKEN_MASKS_HI_ADDRESS    (RENDERER_DARKEN_MASKS_ADDRESS >> 8)
// Note: also defined in renderer.h.s

#define RENDERER_TRANSPARENT_MASK_ADDRESS   0x0900

#define RENDERER_SCREEN_ADDRESS             0xc000
#define RENDERER_LANDSCAPE_WIDTH_IN_CHARS   50
#define RENDERER_LANDSCAPE_WIDTH_IN_TILES   RENDERER_LANDSCAPE_WIDTH_IN_CHARS
#define RENDERER_LANDSCAPE_WIDTH_IN_BYTES   (RENDERER_LANDSCAPE_WIDTH_IN_CHARS << 1)
#define RENDERER_LANDSCAPE_HEIGHT_IN_CHARS  20
#define RENDERER_LANDSCAPE_HEIGHT           (RENDERER_LANDSCAPE_HEIGHT_IN_CHARS << 3)

#define RENDERER_PORTRAIT_WIDTH_IN_CHARS    29
#define RENDERER_PORTRAIT_WIDTH_IN_TILES    RENDERER_PORTRAIT_WIDTH_IN_CHARS
#define RENDERER_PORTRAIT_WIDTH_IN_BYTES    (RENDERER_PORTRAIT_WIDTH_IN_CHARS << 1)

#define RENDERER_DEFAULT_WIDTH_IN_CHARS     40
#define RENDERER_DEFAULT_WIDTH_IN_TILES     RENDERER_DEFAULT_WIDTH_IN_CHARS
#define RENDERER_DEFAULT_WIDTH_IN_BYTES     (RENDERER_DEFAULT_WIDTH_IN_CHARS << 1)

#define RENDERER_LANDSCAPE_ORIENTATION      0
#define RENDERER_PORTRAIT_ORIENTATION       1
#define RENDERER_DEFAULT_ORIENTATION        2

extern void renderer_drawTiles(u8* tile, u8* screen, u8 widthInTiles, u8 heightInTiles) __z88dk_callee;
extern void renderer_drawMaskedTiles(u8* tile, u8* screen, u8 widthInTiles, u8 heightInTiles, u8 maskHiAddress, u8 _pad) __z88dk_callee;
extern void renderer_drawMaskedSprite(u8* sprite, u8* screen, u8 widthInBytes, u8 height) __z88dk_callee;
extern void renderer_drawSpan(u8* screen, u8 pattern, u8 height) __z88dk_callee;

void renderer_setBlackPalette();
void renderer_init(u8 orientation) __z88dk_fastcall;

void renderer_clear();
void renderer_setBlackPalette();
void renderer_fadeIn();
void renderer_fadeOut();

void renderer_doScroll();

#endif // _RENDERER_H_
