;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.module renderer

_renderer_drawMaskedTiles::
  pop af        ;; AF <- return address
  pop hl        ;; HL <- sprite address
  pop de        ;; DE <- screen address
  pop bc        ;; B <- height, C <- width
  exx
    pop bc      ;; B' <- _pad, C' <- mask
    ld hl, #MASK_HI_ADDRESS
    ld (hl), c
  exx
  push af       ;; Put returning address in the stack again

outer_loop:
  push bc
  push de
inner_loop:
  push bc

.equ MASK_HI_ADDRESS, . + 1
  ld b, #0x02

  ; first line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc de
  inc hl

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  set 5, d

  ; second line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  dec e

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  set 3, d

  ; third line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc de
  inc hl

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  res 5, d

  ; fourth line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  dec e

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  set 4, d

  ; fifth line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc de
  inc hl

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  set 5, d

  ; sixth line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  dec e

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  res 3, d

  ; seventh line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc de
  inc hl

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  res 5, d

  ; eighth line
  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl
  dec e

  ld c, (hl)
  ld a, (bc)
  ld (de), a
  inc hl

  pop bc
  djnz next_line

  pop de
  pop bc
  dec c
  ret z
  inc e
  inc de
  jr outer_loop

next_line:
  res 4, d
_renderer_drawMaskedTilesScreenWidthInBytes::
  ld a, #100
  add e
  ld e, a
  jr nc, inner_loop
  inc d
  res 3, d
  jr inner_loop
