;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.module renderer

.include "renderer.h.s"

_renderer_drawSpan:: 
  pop af      ;; AF <- return address
  pop de      ;; DE <- screen address
  pop bc      ;; BC <- B = height, C = pattern
  push af     ;; Put returning address in the stack again

; IN:
;  DE <- screen address
;  B = height, C = pattern
_renderer_drawSpan_asm::
loop:
  ld a, c     ;; A <- pattern
  ld (de), a
  inc e
  ld (de), a
  set 5, d

  ld (de), a
  dec e
  ld (de), a
  set 3, d

  ld (de), a
  inc e
  ld (de), a
  res 5, d

  ld (de), a
  dec e
  ld (de), a
  set 4, d

  ld (de), a
  inc e
  ld (de), a
  set 5, d

  ld (de), a
  dec e
  ld (de), a
  res 3, d

  ld (de), a
  inc e
  ld (de), a
  res 5, d

  ld (de), a
  dec e
  ld (de), a

  dec b
  ret z

  res 4, d
_renderer_drawSpanScreenWidthInBytes::
  ld a, #RENDERER_LANDSCAPE_WIDTH_IN_BYTES
  add e
  ld e, a
  jr nc, loop
  inc d
  res 3, d
  jr loop
