/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include "interruptions.h"
#include "audio.h"
#include "../comic/sequence.h"
#include <cpctelera.h>

u16 interruptions_frame;
u8 interruptions_tick;

void interruptions_handler();

void interruptions_init() {
  interruptions_frame = 0;
  interruptions_tick = 0;

  // Ensure we are at the beginning of a frame
  cpct_waitVSYNC();
  while(cpct_count2VSYNC() == 1);
  // and then set our ISR
  cpct_setInterruptHandler(interruptions_handler);
}

void interruptions_resetFrame() {
  interruptions_frame = 0;
}

void interruptions_waitUntilFrame(u16 frame) __z88dk_fastcall {
  while (interruptions_frame < frame);
}

void interruptions_handler() {
  if (++interruptions_tick == 6) {
    __asm__("push ix");
    audio_play();
    __asm__("pop ix");
    cpct_scanKeyboard_i();
    sequence_checkExit();

    interruptions_tick = 0;
    interruptions_frame++;
  }
}
