;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "../lang/macros.h.s"

.module uncompress

decode_addr_table:
  .ds 156

_uncompress::
  push ix
  push iy
  ld ix, #0
  add ix, sp

  ld l, 6(ix)
  ld h, 7(ix)

  ld e, 8(ix)
  ld d, 9(ix)

  call deexo

  pop iy
  pop ix
  ret

deexo:
  ld iy, #decode_addr_table - #16
  ld a, (hl)
  inc hl
  ld b, #52
  push de
  cp a
exo_initbits:
  ld c, #16
  jr nz, exo_get4bits
  .db #0xdd, #0x69
  ld de, #1       ; DE=b2
exo_get4bits:
  srl a           ; get one bit
  call z, exo_getbit
  rl c
  jr nc, exo_get4bits
  inc c
  ld 16(iy), c    ; bits[i] = b1
  push hl
  ld hl, #1
  .db #48         ; 3 bytes nop (JP NC)
exo_setbit:
  add hl, hl
  dec c
  jr nz, exo_setbit
  ld 68(iy), e
  ld 120(iy), d   ; base[i] = b2
  add hl, de
  ex de, hl
  inc iy
  pop hl
  dec__ixl
  djnz exo_initbits
  pop de
  .db #218
exo_literal:
  ldi
exo_mainloop:
  srl a ; get one bit
  call z, exo_getbit
                  ; literal?
  jr c, exo_literal
  ld bc, #239
exo_getindex:
  srl a           ; get one bit
  call z, exo_getbit
  inc c
  jr nc,exo_getindex
  ret z
  push de
  ld d, b
  ld iy, #decode_addr_table - #256
  call exo_getpair
  push de
  ld bc, #512 + #32
                  ; 2 bits, 48 offset
  rlc d
  jr nz, exo_dontgo
  dec e
  jr z, exo_goforit
  dec e ; 2?
exo_dontgo:
  ld bc, #1024 + #16
                  ; 4 bits, 32 offset
  jr z, exo_goforit
  ld de, #0
  ld c, d         ; 16 offset
exo_goforit:
  call exo_getbits
  ld iy, #decode_addr_table
  add iy, de
  call exo_getpair
  pop bc
  ex (sp), hl
  push hl
  sbc hl, de
  pop de
  ldir
  pop hl
  jr exo_mainloop ; Next!

exo_getpair:
  add iy, bc
  ld e, d
  ld b, 16(iy)
  dec b
  call nz, exo_getbits
  ex de, hl
  ld c, 68(iy)
  ld b, 120(iy)
  add hl, bc      ; Always clear C flag
  ex de, hl
  ret

exo_gbnext:
  ld a, (hl)
  inc hl
exo_getbits:
  rr a            ; get one bit
  jr z, exo_gbnext
  rl e
  rl d
  djnz exo_getbits
  ret

exo_getbit:
  ld a, (hl)
  inc hl
  rra
  ret
