;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

; typedef struct {
;   u16 ix;     // Integer horizontal base position
;   fixed fx;   // Fixed point displacement from base (only horizontal)
;   fixed vx;   // Velocity
;   i8 vy;
;   u8 flags;   // Has gravity, friction or bounces? is on floor or in water?
; } Body;

.equ BODY_HAS_GRAVITY,  0x01
.equ BODY_HAS_FRICTION, 0x02
.equ BODY_HAS_BOUNCE,   0x04
.equ BODY_IGNORE_COLLISIONS, 0x08

.equ BODY_HAS_GRAVITY_BIT, 0
.equ BODY_HAS_FRICTION_BIT, 1
.equ BODY_HAS_BOUNCE_BIT, 2
.equ BODY_IGNORE_COLLISIONS_BIT, 3

.equ BODY_ON_TERRAIN,   0x10
.equ BODY_ON_PLATFORM,  0x20
.equ BODY_IN_WATER,     0x40
.equ BODY_ON_FLOOR ,    (BODY_ON_TERRAIN | BODY_ON_PLATFORM)

.equ BODY_ON_TERRAIN_BIT, 4
.equ BODY_ON_PLATFORM_BIT, 5
.equ BODY_IN_WATER_BIT, 6

.equ BODY_IX, 0
.equ BODY_IX_LO, 0
.equ BODY_IX_HI, 1
.equ BODY_FX, 2
.equ BODY_FX_LO, 2
.equ BODY_FX_HI, 3
.equ BODY_VX, 4
.equ BODY_VX_LO, 4
.equ BODY_VX_HI, 5
.equ BODY_VY, 6
.equ BODY_FLAGS, 7
.equ BODY_SIZE, 8
