;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "lang/bounds.h.s"

; typedef struct {
;   u16 left;           // Screen x position
;   u8 top;             // Screen y position
;   u8* screen;         // Screen pointer to draw to
;   Bounds bounds;      // Char aligned drawing bounds
;   union {
;     u8* sprite;
;     u8* string;
;   };
;   u8 flags;           // DRAWING_REDRAW | ...
; } Drawing;

.equ DRAWING_REDRAW, 0x01
.equ DRAWING_TEXT, 0x10
.equ DRAWING_OPAQUE, 0x20
.equ DRAWING_BLINK, 0x40

.equ DRAWING_REDRAW_BIT, 0
.equ DRAWING_TEXT_BIT, 4
.equ DRAWING_OPAQUE_BIT, 5
.equ DRAWING_BLINK_BIT, 6

.equ DRAWING_LEFT, 0
.equ DRAWING_LEFT_LO, 0
.equ DRAWING_LEFT_HI, 1
.equ DRAWING_TOP, 2
.equ DRAWING_SCREEN, 3
.equ DRAWING_SCREEN_LO, 3
.equ DRAWING_SCREEN_HI, 4
.equ DRAWING_BOUNDS, 5
.equ DRAWING_BOUNDS_LEFT, DRAWING_BOUNDS + BOUNDS_LEFT
.equ DRAWING_BOUNDS_LEFT_LO, DRAWING_BOUNDS + BOUNDS_LEFT_LO
.equ DRAWING_BOUNDS_LEFT_HI, DRAWING_BOUNDS + BOUNDS_LEFT_HI
.equ DRAWING_BOUNDS_RIGHT, DRAWING_BOUNDS + BOUNDS_RIGHT
.equ DRAWING_BOUNDS_RIGHT_LO, DRAWING_BOUNDS + BOUNDS_RIGHT_LO
.equ DRAWING_BOUNDS_RIGHT_HI, DRAWING_BOUNDS + BOUNDS_RIGHT_HI
.equ DRAWING_BOUNDS_TOP, DRAWING_BOUNDS + BOUNDS_TOP
.equ DRAWING_BOUNDS_BOTTOM, DRAWING_BOUNDS + BOUNDS_BOTTOM
.equ DRAWING_SPRITE, DRAWING_BOUNDS + BOUNDS_SIZE
.equ DRAWING_SPRITE_LO, DRAWING_SPRITE
.equ DRAWING_SPRITE_HI, DRAWING_SPRITE + 1
.equ DRAWING_STRING, DRAWING_SPRITE
.equ DRAWING_STRING_LO, DRAWING_STRING
.equ DRAWING_STRING_HI, DRAWING_STRING + 1
.equ DRAWING_FLAGS, DRAWING_SPRITE + 2
.equ DRAWING_SIZE, DRAWING_FLAGS + 1
