;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.equ CONTROLS_P1_LEFT,    0
.equ CONTROLS_P1_RIGHT,   1
.equ CONTROLS_P1_JUMP,    2
.equ CONTROLS_P1_UP,      2
.equ CONTROLS_P1_SLIDE,   3
.equ CONTROLS_P1_DOWN,    3
.equ CONTROLS_P1_ACTION,  4
.equ CONTROLS_P1_EXIT,    5

.equ CONTROLS_COUNT, 6

.globl _controls_reset
.globl _controls_isPressed
.globl _controls_isUsed
.globl _controls_set_asm
.globl _controls_getKeyPressed

; .include "keyboard/keyboard.h.s"
; Keycode constants from https://github.com/lronaldo/cpctelera/blob/development/cpctelera/src/keyboard/keyboard.h.s
; Note: copied instead of included to prevent cpct_keyboard module creation

;; Matrix Line 0x00
Key_CursorUp     = #0x0100  ;; Bit 0 (01h) => | 0000 0001 |
Key_CursorRight  = #0x0200  ;; Bit 1 (02h) => | 0000 0010 |
Key_CursorDown   = #0x0400  ;; Bit 2 (04h) => | 0000 0100 |
Key_F9           = #0x0800  ;; Bit 3 (08h) => | 0000 1000 |
Key_F6           = #0x1000  ;; Bit 4 (10h) => | 0001 0000 |
Key_F3           = #0x2000  ;; Bit 5 (20h) => | 0010 0000 |
Key_Enter        = #0x4000  ;; Bit 6 (40h) => | 0100 0000 |
Key_FDot         = #0x8000  ;; Bit 7 (80h) => | 1000 0000 |
;; Matrix Line 0x01
Key_CursorLeft   = #0x0101
Key_Copy         = #0x0201
Key_F7           = #0x0401
Key_F8           = #0x0801
Key_F5           = #0x1001
Key_F1           = #0x2001
Key_F2           = #0x4001
Key_F0           = #0x8001
;; Matrix Line 0x02
Key_Clr          = #0x0102
Key_OpenBracket  = #0x0202
Key_Return       = #0x0402
Key_CloseBracket = #0x0802
Key_F4           = #0x1002
Key_Shift        = #0x2002
Key_BackSlash    = #0x4002
Key_Control      = #0x8002
;; Matrix Line 0x03
Key_Caret        = #0x0103
Key_Hyphen       = #0x0203
Key_At           = #0x0403
Key_P            = #0x0803
Key_SemiColon    = #0x1003
Key_Colon        = #0x2003
Key_Slash        = #0x4003
Key_Dot          = #0x8003
;; Matrix Line 0x04
Key_0            = #0x0104
Key_9            = #0x0204
Key_O            = #0x0404
Key_I            = #0x0804
Key_L            = #0x1004
Key_K            = #0x2004
Key_M            = #0x4004
Key_Comma        = #0x8004
;; Matrix Line 0x05
Key_8            = #0x0105
Key_7            = #0x0205
Key_U            = #0x0405
Key_Y            = #0x0805
Key_H            = #0x1005
Key_J            = #0x2005
Key_N            = #0x4005
Key_Space        = #0x8005
;; Matrix Line 0x06
Key_6            = #0x0106
Joy1_Up          = #0x0106
Key_5            = #0x0206
Joy1_Down        = #0x0206
Key_R            = #0x0406
Joy1_Left        = #0x0406
Key_T            = #0x0806
Joy1_Right       = #0x0806
Key_G            = #0x1006
Joy1_Fire1       = #0x1006
Key_F            = #0x2006
Joy1_Fire2       = #0x2006
Key_B            = #0x4006
Joy1_Fire3       = #0x4006
Key_V            = #0x8006
;; Matrix Line 0x07
Key_4            = #0x0107
Key_3            = #0x0207
Key_E            = #0x0407
Key_W            = #0x0807
Key_S            = #0x1007
Key_D            = #0x2007
Key_C            = #0x4007
Key_X            = #0x8007
;; Matrix Line 0x08
Key_1            = #0x0108
Key_2            = #0x0208
Key_Esc          = #0x0408
Key_Q            = #0x0808
Key_Tab          = #0x1008
Key_A            = #0x2008
Key_CapsLock     = #0x4008
Key_Z            = #0x8008
;; Matrix Line 0x09
Joy0_Up          = #0x0109
Joy0_Down        = #0x0209
Joy0_Left        = #0x0409
Joy0_Right       = #0x0809
Joy0_Fire1       = #0x1009
Joy0_Fire2       = #0x2009
Joy0_Fire3       = #0x4009
Key_Del          = #0x8009
