/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/


#ifndef _GAME_ASSETS_H_
#define _GAME_ASSETS_H_
#include <types.h>

void game_assets_init();

#define GAME_ASSETS_AT 0x3F00



#define GAME_A_ASSETS_ADDRESS 0x3F00
#define GAME_A_ASSETS_SIZE 16367

#define GAME_A_ASSETS_COMPRESSED_SIZE 8731

#define GAME_A_ASSETS_HIGHEST_ADDRESS 0x7EEF


#define GAME_B_ASSETS_ADDRESS 0x9000
#define GAME_B_ASSETS_SIZE 11505

#define GAME_B_ASSETS_COMPRESSED_SIZE 8196

#define GAME_B_ASSETS_HIGHEST_ADDRESS 0xBCF1




#define SIN_TABLE_ADDRESS 0x3F00
#define SIN_TABLE_SIZE 128




#define PALETTES_ADDRESS 0x3F80
#define PALETTES_SIZE 128




#define TILE_BUFFER_ADDRESS 0x4000
#define TILE_BUFFER_SIZE 1024




#define TERRAIN_HEIGHTS_ADDRESS 0x4400
#define TERRAIN_HEIGHTS_SIZE 256




#define TERRAIN_SCREENS_ADDRESS 0x4500
#define TERRAIN_SCREENS_SIZE 256




#define TERRAIN_TEXTURE_ADDRESS 0x4600
#define TERRAIN_TEXTURE_SIZE 256




#define PLATFORM_HEIGHTS_ADDRESS 0x4700
#define PLATFORM_HEIGHTS_SIZE 64




#define WATER_HEIGHTS_ADDRESS 0x4740
#define WATER_HEIGHTS_SIZE 64




#define PASTEL_BLUE_INKS_ADDRESS 0x4780
#define PASTEL_BLUE_INKS_SIZE 8




#define MAGENTA_INKS_ADDRESS 0x4788
#define MAGENTA_INKS_SIZE 8




#define BLACK_INKS_ADDRESS 0x4790
#define BLACK_INKS_SIZE 8




#define MENU_TEXTURE_ADDRESS 0x4798
#define MENU_TEXTURE_SIZE 7




#define VIBRANT_MEADOWS_TEXTURE_ADDRESS 0x479F
#define VIBRANT_MEADOWS_TEXTURE_SIZE 21




#define BLUE_WAVES_TEXTURE_ADDRESS 0x47B4
#define BLUE_WAVES_TEXTURE_SIZE 27




#define LUCY_IN_THE_SKY_TEXTURE_ADDRESS 0x47CF
#define LUCY_IN_THE_SKY_TEXTURE_SIZE 29




#define GLOOMY_ELECTRIC_TEXTURE_ADDRESS 0x47EC
#define GLOOMY_ELECTRIC_TEXTURE_SIZE 19




#define FONT_ADDRESS 0x47FF
#define FONT_SIZE 540


#define FONT_FORMAT "font3"
#define FONT_WIDTH_IN_BYTES 2
#define FONT_WIDTH 4
#define FONT_HEIGHT 6

#define FONT_COUNT 45

#define FONT_0_ADDRESS 0x47FF

#define FONT_1_ADDRESS 0x480B

#define FONT_2_ADDRESS 0x4817

#define FONT_3_ADDRESS 0x4823

#define FONT_4_ADDRESS 0x482F

#define FONT_5_ADDRESS 0x483B

#define FONT_6_ADDRESS 0x4847

#define FONT_7_ADDRESS 0x4853

#define FONT_8_ADDRESS 0x485F

#define FONT_9_ADDRESS 0x486B

#define FONT_10_ADDRESS 0x4877

#define FONT_11_ADDRESS 0x4883

#define FONT_12_ADDRESS 0x488F

#define FONT_13_ADDRESS 0x489B

#define FONT_14_ADDRESS 0x48A7

#define FONT_15_ADDRESS 0x48B3

#define FONT_16_ADDRESS 0x48BF

#define FONT_17_ADDRESS 0x48CB

#define FONT_18_ADDRESS 0x48D7

#define FONT_19_ADDRESS 0x48E3

#define FONT_20_ADDRESS 0x48EF

#define FONT_21_ADDRESS 0x48FB

#define FONT_22_ADDRESS 0x4907

#define FONT_23_ADDRESS 0x4913

#define FONT_24_ADDRESS 0x491F

#define FONT_25_ADDRESS 0x492B

#define FONT_26_ADDRESS 0x4937

#define FONT_27_ADDRESS 0x4943

#define FONT_28_ADDRESS 0x494F

#define FONT_29_ADDRESS 0x495B

#define FONT_30_ADDRESS 0x4967

#define FONT_31_ADDRESS 0x4973

#define FONT_32_ADDRESS 0x497F

#define FONT_33_ADDRESS 0x498B

#define FONT_34_ADDRESS 0x4997

#define FONT_35_ADDRESS 0x49A3

#define FONT_36_ADDRESS 0x49AF

#define FONT_37_ADDRESS 0x49BB

#define FONT_38_ADDRESS 0x49C7

#define FONT_39_ADDRESS 0x49D3

#define FONT_40_ADDRESS 0x49DF

#define FONT_41_ADDRESS 0x49EB

#define FONT_42_ADDRESS 0x49F7

#define FONT_43_ADDRESS 0x4A03

#define FONT_44_ADDRESS 0x4A0F




#define THE_STRING_ADDRESS 0x4A1B
#define THE_STRING_SIZE 4

#define THE_STRING_LENGTH 3
#define THE_STRING_X_IN_BYTES -1
#define THE_STRING_Y -1




#define TITLE_ADDRESS 0x4A1F
#define TITLE_SIZE 396


#define TITLE_FORMAT "raw"
#define TITLE_WIDTH_IN_BYTES 3
#define TITLE_WIDTH 6
#define TITLE_HEIGHT 14

#define TITLE_COUNT 9

#define TITLE_0_ADDRESS 0x4A1F

#define TITLE_1_ADDRESS 0x4A4B

#define TITLE_2_ADDRESS 0x4A77

#define TITLE_3_ADDRESS 0x4AA3

#define TITLE_4_ADDRESS 0x4ACF

#define TITLE_5_ADDRESS 0x4AFB

#define TITLE_6_ADDRESS 0x4B27

#define TITLE_7_ADDRESS 0x4B53

#define TITLE_8_ADDRESS 0x4B7F




#define SUBTITLE_ADDRESS 0x4BAB
#define SUBTITLE_SIZE 200


#define SUBTITLE_FORMAT "rlz3"
#define SUBTITLE_WIDTH_IN_BYTES 22
#define SUBTITLE_WIDTH 44
#define SUBTITLE_HEIGHT 7

#define SUBTITLE_COUNT 1

#define SUBTITLE_0_ADDRESS 0x4BAC




#define MENU_SUBTITLE_ADDRESS 0x4C73
#define MENU_SUBTITLE_SIZE 9




#define PLAY_STRING_ADDRESS 0x4C7C
#define PLAY_STRING_SIZE 9

#define PLAY_STRING_LENGTH 6
#define PLAY_STRING_X_IN_BYTES -1
#define PLAY_STRING_Y -1




#define REDEFINE_STRING_ADDRESS 0x4C85
#define REDEFINE_STRING_SIZE 13

#define REDEFINE_STRING_LENGTH 10
#define REDEFINE_STRING_X_IN_BYTES -1
#define REDEFINE_STRING_Y -1




#define LEFT_STRING_ADDRESS 0x4C92
#define LEFT_STRING_SIZE 7

#define LEFT_STRING_LENGTH 4
#define LEFT_STRING_X_IN_BYTES -1
#define LEFT_STRING_Y -1




#define RIGHT_STRING_ADDRESS 0x4C99
#define RIGHT_STRING_SIZE 8

#define RIGHT_STRING_LENGTH 5
#define RIGHT_STRING_X_IN_BYTES -1
#define RIGHT_STRING_Y -1




#define JUMP_STRING_ADDRESS 0x4CA1
#define JUMP_STRING_SIZE 11

#define JUMP_STRING_LENGTH 8
#define JUMP_STRING_X_IN_BYTES -1
#define JUMP_STRING_Y -1




#define SLIDE_STRING_ADDRESS 0x4CAC
#define SLIDE_STRING_SIZE 13

#define SLIDE_STRING_LENGTH 10
#define SLIDE_STRING_X_IN_BYTES -1
#define SLIDE_STRING_Y -1




#define ACTION_STRING_ADDRESS 0x4CB9
#define ACTION_STRING_SIZE 9

#define ACTION_STRING_LENGTH 6
#define ACTION_STRING_X_IN_BYTES -1
#define ACTION_STRING_Y -1




#define EXIT_STRING_ADDRESS 0x4CC2
#define EXIT_STRING_SIZE 7

#define EXIT_STRING_LENGTH 4
#define EXIT_STRING_X_IN_BYTES -1
#define EXIT_STRING_Y -1




#define EMPTY_STRING_ADDRESS 0x4CC9
#define EMPTY_STRING_SIZE 4

#define EMPTY_STRING_LENGTH 1
#define EMPTY_STRING_X_IN_BYTES -1
#define EMPTY_STRING_Y -1




#define CODE_STRING_ADDRESS 0x4CCD
#define CODE_STRING_SIZE 19

#define CODE_STRING_LENGTH 16
#define CODE_STRING_X_IN_BYTES -1
#define CODE_STRING_Y -1




#define TULO_STRING_ADDRESS 0x4CE0
#define TULO_STRING_SIZE 19

#define TULO_STRING_LENGTH 16
#define TULO_STRING_X_IN_BYTES -1
#define TULO_STRING_Y -1




#define ART_STRING_ADDRESS 0x4CF3
#define ART_STRING_SIZE 13

#define ART_STRING_LENGTH 10
#define ART_STRING_X_IN_BYTES -1
#define ART_STRING_Y -1




#define ALBERTO_STRING_ADDRESS 0x4D00
#define ALBERTO_STRING_SIZE 29

#define ALBERTO_STRING_LENGTH 26
#define ALBERTO_STRING_X_IN_BYTES -1
#define ALBERTO_STRING_Y -1




#define MUSIC_STRING_ADDRESS 0x4D1D
#define MUSIC_STRING_SIZE 13

#define MUSIC_STRING_LENGTH 10
#define MUSIC_STRING_X_IN_BYTES -1
#define MUSIC_STRING_Y -1




#define JAVIER_STRING_ADDRESS 0x4D2A
#define JAVIER_STRING_SIZE 23

#define JAVIER_STRING_LENGTH 20
#define JAVIER_STRING_X_IN_BYTES -1
#define JAVIER_STRING_Y -1




#define MENU_CREDITS_ADDRESS 0x4D41
#define MENU_CREDITS_SIZE 93




#define COPYRIGHT_ADDRESS 0x4D9E
#define COPYRIGHT_SIZE 293


#define COPYRIGHT_FORMAT "rlz3"
#define COPYRIGHT_WIDTH_IN_BYTES 38
#define COPYRIGHT_WIDTH 76
#define COPYRIGHT_HEIGHT 6

#define COPYRIGHT_COUNT 1

#define COPYRIGHT_0_ADDRESS 0x4DA0




#define MENU_COPYRIGHT_ADDRESS 0x4EC3
#define MENU_COPYRIGHT_SIZE 9




#define MENU_PLAY_ADDRESS 0x4ECC
#define MENU_PLAY_SIZE 9




#define MENU_REDEFINE_ADDRESS 0x4ED5
#define MENU_REDEFINE_SIZE 9




#define MENU_LEFT_ADDRESS 0x4EDE
#define MENU_LEFT_SIZE 9




#define MENU_RIGHT_ADDRESS 0x4EE7
#define MENU_RIGHT_SIZE 9




#define MENU_JUMP_ADDRESS 0x4EF0
#define MENU_JUMP_SIZE 9




#define MENU_SLIDE_ADDRESS 0x4EF9
#define MENU_SLIDE_SIZE 9




#define MENU_ACTION_ADDRESS 0x4F02
#define MENU_ACTION_SIZE 9




#define MENU_EXIT_ADDRESS 0x4F0B
#define MENU_EXIT_SIZE 9




#define LEVEL_STRING_ADDRESS 0x4F14
#define LEVEL_STRING_SIZE 10

#define LEVEL_STRING_LENGTH 7
#define LEVEL_STRING_X_IN_BYTES -1
#define LEVEL_STRING_Y -1




#define TITLE_LEVEL_ADDRESS 0x4F1E
#define TITLE_LEVEL_SIZE 9




#define RESCUE_STRING_ADDRESS 0x4F27
#define RESCUE_STRING_SIZE 7

#define RESCUE_STRING_LENGTH 6
#define RESCUE_STRING_X_IN_BYTES -1
#define RESCUE_STRING_Y -1




#define ENDING_STRING_ADDRESS 0x4F2E
#define ENDING_STRING_SIZE 28

#define ENDING_STRING_LENGTH 27
#define ENDING_STRING_X_IN_BYTES -1
#define ENDING_STRING_Y -1




#define PLAYER_RUN_ADDRESS 0x4F4A
#define PLAYER_RUN_SIZE 1345


#define PLAYER_RUN_FORMAT "rlz3"
#define PLAYER_RUN_WIDTH_IN_BYTES 5
#define PLAYER_RUN_WIDTH 10
#define PLAYER_RUN_HEIGHT 28

#define PLAYER_RUN_COUNT 10

#define PLAYER_RUN_0_ADDRESS 0x4F4A

#define PLAYER_RUN_1_ADDRESS 0x4FCC

#define PLAYER_RUN_2_ADDRESS 0x5058

#define PLAYER_RUN_3_ADDRESS 0x50DE

#define PLAYER_RUN_4_ADDRESS 0x5165

#define PLAYER_RUN_5_ADDRESS 0x51F2

#define PLAYER_RUN_6_ADDRESS 0x5279

#define PLAYER_RUN_7_ADDRESS 0x5302

#define PLAYER_RUN_8_ADDRESS 0x5383

#define PLAYER_RUN_9_ADDRESS 0x5406




#define PLAYER_RUN_FAST_ADDRESS 0x548B
#define PLAYER_RUN_FAST_SIZE 706


#define PLAYER_RUN_FAST_FORMAT "rlz3"
#define PLAYER_RUN_FAST_WIDTH_IN_BYTES 7
#define PLAYER_RUN_FAST_WIDTH 14
#define PLAYER_RUN_FAST_HEIGHT 23

#define PLAYER_RUN_FAST_COUNT 6

#define PLAYER_RUN_FAST_0_ADDRESS 0x548B

#define PLAYER_RUN_FAST_1_ADDRESS 0x54FF

#define PLAYER_RUN_FAST_2_ADDRESS 0x5573

#define PLAYER_RUN_FAST_3_ADDRESS 0x55DF

#define PLAYER_RUN_FAST_4_ADDRESS 0x5659

#define PLAYER_RUN_FAST_5_ADDRESS 0x56DD




#define PLAYER_FLY_ADDRESS 0x574D
#define PLAYER_FLY_SIZE 136


#define PLAYER_FLY_FORMAT "rlz3"
#define PLAYER_FLY_WIDTH_IN_BYTES 4
#define PLAYER_FLY_WIDTH 8
#define PLAYER_FLY_HEIGHT 33

#define PLAYER_FLY_COUNT 1

#define PLAYER_FLY_0_ADDRESS 0x574D




#define PLAYER_FLY_FAST_ADDRESS 0x57D5
#define PLAYER_FLY_FAST_SIZE 120


#define PLAYER_FLY_FAST_FORMAT "rlz3"
#define PLAYER_FLY_FAST_WIDTH_IN_BYTES 7
#define PLAYER_FLY_FAST_WIDTH 14
#define PLAYER_FLY_FAST_HEIGHT 23

#define PLAYER_FLY_FAST_COUNT 1

#define PLAYER_FLY_FAST_0_ADDRESS 0x57D6




#define PLAYER_HIT_ADDRESS 0x584D
#define PLAYER_HIT_SIZE 111


#define PLAYER_HIT_FORMAT "rlz3"
#define PLAYER_HIT_WIDTH_IN_BYTES 7
#define PLAYER_HIT_WIDTH 14
#define PLAYER_HIT_HEIGHT 14

#define PLAYER_HIT_COUNT 1

#define PLAYER_HIT_0_ADDRESS 0x584D




#define PLAYER_JUMP_ADDRESS 0x58BC
#define PLAYER_JUMP_SIZE 352


#define PLAYER_JUMP_FORMAT "rlz3"
#define PLAYER_JUMP_WIDTH_IN_BYTES 6
#define PLAYER_JUMP_WIDTH 12
#define PLAYER_JUMP_HEIGHT 32

#define PLAYER_JUMP_COUNT 3

#define PLAYER_JUMP_0_ADDRESS 0x58BD

#define PLAYER_JUMP_1_ADDRESS 0x5916

#define PLAYER_JUMP_2_ADDRESS 0x5992




#define PLAYER_FALL_ADDRESS 0x5A1C
#define PLAYER_FALL_SIZE 119


#define PLAYER_FALL_FORMAT "rlz3"
#define PLAYER_FALL_WIDTH_IN_BYTES 5
#define PLAYER_FALL_WIDTH 10
#define PLAYER_FALL_HEIGHT 25

#define PLAYER_FALL_COUNT 1

#define PLAYER_FALL_0_ADDRESS 0x5A1C




#define PLAYER_LAND_ADDRESS 0x5A93
#define PLAYER_LAND_SIZE 222


#define PLAYER_LAND_FORMAT "rlz3"
#define PLAYER_LAND_WIDTH_IN_BYTES 5
#define PLAYER_LAND_WIDTH 10
#define PLAYER_LAND_HEIGHT 22

#define PLAYER_LAND_COUNT 2

#define PLAYER_LAND_0_ADDRESS 0x5A93

#define PLAYER_LAND_1_ADDRESS 0x5B00




#define PLAYER_SLIDE_ADDRESS 0x5B71
#define PLAYER_SLIDE_SIZE 394


#define PLAYER_SLIDE_FORMAT "rlz3"
#define PLAYER_SLIDE_WIDTH_IN_BYTES 7
#define PLAYER_SLIDE_WIDTH 14
#define PLAYER_SLIDE_HEIGHT 25

#define PLAYER_SLIDE_COUNT 3

#define PLAYER_SLIDE_0_ADDRESS 0x5B71

#define PLAYER_SLIDE_1_ADDRESS 0x5BF9

#define PLAYER_SLIDE_2_ADDRESS 0x5C7B




#define PLAYER_RUNNING_ADDRESS 0x5CFB
#define PLAYER_RUNNING_SIZE 72




#define PLAYER_RUNNING_FAST_ADDRESS 0x5D43
#define PLAYER_RUNNING_FAST_SIZE 44




#define PLAYER_FLYING_ADDRESS 0x5D6F
#define PLAYER_FLYING_SIZE 16




#define PLAYER_REPELLING_ADDRESS 0x5D7F
#define PLAYER_REPELLING_SIZE 16




#define PLAYER_FLYING_FAST_ADDRESS 0x5D8F
#define PLAYER_FLYING_FAST_SIZE 9




#define PLAYER_HITTING_ADDRESS 0x5D98
#define PLAYER_HITTING_SIZE 9




#define PLAYER_LANDING_ADDRESS 0x5DA1
#define PLAYER_LANDING_SIZE 16




#define PLAYER_JUMPING_ADDRESS 0x5DB1
#define PLAYER_JUMPING_SIZE 23




#define PLAYER_SLIDING_ADDRESS 0x5DC8
#define PLAYER_SLIDING_SIZE 44




#define PLAYER_SLIDING_FAST_ADDRESS 0x5DF4
#define PLAYER_SLIDING_FAST_SIZE 30




#define PLAYER_CARE_ADDRESS 0x5E12
#define PLAYER_CARE_SIZE 117


#define PLAYER_CARE_FORMAT "rlz3"
#define PLAYER_CARE_WIDTH_IN_BYTES 6
#define PLAYER_CARE_WIDTH 12
#define PLAYER_CARE_HEIGHT 24

#define PLAYER_CARE_COUNT 1

#define PLAYER_CARE_0_ADDRESS 0x5E12




#define PLAYER_CARESSING_ADDRESS 0x5E87
#define PLAYER_CARESSING_SIZE 9




#define SONGS_ADDRESS 0x5E90
#define SONGS_SIZE 6509




#define SFX_ADDRESS 0x77FD
#define SFX_SIZE 660




#define EGG_ADDRESS 0x7A91
#define EGG_SIZE 42


#define EGG_FORMAT "rlz3"
#define EGG_WIDTH_IN_BYTES 4
#define EGG_WIDTH 8
#define EGG_HEIGHT 10

#define EGG_COUNT 1

#define EGG_0_ADDRESS 0x7A91




#define FRIED_EGG_ADDRESS 0x7ABB
#define FRIED_EGG_SIZE 78


#define FRIED_EGG_FORMAT "rlz3"
#define FRIED_EGG_WIDTH_IN_BYTES 8
#define FRIED_EGG_WIDTH 16
#define FRIED_EGG_HEIGHT 8

#define FRIED_EGG_COUNT 1

#define FRIED_EGG_0_ADDRESS 0x7ABB




#define EGG_FALLING_ADDRESS 0x7B09
#define EGG_FALLING_SIZE 9




#define EGG_STANDING_ADDRESS 0x7B12
#define EGG_STANDING_SIZE 9




#define HUD_ANIMALS_ADDRESS 0x7B1B
#define HUD_ANIMALS_SIZE 328


#define HUD_ANIMALS_FORMAT "raw"
#define HUD_ANIMALS_WIDTH_IN_BYTES 4
#define HUD_ANIMALS_WIDTH 8
#define HUD_ANIMALS_HEIGHT 20

#define HUD_ANIMALS_COUNT 4

#define HUD_ANIMALS_0_ADDRESS 0x7B1B

#define HUD_ANIMALS_1_ADDRESS 0x7B6D

#define HUD_ANIMALS_2_ADDRESS 0x7BBF

#define HUD_ANIMALS_3_ADDRESS 0x7C11




#define PLAYER_RIDE_ADDRESS 0x7C63
#define PLAYER_RIDE_SIZE 245


#define PLAYER_RIDE_FORMAT "rlz3"
#define PLAYER_RIDE_WIDTH_IN_BYTES 6
#define PLAYER_RIDE_WIDTH 12
#define PLAYER_RIDE_HEIGHT 25

#define PLAYER_RIDE_COUNT 2

#define PLAYER_RIDE_0_ADDRESS 0x7C63

#define PLAYER_RIDE_1_ADDRESS 0x7CDF




#define PLAYER_RIDING_ADDRESS 0x7D58
#define PLAYER_RIDING_SIZE 16




#define SLUG_ADDRESS 0x7D68
#define SLUG_SIZE 237


#define SLUG_FORMAT "rlz3"
#define SLUG_WIDTH_IN_BYTES 4
#define SLUG_WIDTH 8
#define SLUG_HEIGHT 14

#define SLUG_COUNT 4

#define SLUG_0_ADDRESS 0x7D68

#define SLUG_1_ADDRESS 0x7DA6

#define SLUG_2_ADDRESS 0x7DE1

#define SLUG_3_ADDRESS 0x7E0B




#define SLUG_WAITING_ADDRESS 0x7E55
#define SLUG_WAITING_SIZE 9




#define SLUG_NERVIOUS_ADDRESS 0x7E5E
#define SLUG_NERVIOUS_SIZE 16




#define SLUG_JUMPING_ADDRESS 0x7E6E
#define SLUG_JUMPING_SIZE 16




#define PLAYBACK_DATA_ADDRESS 0x7E7E
#define PLAYBACK_DATA_SIZE 113



extern const u8 game_a_assets[8731];

void game_a_uncompress();




#define SCREEN_POINTER_TABLE_ADDRESS 0x9000
#define SCREEN_POINTER_TABLE_SIZE 40




#define MENU_BACKGROUNDS_ADDRESS 0x9028
#define MENU_BACKGROUNDS_SIZE 80


#define MENU_BACKGROUNDS_FORMAT "tile"
#define MENU_BACKGROUNDS_WIDTH_IN_BYTES 2
#define MENU_BACKGROUNDS_WIDTH 4
#define MENU_BACKGROUNDS_HEIGHT 8

#define MENU_BACKGROUNDS_WIDTH_IN_TILES 5
#define MENU_BACKGROUNDS_HEIGHT_IN_TILES 1

#define MENU_BACKGROUNDS_COUNT 5

#define MENU_BACKGROUNDS_0_ADDRESS 0x9028

#define MENU_BACKGROUNDS_1_ADDRESS 0x9038

#define MENU_BACKGROUNDS_2_ADDRESS 0x9048

#define MENU_BACKGROUNDS_3_ADDRESS 0x9058

#define MENU_BACKGROUNDS_4_ADDRESS 0x9068




#define PLANETS_ADDRESS 0x9078
#define PLANETS_SIZE 440


#define PLANETS_FORMAT "tile"
#define PLANETS_WIDTH_IN_BYTES 2
#define PLANETS_WIDTH 4
#define PLANETS_HEIGHT 8

#define PLANETS_WIDTH_IN_TILES 9
#define PLANETS_HEIGHT_IN_TILES 3

#define PLANETS_COUNT 27

#define PLANETS_0_ADDRESS 0x9078

#define PLANETS_1_ADDRESS 0x9088

#define PLANETS_2_ADDRESS 0x9098

#define PLANETS_3_ADDRESS 0x90A8

#define PLANETS_4_ADDRESS 0x90B8

#define PLANETS_5_ADDRESS 0x90C8

#define PLANETS_6_ADDRESS 0x90D8

#define PLANETS_7_ADDRESS 0x90E8

#define PLANETS_8_ADDRESS 0x9100

#define PLANETS_9_ADDRESS 0x9110

#define PLANETS_10_ADDRESS 0x9120

#define PLANETS_11_ADDRESS 0x9130

#define PLANETS_12_ADDRESS 0x9140

#define PLANETS_13_ADDRESS 0x9150

#define PLANETS_14_ADDRESS 0x9160

#define PLANETS_15_ADDRESS 0x9170

#define PLANETS_16_ADDRESS 0x9180

#define PLANETS_17_ADDRESS 0x9190

#define PLANETS_18_ADDRESS 0x91A0

#define PLANETS_19_ADDRESS 0x91B0

#define PLANETS_20_ADDRESS 0x91C0

#define PLANETS_21_ADDRESS 0x91D0

#define PLANETS_22_ADDRESS 0x91E0

#define PLANETS_23_ADDRESS 0x91F0

#define PLANETS_24_ADDRESS 0x9200

#define PLANETS_25_ADDRESS 0x9210

#define PLANETS_26_ADDRESS 0x9220




#define PLATFORMS_ADDRESS 0x9230
#define PLATFORMS_SIZE 176


#define PLATFORMS_FORMAT "tile"
#define PLATFORMS_WIDTH_IN_BYTES 2
#define PLATFORMS_WIDTH 4
#define PLATFORMS_HEIGHT 8

#define PLATFORMS_WIDTH_IN_TILES 11
#define PLATFORMS_HEIGHT_IN_TILES 1

#define PLATFORMS_COUNT 11

#define PLATFORMS_0_ADDRESS 0x9230

#define PLATFORMS_1_ADDRESS 0x9240

#define PLATFORMS_2_ADDRESS 0x9250

#define PLATFORMS_3_ADDRESS 0x9260

#define PLATFORMS_4_ADDRESS 0x9270

#define PLATFORMS_5_ADDRESS 0x9280

#define PLATFORMS_6_ADDRESS 0x9290

#define PLATFORMS_7_ADDRESS 0x92A0

#define PLATFORMS_8_ADDRESS 0x92B0

#define PLATFORMS_9_ADDRESS 0x92C0

#define PLATFORMS_10_ADDRESS 0x92D0




#define STARS_ADDRESS 0x92E0
#define STARS_SIZE 64


#define STARS_FORMAT "tile"
#define STARS_WIDTH_IN_BYTES 2
#define STARS_WIDTH 4
#define STARS_HEIGHT 8

#define STARS_WIDTH_IN_TILES 4
#define STARS_HEIGHT_IN_TILES 1

#define STARS_COUNT 4

#define STARS_0_ADDRESS 0x92E0

#define STARS_1_ADDRESS 0x92F0

#define STARS_2_ADDRESS 0x9300

#define STARS_3_ADDRESS 0x9310




#define BUSH_ADDRESS 0x9320
#define BUSH_SIZE 192


#define BUSH_FORMAT "tile"
#define BUSH_WIDTH_IN_BYTES 2
#define BUSH_WIDTH 4
#define BUSH_HEIGHT 8

#define BUSH_WIDTH_IN_TILES 4
#define BUSH_HEIGHT_IN_TILES 3

#define BUSH_COUNT 12

#define BUSH_0_ADDRESS 0x9320

#define BUSH_1_ADDRESS 0x9330

#define BUSH_2_ADDRESS 0x9340

#define BUSH_3_ADDRESS 0x9350

#define BUSH_4_ADDRESS 0x9360

#define BUSH_5_ADDRESS 0x9370

#define BUSH_6_ADDRESS 0x9380

#define BUSH_7_ADDRESS 0x9390

#define BUSH_8_ADDRESS 0x93A0

#define BUSH_9_ADDRESS 0x93B0

#define BUSH_10_ADDRESS 0x93C0

#define BUSH_11_ADDRESS 0x93D0




#define MEDIUM_WEED_ADDRESS 0x93E0
#define MEDIUM_WEED_SIZE 64


#define MEDIUM_WEED_FORMAT "tile"
#define MEDIUM_WEED_WIDTH_IN_BYTES 2
#define MEDIUM_WEED_WIDTH 4
#define MEDIUM_WEED_HEIGHT 8

#define MEDIUM_WEED_WIDTH_IN_TILES 2
#define MEDIUM_WEED_HEIGHT_IN_TILES 2

#define MEDIUM_WEED_COUNT 4

#define MEDIUM_WEED_0_ADDRESS 0x93E0

#define MEDIUM_WEED_1_ADDRESS 0x93F0

#define MEDIUM_WEED_2_ADDRESS 0x9400

#define MEDIUM_WEED_3_ADDRESS 0x9410




#define HIGH_WEED_ADDRESS 0x9420
#define HIGH_WEED_SIZE 96


#define HIGH_WEED_FORMAT "tile"
#define HIGH_WEED_WIDTH_IN_BYTES 2
#define HIGH_WEED_WIDTH 4
#define HIGH_WEED_HEIGHT 8

#define HIGH_WEED_WIDTH_IN_TILES 2
#define HIGH_WEED_HEIGHT_IN_TILES 3

#define HIGH_WEED_COUNT 6

#define HIGH_WEED_0_ADDRESS 0x9420

#define HIGH_WEED_1_ADDRESS 0x9430

#define HIGH_WEED_2_ADDRESS 0x9440

#define HIGH_WEED_3_ADDRESS 0x9450

#define HIGH_WEED_4_ADDRESS 0x9460

#define HIGH_WEED_5_ADDRESS 0x9470




#define EARTH_ADDRESS 0x9480
#define EARTH_SIZE 234


#define EARTH_FORMAT "rlz3"
#define EARTH_WIDTH_IN_BYTES 7
#define EARTH_WIDTH 14
#define EARTH_HEIGHT 28

#define EARTH_COUNT 1

#define EARTH_0_ADDRESS 0x9481




#define MARS_ADDRESS 0x956A
#define MARS_SIZE 81


#define MARS_FORMAT "rlz3"
#define MARS_WIDTH_IN_BYTES 4
#define MARS_WIDTH 8
#define MARS_HEIGHT 16

#define MARS_COUNT 1

#define MARS_0_ADDRESS 0x956A




#define EARTH_IDLE_ADDRESS 0x95BB
#define EARTH_IDLE_SIZE 9




#define MARS_IDLE_ADDRESS 0x95C4
#define MARS_IDLE_SIZE 9




#define HUD_HEAD_ADDRESS 0x95CD
#define HUD_HEAD_SIZE 404


#define HUD_HEAD_FORMAT "raw"
#define HUD_HEAD_WIDTH_IN_BYTES 8
#define HUD_HEAD_WIDTH 16
#define HUD_HEAD_HEIGHT 25

#define HUD_HEAD_COUNT 2

#define HUD_HEAD_0_ADDRESS 0x95CD

#define HUD_HEAD_1_ADDRESS 0x9697




#define HUD_BAR_FILLING_ADDRESS 0x9761
#define HUD_BAR_FILLING_SIZE 36


#define HUD_BAR_FILLING_FORMAT "raw"
#define HUD_BAR_FILLING_WIDTH_IN_BYTES 1
#define HUD_BAR_FILLING_WIDTH 2
#define HUD_BAR_FILLING_HEIGHT 7

#define HUD_BAR_FILLING_COUNT 4

#define HUD_BAR_FILLING_0_ADDRESS 0x9761

#define HUD_BAR_FILLING_1_ADDRESS 0x976A

#define HUD_BAR_FILLING_2_ADDRESS 0x9773

#define HUD_BAR_FILLING_3_ADDRESS 0x977C




#define HUD_BAR_FILLED_ADDRESS 0x9785
#define HUD_BAR_FILLED_SIZE 27


#define HUD_BAR_FILLED_FORMAT "raw"
#define HUD_BAR_FILLED_WIDTH_IN_BYTES 1
#define HUD_BAR_FILLED_WIDTH 2
#define HUD_BAR_FILLED_HEIGHT 7

#define HUD_BAR_FILLED_COUNT 3

#define HUD_BAR_FILLED_0_ADDRESS 0x9785

#define HUD_BAR_FILLED_1_ADDRESS 0x978E

#define HUD_BAR_FILLED_2_ADDRESS 0x9797




#define HUD_MAP_START_ADDRESS 0x97A0
#define HUD_MAP_START_SIZE 38


#define HUD_MAP_START_FORMAT "raw"
#define HUD_MAP_START_WIDTH_IN_BYTES 4
#define HUD_MAP_START_WIDTH 8
#define HUD_MAP_START_HEIGHT 9

#define HUD_MAP_START_COUNT 1

#define HUD_MAP_START_0_ADDRESS 0x97A0




#define HUD_MAP_SLASH_ADDRESS 0x97C6
#define HUD_MAP_SLASH_SIZE 12


#define HUD_MAP_SLASH_FORMAT "raw"
#define HUD_MAP_SLASH_WIDTH_IN_BYTES 5
#define HUD_MAP_SLASH_WIDTH 10
#define HUD_MAP_SLASH_HEIGHT 2

#define HUD_MAP_SLASH_COUNT 1

#define HUD_MAP_SLASH_0_ADDRESS 0x97C6




#define HUD_MAP_FLAG_ADDRESS 0x97D2
#define HUD_MAP_FLAG_SIZE 134


#define HUD_MAP_FLAG_FORMAT "raw"
#define HUD_MAP_FLAG_WIDTH_IN_BYTES 6
#define HUD_MAP_FLAG_WIDTH 12
#define HUD_MAP_FLAG_HEIGHT 22

#define HUD_MAP_FLAG_COUNT 1

#define HUD_MAP_FLAG_0_ADDRESS 0x97D2




#define HUD_CHARACTERS_ADDRESS 0x9858
#define HUD_CHARACTERS_SIZE 384


#define HUD_CHARACTERS_FORMAT "raw"
#define HUD_CHARACTERS_WIDTH_IN_BYTES 6
#define HUD_CHARACTERS_WIDTH 12
#define HUD_CHARACTERS_HEIGHT 21

#define HUD_CHARACTERS_COUNT 3

#define HUD_CHARACTERS_0_ADDRESS 0x9858

#define HUD_CHARACTERS_1_ADDRESS 0x98D8

#define HUD_CHARACTERS_2_ADDRESS 0x9958




#define BIRDIE_HOVER_ADDRESS 0x99D8
#define BIRDIE_HOVER_SIZE 159


#define BIRDIE_HOVER_FORMAT "rlz3"
#define BIRDIE_HOVER_WIDTH_IN_BYTES 5
#define BIRDIE_HOVER_WIDTH 10
#define BIRDIE_HOVER_HEIGHT 14

#define BIRDIE_HOVER_COUNT 2

#define BIRDIE_HOVER_0_ADDRESS 0x99D8

#define BIRDIE_HOVER_1_ADDRESS 0x9A29




#define BIRDIE_KO_ADDRESS 0x9A77
#define BIRDIE_KO_SIZE 86


#define BIRDIE_KO_FORMAT "rlz3"
#define BIRDIE_KO_WIDTH_IN_BYTES 5
#define BIRDIE_KO_WIDTH 10
#define BIRDIE_KO_HEIGHT 14

#define BIRDIE_KO_COUNT 1

#define BIRDIE_KO_0_ADDRESS 0x9A77




#define BIRDIE_HOVERING_ADDRESS 0x9ACD
#define BIRDIE_HOVERING_SIZE 86




#define BIRDIE_HIT_ADDRESS 0x9B23
#define BIRDIE_HIT_SIZE 30




#define BIRDIE_KOING_ADDRESS 0x9B41
#define BIRDIE_KOING_SIZE 9




#define BIRD_HOVER_ADDRESS 0x9B4A
#define BIRD_HOVER_SIZE 258


#define BIRD_HOVER_FORMAT "rlz3"
#define BIRD_HOVER_WIDTH_IN_BYTES 6
#define BIRD_HOVER_WIDTH 12
#define BIRD_HOVER_HEIGHT 23

#define BIRD_HOVER_COUNT 2

#define BIRD_HOVER_0_ADDRESS 0x9B4A

#define BIRD_HOVER_1_ADDRESS 0x9BCF




#define BIRD_EXPELL_ADDRESS 0x9C4C
#define BIRD_EXPELL_SIZE 151


#define BIRD_EXPELL_FORMAT "rlz3"
#define BIRD_EXPELL_WIDTH_IN_BYTES 6
#define BIRD_EXPELL_WIDTH 12
#define BIRD_EXPELL_HEIGHT 25

#define BIRD_EXPELL_COUNT 1

#define BIRD_EXPELL_0_ADDRESS 0x9C4C




#define BIRD_HOVERING_ADDRESS 0x9CE3
#define BIRD_HOVERING_SIZE 86




#define BIRD_EXPELLING_ADDRESS 0x9D39
#define BIRD_EXPELLING_SIZE 30




#define BIRD_KOING_ADDRESS 0x9D57
#define BIRD_KOING_SIZE 9




#define CHICKEN_SHOT_ADDRESS 0x9D60
#define CHICKEN_SHOT_SIZE 51


#define CHICKEN_SHOT_FORMAT "rlz3"
#define CHICKEN_SHOT_WIDTH_IN_BYTES 6
#define CHICKEN_SHOT_WIDTH 12
#define CHICKEN_SHOT_HEIGHT 6

#define CHICKEN_SHOT_COUNT 1

#define CHICKEN_SHOT_0_ADDRESS 0x9D60




#define CHICKEN_WEAK_SHOT_ADDRESS 0x9D93
#define CHICKEN_WEAK_SHOT_SIZE 74


#define CHICKEN_WEAK_SHOT_FORMAT "rlz3"
#define CHICKEN_WEAK_SHOT_WIDTH_IN_BYTES 4
#define CHICKEN_WEAK_SHOT_WIDTH 8
#define CHICKEN_WEAK_SHOT_HEIGHT 15

#define CHICKEN_WEAK_SHOT_COUNT 1

#define CHICKEN_WEAK_SHOT_0_ADDRESS 0x9D93




#define CHICKEN_LANDED_ADDRESS 0x9DDD
#define CHICKEN_LANDED_SIZE 85


#define CHICKEN_LANDED_FORMAT "rlz3"
#define CHICKEN_LANDED_WIDTH_IN_BYTES 4
#define CHICKEN_LANDED_WIDTH 8
#define CHICKEN_LANDED_HEIGHT 14

#define CHICKEN_LANDED_COUNT 1

#define CHICKEN_LANDED_0_ADDRESS 0x9DDD




#define CHICKEN_SHOOTING_ADDRESS 0x9E32
#define CHICKEN_SHOOTING_SIZE 9




#define CHICKEN_SHOOTING_BIG_COLLIDER_ADDRESS 0x9E3B
#define CHICKEN_SHOOTING_BIG_COLLIDER_SIZE 9




#define CHICKEN_SHOOTING_WEAKLY_ADDRESS 0x9E44
#define CHICKEN_SHOOTING_WEAKLY_SIZE 9




#define CHICKEN_LANDING_ADDRESS 0x9E4D
#define CHICKEN_LANDING_SIZE 9




#define CANDY_ADDRESS 0x9E56
#define CANDY_SIZE 243


#define CANDY_FORMAT "rlz3"
#define CANDY_WIDTH_IN_BYTES 4
#define CANDY_WIDTH 8
#define CANDY_HEIGHT 16

#define CANDY_COUNT 4

#define CANDY_0_ADDRESS 0x9E56

#define CANDY_1_ADDRESS 0x9E8C

#define CANDY_2_ADDRESS 0x9ECC

#define CANDY_3_ADDRESS 0x9F09




#define CANDIES_ADDRESS 0x9F49
#define CANDIES_SIZE 30




#define LANDMINE_ADDRESS 0x9F67
#define LANDMINE_SIZE 76


#define LANDMINE_FORMAT "rlz3"
#define LANDMINE_WIDTH_IN_BYTES 4
#define LANDMINE_WIDTH 8
#define LANDMINE_HEIGHT 7

#define LANDMINE_COUNT 2

#define LANDMINE_0_ADDRESS 0x9F67

#define LANDMINE_1_ADDRESS 0x9F8B




#define LANDMINE_BLINKING_ADDRESS 0x9FB3
#define LANDMINE_BLINKING_SIZE 16




#define LANDMINE_EXPLOSION_ADDRESS 0x9FC3
#define LANDMINE_EXPLOSION_SIZE 169


#define LANDMINE_EXPLOSION_FORMAT "rlz3"
#define LANDMINE_EXPLOSION_WIDTH_IN_BYTES 3
#define LANDMINE_EXPLOSION_WIDTH 6
#define LANDMINE_EXPLOSION_HEIGHT 25

#define LANDMINE_EXPLOSION_COUNT 3

#define LANDMINE_EXPLOSION_0_ADDRESS 0x9FC3

#define LANDMINE_EXPLOSION_1_ADDRESS 0xA014

#define LANDMINE_EXPLOSION_2_ADDRESS 0xA049




#define LANDMINE_EXPLODING_ADDRESS 0xA06C
#define LANDMINE_EXPLODING_SIZE 23




#define HIT_SFX_ADDRESS 0xA083
#define HIT_SFX_SIZE 4




#define SPLASH_SFX_ADDRESS 0xA087
#define SPLASH_SFX_SIZE 4




#define SHOT_SFX_ADDRESS 0xA08B
#define SHOT_SFX_SIZE 4




#define BONUS_SFX_ADDRESS 0xA08F
#define BONUS_SFX_SIZE 4




#define EGG_SFX_ADDRESS 0xA093
#define EGG_SFX_SIZE 4




#define SCREAM_SFX_ADDRESS 0xA097
#define SCREAM_SFX_SIZE 4




#define RECHARGE_SFX_ADDRESS 0xA09B
#define RECHARGE_SFX_SIZE 4




#define MAD_SFX_ADDRESS 0xA09F
#define MAD_SFX_SIZE 4




#define KEYPRESS_SFX_ADDRESS 0xA0A3
#define KEYPRESS_SFX_SIZE 4




#define JUMP_SFX_ADDRESS 0xA0A7
#define JUMP_SFX_SIZE 4




#define LAND_SFX_ADDRESS 0xA0AB
#define LAND_SFX_SIZE 4




#define FURY_SFX_ADDRESS 0xA0AF
#define FURY_SFX_SIZE 4




#define SLIDE_SFX_ADDRESS 0xA0B3
#define SLIDE_SFX_SIZE 4




#define SPIKE_SFX_ADDRESS 0xA0B7
#define SPIKE_SFX_SIZE 4




#define SLUG_NERVOUS_SFX_ADDRESS 0xA0BB
#define SLUG_NERVOUS_SFX_SIZE 4




#define SLUG_JUMP_SFX_ADDRESS 0xA0BF
#define SLUG_JUMP_SFX_SIZE 4




#define LANDMINE_BLIP_SFX_ADDRESS 0xA0C3
#define LANDMINE_BLIP_SFX_SIZE 4




#define LANDMINE_EXPLODE_SFX_ADDRESS 0xA0C7
#define LANDMINE_EXPLODE_SFX_SIZE 4




#define BIRDIE_APPEAR_SFX_ADDRESS 0xA0CB
#define BIRDIE_APPEAR_SFX_SIZE 4




#define BIRD_APPEAR_SFX_ADDRESS 0xA0CF
#define BIRD_APPEAR_SFX_SIZE 4




#define PLAYER_DAMAGE_ADDRESS 0xA0D3
#define PLAYER_DAMAGE_SIZE 133


#define PLAYER_DAMAGE_FORMAT "rlz3"
#define PLAYER_DAMAGE_WIDTH_IN_BYTES 7
#define PLAYER_DAMAGE_WIDTH 14
#define PLAYER_DAMAGE_HEIGHT 20

#define PLAYER_DAMAGE_COUNT 1

#define PLAYER_DAMAGE_0_ADDRESS 0xA0D3




#define PLAYER_SHOOT_ADDRESS 0xA158
#define PLAYER_SHOOT_SIZE 152


#define PLAYER_SHOOT_FORMAT "rlz3"
#define PLAYER_SHOOT_WIDTH_IN_BYTES 5
#define PLAYER_SHOOT_WIDTH 10
#define PLAYER_SHOOT_HEIGHT 28

#define PLAYER_SHOOT_COUNT 1

#define PLAYER_SHOOT_0_ADDRESS 0xA158




#define PLAYER_DAMAGED_ADDRESS 0xA1F0
#define PLAYER_DAMAGED_SIZE 9




#define PLAYER_KO_ADDRESS 0xA1F9
#define PLAYER_KO_SIZE 132


#define PLAYER_KO_FORMAT "rlz3"
#define PLAYER_KO_WIDTH_IN_BYTES 7
#define PLAYER_KO_WIDTH 14
#define PLAYER_KO_HEIGHT 19

#define PLAYER_KO_COUNT 1

#define PLAYER_KO_0_ADDRESS 0xA1F9




#define HEART_ADDRESS 0xA27D
#define HEART_SIZE 70


#define HEART_FORMAT "rlz3"
#define HEART_WIDTH_IN_BYTES 4
#define HEART_WIDTH 8
#define HEART_HEIGHT 8

#define HEART_COUNT 2

#define HEART_0_ADDRESS 0xA27D

#define HEART_1_ADDRESS 0xA2A2




#define PLAYER_KOING_ADDRESS 0xA2C3
#define PLAYER_KOING_SIZE 9




#define PLAYER_SHOOTING_ADDRESS 0xA2CC
#define PLAYER_SHOOTING_SIZE 9




#define HEART_BEATING_ADDRESS 0xA2D5
#define HEART_BEATING_SIZE 51




#define ANIMALS_FLOAT_ADDRESS 0xA308
#define ANIMALS_FLOAT_SIZE 365


#define ANIMALS_FLOAT_FORMAT "rlz3"
#define ANIMALS_FLOAT_WIDTH_IN_BYTES 5
#define ANIMALS_FLOAT_WIDTH 10
#define ANIMALS_FLOAT_HEIGHT 18

#define ANIMALS_FLOAT_COUNT 4

#define ANIMALS_FLOAT_0_ADDRESS 0xA308

#define ANIMALS_FLOAT_1_ADDRESS 0xA35E

#define ANIMALS_FLOAT_2_ADDRESS 0xA3B7

#define ANIMALS_FLOAT_3_ADDRESS 0xA413




#define ANIMALS_STAND_ADDRESS 0xA475
#define ANIMALS_STAND_SIZE 393


#define ANIMALS_STAND_FORMAT "rlz3"
#define ANIMALS_STAND_WIDTH_IN_BYTES 5
#define ANIMALS_STAND_WIDTH 10
#define ANIMALS_STAND_HEIGHT 20

#define ANIMALS_STAND_COUNT 4

#define ANIMALS_STAND_0_ADDRESS 0xA475

#define ANIMALS_STAND_1_ADDRESS 0xA4D4

#define ANIMALS_STAND_2_ADDRESS 0xA531

#define ANIMALS_STAND_3_ADDRESS 0xA598




#define ANIMAL_FLOATING_ADDRESS 0xA5FE
#define ANIMAL_FLOATING_SIZE 44




#define ANIMAL_STANDING_ADDRESS 0xA62A
#define ANIMAL_STANDING_SIZE 9




#define RECHARGE_FX_ADDRESS 0xA633
#define RECHARGE_FX_SIZE 105


#define RECHARGE_FX_FORMAT "rlz3"
#define RECHARGE_FX_WIDTH_IN_BYTES 6
#define RECHARGE_FX_WIDTH 12
#define RECHARGE_FX_HEIGHT 4

#define RECHARGE_FX_COUNT 6

#define RECHARGE_FX_0_ADDRESS 0xA633

#define RECHARGE_FX_1_ADDRESS 0xA642

#define RECHARGE_FX_2_ADDRESS 0xA657

#define RECHARGE_FX_3_ADDRESS 0xA671

#define RECHARGE_FX_4_ADDRESS 0xA684

#define RECHARGE_FX_5_ADDRESS 0xA690




#define SHOT_FX_ADDRESS 0xA69C
#define SHOT_FX_SIZE 207


#define SHOT_FX_FORMAT "rlz3"
#define SHOT_FX_WIDTH_IN_BYTES 7
#define SHOT_FX_WIDTH 14
#define SHOT_FX_HEIGHT 12

#define SHOT_FX_COUNT 5

#define SHOT_FX_0_ADDRESS 0xA69C

#define SHOT_FX_1_ADDRESS 0xA6B9

#define SHOT_FX_2_ADDRESS 0xA6EB

#define SHOT_FX_3_ADDRESS 0xA720

#define SHOT_FX_4_ADDRESS 0xA748




#define SHOOTING_FX_ADDRESS 0xA76B
#define SHOOTING_FX_SIZE 37




#define RECHARGING_FX_ADDRESS 0xA790
#define RECHARGING_FX_SIZE 44




#define ALIEN_HOVER_ADDRESS 0xA7BC
#define ALIEN_HOVER_SIZE 536


#define ALIEN_HOVER_FORMAT "rlz3"
#define ALIEN_HOVER_WIDTH_IN_BYTES 6
#define ALIEN_HOVER_WIDTH 12
#define ALIEN_HOVER_HEIGHT 30

#define ALIEN_HOVER_COUNT 3

#define ALIEN_HOVER_0_ADDRESS 0xA7C0

#define ALIEN_HOVER_1_ADDRESS 0xA877

#define ALIEN_HOVER_2_ADDRESS 0xA92D




#define ALIEN_HOVER_LEFT_ADDRESS 0xA9D4
#define ALIEN_HOVER_LEFT_SIZE 523


#define ALIEN_HOVER_LEFT_FORMAT "rlz3"
#define ALIEN_HOVER_LEFT_WIDTH_IN_BYTES 6
#define ALIEN_HOVER_LEFT_WIDTH 12
#define ALIEN_HOVER_LEFT_HEIGHT 30

#define ALIEN_HOVER_LEFT_COUNT 3

#define ALIEN_HOVER_LEFT_0_ADDRESS 0xA9D4

#define ALIEN_HOVER_LEFT_1_ADDRESS 0xAA81

#define ALIEN_HOVER_LEFT_2_ADDRESS 0xAB2F




#define ALIEN_MAD_ADDRESS 0xABDF
#define ALIEN_MAD_SIZE 401


#define ALIEN_MAD_FORMAT "rlz3"
#define ALIEN_MAD_WIDTH_IN_BYTES 7
#define ALIEN_MAD_WIDTH 14
#define ALIEN_MAD_HEIGHT 32

#define ALIEN_MAD_COUNT 2

#define ALIEN_MAD_0_ADDRESS 0xABE3

#define ALIEN_MAD_1_ADDRESS 0xACA3




#define ALIEN_SHOT_ADDRESS 0xAD70
#define ALIEN_SHOT_SIZE 208


#define ALIEN_SHOT_FORMAT "rlz3"
#define ALIEN_SHOT_WIDTH_IN_BYTES 7
#define ALIEN_SHOT_WIDTH 14
#define ALIEN_SHOT_HEIGHT 34

#define ALIEN_SHOT_COUNT 1

#define ALIEN_SHOT_0_ADDRESS 0xAD70




#define ALIEN_RECHARGE_ADDRESS 0xAE40
#define ALIEN_RECHARGE_SIZE 189


#define ALIEN_RECHARGE_FORMAT "rlz3"
#define ALIEN_RECHARGE_WIDTH_IN_BYTES 6
#define ALIEN_RECHARGE_WIDTH 12
#define ALIEN_RECHARGE_HEIGHT 28

#define ALIEN_RECHARGE_COUNT 1

#define ALIEN_RECHARGE_0_ADDRESS 0xAE40




#define ALIEN_KO_ADDRESS 0xAEFD
#define ALIEN_KO_SIZE 110


#define ALIEN_KO_FORMAT "rlz3"
#define ALIEN_KO_WIDTH_IN_BYTES 6
#define ALIEN_KO_WIDTH 12
#define ALIEN_KO_HEIGHT 15

#define ALIEN_KO_COUNT 1

#define ALIEN_KO_0_ADDRESS 0xAEFD




#define UFO_ADDRESS 0xAF6B
#define UFO_SIZE 75


#define UFO_FORMAT "rlz3"
#define UFO_WIDTH_IN_BYTES 6
#define UFO_WIDTH 12
#define UFO_HEIGHT 10

#define UFO_COUNT 1

#define UFO_0_ADDRESS 0xAF6B




#define ALIEN_HOVERING_ADDRESS 0xAFB6
#define ALIEN_HOVERING_SIZE 44




#define ALIEN_PILOTING_ADDRESS 0xAFE2
#define ALIEN_PILOTING_SIZE 9




#define ALIEN_TURNING_ADDRESS 0xAFEB
#define ALIEN_TURNING_SIZE 16




#define ALIEN_HOVERING_LEFT_ADDRESS 0xAFFB
#define ALIEN_HOVERING_LEFT_SIZE 44




#define ALIEN_PILOTING_LEFT_ADDRESS 0xB027
#define ALIEN_PILOTING_LEFT_SIZE 9




#define ALIEN_TURNING_LEFT_ADDRESS 0xB030
#define ALIEN_TURNING_LEFT_SIZE 16




#define ALIEN_MADDING_ADDRESS 0xB040
#define ALIEN_MADDING_SIZE 23




#define ALIEN_SHOOTING_ADDRESS 0xB057
#define ALIEN_SHOOTING_SIZE 23




#define ALIEN_RECHARGING_ADDRESS 0xB06E
#define ALIEN_RECHARGING_SIZE 30




#define ALIEN_KOING_ADDRESS 0xB08C
#define ALIEN_KOING_SIZE 9




#define UFO_LANDED_ADDRESS 0xB095
#define UFO_LANDED_SIZE 9




#define SHORT_WEED_ADDRESS 0xB09E
#define SHORT_WEED_SIZE 55


#define SHORT_WEED_FORMAT "rlz3"
#define SHORT_WEED_WIDTH_IN_BYTES 2
#define SHORT_WEED_WIDTH 4
#define SHORT_WEED_HEIGHT 16

#define SHORT_WEED_COUNT 1

#define SHORT_WEED_0_ADDRESS 0xB09E




#define SHORTER_WEED_ADDRESS 0xB0D5
#define SHORTER_WEED_SIZE 26


#define SHORTER_WEED_FORMAT "rlz3"
#define SHORTER_WEED_WIDTH_IN_BYTES 2
#define SHORTER_WEED_WIDTH 4
#define SHORTER_WEED_HEIGHT 8

#define SHORTER_WEED_COUNT 1

#define SHORTER_WEED_0_ADDRESS 0xB0D5




#define ORNAMENT_A_ADDRESS 0xB0EF
#define ORNAMENT_A_SIZE 9




#define ORNAMENT_B_ADDRESS 0xB0F8
#define ORNAMENT_B_SIZE 9




#define RAILING_ADDRESS 0xB101
#define RAILING_SIZE 57


#define RAILING_FORMAT "rlz3"
#define RAILING_WIDTH_IN_BYTES 5
#define RAILING_WIDTH 10
#define RAILING_HEIGHT 7

#define RAILING_COUNT 1

#define RAILING_0_ADDRESS 0xB101




#define PLATFORM_BOX_ADDRESS 0xB13A
#define PLATFORM_BOX_SIZE 28


#define PLATFORM_BOX_FORMAT "rlz3"
#define PLATFORM_BOX_WIDTH_IN_BYTES 3
#define PLATFORM_BOX_WIDTH 6
#define PLATFORM_BOX_HEIGHT 6

#define PLATFORM_BOX_COUNT 1

#define PLATFORM_BOX_0_ADDRESS 0xB13A




#define PLATFORM_ORNAMENT_A_ADDRESS 0xB156
#define PLATFORM_ORNAMENT_A_SIZE 9




#define PLATFORM_ORNAMENT_B_ADDRESS 0xB15F
#define PLATFORM_ORNAMENT_B_SIZE 9




#define MINEFIELD_SIGN_ADDRESS 0xB168
#define MINEFIELD_SIGN_SIZE 117


#define MINEFIELD_SIGN_FORMAT "rlz3"
#define MINEFIELD_SIGN_WIDTH_IN_BYTES 6
#define MINEFIELD_SIGN_WIDTH 12
#define MINEFIELD_SIGN_HEIGHT 20

#define MINEFIELD_SIGN_COUNT 1

#define MINEFIELD_SIGN_0_ADDRESS 0xB168




#define MINEFIELD_SIGN_IDLE_ADDRESS 0xB1DD
#define MINEFIELD_SIGN_IDLE_SIZE 9




#define SPIKES_ADDRESS 0xB1E6
#define SPIKES_SIZE 147


#define SPIKES_FORMAT "rlz3"
#define SPIKES_WIDTH_IN_BYTES 6
#define SPIKES_WIDTH 12
#define SPIKES_HEIGHT 17

#define SPIKES_COUNT 2

#define SPIKES_0_ADDRESS 0xB1E6

#define SPIKES_1_ADDRESS 0xB1FD




#define SPIKES_WAITING_ADDRESS 0xB279
#define SPIKES_WAITING_SIZE 9




#define SPIKES_WORKING_ADDRESS 0xB282
#define SPIKES_WORKING_SIZE 9




#define LEVELS_ADDRESS 0xB28B
#define LEVELS_SIZE 2662



extern const u8 game_b_assets[8196];

void game_b_uncompress();





#define FONT_0_INDEX 0


#define FONT_1_INDEX 1


#define FONT_2_INDEX 2


#define FONT_3_INDEX 3


#define FONT_4_INDEX 4


#define FONT_5_INDEX 5


#define FONT_6_INDEX 6


#define FONT_7_INDEX 7


#define FONT_8_INDEX 8


#define FONT_9_INDEX 9


#define FONT_10_INDEX 10


#define FONT_11_INDEX 11


#define FONT_12_INDEX 12


#define FONT_13_INDEX 13


#define FONT_14_INDEX 14


#define FONT_15_INDEX 15


#define FONT_16_INDEX 16


#define FONT_17_INDEX 17


#define FONT_18_INDEX 18


#define FONT_19_INDEX 19


#define FONT_20_INDEX 20


#define FONT_21_INDEX 21


#define FONT_22_INDEX 22


#define FONT_23_INDEX 23


#define FONT_24_INDEX 24


#define FONT_25_INDEX 25


#define FONT_26_INDEX 26


#define FONT_27_INDEX 27


#define FONT_28_INDEX 28


#define FONT_29_INDEX 29


#define FONT_30_INDEX 30


#define FONT_31_INDEX 31


#define FONT_32_INDEX 32


#define FONT_33_INDEX 33


#define FONT_34_INDEX 34


#define FONT_35_INDEX 35


#define FONT_36_INDEX 36


#define FONT_37_INDEX 37


#define FONT_38_INDEX 38


#define FONT_39_INDEX 39


#define FONT_40_INDEX 40


#define FONT_41_INDEX 41


#define FONT_42_INDEX 42


#define FONT_43_INDEX 43


#define FONT_44_INDEX 44

extern const u8* game_indices[45];




#define MENU_BACKGROUNDS_0_INDEX 0


#define MENU_BACKGROUNDS_1_INDEX 1


#define MENU_BACKGROUNDS_2_INDEX 2


#define MENU_BACKGROUNDS_3_INDEX 3


#define MENU_BACKGROUNDS_4_INDEX 4


#define PLANETS_0_INDEX 5


#define PLANETS_1_INDEX 6


#define PLANETS_2_INDEX 7


#define PLANETS_3_INDEX 8


#define PLANETS_4_INDEX 9


#define PLANETS_5_INDEX 10


#define PLANETS_6_INDEX 11


#define PLANETS_7_INDEX 12


#define PLANETS_8_INDEX 13


#define PLANETS_9_INDEX 14


#define PLANETS_10_INDEX 15


#define PLANETS_11_INDEX 16


#define PLANETS_12_INDEX 17


#define PLANETS_13_INDEX 18


#define PLANETS_14_INDEX 19


#define PLANETS_15_INDEX 20


#define PLANETS_16_INDEX 21


#define PLANETS_17_INDEX 22


#define PLANETS_18_INDEX 23


#define PLANETS_19_INDEX 24


#define PLANETS_20_INDEX 25


#define PLANETS_21_INDEX 26


#define PLANETS_22_INDEX 27


#define PLANETS_23_INDEX 28


#define PLANETS_24_INDEX 29


#define PLANETS_25_INDEX 30


#define PLANETS_26_INDEX 31


#define PLATFORMS_0_INDEX 32


#define PLATFORMS_1_INDEX 33


#define PLATFORMS_2_INDEX 34


#define PLATFORMS_3_INDEX 35


#define PLATFORMS_4_INDEX 36


#define PLATFORMS_5_INDEX 37


#define PLATFORMS_6_INDEX 38


#define PLATFORMS_7_INDEX 39


#define PLATFORMS_8_INDEX 40


#define PLATFORMS_9_INDEX 41


#define PLATFORMS_10_INDEX 42


#define STARS_0_INDEX 43


#define STARS_1_INDEX 44


#define STARS_2_INDEX 45


#define STARS_3_INDEX 46


#define BUSH_0_INDEX 47


#define BUSH_1_INDEX 48


#define BUSH_2_INDEX 49


#define BUSH_3_INDEX 50


#define BUSH_4_INDEX 51


#define BUSH_5_INDEX 52


#define BUSH_6_INDEX 53


#define BUSH_7_INDEX 54


#define BUSH_8_INDEX 55


#define BUSH_9_INDEX 56


#define BUSH_10_INDEX 57


#define BUSH_11_INDEX 58


#define MEDIUM_WEED_0_INDEX 59


#define MEDIUM_WEED_1_INDEX 60


#define MEDIUM_WEED_2_INDEX 61


#define MEDIUM_WEED_3_INDEX 62


#define HIGH_WEED_0_INDEX 63


#define HIGH_WEED_1_INDEX 64


#define HIGH_WEED_2_INDEX 65


#define HIGH_WEED_3_INDEX 66


#define HIGH_WEED_4_INDEX 67


#define HIGH_WEED_5_INDEX 68

extern const u16* game_tilesetIndices[69];


#include "level.h"

#define LEVEL_COUNT 3
extern const Level game_levels[3];

#endif // _GAME_ASSETS_H_
