;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

; typedef struct {
;   u8 backgroundColor;
;   u8 bottomColor;
;   u16 backgroundInks;
;   u16 texture;
;   char* name;
;   u8 waterColor;
;   u8 terrainStart;
;   u8* terrain;
;   u8* entities;
;   u8* platforms;
;   u8* water;
;   u8* checkpoints;
; } Level;

.macro LEVEL top, bottom, inks, texture
  .db top
  .db bottom
  .dw 'inks'_ADDRESS
  .dw 'texture'_ADDRESS
.endm

.equ LEVEL_BACKGROUND_COLOR, 0
.equ LEVEL_BOTTOM_COLOR, 1
.equ LEVEL_BACKGROUND_INKS, 2
.equ LEVEL_BACKGROUND_INKS_LO, 2
.equ LEVEL_BACKGROUND_INKS_HI, 3
.equ LEVEL_TEXTURE, 4
.equ LEVEL_TEXTURE_LO, 4
.equ LEVEL_TEXTURE_HI, 5
.equ LEVEL_NAME, 6
.equ LEVEL_NAME_LO, 6
.equ LEVEL_NAME_HI, 7
.equ LEVEL_HUD_ANIMAL, 8
.equ LEVEL_HUD_ANIMAL_LO, 8
.equ LEVEL_HUD_ANIMAL_HI, 9
.equ LEVEL_STANDING_ANIMAL, 10
.equ LEVEL_STANDING_ANIMAL_LO, 10
.equ LEVEL_STANDING_ANIMAL_HI, 11
.equ LEVEL_FLOATING_ANIMAL, 12
.equ LEVEL_FLOATING_ANIMAL_LO, 12
.equ LEVEL_FLOATING_ANIMAL_HI, 13
.equ LEVEL_WATER_COLOR, 14
.equ LEVEL_TERRAIN_START, 15
.equ LEVEL_TERRAIN, 16
.equ LEVEL_TERRAIN_LO, 16
.equ LEVEL_TERRAIN_HI, 17
.equ LEVEL_ENTITIES, 18
.equ LEVEL_ENTITIES_LO, 18
.equ LEVEL_ENTITIES_HI, 19
.equ LEVEL_PLATFORMS, 20
.equ LEVEL_PLATFORMS_LO, 20
.equ LEVEL_PLATFORMS_HI, 21
.equ LEVEL_WATER, 22
.equ LEVEL_WATER_LO, 22
.equ LEVEL_WATER_HI, 23
.equ LEVEL_CHECKPOINTS, 24
.equ LEVEL_CHECKPOINTS_LO, 24
.equ LEVEL_CHECKPOINTS_HI, 25
.equ LEVEL_ENDING, 26
.equ LEVEL_ENDING_LO, 26
.equ LEVEL_ENDING_HI, 27
.equ LEVEL_ALIEN_POSITION, 28
.equ LEVEL_ALIEN_VELOCITY, 29
.equ LEVEL_ALIEN_BEHAVIOR, 30
.equ LEVEL_ALIEN_BEHAVIOR_LO, 30
.equ LEVEL_ALIEN_BEHAVIOR_HI, 31
.equ LEVEL_SIZE, 32
