;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/entities.h.s"
.include "systems/alien.h.s"
.include "systems/ai.h.s"
.include "data/game_assets.h.s"

.module game

.equ BIRD_Y, 26

_bird_def::
  FACTORY_DEF COMPONENT_STATIC, BIRD_HOVERING, bird
_egg_def::
  FACTORY_DEF COMPONENT_ALL, EGG_FALLING, egg

; IN:
;   DE <- x
_bird_create::
  RETURN_IF_ALIEN_IN_SCREEN

  ld b, #BIRD_Y
  ld hl, #_bird_def
  call _entities_create_asm

  set COLLIDABLE_ENEMY_BIT, ENTITY_COLLIDABLE_TYPE (ix)
  ret

_bird_behavior::
  PLAY_SFX BIRD_APPEAR
bird_restart:
  ; SET_ANIMATION BIRD_HOVERING
  RANDOM_WAIT 10, #0x1f, bird_expel
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITION furyCollision, bird_ko
    CONDITIONS_END
bird_expel:
  CREATE egg
  SET_ANIMATION BIRD_EXPELLING
  WAIT 10, bird_wait
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITION furyCollision, bird_ko
    CONDITIONS_END
bird_wait:
  SET_ANIMATION BIRD_HOVERING
  WAIT 40, bird_restart
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITION furyCollision, bird_ko
    CONDITIONS_END
bird_ko:
  SET_ANIMATION BIRD_KOING
  RESET_ENEMY
  SET_VX #0x0181
  SET_BULLET

_egg_create::
  ld hl, #_egg_def
  call _entities_create_asm

  set COLLIDABLE_ENEMY_BIT, ENTITY_COLLIDABLE_TYPE (ix)
  set BODY_HAS_GRAVITY_BIT, ENTITY_BODY_FLAGS (ix)
  ret

_egg_behavior::
  ; SET_ANIMATION EGG_FALLING
  IDLE
    CONDITION onFloor, egg_stand
    CONDITION inWater, egg_stand
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
egg_stand:
  SET_ANIMATION EGG_STANDING
  SET_STATIC
  PLAY_SFX EGG
  IDLE
    CONDITION notInScreen, DESTROY_ENTITY
    ; CONDITION enemyCollision, DESTROY_ENTITY
    ;               ; destroy entity if another egg falls over this one
    CONDITIONS_END
