;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "systems/terrain.h.s"
.include "systems/platform.h.s"
.include "systems/alien.h.s"
.include "data/game_assets.h.s"
.include "lang/macros.h.s"

.module game

.equ BIRDIE_HEIGHT, 16
.equ BIRDIE_KO_VX, #0x0060
.equ BIRDIE_KO_VY, #-6

_birdieTerrain_def::
  FACTORY_DEF COMPONENT_STATIC, BIRDIE_HOVERING, birdie

; IN:
;   DE <- x
_birdieTerrain_create::
  ld ix, #_terrain_getHeight
  jr birdie_create

_birdiePlatform_create::
  ld ix, #_platform_getHeight
  ; jr birdie_create

birdie_create::
  RETURN_IF_ALIEN_IN_SCREEN

  ld l, e
  ld h, d         ; HL <- xInBytes 
  call call_ix
  ld a, l         ; A <- y = terrainOrPlatform
  sub #BIRDIE_HEIGHT
  ld b, a         ; B <- y = terrainOrPlatform - 16

  ld hl, #_birdieTerrain_def
  call _entities_create_asm

  set COLLIDABLE_ENEMY_BIT, ENTITY_COLLIDABLE_TYPE (ix)
  ret

call_ix:
  jp (ix)

_birdie_behavior::
  PLAY_SFX BIRDIE_APPEAR
birdie_hover:
  SET_ANIMATION BIRDIE_HOVERING
  IDLE
    CONDITION furyCollision, birdie_ko
    CONDITION playerCollision, birdie_hit
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
birdie_hit:
  SET_ANIMATION BIRDIE_HIT
  WAIT 10, birdie_hover
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
birdie_ko:
  SET_ANIMATION BIRDIE_KOING
  RESET_ENEMY
  SET_VX BIRDIE_KO_VX
  SET_VY BIRDIE_KO_VY
  SET_BULLET
