;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/player.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "data/game_assets.h.s"
.include "lang/macros.h.s"
.include "lang/math.h.s"

.module game

_candy_def::
  FACTORY_DEF COMPONENT_STATIC, CANDIES, candy

_candy_counter::
  .db #0

; IN:
;   DE <- x
;   B <- y
_candy_create::
  ld hl, #_candy_def
  call _entities_create_asm

  ld ENTITY_COLLIDABLE_TYPE (ix), #COLLIDABLE_GOODIE
  set DRAWING_OPAQUE_BIT, ENTITY_DRAWING_FLAGS (ix)

_candy_set_animation::
  ; index = (candy_counter++) & 0x03
  ld hl, #_candy_counter
  ld a, (hl)
  and #0x03       ; A <- candy_counter % 4
  inc (hl)

  ; candy->animation.step += index
  ld b, a
  MATH_MULT_B STEP_SIZE
  ld l, ENTITY_ANIMATION_STEP_LO (ix)
  ld h, ENTITY_ANIMATION_STEP_HI (ix)
  add_hl_a
  ld ENTITY_ANIMATION_STEP_LO (ix), l
  ld ENTITY_ANIMATION_STEP_HI (ix), h

  ; candy->drawing.sprite = candy->animation.step->sprite
  ; -> Hack to prevent candy being redrawn the first time because
  ; of sprite changing.
  ex de, hl
  ld__iyl_e
  ld__iyh_d
  ld a, STEP_SPRITE_LO (iy)
  ld ENTITY_DRAWING_SPRITE_LO (ix), a
  ld a, STEP_SPRITE_HI (iy)
  ld ENTITY_DRAWING_SPRITE_HI (ix), a

  ret

_candy_behavior::
  ; SET_ANIMATION CANDIES
  IDLE
    CONDITION playerCollision, candy_add_mojo
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
candy_add_mojo:
  CALL_0 _player_addMojo
  PLAY_SFX BONUS
  CLEAR_ENTITY
