/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#ifndef _ENTITY_H_
#define _ENTITY_H_

#include "../components/position.h"
#include "../components/body.h"
#include "../components/drawing.h"
#include "../components/animation.h"
#include "../components/collidable.h"
#include "../components/behavior.h"
#include "../components/timer.h"

#define COMPONENT_BODY        0x01
#define COMPONENT_DRAWING     0x02
#define COMPONENT_ANIMATION   0x04
#define COMPONENT_COLLIDABLE  0x08

#define COMPONENT_ALL         0x0f
#define COMPONENT_STATIC      (COMPONENT_DRAWING | COMPONENT_ANIMATION | COMPONENT_COLLIDABLE)

typedef struct {
  u8 components;
  Behavior behavior;
  Position position;
  Animation animation;
  Timer timer;
  Body body;
  Collidable collidable;
  Drawing drawing;
} Entity;

#endif // _ENTITY_H_
