;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "components/behavior.h.s"
.include "components/position.h.s"
.include "components/animation.h.s"
.include "components/timer.h.s"
.include "components/body.h.s"
.include "components/collidable.h.s"
.include "components/drawing.h.s"

; typedef struct {
;   u8 components;
;   Behavior behavior;
;   Position position;
;   Animation animation;
;   Timer timer;
;   Body body;
;   Collidable collidable;
;   Drawing drawing;
; }

.equ COMPONENT_BODY,        #0x01
.equ COMPONENT_DRAWING,     #0x02
.equ COMPONENT_ANIMATION,   #0x04
.equ COMPONENT_COLLIDABLE,  #0x08

.equ COMPONENT_BODY_BIT,        0
.equ COMPONENT_DRAWING_BIT,     1
.equ COMPONENT_ANIMATION_BIT,   2
.equ COMPONENT_COLLIDABLE_BIT,  3

.equ COMPONENT_ALL, #0x0f
.equ COMPONENT_STATIC, (COMPONENT_DRAWING | COMPONENT_ANIMATION | COMPONENT_COLLIDABLE)


.equ ENTITY_COMPONENTS, 0

.equ ENTITY_BEHAVIOR, 1
.equ ENTITY_BEHAVIOR_ACTION_LO, ENTITY_BEHAVIOR + BEHAVIOR_ACTION_LO
.equ ENTITY_BEHAVIOR_ACTION_HI, ENTITY_BEHAVIOR + BEHAVIOR_ACTION_HI

.equ ENTITY_POSITION, ENTITY_BEHAVIOR + BEHAVIOR_SIZE
.equ ENTITY_POSITION_X_LO, ENTITY_POSITION + POSITION_X_LO
.equ ENTITY_POSITION_X_HI, ENTITY_POSITION + POSITION_X_HI
.equ ENTITY_POSITION_Y, ENTITY_POSITION + POSITION_Y

.equ ENTITY_ANIMATION, ENTITY_POSITION + POSITION_SIZE
.equ ENTITY_ANIMATION_FIRST_LO, ENTITY_ANIMATION + ANIMATION_FIRST_LO
.equ ENTITY_ANIMATION_FIRST_HI, ENTITY_ANIMATION + ANIMATION_FIRST_HI
.equ ENTITY_ANIMATION_STEP_LO, ENTITY_ANIMATION + ANIMATION_STEP_LO
.equ ENTITY_ANIMATION_STEP_HI, ENTITY_ANIMATION + ANIMATION_STEP_HI
.equ ENTITY_ANIMATION_COUNTER, ENTITY_ANIMATION + ANIMATION_COUNTER

.equ ENTITY_TIMER, ENTITY_ANIMATION + ANIMATION_SIZE
.equ ENTITY_TIMER_VALUE, ENTITY_TIMER + TIMER_VALUE

.equ ENTITY_BODY, ENTITY_TIMER + TIMER_SIZE
.equ ENTITY_BODY_IX, ENTITY_BODY + BODY_IX
.equ ENTITY_BODY_IX_LO, ENTITY_BODY + BODY_IX_LO
.equ ENTITY_BODY_IX_HI, ENTITY_BODY + BODY_IX_HI
.equ ENTITY_BODY_FX, ENTITY_BODY + BODY_FX
.equ ENTITY_BODY_FX_LO, ENTITY_BODY + BODY_FX_LO
.equ ENTITY_BODY_FX_HI, ENTITY_BODY + BODY_FX_HI
.equ ENTITY_BODY_VX, ENTITY_BODY + BODY_VX
.equ ENTITY_BODY_VX_LO, ENTITY_BODY + BODY_VX_LO
.equ ENTITY_BODY_VX_HI, ENTITY_BODY + BODY_VX_HI
.equ ENTITY_BODY_VY, ENTITY_BODY + BODY_VY
.equ ENTITY_BODY_FLAGS, ENTITY_BODY + BODY_FLAGS

.equ ENTITY_COLLIDABLE, ENTITY_BODY + BODY_SIZE
.equ ENTITY_COLLIDABLE_BOUNDS, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS
.equ ENTITY_COLLIDABLE_BOUNDS_LEFT, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_LEFT
.equ ENTITY_COLLIDABLE_BOUNDS_LEFT_LO, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_LEFT_LO
.equ ENTITY_COLLIDABLE_BOUNDS_LEFT_HI, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_LEFT_HI
.equ ENTITY_COLLIDABLE_BOUNDS_RIGHT, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_RIGHT
.equ ENTITY_COLLIDABLE_BOUNDS_RIGHT_LO, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_RIGHT_LO
.equ ENTITY_COLLIDABLE_BOUNDS_RIGHT_HI, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_RIGHT_HI
.equ ENTITY_COLLIDABLE_BOUNDS_TOP, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_TOP
.equ ENTITY_COLLIDABLE_BOUNDS_BOTTOM, ENTITY_COLLIDABLE + COLLIDABLE_BOUNDS_BOTTOM
.equ ENTITY_COLLIDABLE_TYPE, ENTITY_COLLIDABLE + COLLIDABLE_TYPE
.equ ENTITY_COLLIDABLE_STATUS, ENTITY_COLLIDABLE + COLLIDABLE_STATUS

.equ ENTITY_DRAWING, ENTITY_COLLIDABLE + COLLIDABLE_SIZE
.equ ENTITY_DRAWING_LEFT, ENTITY_DRAWING + DRAWING_LEFT
.equ ENTITY_DRAWING_LEFT_LO, ENTITY_DRAWING + DRAWING_LEFT_LO
.equ ENTITY_DRAWING_LEFT_HI, ENTITY_DRAWING + DRAWING_LEFT_HI
.equ ENTITY_DRAWING_TOP, ENTITY_DRAWING + DRAWING_TOP
.equ ENTITY_DRAWING_SCREEN, ENTITY_DRAWING + DRAWING_SCREEN
.equ ENTITY_DRAWING_SCREEN_LO, ENTITY_DRAWING + DRAWING_SCREEN_LO
.equ ENTITY_DRAWING_SCREEN_HI, ENTITY_DRAWING + DRAWING_SCREEN_HI
.equ ENTITY_DRAWING_BOUNDS, ENTITY_DRAWING + DRAWING_BOUNDS
.equ ENTITY_DRAWING_BOUNDS_LEFT, ENTITY_DRAWING + DRAWING_BOUNDS_LEFT
.equ ENTITY_DRAWING_BOUNDS_LEFT_LO, ENTITY_DRAWING + DRAWING_BOUNDS_LEFT_LO
.equ ENTITY_DRAWING_BOUNDS_LEFT_HI, ENTITY_DRAWING + DRAWING_BOUNDS_LEFT_HI
.equ ENTITY_DRAWING_BOUNDS_RIGHT, ENTITY_DRAWING + DRAWING_BOUNDS_RIGHT
.equ ENTITY_DRAWING_BOUNDS_RIGHT_LO, ENTITY_DRAWING + DRAWING_BOUNDS_RIGHT_LO
.equ ENTITY_DRAWING_BOUNDS_RIGHT_HI, ENTITY_DRAWING + DRAWING_BOUNDS_RIGHT_HI
.equ ENTITY_DRAWING_BOUNDS_TOP, ENTITY_DRAWING + DRAWING_BOUNDS_TOP
.equ ENTITY_DRAWING_BOUNDS_BOTTOM, ENTITY_DRAWING + DRAWING_BOUNDS_BOTTOM
.equ ENTITY_DRAWING_SPRITE, ENTITY_DRAWING + DRAWING_SPRITE
.equ ENTITY_DRAWING_SPRITE_LO, ENTITY_DRAWING + DRAWING_SPRITE_LO
.equ ENTITY_DRAWING_SPRITE_HI, ENTITY_DRAWING + DRAWING_SPRITE_HI
.equ ENTITY_DRAWING_STRING, ENTITY_DRAWING + DRAWING_STRING
.equ ENTITY_DRAWING_STRING_LO, ENTITY_DRAWING + DRAWING_STRING_LO
.equ ENTITY_DRAWING_STRING_HI, ENTITY_DRAWING + DRAWING_STRING_HI
.equ ENTITY_DRAWING_FLAGS, ENTITY_DRAWING + DRAWING_FLAGS

.equ ENTITY_SIZE, ENTITY_DRAWING + DRAWING_SIZE
