;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "factories.h.s"
.include "lang/macros.h.s"
.include "lang/debug.h.s"

.module factories

_factories::
  .dw _candy_create
  .dw _landmine_create
  .dw _birdieTerrain_create
  .dw _birdiePlatform_create
  .dw _bird_create
  .dw _slug_create
  .dw _terrainOrnament_create
  .dw _platformOrnament_create
  .dw _minefieldSign_create
  .dw _spikes_create
  .dw _animal_create
  .dw #0
  .dw #0
  .dw #0
  .dw #0
  .dw #0

; IN:
;   DE <- xInBytes
;   B <- Y
;   C <- type
; DESTROYS:
;   potencially all?
_factories_create_asm::
  ld a, c
  add a         ; A *= 2
  ld hl, #_factories
  add_hl_a      ; HL <- factory pointer address

  ld a, (hl)
  inc hl
  ld h, (hl)
  ld l, a       ; HL <- factory address

                ; B <- y
                ; DE <- xInBytes
  jp (hl)
