;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "systems/terrain.h.s"
.include "data/game_assets.h.s"
.include "lang/macros.h.s"

.module game

_minefieldSign_def::
  FACTORY_DEF COMPONENT_STATIC, MINEFIELD_SIGN_IDLE, static

; IN:
;   DE <- x
_minefieldSign_create::
  ld l, e
  ld h, d         ; HL <- xInBytes 
  ; dec hl
  ; dec hl
  ; dec hl          ; HL <- xInBytes - 3
  call _terrain_getHeight
  ld b, l         ; B <- y = terrain

  ld hl, #_minefieldSign_def
  call _entities_create_asm

  set DRAWING_OPAQUE_BIT, ENTITY_DRAWING_FLAGS (ix)
  ret
