;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/player.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "data/game_assets.h.s"
.include "lang/macros.h.s"
.include "lang/math.h.s"

.module game

.globl cpct_getRandom_mxor_u8_asm
.globl _candy_set_animation

_mojo_def::
  FACTORY_DEF COMPONENT_ALL, CANDIES, mojo

; IN:
;   DE <- x
;   B <- y
_mojo_create::
  ld hl, #_mojo_def
  ld a, b
  sub #10
  ld b, a       ; y = y - 10
  call _entities_create_asm

  call cpct_getRandom_mxor_u8_asm

  ; i8 vy = (random_get() & 0x03) - 12;
  ld a, l
  and #0x03
  sub #12
  ld ENTITY_BODY_VY (ix), a

  ; i8 vx = ((random_get() & 0x0f) - 1) << 5;
  ld a, l
  rra
  rra
  rra
  and #0x0f
  dec a

  rla
  rla
  rla
  rla
  rla
  ld b, a
  ld a, #0
  adc #0
  ld ENTITY_BODY_VX_HI (ix), a
  ld a, b
  and #0xf0
  ld ENTITY_BODY_VX_LO (ix), a

  ld a, ENTITY_BODY_FLAGS (ix)
  or #(BODY_HAS_GRAVITY | BODY_HAS_BOUNCE)
  ld ENTITY_BODY_FLAGS (ix), a

  jp _candy_set_animation

_mojo_behavior::
  WAIT 15, _clear_behavior
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
