;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "systems/terrain.h.s"
.include "systems/platform.h.s"
.include "data/game_assets.h.s"
.include "lang/macros.h.s"
.include "lang/math.h.s"

.module game

_ornament_def::
  FACTORY_DEF COMPONENT_STATIC, ORNAMENT_A, static
  FACTORY_DEF COMPONENT_STATIC, ORNAMENT_B, static
  FACTORY_DEF COMPONENT_STATIC, PLATFORM_ORNAMENT_A, static
  FACTORY_DEF COMPONENT_STATIC, PLATFORM_ORNAMENT_B, static

_ornament_counter::
  .db #0

; IN:
;   DE <- x
_terrainOrnament_create::
  ld ix, #_terrain_getHeight
  ld a, #0x00
  jr ornament_create

_platformOrnament_create::
  ld ix, #_platform_getHeight
  ld a, #0x02
  ; jr ornament_create

ornament_create:
  ld (#index_displacement), a

  ld l, e
  ld h, d         ; HL <- xInBytes 
  call call_ix
  ld b, l         ; B <- y

  ld hl, #_ornament_counter
  inc (hl)        ; ornament_counter++
  ld a, #1
  and (hl)        ; A <- ornament_counter & 0x01
.equ index_displacement, . + 1
  add #0
  ld c, a
  MATH_MULT_C FACTORY_DEF_SIZE
  ld hl, #_ornament_def
  add_hl_a        ; HL <- ornament def

  call _entities_create_asm

  set DRAWING_OPAQUE_BIT, ENTITY_DRAWING_FLAGS (ix)
  ret

call_ix:
  jp (ix)
