;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/menu.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "cpc/controls.h.s"
.include "data/game_assets.h.s"

.module menu

_redefine_def::
  FACTORY_DEF COMPONENT_ALL, MENU_LEFT, redefine

; IN:
;   DE <- x
_redefine_create::
  ld hl, #_redefine_def
  ld b, #MENU_PLAY_Y + 8
  call _entities_create_asm
  jp _menu_addTextEntity

_redefine_behavior::
  ; SET_ANIMATION MENU_LEFT
  CALL_0 _controls_reset
  NEXT_STEP
  IDLE
    CONDITION getUnusedControl, redefine_set_left
    CONDITIONS_END
redefine_set_left:
  SET_CONTROL CONTROLS_P1_LEFT
  PLAY_SFX KEYPRESS
  SET_ANIMATION MENU_RIGHT
  IDLE
    CONDITION getUnusedControl, redefine_set_right
    CONDITIONS_END
redefine_set_right:
  SET_CONTROL CONTROLS_P1_RIGHT
  PLAY_SFX KEYPRESS
  SET_ANIMATION MENU_JUMP
  IDLE
    CONDITION getUnusedControl, redefine_set_jump
    CONDITIONS_END
redefine_set_jump:
  SET_CONTROL CONTROLS_P1_UP
  PLAY_SFX KEYPRESS
  SET_ANIMATION MENU_SLIDE
  IDLE
    CONDITION getUnusedControl, redefine_set_slide
    CONDITIONS_END
redefine_set_slide:
  SET_CONTROL CONTROLS_P1_DOWN
  PLAY_SFX KEYPRESS
  SET_ANIMATION MENU_ACTION
  IDLE
    CONDITION getUnusedControl, redefine_set_action
    CONDITIONS_END
redefine_set_action:
  SET_CONTROL CONTROLS_P1_ACTION
  PLAY_SFX KEYPRESS
  SET_ANIMATION MENU_EXIT
  IDLE
    CONDITION getUnusedControl, redefine_set_exit
    CONDITIONS_END
redefine_set_exit:
  SET_CONTROL CONTROLS_P1_EXIT
  PLAY_SFX KEYPRESS
back_to_menu:
  create menu
  CLEAR_ENTITY
