;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "systems/terrain.h.s"
.include "systems/alien.h.s"
.include "data/game_assets.h.s"
.include "lang/macros.h.s"

.module game

_slug_def::
  FACTORY_DEF COMPONENT_STATIC, SLUG_WAITING, slug

; IN:
;   DE <- x
_slug_create::
  RETURN_IF_ALIEN_IN_SCREEN

  ld l, e
  ld h, d         ; HL <- xInBytes 
  call _terrain_getHeight
  ld b, l         ; B <- y = terrain
  inc b
  inc b           ; B <- y = terrain + 2

  ld hl, #_slug_def
  call _entities_create_asm

  set BODY_IGNORE_COLLISIONS_BIT, ENTITY_BODY_FLAGS (ix)
  set COLLIDABLE_ENEMY_BIT, ENTITY_COLLIDABLE_TYPE (ix)
  ret

slug_restart:
  SET_ANIMATION SLUG_WAITING
_slug_behavior::
  IDLE
    CONDITION nearPlayer, slug_get_nervious
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
slug_get_nervious:
  SET_ANIMATION SLUG_NERVIOUS
  PLAY_SFX SLUG_NERVOUS
  IDLE
    CONDITION furyCollision, slug_ko
    CONDITION nearestToPlayer, slug_prepare_jump
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
slug_prepare_jump:
  SET_ANIMATION SLUG_JUMPING
  WAIT 8, slug_jump
    CONDITION furyCollision, slug_ko
    CONDITION notInScreen, DESTROY_ENTITY
    ; CONDITION playerCollision, slug_*
    CONDITIONS_END
slug_jump:
  RESET_STATIC
  ADD_GRAVITY
  PLAY_SFX SLUG_JUMP
  SET_VY -8
  WAIT 16, slug_landing
    CONDITION furyCollision, slug_ko
    CONDITION notInScreen, DESTROY_ENTITY
    ; CONDITION playerCollision, slug_*
    CONDITIONS_END
slug_landing:
  REMOVE_GRAVITY
  SET_STATIC
  SET_VY 0
  WAIT 4, slug_restart
    CONDITION notInScreen, DESTROY_ENTITY
    CONDITIONS_END
slug_ko:
  SET_ANIMATION SLUG_WAITING
  RESET_ENEMY
  SET_VX #0x0040
  SET_VY #-8
  SET_BULLET
