;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/menu.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "data/game_assets.h.s"

.module menu

_submenu_def::
  FACTORY_DEF COMPONENT_ALL, MENU_REDEFINE, submenu

; IN:
;   DE <- x
_submenu_create::
  ld hl, #_submenu_def
  ld b, #MENU_REDEFINE_Y
  call _entities_create_asm
  jp _menu_addTextEntity

_submenu_behavior::
  WAIT MENU_CREDITS_TIME, _clear_behavior
    CONDITION playPressed, submenu_idle
    CONDITION redefinePressed, submenu_wait
    CONDITIONS_END
submenu_wait:
  PLAY_SFX KEYPRESS
  IDLE
    CONDITION notAnyKeyPressed, _clear_behavior
    CONDITIONS_END
submenu_idle:
  IDLE
    CONDITIONS_END
