;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entity.h.s"
.include "factories.h.s"
.include "systems/entities.h.s"
.include "systems/ai.h.s"
.include "stages/game.h.s"
.include "data/game_assets.h.s"
.include "data/songs.h.s"

.module success

.equ SUCCESS_BRAKING_VX, #0x0080
.equ SUCCESS_VX, #0x0100

_heart_def::
  FACTORY_DEF COMPONENT_STATIC, HEART_BEATING, static

_heart_create::
  ld hl, #4
  add hl, de
  ex de, hl         ; DE <- xInBytes
  ld hl, #_heart_def
  jp _entities_create_asm

_successFromRiding_behavior::
  CREATE ufo
  JUMP
  SET_VX SUCCESS_VX

_success_behavior::
  ADD_GRAVITY
  SET_ANIMATION PLAYER_RUNNING
  SET_VX SUCCESS_BRAKING_VX
  IDLE_RUNNING
    CONDITION notOnFloor, success_fall
    CONDITION alienCollision, success_stop_camera
    CONDITIONS_END
success_fall:
  SET_ANIMATION PLAYER_FLYING
  IDLE
    CONDITION onFloor, success_land
    CONDITIONS_END
success_land:
  SET_ANIMATION PLAYER_LANDING
  STOP
  PLAY_SFX LAND
  WAIT 4, _success_behavior
    CONDITIONS_END
success_stop_camera:
  STOP_CAMERA
  SET_VX SUCCESS_VX
  WAIT 42, success_care
    CONDITIONS_END
success_care:
  CREATE heart
  SET_VX #0
  SET_ANIMATION PLAYER_CARESSING
  PLAY_SONG CLEAR
  WAIT 180, success_fade
    CONDITION anyKeyPressed, success_fade
    CONDITIONS_END
success_fade:
  FADE_OUT
  WAIT 20, success_end
    CONDITIONS_END
success_end:
  SET_EVENT GAME_SUCESS
  CLEAR_ENTITY
