/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#ifndef _DEBUG_H_
#define _DEBUG_H_

// Debug variables. Uncomment to see its effects.
// Note: it may require "make clean"
// Note2: there are more debug variables in debug.h.s
#define DEBUG_ENABLE_ASSERTS        0
#define DEBUG_ENABLE_BORDERS        0

// Force breakpoint
#define BREAKPOINT  __asm__(".db #0xed, #0xff")

#ifdef DEBUG_ENABLE_BORDERS
  #include <cpctelera.h>

  #define debug_setBorder(color)  \
    cpct_setBorder(color);        \
    cpct_setPALColour(0, color);

  #define debug_resetBorder()       \
    cpct_setBorder(HW_BLACK);       \
    cpct_setPALColour(0, HW_BLACK);
#else
  #define debug_setBorder(_color)
  #define debug_resetBorder()
#endif

#endif // _DEBUG_H_
