;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.module pvector

; extern void pvector_remove(Pvector *pvector, void* pointer) __z88dk_callee;

; _pvector_remove::
;   pop af      ;; AF <- return address
;   pop hl      ;; HL <- pvector pointer
;   pop bc      ;; BC <- pointer to remove
;   push af     ;; Put returning address in the stack again

; IN:
;   HL <- pvector pointer
;   BC <- pointer to remove
; DESTROYS:
;   AF, BC, DE, HL
_pvector_remove_asm::
  ld e, (hl)
  inc hl
  ld d, (hl)  ; DE <- next pointer (points to null)
  
  push de
    ; pvector->next = pvector->next - 1;
    dec de
    dec de
    ld (hl), d
    dec hl
    ld (hl), e
    inc hl
    inc hl
  pop de

loop:
  ; check lo
  ld a, (hl)
  cp c
  jr z, check_hi
  inc hl
  inc hl
  jr loop

check_hi:
  inc hl
  ld a, (hl)
  cp b
  jr z, found
  inc hl
  jr loop

found:
  dec hl    ; HL <- destination pointer

  ld a, e
  sub l
  ld c, a
  ld a, d
  sbc h
  ld b, a   ; BC <- DE - HL = counter

  ld e, l
  ld d, h
  inc hl
  inc hl
  ldir

  ret
