/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#include "cpc/interrupts.h"
#include "systems/sunset.h"
#include "systems/terrain.h"
#include "systems/platform.h"
#include "systems/water.h"
#include "systems/checkpoint.h"
#include "systems/renderer.h"
#include "cpc/audio.h"
#include "systems/animator.h"
#include "systems/physics.h"
#include "systems/collision.h"
#include "systems/background.h"
#include "systems/ai.h"
#include "systems/entities.h"
#include "systems/alien.h"
#include "systems/hud.h"
#include "systems/menu.h"
#include "systems/event.h"
#include "systems/success.h"
#include "systems/failure.h"
#include "systems/playback.h"
#include "systems/record.h"
#include "data/game_assets.h"

#include "stages/menu.h"
#include "stages/game.h"
#include "stages/manager.h"
#include "lang/random.h"
// #include "cpc/wait.h"

// mix code.mmap ../reboot/obj/game.map -i _game_a_assets,_game_b_assets
// mix assets.create ../art/reboot.json -o ../reboot/src/data -c
// cloc --exclude-dir=data src/
void main(void) {
  interrupts_init();
  sunset_init();
  terrain_init();
  platform_init();
  water_init();
  checkpoint_init();
  background_init();
  renderer_init();
  audio_init();
  collision_init();
  physics_init();
  animator_init();
  ai_init();
  entities_init();
  alien_init();
  hud_init();
  menu_init();
  event_init();
  success_init();
  failure_init();
  playback_init();
  record_init();
  game_assets_init();

// Uncoment these lines when recording. When in breakpoint, start
// winape video and audio recording.
// wait_seconds(2);
// __asm__(".db #0xed, #0xff");
// wait_seconds(2);
// __asm__("nop");

  while (1) {
    menu_start();
  }

  // event_clear();
  // checkpoint_reset();
  // while (1) {
  //   random_reset();
  //   manager_start();
  //   // game_start(2, GAME_NORMAL_MODE);
  //   // game_start(2, GAME_ATTRACT_MODE);
  // }
}
