;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entities.h.s"
.include "entities/entity.h.s"
.include "lang/macros.h.s"

.module animator

_animator_step::
  push ix
  ld hl, #_animator_update
  call _entities_each_asm
  pop ix
  ret

; void animator_update(Entity* entity) {
;   if (--entity->animation.counter == 0) {
;     Step* step = entity->animation.step + 1;
;     if (!step->sprite) {
;       step = entity->animation.first;
;     }
;     entity->animation.step = step;
;     entity->animation.counter = step->time;
;   }
; }
; Rewriting goes from 124 to 44

; IN:
;   IX <- Entity pointer
_animator_update::
  dec ENTITY_ANIMATION_COUNTER (ix)
  ret nz

  ; get next animation step
  ld l, ENTITY_ANIMATION_STEP_LO (ix)
  ld h, ENTITY_ANIMATION_STEP_HI (ix)
  ld a, #STEP_SIZE
  add_hl_a        ; HL <- animation.step + 1

  ld a, (hl)
  inc hl
  or (hl)
  dec hl
  jr nz, continue

  ; if we reached the end of the animation, just get first step
  ld l, ENTITY_ANIMATION_FIRST_LO (ix)
  ld h, ENTITY_ANIMATION_FIRST_HI (ix)

continue:
  ; set new step
  ld ENTITY_ANIMATION_STEP_LO (ix), l
  ld ENTITY_ANIMATION_STEP_HI (ix), h

  ; set step counter as animation counter
  .rept STEP_TIME
  inc hl
  .endm
  ld a, (hl)      ; A <- step->time
  ld ENTITY_ANIMATION_COUNTER (ix), a

  ret


; IN:
;   IX <- entity address
;   DE <- animation address
; DESTROYS:
;   AF, HL
_animator_setAnimation_asm::
;   entity->animation.first = entity->animation.step = step;
  ld ENTITY_ANIMATION_FIRST_LO (ix), e
  ld ENTITY_ANIMATION_FIRST_HI (ix), d
  ld ENTITY_ANIMATION_STEP_LO (ix), e
  ld ENTITY_ANIMATION_STEP_HI (ix), d

;   entity->animation.counter = step->time;
  ld hl, #STEP_TIME
  add hl, de
  ld a, (hl)
  ld ENTITY_ANIMATION_COUNTER (ix), a
  ret
