;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "data/game_assets.h.s"
.include "background.h.s"
.include "lang/macros.h.s"
.include "lang/debug.h.s"

.module background

.equ BASE, #STARS_0_INDEX

.globl cpct_getRandom_mxor_u8_asm

_background_stars::
  call cpct_getRandom_mxor_u8_asm
  ld a, l       ; L <- original random saved for later
  and #0x03     ; A <- random between [0, 4)
  ret nz

  ld a, l
  rra
  rra
  ld b, a       ; B <- save random for later
  and #0x07     ; A <- random bewteen [0, 8)

  ld hl, (#_background_column)
  add_hl_a
  ENSURE_HL_IN_BUFFER

  ld a, b
  rra
  rra
  rra
  and #0x03     ; A <- random between [0, 4)
  add #BASE
  scf
  rla           ; A <- ((BASE + random) * 2) + 1

  ld (hl), a

  ret
