;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "renderer.h.s"
.include "alien.h.s"
.include "lang/debug.h.s"
.include "data/level.h.s"

.module checkpoint

_checkpoint_level::
  .dw #0
_checkpoint_position::
  .dw #0
_checkpoint_alienPosition::
  .dw #0
_checkpoint_alienState::
  .dw #0

_checkpoint_clear::
  ; checkpoint_level = level->checkpoints
  ld bc, #LEVEL_CHECKPOINTS
  add hl, bc
  ld e, (hl)
  inc hl
  ld d, (hl)      ; DE <- level checkpoint data
  ld (#_checkpoint_level), de

  ret

_checkpoint_reset::
  ; checkpoint_position = 0
  ld hl, #0
  ld (_checkpoint_position), hl

  ; checkpoint_alienPosition = 0
  ; ld hl, #0
  ld (_checkpoint_alienPosition), hl

  ; checkpoint_alienState = alien_aheadPlayer
  ld hl, #_alien_aheadPlayer
  ld (_checkpoint_alienState), hl

  ret

_checkpoint_step::
  ; next_checkpoint < renderer_left?
  ld hl, (#_checkpoint_level)
  ld e, (hl)
  inc hl
  ld d, (hl)      ; DE <- next_checkpoint
  ld bc, (#_renderer_left)
                  ; BC <- renderer_left
  ld a, e
  sub c
  ld a, d
  sbc b
  ret nc

  ; update position
  ld (#_checkpoint_position), de
  ; update level pointer
  inc hl
  ld (#_checkpoint_level), hl

  ; update alien position
  ld hl, (#_alien_position)
  ld (#_checkpoint_alienPosition), hl
  ; update alien state
  ld hl, (#_alien_state)
  ld (#_checkpoint_alienState), hl

  ret

_checkpoint_getNext::
  ld hl, (#_checkpoint_level)
  ld a, (hl)
  inc hl
  ld h, (hl)
  ld l, a
  ret
