;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entities/factories.h.s"
.include "cpc/palette.h.s"
.include "systems/renderer.h.s"
.include "data/game_assets.h.s"
.include "data/level.h.s"
.include "lang/macros.h.s"

.module ending

.equ STRING_X, 25
.equ STRING_Y, 32
.equ BASE, #STARS_0_INDEX

.globl cpct_memset_asm
.globl cpct_getRandom_mxor_u8_asm

_ending_clear::
  push ix

  ; Clear HUD
  ld a, #0x0c         ; TODO use proper constant/macro
  call _renderer_clearHud_asm

  ; Draw text
  ld bc, #ENDING_STRING_ADDRESS
  RENDERER_HUD_SCREEN_POINTER de, STRING_X, STRING_Y
  call _renderer_drawHudString_asm

  ; Clear tile buffer
  xor a
  ld de, #TILE_BUFFER_ADDRESS
  ld bc, #TILE_BUFFER_SIZE
  call cpct_memset_asm

  ; Draw stars
  ld hl, #TILE_BUFFER_ADDRESS
  ld b, #RENDERER_GAME_WIDTH_IN_TILES
loop:
  push bc
  push hl
    push hl
      call cpct_getRandom_mxor_u8_asm
      ld a, l
      ld d, l     ; D <- store complete random number for later
    pop hl
    and #0x1f
    ld c, a       ; C <- random in [0, 32)
    ld a, #RENDERER_GAME_HEIGHT_IN_TILES
    cp c          ; ensure C < column height
    jr c, next_column

    ld b, #0
    add hl, bc    ; HL <- tile buffer position address

    ld a, d
    rra
    rra
    rra
    rra
    rra           ; A <- next random bits
    and #0x03     ; A <- random in [0, 4)
    add #BASE
    scf
    rla           ; A <- ((BASE + random) * 2) + 1

    ld (hl), a

next_column:
  pop hl
  pop bc
  ld de, #RENDERER_GAME_HEIGHT_IN_TILES
  add hl, de
  djnz loop

  call _earth_create
  call _mars_create
  call _ending_create

  pop ix
  ret
