;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entities.h.s"
.include "menu.h.s"
.include "renderer.h.s"
.include "data/game_assets.h.s"
.include "data/level.h.s"
.include "entities/factories.h.s"
.include "entities/entity.h.s"
.include "lang/macros.h.s"

.module menu

.equ THE_X,      ((RENDERER_HUD_WIDTH_IN_BYTES - THE_STRING_LENGTH * 2) / 2) + 1
.equ THE_Y,      0

.equ TITLE_LENGTH,           TITLE_COUNT
.equ TOTAL_WIDTH_IN_BYTES,   (TITLE_WIDTH_IN_BYTES * (TITLE_LENGTH * 2 - 1) - 6)
.equ TITLE_X,                ((RENDERER_HUD_WIDTH_IN_BYTES - TOTAL_WIDTH_IN_BYTES) / 2) - 1
.equ TITLE_Y,                24 ; (RENDERER_HUD_HEIGHT - TITLE_HEIGHT)

.equ TITLE_I_INDEX, 3
.equ TITLE_DX_I, 4
.equ TITLE_DX, 6

_menu_clear::
  push ix

  ; Draw HUD "the"
  ld bc, #THE_STRING_ADDRESS
  RENDERER_HUD_SCREEN_POINTER de, THE_X, THE_Y
  call _renderer_drawHudString_asm

  ; Draw HUD title
  ld b, #TITLE_COUNT
  ld hl, #TITLE_0_ADDRESS
  RENDERER_HUD_SCREEN_POINTER de, TITLE_X, TITLE_Y
title_loop:
  push bc
  push de
  push hl
    call _renderer_drawHudSprite_asm
  pop hl
  pop de
  pop bc

  .rept TITLE_DX_I
  inc de
  .endm

  ; taking care with "I" being smaller
  ld a, #TITLE_I_INDEX
  cp b
  jr z, title_continue

  .rept TITLE_DX - TITLE_DX_I
  inc de
  .endm

title_continue:
  ld a, #(TITLE_WIDTH_IN_BYTES * TITLE_HEIGHT) + 2
  add_hl_a

  djnz title_loop

  ; And finally create menu entities
  call _subtitle_create
  call _copyright_create
  ld de, #MENU_STRING_X
  call _menu_create

  pop ix
  ret


_menu_addOpaqueEntity::
  set #DRAWING_OPAQUE_BIT, ENTITY_DRAWING_FLAGS (ix)
set_common_entity_data:
  ld ENTITY_BODY_VX_LO (ix), #0
  ld ENTITY_BODY_VX_HI (ix), #MENU_DISPLACEMENT
  set #BODY_IGNORE_COLLISIONS_BIT, ENTITY_BODY_FLAGS (ix)
  ret


_menu_addTextEntity::
  set #DRAWING_TEXT_BIT, ENTITY_DRAWING_FLAGS (ix)
  jr set_common_entity_data
