;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "renderer.h.s"
.include "cpc/controls.h.s"
.include "lang/debug.h.s"

.module record

.equ RECORD_ENABLED, 0

.if RECORD_ENABLED

_record_position::
  .dw #0

_record_clear::
  RENDERER_HUD_SCREEN_POINTER hl, 6, 36
  ld (#_record_position), hl
  xor a
  ld (hl), a      ; first counter = 0
  dec a
  inc hl
  ld (hl), a      ; first status = 0xff
  ret

_record_step::
  ld l, #CONTROLS_COUNT - 1
                  ; L <- key index
  ld c, #0xff     ; C <- status
  ld b, #CONTROLS_COUNT
key_loop:
  push bc
  push hl

    call _controls_isPressed

  pop hl
  pop bc

  or a

  ; put zero flag in carry
  scf
  jr z, . + 3
  ccf

  rl c            ; add key value bit to status

  dec l
  djnz key_loop

  ; compare with old status
  ld hl, (#_record_position)
  inc (hl)
  ld a, #0xff     ; check counter overflow
  cp (hl)
  inc hl
  jr z, next_position
  ld a, (hl)      ; A <- old status
  cp c
  ret z

next_position:
  inc hl
  ld (hl), #0
  ld (#_record_position), hl
  inc hl
  ld (hl), c
  ret

.endif  ; RECORD_ENABLED
