;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "renderer.h.s"
.include "lang/macros.h.s"

.module renderer

_renderer_drawHudSprite::
  pop af      ;; AF <- return address
  pop hl      ;; HL <- sprite address
  pop de      ;; DE <- screen address
  push af     ;; Put returning address in the stack again

  ; HL <- sprite address
  ; DE <- screen address
_renderer_drawHudSprite_asm::
  ld c, (hl)  ; C <- width
  inc hl
  ld b, (hl)  ; B <- height
  inc hl

  push ix
  ld__ixl_b   ; IXL <- height
  ld__ixh_c   ; IXH <- width
  ld b, #0

loop:
  ; draw line
  push de
    ld__c_ixh   ; BC <- width
    ldir
  pop de

  dec__ixl
  jr z, end_drawing

  ;; next line (add 0x800)
  set 3, d

  ; draw line
  push de
    ld__c_ixh   ; BC <- width
    ldir
  pop de

  dec__ixl
  jr z, end_drawing

  ; next line (add -0x800 + 0x64)
  res 3, d
  ld a, #RENDERER_HUD_WIDTH_IN_BYTES
  add e
  ld e, a
  ld a, d
  adc #0
  ld d, a

  jr loop

end_drawing:
  pop ix
  ret
