;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "lang/macros.h.s"
.include "renderer.h.s"

.module renderer

.equ MASK_1, #170
.equ MASK_2, #85

.macro back_to_loop
  jp (ix)
.endm

.macro next_line ?continue
  ld a, d
  add c       ; add #0x08
  ld d, a
  and #0x38
  jr nz, continue

  ld a, d
  sub #0x40
  ld d, a
  ld a, e
  add #RENDERER_GAME_WIDTH_IN_BYTES
  ld e, a
  jr nc, continue

  inc d
  ld a, d
  and b       ; and #0x07
  jr nz, continue

  ld a, d
  sub c       ; sub #0x08
  ld d, a
continue:
.endm

.macro next_byte ?continue
  inc e
  jr nz, continue
  inc d
  ld a, d
  and b       ; and #0x07
  jr nz, continue
  ld a, d
  sub c       ; sub #0x08
  ld d, a
continue:
.endm

.macro next_byte_and_back_to_loop
  inc e
  jr nz, loop
  inc d
  ld a, d
  and b       ; and #0x07
  jr nz, loop
  ld a, d
  sub c       ; sub #0x08
  ld d, a
  back_to_loop
.endm

.macro draw_3
  ld a, (hl)
  ld (de), a
  inc l
.endm

.macro draw_3_and_move
  draw_3
  next_byte
.endm

.macro draw_masked mask
  ld a, (de)  ; 7c
  and mask    ; 7c
  or (hl)     ; 7c
  ld (de), a  ; 7c
  inc l       ; 4c
  ; 32c
.endm

.macro draw_1
  draw_masked #MASK_1
.endm

.macro draw_2
  draw_masked #MASK_2
.endm

; _renderer_drawRlz3::
;   pop  af       ;; AF <- return address
;   pop  hl       ;; HL <- sprite address
;   pop  de       ;; DE <- screen address
;   push af       ;; Put returning address in the stack again

; IN:
;   HL <- sprite address
;   DE <- screen address
; DESTROYS:
;   AF, BC, DE, HL
_renderer_drawRlz3_asm::
  push ix
  ld ix, #loop

  ld bc, #0x0708

  push de       ; save screen pointer for each line
  jp loop

draw_0000:
  next_byte
draw_000:
  next_byte
draw_00:
  next_byte
draw_0:
  next_byte_and_back_to_loop

draw_1:
  draw_1
  next_byte_and_back_to_loop

draw_1r:
  draw_1
  jp next_line

draw_2:
  draw_2
  next_byte_and_back_to_loop

draw_2r:
  draw_2
  jp next_line

loop:
  ld a, (hl)
  inc hl
  ld (#command_address), a
.equ command_address, . + 1
  jr__0

draw_end:
  pop de
  pop ix
  ret

draw_3333:
  draw_3_and_move
draw_333:
  draw_3_and_move
draw_33:
  draw_3_and_move
draw_3:
  draw_3
  next_byte_and_back_to_loop

draw_3333r:
  draw_3_and_move
draw_333r:
  draw_3_and_move
draw_33r:
  draw_3_and_move
draw_3r:
  draw_3
  ; jp next_line

draw_r:
  ; jp next_line

next_line:
  pop de
  next_line
  push de
  back_to_loop
