;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "data/game_assets.h.s"
.include "renderer.h.s"

.module renderer

.equ FONT_MIN_CHAR, #46
.equ FONT_SPACE_CHAR, #32

.globl _renderer_drawChar3_asm
.globl _renderer_drawHudChar3_asm

; _renderer_drawHudString::
;   pop  af       ;; AF <- return address
;   pop  bc       ;; BC <- string address
;   pop  de       ;; DE <- screen address
;   push af       ;; Put returning address in the stack again

; IN:
;   BC <- string address
;   DE <- screen address
_renderer_drawHudString_asm::
  ld hl, #_renderer_drawHudChar3_asm
  ld (#draw_char_call_address), hl

  call _renderer_drawString_asm 

  ld hl, #_renderer_drawChar3_asm
  ld (#draw_char_call_address), hl

  ret

_renderer_drawString::
  pop  af       ;; AF <- return address
  pop  bc       ;; BC <- string address
  pop  de       ;; DE <- screen address
  push af       ;; Put returning address in the stack again

; IN:
;   BC <- string address
;   DE <- screen address
_renderer_drawString_asm::
loop:
  ; while (ch = *str++) {
  ld a, (bc)
  or a
  ret z

  inc bc

  cp #FONT_SPACE_CHAR
  jr z, next_char

  ; u8 index = ch - (RENDERER_FONT_MIN_CHAR - FONT_0_INDEX);
  sub #(FONT_MIN_CHAR - FONT_0_INDEX)

  ; u8* sprite = (u8*)game_indices[index];
  push de
	ld l, a
	ld h, #0x00
  add hl, hl
  ld de, #_game_indices
  add hl, de
  ld e, (hl)
  inc hl
  ld d, (hl)
  ex de, hl
  pop de

  ; renderer_drawChar(sprite, screen);
  push bc
  push de
  ex de, hl
.equ draw_char_call_address, . + 1
  call _renderer_drawChar3_asm
  ex de, hl
  pop de
  pop bc

  ; screen += 2;
next_char:
  inc e
  inc e
  jr nz, loop
  inc d
  ld a, d
  and #0x07
  jr nz, loop
  ld a, d
  sub #0x08
  ld d, a
  jr loop
