;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "renderer.h.s"
.include "player.h.s"
.include "stages/game.h.s"
.include "lang/macros.h.s"
.include "lang/debug.h.s"
.include "data/level.h.s"
.include "data/game_assets.h.s"

.module success

; IN:
;   HL <- level address
_success_clear::
  pop  af         ;; AF <- return address
  pop  de         ;; DE <- level address
  pop  bc         ;; C <- game mode
  push af         ;; Put returning address in the stack again

  ld a, c
  cp #GAME_FAILING_MODE
  jr nz, continue_clear

  ; if failing, set unreachable success position
  ld hl, #0xffff
  jr set_success_position

continue_clear:
  ld__iyl_e
  ld__iyh_d       ; IY <- level address

  ; set level animal directly into animation
  ld l, LEVEL_STANDING_ANIMAL_LO (iy)
  ld h, LEVEL_STANDING_ANIMAL_HI (iy)
  ld (#ANIMAL_STANDING_ADDRESS), hl

  ; set success position
  ld l, LEVEL_ENDING_LO (iy)
  ld h, LEVEL_ENDING_HI (iy)
set_success_position:
  ld (#success_position), hl

  ret

_success_step::
  ; success_position < renderer_left?
.equ success_position, . + 1
  ld de, #0
  ld bc, (#_renderer_left)
                  ; BC <- renderer_left
  ld a, e
  sub c
  ld a, d
  sbc b
  ret nc

  ; set impossible succcess position
  ld de, #0xffff
  ld (#success_position), de

  jp _player_success
