;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "background.h.s"
.include "renderer.h.s"
.include "cpc/palette.h.s"
.include "data/game_assets.h.s"

.module sunset

.equ TILE_MAGENTA_BLUE,             MENU_BACKGROUNDS_0_INDEX
.equ TILE_BRIGHT_MAGENTA_MAGENTA,   MENU_BACKGROUNDS_1_INDEX
.equ TILE_PINK_BRIGHT_MAGENTA,      MENU_BACKGROUNDS_2_INDEX
.equ TILE_ORANGE_PINK,              MENU_BACKGROUNDS_3_INDEX
.equ TILE_ORANGE_RED,               MENU_BACKGROUNDS_4_INDEX

.macro PATTERN name
  PALETTE_PATTERN name
.endm

.macro TILE name
  .db #(TILE_'name' << 1) + 1
.endm

_sunset_pattern::
  PATTERN BACKGROUND
  PATTERN BACKGROUND
  PATTERN BLUE
  PATTERN BACKGROUND
  PATTERN BLUE
  TILE MAGENTA_BLUE
  PATTERN BLUE
  PATTERN MAGENTA
  PATTERN MAGENTA
  PATTERN MAGENTA
  TILE BRIGHT_MAGENTA_MAGENTA
  PATTERN BRIGHT_MAGENTA
  PATTERN BRIGHT_MAGENTA
  TILE PINK_BRIGHT_MAGENTA
  TILE PINK_BRIGHT_MAGENTA
  TILE ORANGE_PINK
  TILE ORANGE_RED
  PATTERN MAGENTA
  PATTERN MAGENTA
  PATTERN MAGENTA

_sunset_index::
  .dw 0
_sunset_column::
  .dw 0

_sunset_clear::
  ld hl, #0
  ld (#_sunset_index), hl

  ld hl, #TILE_BUFFER_ADDRESS
  ld (#_sunset_column), hl

  ret

_sunset_step::
  ; u16 index = renderer_right >> 1;
  ld bc, (_renderer_right)
  srl b
  rr c          ; BC <- renderer_right >> 1

  ld hl, (#_sunset_index)
                ; HL <- sunset

  ; while (sunset_index < index) {
step_loop:
  ld a, l
  sub c
  ld a, h
  sbc b
  ret nc

  push bc
  push hl
    ld hl, (#_sunset_column)
    ld de, #_sunset_pattern
    ld b, #20
column_loop:
    ld a, (de)
    ld (hl), a
    inc de
    inc hl
    ENSURE_HL_IN_BUFFER
    djnz column_loop

    ld (#_sunset_column), hl
  pop hl
  pop bc

  ; sunset_index++;
  inc hl
  ld (#_sunset_index), hl
  jr step_loop
