;; The Abduction of Oscar Z
;; ========================
;;
;; "Oscar loved watching night skies long after his parents slept. But tonight
;; that sky was watching him..."
;;
;; * PRODUCTION & CODE / Tulo / @tulinmola
;; * ART & STORY / Alberto Hache / @Alberto_H9
;; * MUSIC & FX / Gryzor87 / @Gryzor87
;;
;; A 2020 Dreamin`Bits production
;; https://dreaminbits.com/
;;
;; MIT License
;;
;; Copyright (c) 2020 Dreamin`Bits
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in all
;; copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.

.include "entities/factories.h.s"
.include "systems/renderer.h.s"
.include "data/game_assets.h.s"
.include "data/level.h.s"
.include "lang/macros.h.s"

.module title

.equ TOP_LINES, 4

.globl _title_animalString

_title_clear::
  push ix

  ; Set animal name string
  ld a, #LEVEL_NAME
  add_hl_a
  ld a, (hl)
  inc hl
  ld h, (hl)
  ld l, a
  ld (#_title_animalString), hl

  ; Clear HUD screen with top pattern color
  ld a, #0x0c     ; TODO extract from level
  call _renderer_clearHud_asm

  ; Draw background
  ld bc, #RENDERER_GAME_WIDTH_IN_TILES << 8
  ld hl, #TILE_BUFFER_ADDRESS
  ld de, #TILE_BUFFER_ADDRESS + 1
loop:
  push bc
  ld (hl), #0x0c  ; TODO extract from level
  ld bc, #TOP_LINES
  ldir
  ld c, #RENDERER_GAME_HEIGHT_IN_TILES - TOP_LINES
  ld (hl), #0
  ldir
  pop bc
  djnz loop

  ; And create entity
  call _title_create

  pop ix
  ret
