/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#ifndef _SCREENS_ASSETS_H_
#define _SCREENS_ASSETS_H_

#include <types.h>

void screens_assets_init();



#define SCREENS_ASSETS_ADDRESS 0x5000
#define SCREENS_ASSETS_SIZE 18680
#define SCREENS_ASSETS_COMPRESSED_SIZE 3087
#define SCREENS_ASSETS_HIGHEST_ADDRESS 0x98F8


#define PALETTES_ADDRESS 0x5000
#define PALETTES_SIZE 128


#define LOGO_ADDRESS 0x5080
#define LOGO_SIZE 901

#define LOGO_FORMAT "raw"
#define LOGO_WIDTH_IN_BYTES 17
#define LOGO_WIDTH 34
#define LOGO_HEIGHT 53
#define LOGO_COUNT 1
#define LOGO_0_ADDRESS 0x5080


#define EXPERIENCE_ADDRESS 0x5405
#define EXPERIENCE_SIZE 544

#define EXPERIENCE_FORMAT "raw"
#define EXPERIENCE_WIDTH_IN_BYTES 34
#define EXPERIENCE_WIDTH 68
#define EXPERIENCE_HEIGHT 16
#define EXPERIENCE_COUNT 1
#define EXPERIENCE_0_ADDRESS 0x5405


#define HEADPHONES_ADDRESS 0x5625
#define HEADPHONES_SIZE 1107

#define HEADPHONES_FORMAT "raw"
#define HEADPHONES_WIDTH_IN_BYTES 41
#define HEADPHONES_WIDTH 82
#define HEADPHONES_HEIGHT 27
#define HEADPHONES_COUNT 1
#define HEADPHONES_0_ADDRESS 0x5625


#define LOAD_SCREEN_ADDRESS 0x5A78
#define LOAD_SCREEN_SIZE 16000

#define LOAD_SCREEN_FORMAT "raw"
#define LOAD_SCREEN_WIDTH_IN_BYTES 40
#define LOAD_SCREEN_WIDTH 80
#define LOAD_SCREEN_HEIGHT 200
#define LOAD_SCREEN_COUNT 2
#define LOAD_SCREEN_0_ADDRESS 0x5A78
#define LOAD_SCREEN_1_ADDRESS 0x79B8


extern const u8 screens_assets[3087];

void screens_uncompress();





#endif // _SCREENS_ASSETS_H_
