/*
  The Abduction of Oscar Z
  ========================

  "Oscar loved watching night skies long after his parents slept. But tonight
  that sky was watching him..."

  * PRODUCTION & CODE / Tulo / @tulinmola
  * ART & STORY / Alberto Hache / @Alberto_H9
  * MUSIC & FX / Gryzor87 / @Gryzor87

  A 2020 Dreamin`Bits production
  https://dreaminbits.com/

  MIT License

  Copyright (c) 2020 Dreamin`Bits

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the"Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all
  copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  SOFTWARE.
*/

#ifndef _COMIC_ASSETS_H_
#define _COMIC_ASSETS_H_

#include <types.h>

void comic_assets_init();

#define COMIC_ASSETS_AT 0x2100

#define COMIC_E_ASSETS_ADDRESS 0x5A00
#define COMIC_E_ASSETS_SIZE 10627
#define COMIC_E_ASSETS_COMPRESSED_SIZE 2165
#define COMIC_E_ASSETS_HIGHEST_ADDRESS 0x8383
#define COMIC_D_ASSETS_ADDRESS 0x5660
#define COMIC_D_ASSETS_SIZE 13187
#define COMIC_D_ASSETS_COMPRESSED_SIZE 4060
#define COMIC_D_ASSETS_HIGHEST_ADDRESS 0x89E3
#define COMIC_C_ASSETS_ADDRESS 0x6D90
#define COMIC_C_ASSETS_SIZE 14434
#define COMIC_C_ASSETS_COMPRESSED_SIZE 3734
#define COMIC_C_ASSETS_HIGHEST_ADDRESS 0xA5F2
#define COMIC_B_ASSETS_ADDRESS 0x5630
#define COMIC_B_ASSETS_SIZE 17457
#define COMIC_B_ASSETS_COMPRESSED_SIZE 5566
#define COMIC_B_ASSETS_HIGHEST_ADDRESS 0x9A61
#define COMIC_A_ASSETS_ADDRESS 0x5E00
#define COMIC_A_ASSETS_SIZE 18396
#define COMIC_A_ASSETS_COMPRESSED_SIZE 6021
#define COMIC_A_ASSETS_HIGHEST_ADDRESS 0xA5DC

#define PAGE3_B_ADDRESS 0x5A00
#define PAGE3_B_SIZE 9216
#define PAGE3_B_FORMAT "tile"
#define PAGE3_B_WIDTH_IN_BYTES 2
#define PAGE3_B_WIDTH 4
#define PAGE3_B_HEIGHT 8
#define PAGE3_B_WIDTH_IN_TILES 32
#define PAGE3_B_HEIGHT_IN_TILES 18
#define PAGE3_B_COUNT 576
#define PAGE3_B_0_ADDRESS 0x5A00
#define PAGE3_B_1_ADDRESS 0x5A10
#define PAGE3_B_2_ADDRESS 0x5A20
#define PAGE3_B_3_ADDRESS 0x5A30
#define PAGE3_B_4_ADDRESS 0x5A40
#define PAGE3_B_5_ADDRESS 0x5A50
#define PAGE3_B_6_ADDRESS 0x5A60
#define PAGE3_B_7_ADDRESS 0x5A70
#define PAGE3_B_8_ADDRESS 0x5A80
#define PAGE3_B_9_ADDRESS 0x5A90
#define PAGE3_B_10_ADDRESS 0x5AA0
#define PAGE3_B_11_ADDRESS 0x5AB0
#define PAGE3_B_12_ADDRESS 0x5AC0
#define PAGE3_B_13_ADDRESS 0x5AD0
#define PAGE3_B_14_ADDRESS 0x5AE0
#define PAGE3_B_15_ADDRESS 0x5AF0
#define PAGE3_B_16_ADDRESS 0x5B00
#define PAGE3_B_17_ADDRESS 0x5B10
#define PAGE3_B_18_ADDRESS 0x5B20
#define PAGE3_B_19_ADDRESS 0x5B30
#define PAGE3_B_20_ADDRESS 0x5B40
#define PAGE3_B_21_ADDRESS 0x5B50
#define PAGE3_B_22_ADDRESS 0x5B60
#define PAGE3_B_23_ADDRESS 0x5B70
#define PAGE3_B_24_ADDRESS 0x5B80
#define PAGE3_B_25_ADDRESS 0x5B90
#define PAGE3_B_26_ADDRESS 0x5BA0
#define PAGE3_B_27_ADDRESS 0x5BB0
#define PAGE3_B_28_ADDRESS 0x5BC0
#define PAGE3_B_29_ADDRESS 0x5BD0
#define PAGE3_B_30_ADDRESS 0x5BE0
#define PAGE3_B_31_ADDRESS 0x5BF0
#define PAGE3_B_32_ADDRESS 0x5C00
#define PAGE3_B_33_ADDRESS 0x5C10
#define PAGE3_B_34_ADDRESS 0x5C20
#define PAGE3_B_35_ADDRESS 0x5C30
#define PAGE3_B_36_ADDRESS 0x5C40
#define PAGE3_B_37_ADDRESS 0x5C50
#define PAGE3_B_38_ADDRESS 0x5C60
#define PAGE3_B_39_ADDRESS 0x5C70
#define PAGE3_B_40_ADDRESS 0x5C80
#define PAGE3_B_41_ADDRESS 0x5C90
#define PAGE3_B_42_ADDRESS 0x5CA0
#define PAGE3_B_43_ADDRESS 0x5CB0
#define PAGE3_B_44_ADDRESS 0x5CC0
#define PAGE3_B_45_ADDRESS 0x5CD0
#define PAGE3_B_46_ADDRESS 0x5CE0
#define PAGE3_B_47_ADDRESS 0x5CF0
#define PAGE3_B_48_ADDRESS 0x5D00
#define PAGE3_B_49_ADDRESS 0x5D10
#define PAGE3_B_50_ADDRESS 0x5D20
#define PAGE3_B_51_ADDRESS 0x5D30
#define PAGE3_B_52_ADDRESS 0x5D40
#define PAGE3_B_53_ADDRESS 0x5D50
#define PAGE3_B_54_ADDRESS 0x5D60
#define PAGE3_B_55_ADDRESS 0x5D70
#define PAGE3_B_56_ADDRESS 0x5D80
#define PAGE3_B_57_ADDRESS 0x5D90
#define PAGE3_B_58_ADDRESS 0x5DA0
#define PAGE3_B_59_ADDRESS 0x5DB0
#define PAGE3_B_60_ADDRESS 0x5DC0
#define PAGE3_B_61_ADDRESS 0x5DD0
#define PAGE3_B_62_ADDRESS 0x5DE0
#define PAGE3_B_63_ADDRESS 0x5DF0
#define PAGE3_B_64_ADDRESS 0x5E00
#define PAGE3_B_65_ADDRESS 0x5E10
#define PAGE3_B_66_ADDRESS 0x5E20
#define PAGE3_B_67_ADDRESS 0x5E30
#define PAGE3_B_68_ADDRESS 0x5E40
#define PAGE3_B_69_ADDRESS 0x5E50
#define PAGE3_B_70_ADDRESS 0x5E60
#define PAGE3_B_71_ADDRESS 0x5E70
#define PAGE3_B_72_ADDRESS 0x5E80
#define PAGE3_B_73_ADDRESS 0x5E90
#define PAGE3_B_74_ADDRESS 0x5EA0
#define PAGE3_B_75_ADDRESS 0x5EB0
#define PAGE3_B_76_ADDRESS 0x5EC0
#define PAGE3_B_77_ADDRESS 0x5ED0
#define PAGE3_B_78_ADDRESS 0x5EE0
#define PAGE3_B_79_ADDRESS 0x5EF0
#define PAGE3_B_80_ADDRESS 0x5F00
#define PAGE3_B_81_ADDRESS 0x5F10
#define PAGE3_B_82_ADDRESS 0x5F20
#define PAGE3_B_83_ADDRESS 0x5F30
#define PAGE3_B_84_ADDRESS 0x5F40
#define PAGE3_B_85_ADDRESS 0x5F50
#define PAGE3_B_86_ADDRESS 0x5F60
#define PAGE3_B_87_ADDRESS 0x5F70
#define PAGE3_B_88_ADDRESS 0x5F80
#define PAGE3_B_89_ADDRESS 0x5F90
#define PAGE3_B_90_ADDRESS 0x5FA0
#define PAGE3_B_91_ADDRESS 0x5FB0
#define PAGE3_B_92_ADDRESS 0x5FC0
#define PAGE3_B_93_ADDRESS 0x5FD0
#define PAGE3_B_94_ADDRESS 0x5FE0
#define PAGE3_B_95_ADDRESS 0x5FF0
#define PAGE3_B_96_ADDRESS 0x6000
#define PAGE3_B_97_ADDRESS 0x6010
#define PAGE3_B_98_ADDRESS 0x6020
#define PAGE3_B_99_ADDRESS 0x6030
#define PAGE3_B_100_ADDRESS 0x6040
#define PAGE3_B_101_ADDRESS 0x6050
#define PAGE3_B_102_ADDRESS 0x6060
#define PAGE3_B_103_ADDRESS 0x6070
#define PAGE3_B_104_ADDRESS 0x6080
#define PAGE3_B_105_ADDRESS 0x6090
#define PAGE3_B_106_ADDRESS 0x60A0
#define PAGE3_B_107_ADDRESS 0x60B0
#define PAGE3_B_108_ADDRESS 0x60C0
#define PAGE3_B_109_ADDRESS 0x60D0
#define PAGE3_B_110_ADDRESS 0x60E0
#define PAGE3_B_111_ADDRESS 0x60F0
#define PAGE3_B_112_ADDRESS 0x6100
#define PAGE3_B_113_ADDRESS 0x6110
#define PAGE3_B_114_ADDRESS 0x6120
#define PAGE3_B_115_ADDRESS 0x6130
#define PAGE3_B_116_ADDRESS 0x6140
#define PAGE3_B_117_ADDRESS 0x6150
#define PAGE3_B_118_ADDRESS 0x6160
#define PAGE3_B_119_ADDRESS 0x6170
#define PAGE3_B_120_ADDRESS 0x6180
#define PAGE3_B_121_ADDRESS 0x6190
#define PAGE3_B_122_ADDRESS 0x61A0
#define PAGE3_B_123_ADDRESS 0x61B0
#define PAGE3_B_124_ADDRESS 0x61C0
#define PAGE3_B_125_ADDRESS 0x61D0
#define PAGE3_B_126_ADDRESS 0x61E0
#define PAGE3_B_127_ADDRESS 0x61F0
#define PAGE3_B_128_ADDRESS 0x6200
#define PAGE3_B_129_ADDRESS 0x6210
#define PAGE3_B_130_ADDRESS 0x6220
#define PAGE3_B_131_ADDRESS 0x6230
#define PAGE3_B_132_ADDRESS 0x6240
#define PAGE3_B_133_ADDRESS 0x6250
#define PAGE3_B_134_ADDRESS 0x6260
#define PAGE3_B_135_ADDRESS 0x6270
#define PAGE3_B_136_ADDRESS 0x6280
#define PAGE3_B_137_ADDRESS 0x6290
#define PAGE3_B_138_ADDRESS 0x62A0
#define PAGE3_B_139_ADDRESS 0x62B0
#define PAGE3_B_140_ADDRESS 0x62C0
#define PAGE3_B_141_ADDRESS 0x62D0
#define PAGE3_B_142_ADDRESS 0x62E0
#define PAGE3_B_143_ADDRESS 0x62F0
#define PAGE3_B_144_ADDRESS 0x6300
#define PAGE3_B_145_ADDRESS 0x6310
#define PAGE3_B_146_ADDRESS 0x6320
#define PAGE3_B_147_ADDRESS 0x6330
#define PAGE3_B_148_ADDRESS 0x6340
#define PAGE3_B_149_ADDRESS 0x6350
#define PAGE3_B_150_ADDRESS 0x6360
#define PAGE3_B_151_ADDRESS 0x6370
#define PAGE3_B_152_ADDRESS 0x6380
#define PAGE3_B_153_ADDRESS 0x6390
#define PAGE3_B_154_ADDRESS 0x63A0
#define PAGE3_B_155_ADDRESS 0x63B0
#define PAGE3_B_156_ADDRESS 0x63C0
#define PAGE3_B_157_ADDRESS 0x63D0
#define PAGE3_B_158_ADDRESS 0x63E0
#define PAGE3_B_159_ADDRESS 0x63F0
#define PAGE3_B_160_ADDRESS 0x6400
#define PAGE3_B_161_ADDRESS 0x6410
#define PAGE3_B_162_ADDRESS 0x6420
#define PAGE3_B_163_ADDRESS 0x6430
#define PAGE3_B_164_ADDRESS 0x6440
#define PAGE3_B_165_ADDRESS 0x6450
#define PAGE3_B_166_ADDRESS 0x6460
#define PAGE3_B_167_ADDRESS 0x6470
#define PAGE3_B_168_ADDRESS 0x6480
#define PAGE3_B_169_ADDRESS 0x6490
#define PAGE3_B_170_ADDRESS 0x64A0
#define PAGE3_B_171_ADDRESS 0x64B0
#define PAGE3_B_172_ADDRESS 0x64C0
#define PAGE3_B_173_ADDRESS 0x64D0
#define PAGE3_B_174_ADDRESS 0x64E0
#define PAGE3_B_175_ADDRESS 0x64F0
#define PAGE3_B_176_ADDRESS 0x6500
#define PAGE3_B_177_ADDRESS 0x6510
#define PAGE3_B_178_ADDRESS 0x6520
#define PAGE3_B_179_ADDRESS 0x6530
#define PAGE3_B_180_ADDRESS 0x6540
#define PAGE3_B_181_ADDRESS 0x6550
#define PAGE3_B_182_ADDRESS 0x6560
#define PAGE3_B_183_ADDRESS 0x6570
#define PAGE3_B_184_ADDRESS 0x6580
#define PAGE3_B_185_ADDRESS 0x6590
#define PAGE3_B_186_ADDRESS 0x65A0
#define PAGE3_B_187_ADDRESS 0x65B0
#define PAGE3_B_188_ADDRESS 0x65C0
#define PAGE3_B_189_ADDRESS 0x65D0
#define PAGE3_B_190_ADDRESS 0x65E0
#define PAGE3_B_191_ADDRESS 0x65F0
#define PAGE3_B_192_ADDRESS 0x6600
#define PAGE3_B_193_ADDRESS 0x6610
#define PAGE3_B_194_ADDRESS 0x6620
#define PAGE3_B_195_ADDRESS 0x6630
#define PAGE3_B_196_ADDRESS 0x6640
#define PAGE3_B_197_ADDRESS 0x6650
#define PAGE3_B_198_ADDRESS 0x6660
#define PAGE3_B_199_ADDRESS 0x6670
#define PAGE3_B_200_ADDRESS 0x6680
#define PAGE3_B_201_ADDRESS 0x6690
#define PAGE3_B_202_ADDRESS 0x66A0
#define PAGE3_B_203_ADDRESS 0x66B0
#define PAGE3_B_204_ADDRESS 0x66C0
#define PAGE3_B_205_ADDRESS 0x66D0
#define PAGE3_B_206_ADDRESS 0x66E0
#define PAGE3_B_207_ADDRESS 0x66F0
#define PAGE3_B_208_ADDRESS 0x6700
#define PAGE3_B_209_ADDRESS 0x6710
#define PAGE3_B_210_ADDRESS 0x6720
#define PAGE3_B_211_ADDRESS 0x6730
#define PAGE3_B_212_ADDRESS 0x6740
#define PAGE3_B_213_ADDRESS 0x6750
#define PAGE3_B_214_ADDRESS 0x6760
#define PAGE3_B_215_ADDRESS 0x6770
#define PAGE3_B_216_ADDRESS 0x6780
#define PAGE3_B_217_ADDRESS 0x6790
#define PAGE3_B_218_ADDRESS 0x67A0
#define PAGE3_B_219_ADDRESS 0x67B0
#define PAGE3_B_220_ADDRESS 0x67C0
#define PAGE3_B_221_ADDRESS 0x67D0
#define PAGE3_B_222_ADDRESS 0x67E0
#define PAGE3_B_223_ADDRESS 0x67F0
#define PAGE3_B_224_ADDRESS 0x6800
#define PAGE3_B_225_ADDRESS 0x6810
#define PAGE3_B_226_ADDRESS 0x6820
#define PAGE3_B_227_ADDRESS 0x6830
#define PAGE3_B_228_ADDRESS 0x6840
#define PAGE3_B_229_ADDRESS 0x6850
#define PAGE3_B_230_ADDRESS 0x6860
#define PAGE3_B_231_ADDRESS 0x6870
#define PAGE3_B_232_ADDRESS 0x6880
#define PAGE3_B_233_ADDRESS 0x6890
#define PAGE3_B_234_ADDRESS 0x68A0
#define PAGE3_B_235_ADDRESS 0x68B0
#define PAGE3_B_236_ADDRESS 0x68C0
#define PAGE3_B_237_ADDRESS 0x68D0
#define PAGE3_B_238_ADDRESS 0x68E0
#define PAGE3_B_239_ADDRESS 0x68F0
#define PAGE3_B_240_ADDRESS 0x6900
#define PAGE3_B_241_ADDRESS 0x6910
#define PAGE3_B_242_ADDRESS 0x6920
#define PAGE3_B_243_ADDRESS 0x6930
#define PAGE3_B_244_ADDRESS 0x6940
#define PAGE3_B_245_ADDRESS 0x6950
#define PAGE3_B_246_ADDRESS 0x6960
#define PAGE3_B_247_ADDRESS 0x6970
#define PAGE3_B_248_ADDRESS 0x6980
#define PAGE3_B_249_ADDRESS 0x6990
#define PAGE3_B_250_ADDRESS 0x69A0
#define PAGE3_B_251_ADDRESS 0x69B0
#define PAGE3_B_252_ADDRESS 0x69C0
#define PAGE3_B_253_ADDRESS 0x69D0
#define PAGE3_B_254_ADDRESS 0x69E0
#define PAGE3_B_255_ADDRESS 0x69F0
#define PAGE3_B_256_ADDRESS 0x6A00
#define PAGE3_B_257_ADDRESS 0x6A10
#define PAGE3_B_258_ADDRESS 0x6A20
#define PAGE3_B_259_ADDRESS 0x6A30
#define PAGE3_B_260_ADDRESS 0x6A40
#define PAGE3_B_261_ADDRESS 0x6A50
#define PAGE3_B_262_ADDRESS 0x6A60
#define PAGE3_B_263_ADDRESS 0x6A70
#define PAGE3_B_264_ADDRESS 0x6A80
#define PAGE3_B_265_ADDRESS 0x6A90
#define PAGE3_B_266_ADDRESS 0x6AA0
#define PAGE3_B_267_ADDRESS 0x6AB0
#define PAGE3_B_268_ADDRESS 0x6AC0
#define PAGE3_B_269_ADDRESS 0x6AD0
#define PAGE3_B_270_ADDRESS 0x6AE0
#define PAGE3_B_271_ADDRESS 0x6AF0
#define PAGE3_B_272_ADDRESS 0x6B00
#define PAGE3_B_273_ADDRESS 0x6B10
#define PAGE3_B_274_ADDRESS 0x6B20
#define PAGE3_B_275_ADDRESS 0x6B30
#define PAGE3_B_276_ADDRESS 0x6B40
#define PAGE3_B_277_ADDRESS 0x6B50
#define PAGE3_B_278_ADDRESS 0x6B60
#define PAGE3_B_279_ADDRESS 0x6B70
#define PAGE3_B_280_ADDRESS 0x6B80
#define PAGE3_B_281_ADDRESS 0x6B90
#define PAGE3_B_282_ADDRESS 0x6BA0
#define PAGE3_B_283_ADDRESS 0x6BB0
#define PAGE3_B_284_ADDRESS 0x6BC0
#define PAGE3_B_285_ADDRESS 0x6BD0
#define PAGE3_B_286_ADDRESS 0x6BE0
#define PAGE3_B_287_ADDRESS 0x6BF0
#define PAGE3_B_288_ADDRESS 0x6C00
#define PAGE3_B_289_ADDRESS 0x6C10
#define PAGE3_B_290_ADDRESS 0x6C20
#define PAGE3_B_291_ADDRESS 0x6C30
#define PAGE3_B_292_ADDRESS 0x6C40
#define PAGE3_B_293_ADDRESS 0x6C50
#define PAGE3_B_294_ADDRESS 0x6C60
#define PAGE3_B_295_ADDRESS 0x6C70
#define PAGE3_B_296_ADDRESS 0x6C80
#define PAGE3_B_297_ADDRESS 0x6C90
#define PAGE3_B_298_ADDRESS 0x6CA0
#define PAGE3_B_299_ADDRESS 0x6CB0
#define PAGE3_B_300_ADDRESS 0x6CC0
#define PAGE3_B_301_ADDRESS 0x6CD0
#define PAGE3_B_302_ADDRESS 0x6CE0
#define PAGE3_B_303_ADDRESS 0x6CF0
#define PAGE3_B_304_ADDRESS 0x6D00
#define PAGE3_B_305_ADDRESS 0x6D10
#define PAGE3_B_306_ADDRESS 0x6D20
#define PAGE3_B_307_ADDRESS 0x6D30
#define PAGE3_B_308_ADDRESS 0x6D40
#define PAGE3_B_309_ADDRESS 0x6D50
#define PAGE3_B_310_ADDRESS 0x6D60
#define PAGE3_B_311_ADDRESS 0x6D70
#define PAGE3_B_312_ADDRESS 0x6D80
#define PAGE3_B_313_ADDRESS 0x6D90
#define PAGE3_B_314_ADDRESS 0x6DA0
#define PAGE3_B_315_ADDRESS 0x6DB0
#define PAGE3_B_316_ADDRESS 0x6DC0
#define PAGE3_B_317_ADDRESS 0x6DD0
#define PAGE3_B_318_ADDRESS 0x6DE0
#define PAGE3_B_319_ADDRESS 0x6DF0
#define PAGE3_B_320_ADDRESS 0x6E00
#define PAGE3_B_321_ADDRESS 0x6E10
#define PAGE3_B_322_ADDRESS 0x6E20
#define PAGE3_B_323_ADDRESS 0x6E30
#define PAGE3_B_324_ADDRESS 0x6E40
#define PAGE3_B_325_ADDRESS 0x6E50
#define PAGE3_B_326_ADDRESS 0x6E60
#define PAGE3_B_327_ADDRESS 0x6E70
#define PAGE3_B_328_ADDRESS 0x6E80
#define PAGE3_B_329_ADDRESS 0x6E90
#define PAGE3_B_330_ADDRESS 0x6EA0
#define PAGE3_B_331_ADDRESS 0x6EB0
#define PAGE3_B_332_ADDRESS 0x6EC0
#define PAGE3_B_333_ADDRESS 0x6ED0
#define PAGE3_B_334_ADDRESS 0x6EE0
#define PAGE3_B_335_ADDRESS 0x6EF0
#define PAGE3_B_336_ADDRESS 0x6F00
#define PAGE3_B_337_ADDRESS 0x6F10
#define PAGE3_B_338_ADDRESS 0x6F20
#define PAGE3_B_339_ADDRESS 0x6F30
#define PAGE3_B_340_ADDRESS 0x6F40
#define PAGE3_B_341_ADDRESS 0x6F50
#define PAGE3_B_342_ADDRESS 0x6F60
#define PAGE3_B_343_ADDRESS 0x6F70
#define PAGE3_B_344_ADDRESS 0x6F80
#define PAGE3_B_345_ADDRESS 0x6F90
#define PAGE3_B_346_ADDRESS 0x6FA0
#define PAGE3_B_347_ADDRESS 0x6FB0
#define PAGE3_B_348_ADDRESS 0x6FC0
#define PAGE3_B_349_ADDRESS 0x6FD0
#define PAGE3_B_350_ADDRESS 0x6FE0
#define PAGE3_B_351_ADDRESS 0x6FF0
#define PAGE3_B_352_ADDRESS 0x7000
#define PAGE3_B_353_ADDRESS 0x7010
#define PAGE3_B_354_ADDRESS 0x7020
#define PAGE3_B_355_ADDRESS 0x7030
#define PAGE3_B_356_ADDRESS 0x7040
#define PAGE3_B_357_ADDRESS 0x7050
#define PAGE3_B_358_ADDRESS 0x7060
#define PAGE3_B_359_ADDRESS 0x7070
#define PAGE3_B_360_ADDRESS 0x7080
#define PAGE3_B_361_ADDRESS 0x7090
#define PAGE3_B_362_ADDRESS 0x70A0
#define PAGE3_B_363_ADDRESS 0x70B0
#define PAGE3_B_364_ADDRESS 0x70C0
#define PAGE3_B_365_ADDRESS 0x70D0
#define PAGE3_B_366_ADDRESS 0x70E0
#define PAGE3_B_367_ADDRESS 0x70F0
#define PAGE3_B_368_ADDRESS 0x7100
#define PAGE3_B_369_ADDRESS 0x7110
#define PAGE3_B_370_ADDRESS 0x7120
#define PAGE3_B_371_ADDRESS 0x7130
#define PAGE3_B_372_ADDRESS 0x7140
#define PAGE3_B_373_ADDRESS 0x7150
#define PAGE3_B_374_ADDRESS 0x7160
#define PAGE3_B_375_ADDRESS 0x7170
#define PAGE3_B_376_ADDRESS 0x7180
#define PAGE3_B_377_ADDRESS 0x7190
#define PAGE3_B_378_ADDRESS 0x71A0
#define PAGE3_B_379_ADDRESS 0x71B0
#define PAGE3_B_380_ADDRESS 0x71C0
#define PAGE3_B_381_ADDRESS 0x71D0
#define PAGE3_B_382_ADDRESS 0x71E0
#define PAGE3_B_383_ADDRESS 0x71F0
#define PAGE3_B_384_ADDRESS 0x7200
#define PAGE3_B_385_ADDRESS 0x7210
#define PAGE3_B_386_ADDRESS 0x7220
#define PAGE3_B_387_ADDRESS 0x7230
#define PAGE3_B_388_ADDRESS 0x7240
#define PAGE3_B_389_ADDRESS 0x7250
#define PAGE3_B_390_ADDRESS 0x7260
#define PAGE3_B_391_ADDRESS 0x7270
#define PAGE3_B_392_ADDRESS 0x7280
#define PAGE3_B_393_ADDRESS 0x7290
#define PAGE3_B_394_ADDRESS 0x72A0
#define PAGE3_B_395_ADDRESS 0x72B0
#define PAGE3_B_396_ADDRESS 0x72C0
#define PAGE3_B_397_ADDRESS 0x72D0
#define PAGE3_B_398_ADDRESS 0x72E0
#define PAGE3_B_399_ADDRESS 0x72F0
#define PAGE3_B_400_ADDRESS 0x7300
#define PAGE3_B_401_ADDRESS 0x7310
#define PAGE3_B_402_ADDRESS 0x7320
#define PAGE3_B_403_ADDRESS 0x7330
#define PAGE3_B_404_ADDRESS 0x7340
#define PAGE3_B_405_ADDRESS 0x7350
#define PAGE3_B_406_ADDRESS 0x7360
#define PAGE3_B_407_ADDRESS 0x7370
#define PAGE3_B_408_ADDRESS 0x7380
#define PAGE3_B_409_ADDRESS 0x7390
#define PAGE3_B_410_ADDRESS 0x73A0
#define PAGE3_B_411_ADDRESS 0x73B0
#define PAGE3_B_412_ADDRESS 0x73C0
#define PAGE3_B_413_ADDRESS 0x73D0
#define PAGE3_B_414_ADDRESS 0x73E0
#define PAGE3_B_415_ADDRESS 0x73F0
#define PAGE3_B_416_ADDRESS 0x7400
#define PAGE3_B_417_ADDRESS 0x7410
#define PAGE3_B_418_ADDRESS 0x7420
#define PAGE3_B_419_ADDRESS 0x7430
#define PAGE3_B_420_ADDRESS 0x7440
#define PAGE3_B_421_ADDRESS 0x7450
#define PAGE3_B_422_ADDRESS 0x7460
#define PAGE3_B_423_ADDRESS 0x7470
#define PAGE3_B_424_ADDRESS 0x7480
#define PAGE3_B_425_ADDRESS 0x7490
#define PAGE3_B_426_ADDRESS 0x74A0
#define PAGE3_B_427_ADDRESS 0x74B0
#define PAGE3_B_428_ADDRESS 0x74C0
#define PAGE3_B_429_ADDRESS 0x74D0
#define PAGE3_B_430_ADDRESS 0x74E0
#define PAGE3_B_431_ADDRESS 0x74F0
#define PAGE3_B_432_ADDRESS 0x7500
#define PAGE3_B_433_ADDRESS 0x7510
#define PAGE3_B_434_ADDRESS 0x7520
#define PAGE3_B_435_ADDRESS 0x7530
#define PAGE3_B_436_ADDRESS 0x7540
#define PAGE3_B_437_ADDRESS 0x7550
#define PAGE3_B_438_ADDRESS 0x7560
#define PAGE3_B_439_ADDRESS 0x7570
#define PAGE3_B_440_ADDRESS 0x7580
#define PAGE3_B_441_ADDRESS 0x7590
#define PAGE3_B_442_ADDRESS 0x75A0
#define PAGE3_B_443_ADDRESS 0x75B0
#define PAGE3_B_444_ADDRESS 0x75C0
#define PAGE3_B_445_ADDRESS 0x75D0
#define PAGE3_B_446_ADDRESS 0x75E0
#define PAGE3_B_447_ADDRESS 0x75F0
#define PAGE3_B_448_ADDRESS 0x7600
#define PAGE3_B_449_ADDRESS 0x7610
#define PAGE3_B_450_ADDRESS 0x7620
#define PAGE3_B_451_ADDRESS 0x7630
#define PAGE3_B_452_ADDRESS 0x7640
#define PAGE3_B_453_ADDRESS 0x7650
#define PAGE3_B_454_ADDRESS 0x7660
#define PAGE3_B_455_ADDRESS 0x7670
#define PAGE3_B_456_ADDRESS 0x7680
#define PAGE3_B_457_ADDRESS 0x7690
#define PAGE3_B_458_ADDRESS 0x76A0
#define PAGE3_B_459_ADDRESS 0x76B0
#define PAGE3_B_460_ADDRESS 0x76C0
#define PAGE3_B_461_ADDRESS 0x76D0
#define PAGE3_B_462_ADDRESS 0x76E0
#define PAGE3_B_463_ADDRESS 0x76F0
#define PAGE3_B_464_ADDRESS 0x7700
#define PAGE3_B_465_ADDRESS 0x7710
#define PAGE3_B_466_ADDRESS 0x7720
#define PAGE3_B_467_ADDRESS 0x7730
#define PAGE3_B_468_ADDRESS 0x7740
#define PAGE3_B_469_ADDRESS 0x7750
#define PAGE3_B_470_ADDRESS 0x7760
#define PAGE3_B_471_ADDRESS 0x7770
#define PAGE3_B_472_ADDRESS 0x7780
#define PAGE3_B_473_ADDRESS 0x7790
#define PAGE3_B_474_ADDRESS 0x77A0
#define PAGE3_B_475_ADDRESS 0x77B0
#define PAGE3_B_476_ADDRESS 0x77C0
#define PAGE3_B_477_ADDRESS 0x77D0
#define PAGE3_B_478_ADDRESS 0x77E0
#define PAGE3_B_479_ADDRESS 0x77F0
#define PAGE3_B_480_ADDRESS 0x7800
#define PAGE3_B_481_ADDRESS 0x7810
#define PAGE3_B_482_ADDRESS 0x7820
#define PAGE3_B_483_ADDRESS 0x7830
#define PAGE3_B_484_ADDRESS 0x7840
#define PAGE3_B_485_ADDRESS 0x7850
#define PAGE3_B_486_ADDRESS 0x7860
#define PAGE3_B_487_ADDRESS 0x7870
#define PAGE3_B_488_ADDRESS 0x7880
#define PAGE3_B_489_ADDRESS 0x7890
#define PAGE3_B_490_ADDRESS 0x78A0
#define PAGE3_B_491_ADDRESS 0x78B0
#define PAGE3_B_492_ADDRESS 0x78C0
#define PAGE3_B_493_ADDRESS 0x78D0
#define PAGE3_B_494_ADDRESS 0x78E0
#define PAGE3_B_495_ADDRESS 0x78F0
#define PAGE3_B_496_ADDRESS 0x7900
#define PAGE3_B_497_ADDRESS 0x7910
#define PAGE3_B_498_ADDRESS 0x7920
#define PAGE3_B_499_ADDRESS 0x7930
#define PAGE3_B_500_ADDRESS 0x7940
#define PAGE3_B_501_ADDRESS 0x7950
#define PAGE3_B_502_ADDRESS 0x7960
#define PAGE3_B_503_ADDRESS 0x7970
#define PAGE3_B_504_ADDRESS 0x7980
#define PAGE3_B_505_ADDRESS 0x7990
#define PAGE3_B_506_ADDRESS 0x79A0
#define PAGE3_B_507_ADDRESS 0x79B0
#define PAGE3_B_508_ADDRESS 0x79C0
#define PAGE3_B_509_ADDRESS 0x79D0
#define PAGE3_B_510_ADDRESS 0x79E0
#define PAGE3_B_511_ADDRESS 0x79F0
#define PAGE3_B_512_ADDRESS 0x7A00
#define PAGE3_B_513_ADDRESS 0x7A10
#define PAGE3_B_514_ADDRESS 0x7A20
#define PAGE3_B_515_ADDRESS 0x7A30
#define PAGE3_B_516_ADDRESS 0x7A40
#define PAGE3_B_517_ADDRESS 0x7A50
#define PAGE3_B_518_ADDRESS 0x7A60
#define PAGE3_B_519_ADDRESS 0x7A70
#define PAGE3_B_520_ADDRESS 0x7A80
#define PAGE3_B_521_ADDRESS 0x7A90
#define PAGE3_B_522_ADDRESS 0x7AA0
#define PAGE3_B_523_ADDRESS 0x7AB0
#define PAGE3_B_524_ADDRESS 0x7AC0
#define PAGE3_B_525_ADDRESS 0x7AD0
#define PAGE3_B_526_ADDRESS 0x7AE0
#define PAGE3_B_527_ADDRESS 0x7AF0
#define PAGE3_B_528_ADDRESS 0x7B00
#define PAGE3_B_529_ADDRESS 0x7B10
#define PAGE3_B_530_ADDRESS 0x7B20
#define PAGE3_B_531_ADDRESS 0x7B30
#define PAGE3_B_532_ADDRESS 0x7B40
#define PAGE3_B_533_ADDRESS 0x7B50
#define PAGE3_B_534_ADDRESS 0x7B60
#define PAGE3_B_535_ADDRESS 0x7B70
#define PAGE3_B_536_ADDRESS 0x7B80
#define PAGE3_B_537_ADDRESS 0x7B90
#define PAGE3_B_538_ADDRESS 0x7BA0
#define PAGE3_B_539_ADDRESS 0x7BB0
#define PAGE3_B_540_ADDRESS 0x7BC0
#define PAGE3_B_541_ADDRESS 0x7BD0
#define PAGE3_B_542_ADDRESS 0x7BE0
#define PAGE3_B_543_ADDRESS 0x7BF0
#define PAGE3_B_544_ADDRESS 0x7C00
#define PAGE3_B_545_ADDRESS 0x7C10
#define PAGE3_B_546_ADDRESS 0x7C20
#define PAGE3_B_547_ADDRESS 0x7C30
#define PAGE3_B_548_ADDRESS 0x7C40
#define PAGE3_B_549_ADDRESS 0x7C50
#define PAGE3_B_550_ADDRESS 0x7C60
#define PAGE3_B_551_ADDRESS 0x7C70
#define PAGE3_B_552_ADDRESS 0x7C80
#define PAGE3_B_553_ADDRESS 0x7C90
#define PAGE3_B_554_ADDRESS 0x7CA0
#define PAGE3_B_555_ADDRESS 0x7CB0
#define PAGE3_B_556_ADDRESS 0x7CC0
#define PAGE3_B_557_ADDRESS 0x7CD0
#define PAGE3_B_558_ADDRESS 0x7CE0
#define PAGE3_B_559_ADDRESS 0x7CF0
#define PAGE3_B_560_ADDRESS 0x7D00
#define PAGE3_B_561_ADDRESS 0x7D10
#define PAGE3_B_562_ADDRESS 0x7D20
#define PAGE3_B_563_ADDRESS 0x7D30
#define PAGE3_B_564_ADDRESS 0x7D40
#define PAGE3_B_565_ADDRESS 0x7D50
#define PAGE3_B_566_ADDRESS 0x7D60
#define PAGE3_B_567_ADDRESS 0x7D70
#define PAGE3_B_568_ADDRESS 0x7D80
#define PAGE3_B_569_ADDRESS 0x7D90
#define PAGE3_B_570_ADDRESS 0x7DA0
#define PAGE3_B_571_ADDRESS 0x7DB0
#define PAGE3_B_572_ADDRESS 0x7DC0
#define PAGE3_B_573_ADDRESS 0x7DD0
#define PAGE3_B_574_ADDRESS 0x7DE0
#define PAGE3_B_575_ADDRESS 0x7DF0

#define PAGE3_B_TEXT_01_ADDRESS 0x7E00
#define PAGE3_B_TEXT_01_SIZE 152
#define PAGE3_B_TEXT_01_FORMAT "raw"
#define PAGE3_B_TEXT_01_WIDTH_IN_BYTES 25
#define PAGE3_B_TEXT_01_WIDTH 50
#define PAGE3_B_TEXT_01_HEIGHT 6
#define PAGE3_B_TEXT_01_COUNT 1
#define PAGE3_B_TEXT_01_0_ADDRESS 0x7E00

#define PAGE3_B_TEXT_02_ADDRESS 0x7E98
#define PAGE3_B_TEXT_02_SIZE 110
#define PAGE3_B_TEXT_02_FORMAT "raw"
#define PAGE3_B_TEXT_02_WIDTH_IN_BYTES 18
#define PAGE3_B_TEXT_02_WIDTH 36
#define PAGE3_B_TEXT_02_HEIGHT 6
#define PAGE3_B_TEXT_02_COUNT 1
#define PAGE3_B_TEXT_02_0_ADDRESS 0x7E98

#define PAGE3_B_TEXT_03_ADDRESS 0x7F06
#define PAGE3_B_TEXT_03_SIZE 74
#define PAGE3_B_TEXT_03_FORMAT "raw"
#define PAGE3_B_TEXT_03_WIDTH_IN_BYTES 12
#define PAGE3_B_TEXT_03_WIDTH 24
#define PAGE3_B_TEXT_03_HEIGHT 6
#define PAGE3_B_TEXT_03_COUNT 1
#define PAGE3_B_TEXT_03_0_ADDRESS 0x7F06

#define WHOOOSH_ADDRESS 0x7F50
#define WHOOOSH_SIZE 938
#define WHOOOSH_FORMAT "raw"
#define WHOOOSH_WIDTH_IN_BYTES 9
#define WHOOOSH_WIDTH 18
#define WHOOOSH_HEIGHT 104
#define WHOOOSH_COUNT 1
#define WHOOOSH_0_ADDRESS 0x7F50

#define INTERROGATION_ADDRESS 0x82FA
#define INTERROGATION_SIZE 137
#define INTERROGATION_FORMAT "raw"
#define INTERROGATION_WIDTH_IN_BYTES 5
#define INTERROGATION_WIDTH 10
#define INTERROGATION_HEIGHT 27
#define INTERROGATION_COUNT 1
#define INTERROGATION_0_ADDRESS 0x82FA


extern const u8 comic_e_assets[2165];


#define MUSIC_SECTION_D_ADDRESS 0x5660
#define MUSIC_SECTION_D_SIZE 750

#define BZZZ_ADDRESS 0x594E
#define BZZZ_SIZE 1157
#define BZZZ_FORMAT "raw"
#define BZZZ_WIDTH_IN_BYTES 35
#define BZZZ_WIDTH 70
#define BZZZ_HEIGHT 33
#define BZZZ_COUNT 1
#define BZZZ_0_ADDRESS 0x594E

#define EXCLAMATION_ADDRESS 0x5DD3
#define EXCLAMATION_SIZE 450
#define EXCLAMATION_FORMAT "raw"
#define EXCLAMATION_WIDTH_IN_BYTES 7
#define EXCLAMATION_WIDTH 14
#define EXCLAMATION_HEIGHT 64
#define EXCLAMATION_COUNT 1
#define EXCLAMATION_0_ADDRESS 0x5DD3

#define SHEEP_ADDRESS 0x5F95
#define SHEEP_SIZE 409
#define SHEEP_FORMAT "raw"
#define SHEEP_WIDTH_IN_BYTES 11
#define SHEEP_WIDTH 22
#define SHEEP_HEIGHT 37
#define SHEEP_COUNT 1
#define SHEEP_0_ADDRESS 0x5F95

#define GUNTER_ADDRESS 0x612E
#define GUNTER_SIZE 442
#define GUNTER_FORMAT "raw"
#define GUNTER_WIDTH_IN_BYTES 10
#define GUNTER_WIDTH 20
#define GUNTER_HEIGHT 44
#define GUNTER_COUNT 1
#define GUNTER_0_ADDRESS 0x612E

#define DUCK_ADDRESS 0x62E8
#define DUCK_SIZE 140
#define DUCK_FORMAT "raw"
#define DUCK_WIDTH_IN_BYTES 6
#define DUCK_WIDTH 12
#define DUCK_HEIGHT 23
#define DUCK_COUNT 1
#define DUCK_0_ADDRESS 0x62E8

#define PAGE2_TEXT_01_ADDRESS 0x6374
#define PAGE2_TEXT_01_SIZE 56
#define PAGE2_TEXT_01_FORMAT "raw"
#define PAGE2_TEXT_01_WIDTH_IN_BYTES 9
#define PAGE2_TEXT_01_WIDTH 18
#define PAGE2_TEXT_01_HEIGHT 6
#define PAGE2_TEXT_01_COUNT 1
#define PAGE2_TEXT_01_0_ADDRESS 0x6374

#define PAGE2_TEXT_02_ADDRESS 0x63AC
#define PAGE2_TEXT_02_SIZE 182
#define PAGE2_TEXT_02_FORMAT "raw"
#define PAGE2_TEXT_02_WIDTH_IN_BYTES 30
#define PAGE2_TEXT_02_WIDTH 60
#define PAGE2_TEXT_02_HEIGHT 6
#define PAGE2_TEXT_02_COUNT 1
#define PAGE2_TEXT_02_0_ADDRESS 0x63AC

#define YELP_ADDRESS 0x6462
#define YELP_SIZE 887
#define YELP_FORMAT "raw"
#define YELP_WIDTH_IN_BYTES 15
#define YELP_WIDTH 30
#define YELP_HEIGHT 59
#define YELP_COUNT 1
#define YELP_0_ADDRESS 0x6462

#define PAGE3_A_TOP_ADDRESS 0x67D9
#define PAGE3_A_TOP_SIZE 5632
#define PAGE3_A_TOP_FORMAT "tile"
#define PAGE3_A_TOP_WIDTH_IN_BYTES 2
#define PAGE3_A_TOP_WIDTH 4
#define PAGE3_A_TOP_HEIGHT 8
#define PAGE3_A_TOP_WIDTH_IN_TILES 32
#define PAGE3_A_TOP_HEIGHT_IN_TILES 11
#define PAGE3_A_TOP_COUNT 352
#define PAGE3_A_TOP_0_ADDRESS 0x67D9
#define PAGE3_A_TOP_1_ADDRESS 0x67E9
#define PAGE3_A_TOP_2_ADDRESS 0x67F9
#define PAGE3_A_TOP_3_ADDRESS 0x6809
#define PAGE3_A_TOP_4_ADDRESS 0x6819
#define PAGE3_A_TOP_5_ADDRESS 0x6829
#define PAGE3_A_TOP_6_ADDRESS 0x6839
#define PAGE3_A_TOP_7_ADDRESS 0x6849
#define PAGE3_A_TOP_8_ADDRESS 0x6859
#define PAGE3_A_TOP_9_ADDRESS 0x6869
#define PAGE3_A_TOP_10_ADDRESS 0x6879
#define PAGE3_A_TOP_11_ADDRESS 0x6889
#define PAGE3_A_TOP_12_ADDRESS 0x6899
#define PAGE3_A_TOP_13_ADDRESS 0x68A9
#define PAGE3_A_TOP_14_ADDRESS 0x68B9
#define PAGE3_A_TOP_15_ADDRESS 0x68C9
#define PAGE3_A_TOP_16_ADDRESS 0x68D9
#define PAGE3_A_TOP_17_ADDRESS 0x68E9
#define PAGE3_A_TOP_18_ADDRESS 0x68F9
#define PAGE3_A_TOP_19_ADDRESS 0x6909
#define PAGE3_A_TOP_20_ADDRESS 0x6919
#define PAGE3_A_TOP_21_ADDRESS 0x6929
#define PAGE3_A_TOP_22_ADDRESS 0x6939
#define PAGE3_A_TOP_23_ADDRESS 0x6949
#define PAGE3_A_TOP_24_ADDRESS 0x6959
#define PAGE3_A_TOP_25_ADDRESS 0x6969
#define PAGE3_A_TOP_26_ADDRESS 0x6979
#define PAGE3_A_TOP_27_ADDRESS 0x6989
#define PAGE3_A_TOP_28_ADDRESS 0x6999
#define PAGE3_A_TOP_29_ADDRESS 0x69A9
#define PAGE3_A_TOP_30_ADDRESS 0x69B9
#define PAGE3_A_TOP_31_ADDRESS 0x69C9
#define PAGE3_A_TOP_32_ADDRESS 0x69D9
#define PAGE3_A_TOP_33_ADDRESS 0x69E9
#define PAGE3_A_TOP_34_ADDRESS 0x69F9
#define PAGE3_A_TOP_35_ADDRESS 0x6A09
#define PAGE3_A_TOP_36_ADDRESS 0x6A19
#define PAGE3_A_TOP_37_ADDRESS 0x6A29
#define PAGE3_A_TOP_38_ADDRESS 0x6A39
#define PAGE3_A_TOP_39_ADDRESS 0x6A49
#define PAGE3_A_TOP_40_ADDRESS 0x6A59
#define PAGE3_A_TOP_41_ADDRESS 0x6A69
#define PAGE3_A_TOP_42_ADDRESS 0x6A79
#define PAGE3_A_TOP_43_ADDRESS 0x6A89
#define PAGE3_A_TOP_44_ADDRESS 0x6A99
#define PAGE3_A_TOP_45_ADDRESS 0x6AA9
#define PAGE3_A_TOP_46_ADDRESS 0x6AB9
#define PAGE3_A_TOP_47_ADDRESS 0x6AC9
#define PAGE3_A_TOP_48_ADDRESS 0x6AD9
#define PAGE3_A_TOP_49_ADDRESS 0x6AE9
#define PAGE3_A_TOP_50_ADDRESS 0x6AF9
#define PAGE3_A_TOP_51_ADDRESS 0x6B09
#define PAGE3_A_TOP_52_ADDRESS 0x6B19
#define PAGE3_A_TOP_53_ADDRESS 0x6B29
#define PAGE3_A_TOP_54_ADDRESS 0x6B39
#define PAGE3_A_TOP_55_ADDRESS 0x6B49
#define PAGE3_A_TOP_56_ADDRESS 0x6B59
#define PAGE3_A_TOP_57_ADDRESS 0x6B69
#define PAGE3_A_TOP_58_ADDRESS 0x6B79
#define PAGE3_A_TOP_59_ADDRESS 0x6B89
#define PAGE3_A_TOP_60_ADDRESS 0x6B99
#define PAGE3_A_TOP_61_ADDRESS 0x6BA9
#define PAGE3_A_TOP_62_ADDRESS 0x6BB9
#define PAGE3_A_TOP_63_ADDRESS 0x6BC9
#define PAGE3_A_TOP_64_ADDRESS 0x6BD9
#define PAGE3_A_TOP_65_ADDRESS 0x6BE9
#define PAGE3_A_TOP_66_ADDRESS 0x6BF9
#define PAGE3_A_TOP_67_ADDRESS 0x6C09
#define PAGE3_A_TOP_68_ADDRESS 0x6C19
#define PAGE3_A_TOP_69_ADDRESS 0x6C29
#define PAGE3_A_TOP_70_ADDRESS 0x6C39
#define PAGE3_A_TOP_71_ADDRESS 0x6C49
#define PAGE3_A_TOP_72_ADDRESS 0x6C59
#define PAGE3_A_TOP_73_ADDRESS 0x6C69
#define PAGE3_A_TOP_74_ADDRESS 0x6C79
#define PAGE3_A_TOP_75_ADDRESS 0x6C89
#define PAGE3_A_TOP_76_ADDRESS 0x6C99
#define PAGE3_A_TOP_77_ADDRESS 0x6CA9
#define PAGE3_A_TOP_78_ADDRESS 0x6CB9
#define PAGE3_A_TOP_79_ADDRESS 0x6CC9
#define PAGE3_A_TOP_80_ADDRESS 0x6CD9
#define PAGE3_A_TOP_81_ADDRESS 0x6CE9
#define PAGE3_A_TOP_82_ADDRESS 0x6CF9
#define PAGE3_A_TOP_83_ADDRESS 0x6D09
#define PAGE3_A_TOP_84_ADDRESS 0x6D19
#define PAGE3_A_TOP_85_ADDRESS 0x6D29
#define PAGE3_A_TOP_86_ADDRESS 0x6D39
#define PAGE3_A_TOP_87_ADDRESS 0x6D49
#define PAGE3_A_TOP_88_ADDRESS 0x6D59
#define PAGE3_A_TOP_89_ADDRESS 0x6D69
#define PAGE3_A_TOP_90_ADDRESS 0x6D79
#define PAGE3_A_TOP_91_ADDRESS 0x6D89
#define PAGE3_A_TOP_92_ADDRESS 0x6D99
#define PAGE3_A_TOP_93_ADDRESS 0x6DA9
#define PAGE3_A_TOP_94_ADDRESS 0x6DB9
#define PAGE3_A_TOP_95_ADDRESS 0x6DC9
#define PAGE3_A_TOP_96_ADDRESS 0x6DD9
#define PAGE3_A_TOP_97_ADDRESS 0x6DE9
#define PAGE3_A_TOP_98_ADDRESS 0x6DF9
#define PAGE3_A_TOP_99_ADDRESS 0x6E09
#define PAGE3_A_TOP_100_ADDRESS 0x6E19
#define PAGE3_A_TOP_101_ADDRESS 0x6E29
#define PAGE3_A_TOP_102_ADDRESS 0x6E39
#define PAGE3_A_TOP_103_ADDRESS 0x6E49
#define PAGE3_A_TOP_104_ADDRESS 0x6E59
#define PAGE3_A_TOP_105_ADDRESS 0x6E69
#define PAGE3_A_TOP_106_ADDRESS 0x6E79
#define PAGE3_A_TOP_107_ADDRESS 0x6E89
#define PAGE3_A_TOP_108_ADDRESS 0x6E99
#define PAGE3_A_TOP_109_ADDRESS 0x6EA9
#define PAGE3_A_TOP_110_ADDRESS 0x6EB9
#define PAGE3_A_TOP_111_ADDRESS 0x6EC9
#define PAGE3_A_TOP_112_ADDRESS 0x6ED9
#define PAGE3_A_TOP_113_ADDRESS 0x6EE9
#define PAGE3_A_TOP_114_ADDRESS 0x6EF9
#define PAGE3_A_TOP_115_ADDRESS 0x6F09
#define PAGE3_A_TOP_116_ADDRESS 0x6F19
#define PAGE3_A_TOP_117_ADDRESS 0x6F29
#define PAGE3_A_TOP_118_ADDRESS 0x6F39
#define PAGE3_A_TOP_119_ADDRESS 0x6F49
#define PAGE3_A_TOP_120_ADDRESS 0x6F59
#define PAGE3_A_TOP_121_ADDRESS 0x6F69
#define PAGE3_A_TOP_122_ADDRESS 0x6F79
#define PAGE3_A_TOP_123_ADDRESS 0x6F89
#define PAGE3_A_TOP_124_ADDRESS 0x6F99
#define PAGE3_A_TOP_125_ADDRESS 0x6FA9
#define PAGE3_A_TOP_126_ADDRESS 0x6FB9
#define PAGE3_A_TOP_127_ADDRESS 0x6FC9
#define PAGE3_A_TOP_128_ADDRESS 0x6FD9
#define PAGE3_A_TOP_129_ADDRESS 0x6FE9
#define PAGE3_A_TOP_130_ADDRESS 0x6FF9
#define PAGE3_A_TOP_131_ADDRESS 0x7009
#define PAGE3_A_TOP_132_ADDRESS 0x7019
#define PAGE3_A_TOP_133_ADDRESS 0x7029
#define PAGE3_A_TOP_134_ADDRESS 0x7039
#define PAGE3_A_TOP_135_ADDRESS 0x7049
#define PAGE3_A_TOP_136_ADDRESS 0x7059
#define PAGE3_A_TOP_137_ADDRESS 0x7069
#define PAGE3_A_TOP_138_ADDRESS 0x7079
#define PAGE3_A_TOP_139_ADDRESS 0x7089
#define PAGE3_A_TOP_140_ADDRESS 0x7099
#define PAGE3_A_TOP_141_ADDRESS 0x70A9
#define PAGE3_A_TOP_142_ADDRESS 0x70B9
#define PAGE3_A_TOP_143_ADDRESS 0x70C9
#define PAGE3_A_TOP_144_ADDRESS 0x70D9
#define PAGE3_A_TOP_145_ADDRESS 0x70E9
#define PAGE3_A_TOP_146_ADDRESS 0x70F9
#define PAGE3_A_TOP_147_ADDRESS 0x7109
#define PAGE3_A_TOP_148_ADDRESS 0x7119
#define PAGE3_A_TOP_149_ADDRESS 0x7129
#define PAGE3_A_TOP_150_ADDRESS 0x7139
#define PAGE3_A_TOP_151_ADDRESS 0x7149
#define PAGE3_A_TOP_152_ADDRESS 0x7159
#define PAGE3_A_TOP_153_ADDRESS 0x7169
#define PAGE3_A_TOP_154_ADDRESS 0x7179
#define PAGE3_A_TOP_155_ADDRESS 0x7189
#define PAGE3_A_TOP_156_ADDRESS 0x7199
#define PAGE3_A_TOP_157_ADDRESS 0x71A9
#define PAGE3_A_TOP_158_ADDRESS 0x71B9
#define PAGE3_A_TOP_159_ADDRESS 0x71C9
#define PAGE3_A_TOP_160_ADDRESS 0x71D9
#define PAGE3_A_TOP_161_ADDRESS 0x71E9
#define PAGE3_A_TOP_162_ADDRESS 0x71F9
#define PAGE3_A_TOP_163_ADDRESS 0x7209
#define PAGE3_A_TOP_164_ADDRESS 0x7219
#define PAGE3_A_TOP_165_ADDRESS 0x7229
#define PAGE3_A_TOP_166_ADDRESS 0x7239
#define PAGE3_A_TOP_167_ADDRESS 0x7249
#define PAGE3_A_TOP_168_ADDRESS 0x7259
#define PAGE3_A_TOP_169_ADDRESS 0x7269
#define PAGE3_A_TOP_170_ADDRESS 0x7279
#define PAGE3_A_TOP_171_ADDRESS 0x7289
#define PAGE3_A_TOP_172_ADDRESS 0x7299
#define PAGE3_A_TOP_173_ADDRESS 0x72A9
#define PAGE3_A_TOP_174_ADDRESS 0x72B9
#define PAGE3_A_TOP_175_ADDRESS 0x72C9
#define PAGE3_A_TOP_176_ADDRESS 0x72D9
#define PAGE3_A_TOP_177_ADDRESS 0x72E9
#define PAGE3_A_TOP_178_ADDRESS 0x72F9
#define PAGE3_A_TOP_179_ADDRESS 0x7309
#define PAGE3_A_TOP_180_ADDRESS 0x7319
#define PAGE3_A_TOP_181_ADDRESS 0x7329
#define PAGE3_A_TOP_182_ADDRESS 0x7339
#define PAGE3_A_TOP_183_ADDRESS 0x7349
#define PAGE3_A_TOP_184_ADDRESS 0x7359
#define PAGE3_A_TOP_185_ADDRESS 0x7369
#define PAGE3_A_TOP_186_ADDRESS 0x7379
#define PAGE3_A_TOP_187_ADDRESS 0x7389
#define PAGE3_A_TOP_188_ADDRESS 0x7399
#define PAGE3_A_TOP_189_ADDRESS 0x73A9
#define PAGE3_A_TOP_190_ADDRESS 0x73B9
#define PAGE3_A_TOP_191_ADDRESS 0x73C9
#define PAGE3_A_TOP_192_ADDRESS 0x73D9
#define PAGE3_A_TOP_193_ADDRESS 0x73E9
#define PAGE3_A_TOP_194_ADDRESS 0x73F9
#define PAGE3_A_TOP_195_ADDRESS 0x7409
#define PAGE3_A_TOP_196_ADDRESS 0x7419
#define PAGE3_A_TOP_197_ADDRESS 0x7429
#define PAGE3_A_TOP_198_ADDRESS 0x7439
#define PAGE3_A_TOP_199_ADDRESS 0x7449
#define PAGE3_A_TOP_200_ADDRESS 0x7459
#define PAGE3_A_TOP_201_ADDRESS 0x7469
#define PAGE3_A_TOP_202_ADDRESS 0x7479
#define PAGE3_A_TOP_203_ADDRESS 0x7489
#define PAGE3_A_TOP_204_ADDRESS 0x7499
#define PAGE3_A_TOP_205_ADDRESS 0x74A9
#define PAGE3_A_TOP_206_ADDRESS 0x74B9
#define PAGE3_A_TOP_207_ADDRESS 0x74C9
#define PAGE3_A_TOP_208_ADDRESS 0x74D9
#define PAGE3_A_TOP_209_ADDRESS 0x74E9
#define PAGE3_A_TOP_210_ADDRESS 0x74F9
#define PAGE3_A_TOP_211_ADDRESS 0x7509
#define PAGE3_A_TOP_212_ADDRESS 0x7519
#define PAGE3_A_TOP_213_ADDRESS 0x7529
#define PAGE3_A_TOP_214_ADDRESS 0x7539
#define PAGE3_A_TOP_215_ADDRESS 0x7549
#define PAGE3_A_TOP_216_ADDRESS 0x7559
#define PAGE3_A_TOP_217_ADDRESS 0x7569
#define PAGE3_A_TOP_218_ADDRESS 0x7579
#define PAGE3_A_TOP_219_ADDRESS 0x7589
#define PAGE3_A_TOP_220_ADDRESS 0x7599
#define PAGE3_A_TOP_221_ADDRESS 0x75A9
#define PAGE3_A_TOP_222_ADDRESS 0x75B9
#define PAGE3_A_TOP_223_ADDRESS 0x75C9
#define PAGE3_A_TOP_224_ADDRESS 0x75D9
#define PAGE3_A_TOP_225_ADDRESS 0x75E9
#define PAGE3_A_TOP_226_ADDRESS 0x75F9
#define PAGE3_A_TOP_227_ADDRESS 0x7609
#define PAGE3_A_TOP_228_ADDRESS 0x7619
#define PAGE3_A_TOP_229_ADDRESS 0x7629
#define PAGE3_A_TOP_230_ADDRESS 0x7639
#define PAGE3_A_TOP_231_ADDRESS 0x7649
#define PAGE3_A_TOP_232_ADDRESS 0x7659
#define PAGE3_A_TOP_233_ADDRESS 0x7669
#define PAGE3_A_TOP_234_ADDRESS 0x7679
#define PAGE3_A_TOP_235_ADDRESS 0x7689
#define PAGE3_A_TOP_236_ADDRESS 0x7699
#define PAGE3_A_TOP_237_ADDRESS 0x76A9
#define PAGE3_A_TOP_238_ADDRESS 0x76B9
#define PAGE3_A_TOP_239_ADDRESS 0x76C9
#define PAGE3_A_TOP_240_ADDRESS 0x76D9
#define PAGE3_A_TOP_241_ADDRESS 0x76E9
#define PAGE3_A_TOP_242_ADDRESS 0x76F9
#define PAGE3_A_TOP_243_ADDRESS 0x7709
#define PAGE3_A_TOP_244_ADDRESS 0x7719
#define PAGE3_A_TOP_245_ADDRESS 0x7729
#define PAGE3_A_TOP_246_ADDRESS 0x7739
#define PAGE3_A_TOP_247_ADDRESS 0x7749
#define PAGE3_A_TOP_248_ADDRESS 0x7759
#define PAGE3_A_TOP_249_ADDRESS 0x7769
#define PAGE3_A_TOP_250_ADDRESS 0x7779
#define PAGE3_A_TOP_251_ADDRESS 0x7789
#define PAGE3_A_TOP_252_ADDRESS 0x7799
#define PAGE3_A_TOP_253_ADDRESS 0x77A9
#define PAGE3_A_TOP_254_ADDRESS 0x77B9
#define PAGE3_A_TOP_255_ADDRESS 0x77C9
#define PAGE3_A_TOP_256_ADDRESS 0x77D9
#define PAGE3_A_TOP_257_ADDRESS 0x77E9
#define PAGE3_A_TOP_258_ADDRESS 0x77F9
#define PAGE3_A_TOP_259_ADDRESS 0x7809
#define PAGE3_A_TOP_260_ADDRESS 0x7819
#define PAGE3_A_TOP_261_ADDRESS 0x7829
#define PAGE3_A_TOP_262_ADDRESS 0x7839
#define PAGE3_A_TOP_263_ADDRESS 0x7849
#define PAGE3_A_TOP_264_ADDRESS 0x7859
#define PAGE3_A_TOP_265_ADDRESS 0x7869
#define PAGE3_A_TOP_266_ADDRESS 0x7879
#define PAGE3_A_TOP_267_ADDRESS 0x7889
#define PAGE3_A_TOP_268_ADDRESS 0x7899
#define PAGE3_A_TOP_269_ADDRESS 0x78A9
#define PAGE3_A_TOP_270_ADDRESS 0x78B9
#define PAGE3_A_TOP_271_ADDRESS 0x78C9
#define PAGE3_A_TOP_272_ADDRESS 0x78D9
#define PAGE3_A_TOP_273_ADDRESS 0x78E9
#define PAGE3_A_TOP_274_ADDRESS 0x78F9
#define PAGE3_A_TOP_275_ADDRESS 0x7909
#define PAGE3_A_TOP_276_ADDRESS 0x7919
#define PAGE3_A_TOP_277_ADDRESS 0x7929
#define PAGE3_A_TOP_278_ADDRESS 0x7939
#define PAGE3_A_TOP_279_ADDRESS 0x7949
#define PAGE3_A_TOP_280_ADDRESS 0x7959
#define PAGE3_A_TOP_281_ADDRESS 0x7969
#define PAGE3_A_TOP_282_ADDRESS 0x7979
#define PAGE3_A_TOP_283_ADDRESS 0x7989
#define PAGE3_A_TOP_284_ADDRESS 0x7999
#define PAGE3_A_TOP_285_ADDRESS 0x79A9
#define PAGE3_A_TOP_286_ADDRESS 0x79B9
#define PAGE3_A_TOP_287_ADDRESS 0x79C9
#define PAGE3_A_TOP_288_ADDRESS 0x79D9
#define PAGE3_A_TOP_289_ADDRESS 0x79E9
#define PAGE3_A_TOP_290_ADDRESS 0x79F9
#define PAGE3_A_TOP_291_ADDRESS 0x7A09
#define PAGE3_A_TOP_292_ADDRESS 0x7A19
#define PAGE3_A_TOP_293_ADDRESS 0x7A29
#define PAGE3_A_TOP_294_ADDRESS 0x7A39
#define PAGE3_A_TOP_295_ADDRESS 0x7A49
#define PAGE3_A_TOP_296_ADDRESS 0x7A59
#define PAGE3_A_TOP_297_ADDRESS 0x7A69
#define PAGE3_A_TOP_298_ADDRESS 0x7A79
#define PAGE3_A_TOP_299_ADDRESS 0x7A89
#define PAGE3_A_TOP_300_ADDRESS 0x7A99
#define PAGE3_A_TOP_301_ADDRESS 0x7AA9
#define PAGE3_A_TOP_302_ADDRESS 0x7AB9
#define PAGE3_A_TOP_303_ADDRESS 0x7AC9
#define PAGE3_A_TOP_304_ADDRESS 0x7AD9
#define PAGE3_A_TOP_305_ADDRESS 0x7AE9
#define PAGE3_A_TOP_306_ADDRESS 0x7AF9
#define PAGE3_A_TOP_307_ADDRESS 0x7B09
#define PAGE3_A_TOP_308_ADDRESS 0x7B19
#define PAGE3_A_TOP_309_ADDRESS 0x7B29
#define PAGE3_A_TOP_310_ADDRESS 0x7B39
#define PAGE3_A_TOP_311_ADDRESS 0x7B49
#define PAGE3_A_TOP_312_ADDRESS 0x7B59
#define PAGE3_A_TOP_313_ADDRESS 0x7B69
#define PAGE3_A_TOP_314_ADDRESS 0x7B79
#define PAGE3_A_TOP_315_ADDRESS 0x7B89
#define PAGE3_A_TOP_316_ADDRESS 0x7B99
#define PAGE3_A_TOP_317_ADDRESS 0x7BA9
#define PAGE3_A_TOP_318_ADDRESS 0x7BB9
#define PAGE3_A_TOP_319_ADDRESS 0x7BC9
#define PAGE3_A_TOP_320_ADDRESS 0x7BD9
#define PAGE3_A_TOP_321_ADDRESS 0x7BE9
#define PAGE3_A_TOP_322_ADDRESS 0x7BF9
#define PAGE3_A_TOP_323_ADDRESS 0x7C09
#define PAGE3_A_TOP_324_ADDRESS 0x7C19
#define PAGE3_A_TOP_325_ADDRESS 0x7C29
#define PAGE3_A_TOP_326_ADDRESS 0x7C39
#define PAGE3_A_TOP_327_ADDRESS 0x7C49
#define PAGE3_A_TOP_328_ADDRESS 0x7C59
#define PAGE3_A_TOP_329_ADDRESS 0x7C69
#define PAGE3_A_TOP_330_ADDRESS 0x7C79
#define PAGE3_A_TOP_331_ADDRESS 0x7C89
#define PAGE3_A_TOP_332_ADDRESS 0x7C99
#define PAGE3_A_TOP_333_ADDRESS 0x7CA9
#define PAGE3_A_TOP_334_ADDRESS 0x7CB9
#define PAGE3_A_TOP_335_ADDRESS 0x7CC9
#define PAGE3_A_TOP_336_ADDRESS 0x7CD9
#define PAGE3_A_TOP_337_ADDRESS 0x7CE9
#define PAGE3_A_TOP_338_ADDRESS 0x7CF9
#define PAGE3_A_TOP_339_ADDRESS 0x7D09
#define PAGE3_A_TOP_340_ADDRESS 0x7D19
#define PAGE3_A_TOP_341_ADDRESS 0x7D29
#define PAGE3_A_TOP_342_ADDRESS 0x7D39
#define PAGE3_A_TOP_343_ADDRESS 0x7D49
#define PAGE3_A_TOP_344_ADDRESS 0x7D59
#define PAGE3_A_TOP_345_ADDRESS 0x7D69
#define PAGE3_A_TOP_346_ADDRESS 0x7D79
#define PAGE3_A_TOP_347_ADDRESS 0x7D89
#define PAGE3_A_TOP_348_ADDRESS 0x7D99
#define PAGE3_A_TOP_349_ADDRESS 0x7DA9
#define PAGE3_A_TOP_350_ADDRESS 0x7DB9
#define PAGE3_A_TOP_351_ADDRESS 0x7DC9

#define PAGE3_A_BOTTOM_ADDRESS 0x7DD9
#define PAGE3_A_BOTTOM_SIZE 2560
#define PAGE3_A_BOTTOM_FORMAT "tile"
#define PAGE3_A_BOTTOM_WIDTH_IN_BYTES 2
#define PAGE3_A_BOTTOM_WIDTH 4
#define PAGE3_A_BOTTOM_HEIGHT 8
#define PAGE3_A_BOTTOM_WIDTH_IN_TILES 32
#define PAGE3_A_BOTTOM_HEIGHT_IN_TILES 5
#define PAGE3_A_BOTTOM_COUNT 160
#define PAGE3_A_BOTTOM_0_ADDRESS 0x7DD9
#define PAGE3_A_BOTTOM_1_ADDRESS 0x7DE9
#define PAGE3_A_BOTTOM_2_ADDRESS 0x7DF9
#define PAGE3_A_BOTTOM_3_ADDRESS 0x7E09
#define PAGE3_A_BOTTOM_4_ADDRESS 0x7E19
#define PAGE3_A_BOTTOM_5_ADDRESS 0x7E29
#define PAGE3_A_BOTTOM_6_ADDRESS 0x7E39
#define PAGE3_A_BOTTOM_7_ADDRESS 0x7E49
#define PAGE3_A_BOTTOM_8_ADDRESS 0x7E59
#define PAGE3_A_BOTTOM_9_ADDRESS 0x7E69
#define PAGE3_A_BOTTOM_10_ADDRESS 0x7E79
#define PAGE3_A_BOTTOM_11_ADDRESS 0x7E89
#define PAGE3_A_BOTTOM_12_ADDRESS 0x7E99
#define PAGE3_A_BOTTOM_13_ADDRESS 0x7EA9
#define PAGE3_A_BOTTOM_14_ADDRESS 0x7EB9
#define PAGE3_A_BOTTOM_15_ADDRESS 0x7EC9
#define PAGE3_A_BOTTOM_16_ADDRESS 0x7ED9
#define PAGE3_A_BOTTOM_17_ADDRESS 0x7EE9
#define PAGE3_A_BOTTOM_18_ADDRESS 0x7EF9
#define PAGE3_A_BOTTOM_19_ADDRESS 0x7F09
#define PAGE3_A_BOTTOM_20_ADDRESS 0x7F19
#define PAGE3_A_BOTTOM_21_ADDRESS 0x7F29
#define PAGE3_A_BOTTOM_22_ADDRESS 0x7F39
#define PAGE3_A_BOTTOM_23_ADDRESS 0x7F49
#define PAGE3_A_BOTTOM_24_ADDRESS 0x7F59
#define PAGE3_A_BOTTOM_25_ADDRESS 0x7F69
#define PAGE3_A_BOTTOM_26_ADDRESS 0x7F79
#define PAGE3_A_BOTTOM_27_ADDRESS 0x7F89
#define PAGE3_A_BOTTOM_28_ADDRESS 0x7F99
#define PAGE3_A_BOTTOM_29_ADDRESS 0x7FA9
#define PAGE3_A_BOTTOM_30_ADDRESS 0x7FB9
#define PAGE3_A_BOTTOM_31_ADDRESS 0x7FC9
#define PAGE3_A_BOTTOM_32_ADDRESS 0x7FD9
#define PAGE3_A_BOTTOM_33_ADDRESS 0x7FE9
#define PAGE3_A_BOTTOM_34_ADDRESS 0x7FF9
#define PAGE3_A_BOTTOM_35_ADDRESS 0x8009
#define PAGE3_A_BOTTOM_36_ADDRESS 0x8019
#define PAGE3_A_BOTTOM_37_ADDRESS 0x8029
#define PAGE3_A_BOTTOM_38_ADDRESS 0x8039
#define PAGE3_A_BOTTOM_39_ADDRESS 0x8049
#define PAGE3_A_BOTTOM_40_ADDRESS 0x8059
#define PAGE3_A_BOTTOM_41_ADDRESS 0x8069
#define PAGE3_A_BOTTOM_42_ADDRESS 0x8079
#define PAGE3_A_BOTTOM_43_ADDRESS 0x8089
#define PAGE3_A_BOTTOM_44_ADDRESS 0x8099
#define PAGE3_A_BOTTOM_45_ADDRESS 0x80A9
#define PAGE3_A_BOTTOM_46_ADDRESS 0x80B9
#define PAGE3_A_BOTTOM_47_ADDRESS 0x80C9
#define PAGE3_A_BOTTOM_48_ADDRESS 0x80D9
#define PAGE3_A_BOTTOM_49_ADDRESS 0x80E9
#define PAGE3_A_BOTTOM_50_ADDRESS 0x80F9
#define PAGE3_A_BOTTOM_51_ADDRESS 0x8109
#define PAGE3_A_BOTTOM_52_ADDRESS 0x8119
#define PAGE3_A_BOTTOM_53_ADDRESS 0x8129
#define PAGE3_A_BOTTOM_54_ADDRESS 0x8139
#define PAGE3_A_BOTTOM_55_ADDRESS 0x8149
#define PAGE3_A_BOTTOM_56_ADDRESS 0x8159
#define PAGE3_A_BOTTOM_57_ADDRESS 0x8169
#define PAGE3_A_BOTTOM_58_ADDRESS 0x8179
#define PAGE3_A_BOTTOM_59_ADDRESS 0x8189
#define PAGE3_A_BOTTOM_60_ADDRESS 0x8199
#define PAGE3_A_BOTTOM_61_ADDRESS 0x81A9
#define PAGE3_A_BOTTOM_62_ADDRESS 0x81B9
#define PAGE3_A_BOTTOM_63_ADDRESS 0x81C9
#define PAGE3_A_BOTTOM_64_ADDRESS 0x81D9
#define PAGE3_A_BOTTOM_65_ADDRESS 0x81E9
#define PAGE3_A_BOTTOM_66_ADDRESS 0x81F9
#define PAGE3_A_BOTTOM_67_ADDRESS 0x8209
#define PAGE3_A_BOTTOM_68_ADDRESS 0x8219
#define PAGE3_A_BOTTOM_69_ADDRESS 0x8229
#define PAGE3_A_BOTTOM_70_ADDRESS 0x8239
#define PAGE3_A_BOTTOM_71_ADDRESS 0x8249
#define PAGE3_A_BOTTOM_72_ADDRESS 0x8259
#define PAGE3_A_BOTTOM_73_ADDRESS 0x8269
#define PAGE3_A_BOTTOM_74_ADDRESS 0x8279
#define PAGE3_A_BOTTOM_75_ADDRESS 0x8289
#define PAGE3_A_BOTTOM_76_ADDRESS 0x8299
#define PAGE3_A_BOTTOM_77_ADDRESS 0x82A9
#define PAGE3_A_BOTTOM_78_ADDRESS 0x82B9
#define PAGE3_A_BOTTOM_79_ADDRESS 0x82C9
#define PAGE3_A_BOTTOM_80_ADDRESS 0x82D9
#define PAGE3_A_BOTTOM_81_ADDRESS 0x82E9
#define PAGE3_A_BOTTOM_82_ADDRESS 0x82F9
#define PAGE3_A_BOTTOM_83_ADDRESS 0x8309
#define PAGE3_A_BOTTOM_84_ADDRESS 0x8319
#define PAGE3_A_BOTTOM_85_ADDRESS 0x8329
#define PAGE3_A_BOTTOM_86_ADDRESS 0x8339
#define PAGE3_A_BOTTOM_87_ADDRESS 0x8349
#define PAGE3_A_BOTTOM_88_ADDRESS 0x8359
#define PAGE3_A_BOTTOM_89_ADDRESS 0x8369
#define PAGE3_A_BOTTOM_90_ADDRESS 0x8379
#define PAGE3_A_BOTTOM_91_ADDRESS 0x8389
#define PAGE3_A_BOTTOM_92_ADDRESS 0x8399
#define PAGE3_A_BOTTOM_93_ADDRESS 0x83A9
#define PAGE3_A_BOTTOM_94_ADDRESS 0x83B9
#define PAGE3_A_BOTTOM_95_ADDRESS 0x83C9
#define PAGE3_A_BOTTOM_96_ADDRESS 0x83D9
#define PAGE3_A_BOTTOM_97_ADDRESS 0x83E9
#define PAGE3_A_BOTTOM_98_ADDRESS 0x83F9
#define PAGE3_A_BOTTOM_99_ADDRESS 0x8409
#define PAGE3_A_BOTTOM_100_ADDRESS 0x8419
#define PAGE3_A_BOTTOM_101_ADDRESS 0x8429
#define PAGE3_A_BOTTOM_102_ADDRESS 0x8439
#define PAGE3_A_BOTTOM_103_ADDRESS 0x8449
#define PAGE3_A_BOTTOM_104_ADDRESS 0x8459
#define PAGE3_A_BOTTOM_105_ADDRESS 0x8469
#define PAGE3_A_BOTTOM_106_ADDRESS 0x8479
#define PAGE3_A_BOTTOM_107_ADDRESS 0x8489
#define PAGE3_A_BOTTOM_108_ADDRESS 0x8499
#define PAGE3_A_BOTTOM_109_ADDRESS 0x84A9
#define PAGE3_A_BOTTOM_110_ADDRESS 0x84B9
#define PAGE3_A_BOTTOM_111_ADDRESS 0x84C9
#define PAGE3_A_BOTTOM_112_ADDRESS 0x84D9
#define PAGE3_A_BOTTOM_113_ADDRESS 0x84E9
#define PAGE3_A_BOTTOM_114_ADDRESS 0x84F9
#define PAGE3_A_BOTTOM_115_ADDRESS 0x8509
#define PAGE3_A_BOTTOM_116_ADDRESS 0x8519
#define PAGE3_A_BOTTOM_117_ADDRESS 0x8529
#define PAGE3_A_BOTTOM_118_ADDRESS 0x8539
#define PAGE3_A_BOTTOM_119_ADDRESS 0x8549
#define PAGE3_A_BOTTOM_120_ADDRESS 0x8559
#define PAGE3_A_BOTTOM_121_ADDRESS 0x8569
#define PAGE3_A_BOTTOM_122_ADDRESS 0x8579
#define PAGE3_A_BOTTOM_123_ADDRESS 0x8589
#define PAGE3_A_BOTTOM_124_ADDRESS 0x8599
#define PAGE3_A_BOTTOM_125_ADDRESS 0x85A9
#define PAGE3_A_BOTTOM_126_ADDRESS 0x85B9
#define PAGE3_A_BOTTOM_127_ADDRESS 0x85C9
#define PAGE3_A_BOTTOM_128_ADDRESS 0x85D9
#define PAGE3_A_BOTTOM_129_ADDRESS 0x85E9
#define PAGE3_A_BOTTOM_130_ADDRESS 0x85F9
#define PAGE3_A_BOTTOM_131_ADDRESS 0x8609
#define PAGE3_A_BOTTOM_132_ADDRESS 0x8619
#define PAGE3_A_BOTTOM_133_ADDRESS 0x8629
#define PAGE3_A_BOTTOM_134_ADDRESS 0x8639
#define PAGE3_A_BOTTOM_135_ADDRESS 0x8649
#define PAGE3_A_BOTTOM_136_ADDRESS 0x8659
#define PAGE3_A_BOTTOM_137_ADDRESS 0x8669
#define PAGE3_A_BOTTOM_138_ADDRESS 0x8679
#define PAGE3_A_BOTTOM_139_ADDRESS 0x8689
#define PAGE3_A_BOTTOM_140_ADDRESS 0x8699
#define PAGE3_A_BOTTOM_141_ADDRESS 0x86A9
#define PAGE3_A_BOTTOM_142_ADDRESS 0x86B9
#define PAGE3_A_BOTTOM_143_ADDRESS 0x86C9
#define PAGE3_A_BOTTOM_144_ADDRESS 0x86D9
#define PAGE3_A_BOTTOM_145_ADDRESS 0x86E9
#define PAGE3_A_BOTTOM_146_ADDRESS 0x86F9
#define PAGE3_A_BOTTOM_147_ADDRESS 0x8709
#define PAGE3_A_BOTTOM_148_ADDRESS 0x8719
#define PAGE3_A_BOTTOM_149_ADDRESS 0x8729
#define PAGE3_A_BOTTOM_150_ADDRESS 0x8739
#define PAGE3_A_BOTTOM_151_ADDRESS 0x8749
#define PAGE3_A_BOTTOM_152_ADDRESS 0x8759
#define PAGE3_A_BOTTOM_153_ADDRESS 0x8769
#define PAGE3_A_BOTTOM_154_ADDRESS 0x8779
#define PAGE3_A_BOTTOM_155_ADDRESS 0x8789
#define PAGE3_A_BOTTOM_156_ADDRESS 0x8799
#define PAGE3_A_BOTTOM_157_ADDRESS 0x87A9
#define PAGE3_A_BOTTOM_158_ADDRESS 0x87B9
#define PAGE3_A_BOTTOM_159_ADDRESS 0x87C9

#define PAGE3_A_TEXT_01_ADDRESS 0x87D9
#define PAGE3_A_TEXT_01_SIZE 164
#define PAGE3_A_TEXT_01_FORMAT "raw"
#define PAGE3_A_TEXT_01_WIDTH_IN_BYTES 27
#define PAGE3_A_TEXT_01_WIDTH 54
#define PAGE3_A_TEXT_01_HEIGHT 6
#define PAGE3_A_TEXT_01_COUNT 1
#define PAGE3_A_TEXT_01_0_ADDRESS 0x87D9

#define PAGE3_A_TEXT_02_ADDRESS 0x887D
#define PAGE3_A_TEXT_02_SIZE 170
#define PAGE3_A_TEXT_02_FORMAT "raw"
#define PAGE3_A_TEXT_02_WIDTH_IN_BYTES 28
#define PAGE3_A_TEXT_02_WIDTH 56
#define PAGE3_A_TEXT_02_HEIGHT 6
#define PAGE3_A_TEXT_02_COUNT 1
#define PAGE3_A_TEXT_02_0_ADDRESS 0x887D

#define PAGE3_A_TEXT_03_ADDRESS 0x8927
#define PAGE3_A_TEXT_03_SIZE 188
#define PAGE3_A_TEXT_03_FORMAT "raw"
#define PAGE3_A_TEXT_03_WIDTH_IN_BYTES 31
#define PAGE3_A_TEXT_03_WIDTH 62
#define PAGE3_A_TEXT_03_HEIGHT 6
#define PAGE3_A_TEXT_03_COUNT 1
#define PAGE3_A_TEXT_03_0_ADDRESS 0x8927


extern const u8 comic_d_assets[4060];


#define BARK_ADDRESS 0x6D90
#define BARK_SIZE 478
#define BARK_FORMAT "raw"
#define BARK_WIDTH_IN_BYTES 17
#define BARK_WIDTH 34
#define BARK_HEIGHT 28
#define BARK_COUNT 1
#define BARK_0_ADDRESS 0x6D90

#define PAGE1_B_TEXT_08_ADDRESS 0x6F6E
#define PAGE1_B_TEXT_08_SIZE 92
#define PAGE1_B_TEXT_08_FORMAT "raw"
#define PAGE1_B_TEXT_08_WIDTH_IN_BYTES 15
#define PAGE1_B_TEXT_08_WIDTH 30
#define PAGE1_B_TEXT_08_HEIGHT 6
#define PAGE1_B_TEXT_08_COUNT 1
#define PAGE1_B_TEXT_08_0_ADDRESS 0x6F6E

#define PAGE2_ADDRESS 0x6FCA
#define PAGE2_SIZE 11616
#define PAGE2_FORMAT "tile"
#define PAGE2_WIDTH_IN_BYTES 2
#define PAGE2_WIDTH 4
#define PAGE2_HEIGHT 8
#define PAGE2_WIDTH_IN_TILES 22
#define PAGE2_HEIGHT_IN_TILES 33
#define PAGE2_COUNT 726
#define PAGE2_0_ADDRESS 0x6FCA
#define PAGE2_1_ADDRESS 0x6FDA
#define PAGE2_2_ADDRESS 0x6FEA
#define PAGE2_3_ADDRESS 0x6FFA
#define PAGE2_4_ADDRESS 0x700A
#define PAGE2_5_ADDRESS 0x701A
#define PAGE2_6_ADDRESS 0x702A
#define PAGE2_7_ADDRESS 0x703A
#define PAGE2_8_ADDRESS 0x704A
#define PAGE2_9_ADDRESS 0x705A
#define PAGE2_10_ADDRESS 0x706A
#define PAGE2_11_ADDRESS 0x707A
#define PAGE2_12_ADDRESS 0x708A
#define PAGE2_13_ADDRESS 0x709A
#define PAGE2_14_ADDRESS 0x70AA
#define PAGE2_15_ADDRESS 0x70BA
#define PAGE2_16_ADDRESS 0x70CA
#define PAGE2_17_ADDRESS 0x70DA
#define PAGE2_18_ADDRESS 0x70EA
#define PAGE2_19_ADDRESS 0x70FA
#define PAGE2_20_ADDRESS 0x710A
#define PAGE2_21_ADDRESS 0x711A
#define PAGE2_22_ADDRESS 0x712A
#define PAGE2_23_ADDRESS 0x713A
#define PAGE2_24_ADDRESS 0x714A
#define PAGE2_25_ADDRESS 0x715A
#define PAGE2_26_ADDRESS 0x716A
#define PAGE2_27_ADDRESS 0x717A
#define PAGE2_28_ADDRESS 0x718A
#define PAGE2_29_ADDRESS 0x719A
#define PAGE2_30_ADDRESS 0x71AA
#define PAGE2_31_ADDRESS 0x71BA
#define PAGE2_32_ADDRESS 0x71CA
#define PAGE2_33_ADDRESS 0x71DA
#define PAGE2_34_ADDRESS 0x71EA
#define PAGE2_35_ADDRESS 0x71FA
#define PAGE2_36_ADDRESS 0x720A
#define PAGE2_37_ADDRESS 0x721A
#define PAGE2_38_ADDRESS 0x722A
#define PAGE2_39_ADDRESS 0x723A
#define PAGE2_40_ADDRESS 0x724A
#define PAGE2_41_ADDRESS 0x725A
#define PAGE2_42_ADDRESS 0x726A
#define PAGE2_43_ADDRESS 0x727A
#define PAGE2_44_ADDRESS 0x728A
#define PAGE2_45_ADDRESS 0x729A
#define PAGE2_46_ADDRESS 0x72AA
#define PAGE2_47_ADDRESS 0x72BA
#define PAGE2_48_ADDRESS 0x72CA
#define PAGE2_49_ADDRESS 0x72DA
#define PAGE2_50_ADDRESS 0x72EA
#define PAGE2_51_ADDRESS 0x72FA
#define PAGE2_52_ADDRESS 0x730A
#define PAGE2_53_ADDRESS 0x731A
#define PAGE2_54_ADDRESS 0x732A
#define PAGE2_55_ADDRESS 0x733A
#define PAGE2_56_ADDRESS 0x734A
#define PAGE2_57_ADDRESS 0x735A
#define PAGE2_58_ADDRESS 0x736A
#define PAGE2_59_ADDRESS 0x737A
#define PAGE2_60_ADDRESS 0x738A
#define PAGE2_61_ADDRESS 0x739A
#define PAGE2_62_ADDRESS 0x73AA
#define PAGE2_63_ADDRESS 0x73BA
#define PAGE2_64_ADDRESS 0x73CA
#define PAGE2_65_ADDRESS 0x73DA
#define PAGE2_66_ADDRESS 0x73EA
#define PAGE2_67_ADDRESS 0x73FA
#define PAGE2_68_ADDRESS 0x740A
#define PAGE2_69_ADDRESS 0x741A
#define PAGE2_70_ADDRESS 0x742A
#define PAGE2_71_ADDRESS 0x743A
#define PAGE2_72_ADDRESS 0x744A
#define PAGE2_73_ADDRESS 0x745A
#define PAGE2_74_ADDRESS 0x746A
#define PAGE2_75_ADDRESS 0x747A
#define PAGE2_76_ADDRESS 0x748A
#define PAGE2_77_ADDRESS 0x749A
#define PAGE2_78_ADDRESS 0x74AA
#define PAGE2_79_ADDRESS 0x74BA
#define PAGE2_80_ADDRESS 0x74CA
#define PAGE2_81_ADDRESS 0x74DA
#define PAGE2_82_ADDRESS 0x74EA
#define PAGE2_83_ADDRESS 0x74FA
#define PAGE2_84_ADDRESS 0x750A
#define PAGE2_85_ADDRESS 0x751A
#define PAGE2_86_ADDRESS 0x752A
#define PAGE2_87_ADDRESS 0x753A
#define PAGE2_88_ADDRESS 0x754A
#define PAGE2_89_ADDRESS 0x755A
#define PAGE2_90_ADDRESS 0x756A
#define PAGE2_91_ADDRESS 0x757A
#define PAGE2_92_ADDRESS 0x758A
#define PAGE2_93_ADDRESS 0x759A
#define PAGE2_94_ADDRESS 0x75AA
#define PAGE2_95_ADDRESS 0x75BA
#define PAGE2_96_ADDRESS 0x75CA
#define PAGE2_97_ADDRESS 0x75DA
#define PAGE2_98_ADDRESS 0x75EA
#define PAGE2_99_ADDRESS 0x75FA
#define PAGE2_100_ADDRESS 0x760A
#define PAGE2_101_ADDRESS 0x761A
#define PAGE2_102_ADDRESS 0x762A
#define PAGE2_103_ADDRESS 0x763A
#define PAGE2_104_ADDRESS 0x764A
#define PAGE2_105_ADDRESS 0x765A
#define PAGE2_106_ADDRESS 0x766A
#define PAGE2_107_ADDRESS 0x767A
#define PAGE2_108_ADDRESS 0x768A
#define PAGE2_109_ADDRESS 0x769A
#define PAGE2_110_ADDRESS 0x76AA
#define PAGE2_111_ADDRESS 0x76BA
#define PAGE2_112_ADDRESS 0x76CA
#define PAGE2_113_ADDRESS 0x76DA
#define PAGE2_114_ADDRESS 0x76EA
#define PAGE2_115_ADDRESS 0x76FA
#define PAGE2_116_ADDRESS 0x770A
#define PAGE2_117_ADDRESS 0x771A
#define PAGE2_118_ADDRESS 0x772A
#define PAGE2_119_ADDRESS 0x773A
#define PAGE2_120_ADDRESS 0x774A
#define PAGE2_121_ADDRESS 0x775A
#define PAGE2_122_ADDRESS 0x776A
#define PAGE2_123_ADDRESS 0x777A
#define PAGE2_124_ADDRESS 0x778A
#define PAGE2_125_ADDRESS 0x779A
#define PAGE2_126_ADDRESS 0x77AA
#define PAGE2_127_ADDRESS 0x77BA
#define PAGE2_128_ADDRESS 0x77CA
#define PAGE2_129_ADDRESS 0x77DA
#define PAGE2_130_ADDRESS 0x77EA
#define PAGE2_131_ADDRESS 0x77FA
#define PAGE2_132_ADDRESS 0x780A
#define PAGE2_133_ADDRESS 0x781A
#define PAGE2_134_ADDRESS 0x782A
#define PAGE2_135_ADDRESS 0x783A
#define PAGE2_136_ADDRESS 0x784A
#define PAGE2_137_ADDRESS 0x785A
#define PAGE2_138_ADDRESS 0x786A
#define PAGE2_139_ADDRESS 0x787A
#define PAGE2_140_ADDRESS 0x788A
#define PAGE2_141_ADDRESS 0x789A
#define PAGE2_142_ADDRESS 0x78AA
#define PAGE2_143_ADDRESS 0x78BA
#define PAGE2_144_ADDRESS 0x78CA
#define PAGE2_145_ADDRESS 0x78DA
#define PAGE2_146_ADDRESS 0x78EA
#define PAGE2_147_ADDRESS 0x78FA
#define PAGE2_148_ADDRESS 0x790A
#define PAGE2_149_ADDRESS 0x791A
#define PAGE2_150_ADDRESS 0x792A
#define PAGE2_151_ADDRESS 0x793A
#define PAGE2_152_ADDRESS 0x794A
#define PAGE2_153_ADDRESS 0x795A
#define PAGE2_154_ADDRESS 0x796A
#define PAGE2_155_ADDRESS 0x797A
#define PAGE2_156_ADDRESS 0x798A
#define PAGE2_157_ADDRESS 0x799A
#define PAGE2_158_ADDRESS 0x79AA
#define PAGE2_159_ADDRESS 0x79BA
#define PAGE2_160_ADDRESS 0x79CA
#define PAGE2_161_ADDRESS 0x79DA
#define PAGE2_162_ADDRESS 0x79EA
#define PAGE2_163_ADDRESS 0x79FA
#define PAGE2_164_ADDRESS 0x7A0A
#define PAGE2_165_ADDRESS 0x7A1A
#define PAGE2_166_ADDRESS 0x7A2A
#define PAGE2_167_ADDRESS 0x7A3A
#define PAGE2_168_ADDRESS 0x7A4A
#define PAGE2_169_ADDRESS 0x7A5A
#define PAGE2_170_ADDRESS 0x7A6A
#define PAGE2_171_ADDRESS 0x7A7A
#define PAGE2_172_ADDRESS 0x7A8A
#define PAGE2_173_ADDRESS 0x7A9A
#define PAGE2_174_ADDRESS 0x7AAA
#define PAGE2_175_ADDRESS 0x7ABA
#define PAGE2_176_ADDRESS 0x7ACA
#define PAGE2_177_ADDRESS 0x7ADA
#define PAGE2_178_ADDRESS 0x7AEA
#define PAGE2_179_ADDRESS 0x7AFA
#define PAGE2_180_ADDRESS 0x7B0A
#define PAGE2_181_ADDRESS 0x7B1A
#define PAGE2_182_ADDRESS 0x7B2A
#define PAGE2_183_ADDRESS 0x7B3A
#define PAGE2_184_ADDRESS 0x7B4A
#define PAGE2_185_ADDRESS 0x7B5A
#define PAGE2_186_ADDRESS 0x7B6A
#define PAGE2_187_ADDRESS 0x7B7A
#define PAGE2_188_ADDRESS 0x7B8A
#define PAGE2_189_ADDRESS 0x7B9A
#define PAGE2_190_ADDRESS 0x7BAA
#define PAGE2_191_ADDRESS 0x7BBA
#define PAGE2_192_ADDRESS 0x7BCA
#define PAGE2_193_ADDRESS 0x7BDA
#define PAGE2_194_ADDRESS 0x7BEA
#define PAGE2_195_ADDRESS 0x7BFA
#define PAGE2_196_ADDRESS 0x7C0A
#define PAGE2_197_ADDRESS 0x7C1A
#define PAGE2_198_ADDRESS 0x7C2A
#define PAGE2_199_ADDRESS 0x7C3A
#define PAGE2_200_ADDRESS 0x7C4A
#define PAGE2_201_ADDRESS 0x7C5A
#define PAGE2_202_ADDRESS 0x7C6A
#define PAGE2_203_ADDRESS 0x7C7A
#define PAGE2_204_ADDRESS 0x7C8A
#define PAGE2_205_ADDRESS 0x7C9A
#define PAGE2_206_ADDRESS 0x7CAA
#define PAGE2_207_ADDRESS 0x7CBA
#define PAGE2_208_ADDRESS 0x7CCA
#define PAGE2_209_ADDRESS 0x7CDA
#define PAGE2_210_ADDRESS 0x7CEA
#define PAGE2_211_ADDRESS 0x7CFA
#define PAGE2_212_ADDRESS 0x7D0A
#define PAGE2_213_ADDRESS 0x7D1A
#define PAGE2_214_ADDRESS 0x7D2A
#define PAGE2_215_ADDRESS 0x7D3A
#define PAGE2_216_ADDRESS 0x7D4A
#define PAGE2_217_ADDRESS 0x7D5A
#define PAGE2_218_ADDRESS 0x7D6A
#define PAGE2_219_ADDRESS 0x7D7A
#define PAGE2_220_ADDRESS 0x7D8A
#define PAGE2_221_ADDRESS 0x7D9A
#define PAGE2_222_ADDRESS 0x7DAA
#define PAGE2_223_ADDRESS 0x7DBA
#define PAGE2_224_ADDRESS 0x7DCA
#define PAGE2_225_ADDRESS 0x7DDA
#define PAGE2_226_ADDRESS 0x7DEA
#define PAGE2_227_ADDRESS 0x7DFA
#define PAGE2_228_ADDRESS 0x7E0A
#define PAGE2_229_ADDRESS 0x7E1A
#define PAGE2_230_ADDRESS 0x7E2A
#define PAGE2_231_ADDRESS 0x7E3A
#define PAGE2_232_ADDRESS 0x7E4A
#define PAGE2_233_ADDRESS 0x7E5A
#define PAGE2_234_ADDRESS 0x7E6A
#define PAGE2_235_ADDRESS 0x7E7A
#define PAGE2_236_ADDRESS 0x7E8A
#define PAGE2_237_ADDRESS 0x7E9A
#define PAGE2_238_ADDRESS 0x7EAA
#define PAGE2_239_ADDRESS 0x7EBA
#define PAGE2_240_ADDRESS 0x7ECA
#define PAGE2_241_ADDRESS 0x7EDA
#define PAGE2_242_ADDRESS 0x7EEA
#define PAGE2_243_ADDRESS 0x7EFA
#define PAGE2_244_ADDRESS 0x7F0A
#define PAGE2_245_ADDRESS 0x7F1A
#define PAGE2_246_ADDRESS 0x7F2A
#define PAGE2_247_ADDRESS 0x7F3A
#define PAGE2_248_ADDRESS 0x7F4A
#define PAGE2_249_ADDRESS 0x7F5A
#define PAGE2_250_ADDRESS 0x7F6A
#define PAGE2_251_ADDRESS 0x7F7A
#define PAGE2_252_ADDRESS 0x7F8A
#define PAGE2_253_ADDRESS 0x7F9A
#define PAGE2_254_ADDRESS 0x7FAA
#define PAGE2_255_ADDRESS 0x7FBA
#define PAGE2_256_ADDRESS 0x7FCA
#define PAGE2_257_ADDRESS 0x7FDA
#define PAGE2_258_ADDRESS 0x7FEA
#define PAGE2_259_ADDRESS 0x7FFA
#define PAGE2_260_ADDRESS 0x800A
#define PAGE2_261_ADDRESS 0x801A
#define PAGE2_262_ADDRESS 0x802A
#define PAGE2_263_ADDRESS 0x803A
#define PAGE2_264_ADDRESS 0x804A
#define PAGE2_265_ADDRESS 0x805A
#define PAGE2_266_ADDRESS 0x806A
#define PAGE2_267_ADDRESS 0x807A
#define PAGE2_268_ADDRESS 0x808A
#define PAGE2_269_ADDRESS 0x809A
#define PAGE2_270_ADDRESS 0x80AA
#define PAGE2_271_ADDRESS 0x80BA
#define PAGE2_272_ADDRESS 0x80CA
#define PAGE2_273_ADDRESS 0x80DA
#define PAGE2_274_ADDRESS 0x80EA
#define PAGE2_275_ADDRESS 0x80FA
#define PAGE2_276_ADDRESS 0x810A
#define PAGE2_277_ADDRESS 0x811A
#define PAGE2_278_ADDRESS 0x812A
#define PAGE2_279_ADDRESS 0x813A
#define PAGE2_280_ADDRESS 0x814A
#define PAGE2_281_ADDRESS 0x815A
#define PAGE2_282_ADDRESS 0x816A
#define PAGE2_283_ADDRESS 0x817A
#define PAGE2_284_ADDRESS 0x818A
#define PAGE2_285_ADDRESS 0x819A
#define PAGE2_286_ADDRESS 0x81AA
#define PAGE2_287_ADDRESS 0x81BA
#define PAGE2_288_ADDRESS 0x81CA
#define PAGE2_289_ADDRESS 0x81DA
#define PAGE2_290_ADDRESS 0x81EA
#define PAGE2_291_ADDRESS 0x81FA
#define PAGE2_292_ADDRESS 0x820A
#define PAGE2_293_ADDRESS 0x821A
#define PAGE2_294_ADDRESS 0x822A
#define PAGE2_295_ADDRESS 0x823A
#define PAGE2_296_ADDRESS 0x824A
#define PAGE2_297_ADDRESS 0x825A
#define PAGE2_298_ADDRESS 0x826A
#define PAGE2_299_ADDRESS 0x827A
#define PAGE2_300_ADDRESS 0x828A
#define PAGE2_301_ADDRESS 0x829A
#define PAGE2_302_ADDRESS 0x82AA
#define PAGE2_303_ADDRESS 0x82BA
#define PAGE2_304_ADDRESS 0x82CA
#define PAGE2_305_ADDRESS 0x82DA
#define PAGE2_306_ADDRESS 0x82EA
#define PAGE2_307_ADDRESS 0x82FA
#define PAGE2_308_ADDRESS 0x830A
#define PAGE2_309_ADDRESS 0x831A
#define PAGE2_310_ADDRESS 0x832A
#define PAGE2_311_ADDRESS 0x833A
#define PAGE2_312_ADDRESS 0x834A
#define PAGE2_313_ADDRESS 0x835A
#define PAGE2_314_ADDRESS 0x836A
#define PAGE2_315_ADDRESS 0x837A
#define PAGE2_316_ADDRESS 0x838A
#define PAGE2_317_ADDRESS 0x839A
#define PAGE2_318_ADDRESS 0x83AA
#define PAGE2_319_ADDRESS 0x83BA
#define PAGE2_320_ADDRESS 0x83CA
#define PAGE2_321_ADDRESS 0x83DA
#define PAGE2_322_ADDRESS 0x83EA
#define PAGE2_323_ADDRESS 0x83FA
#define PAGE2_324_ADDRESS 0x840A
#define PAGE2_325_ADDRESS 0x841A
#define PAGE2_326_ADDRESS 0x842A
#define PAGE2_327_ADDRESS 0x843A
#define PAGE2_328_ADDRESS 0x844A
#define PAGE2_329_ADDRESS 0x845A
#define PAGE2_330_ADDRESS 0x846A
#define PAGE2_331_ADDRESS 0x847A
#define PAGE2_332_ADDRESS 0x848A
#define PAGE2_333_ADDRESS 0x849A
#define PAGE2_334_ADDRESS 0x84AA
#define PAGE2_335_ADDRESS 0x84BA
#define PAGE2_336_ADDRESS 0x84CA
#define PAGE2_337_ADDRESS 0x84DA
#define PAGE2_338_ADDRESS 0x84EA
#define PAGE2_339_ADDRESS 0x84FA
#define PAGE2_340_ADDRESS 0x850A
#define PAGE2_341_ADDRESS 0x851A
#define PAGE2_342_ADDRESS 0x852A
#define PAGE2_343_ADDRESS 0x853A
#define PAGE2_344_ADDRESS 0x854A
#define PAGE2_345_ADDRESS 0x855A
#define PAGE2_346_ADDRESS 0x856A
#define PAGE2_347_ADDRESS 0x857A
#define PAGE2_348_ADDRESS 0x858A
#define PAGE2_349_ADDRESS 0x859A
#define PAGE2_350_ADDRESS 0x85AA
#define PAGE2_351_ADDRESS 0x85BA
#define PAGE2_352_ADDRESS 0x85CA
#define PAGE2_353_ADDRESS 0x85DA
#define PAGE2_354_ADDRESS 0x85EA
#define PAGE2_355_ADDRESS 0x85FA
#define PAGE2_356_ADDRESS 0x860A
#define PAGE2_357_ADDRESS 0x861A
#define PAGE2_358_ADDRESS 0x862A
#define PAGE2_359_ADDRESS 0x863A
#define PAGE2_360_ADDRESS 0x864A
#define PAGE2_361_ADDRESS 0x865A
#define PAGE2_362_ADDRESS 0x866A
#define PAGE2_363_ADDRESS 0x867A
#define PAGE2_364_ADDRESS 0x868A
#define PAGE2_365_ADDRESS 0x869A
#define PAGE2_366_ADDRESS 0x86AA
#define PAGE2_367_ADDRESS 0x86BA
#define PAGE2_368_ADDRESS 0x86CA
#define PAGE2_369_ADDRESS 0x86DA
#define PAGE2_370_ADDRESS 0x86EA
#define PAGE2_371_ADDRESS 0x86FA
#define PAGE2_372_ADDRESS 0x870A
#define PAGE2_373_ADDRESS 0x871A
#define PAGE2_374_ADDRESS 0x872A
#define PAGE2_375_ADDRESS 0x873A
#define PAGE2_376_ADDRESS 0x874A
#define PAGE2_377_ADDRESS 0x875A
#define PAGE2_378_ADDRESS 0x876A
#define PAGE2_379_ADDRESS 0x877A
#define PAGE2_380_ADDRESS 0x878A
#define PAGE2_381_ADDRESS 0x879A
#define PAGE2_382_ADDRESS 0x87AA
#define PAGE2_383_ADDRESS 0x87BA
#define PAGE2_384_ADDRESS 0x87CA
#define PAGE2_385_ADDRESS 0x87DA
#define PAGE2_386_ADDRESS 0x87EA
#define PAGE2_387_ADDRESS 0x87FA
#define PAGE2_388_ADDRESS 0x880A
#define PAGE2_389_ADDRESS 0x881A
#define PAGE2_390_ADDRESS 0x882A
#define PAGE2_391_ADDRESS 0x883A
#define PAGE2_392_ADDRESS 0x884A
#define PAGE2_393_ADDRESS 0x885A
#define PAGE2_394_ADDRESS 0x886A
#define PAGE2_395_ADDRESS 0x887A
#define PAGE2_396_ADDRESS 0x888A
#define PAGE2_397_ADDRESS 0x889A
#define PAGE2_398_ADDRESS 0x88AA
#define PAGE2_399_ADDRESS 0x88BA
#define PAGE2_400_ADDRESS 0x88CA
#define PAGE2_401_ADDRESS 0x88DA
#define PAGE2_402_ADDRESS 0x88EA
#define PAGE2_403_ADDRESS 0x88FA
#define PAGE2_404_ADDRESS 0x890A
#define PAGE2_405_ADDRESS 0x891A
#define PAGE2_406_ADDRESS 0x892A
#define PAGE2_407_ADDRESS 0x893A
#define PAGE2_408_ADDRESS 0x894A
#define PAGE2_409_ADDRESS 0x895A
#define PAGE2_410_ADDRESS 0x896A
#define PAGE2_411_ADDRESS 0x897A
#define PAGE2_412_ADDRESS 0x898A
#define PAGE2_413_ADDRESS 0x899A
#define PAGE2_414_ADDRESS 0x89AA
#define PAGE2_415_ADDRESS 0x89BA
#define PAGE2_416_ADDRESS 0x89CA
#define PAGE2_417_ADDRESS 0x89DA
#define PAGE2_418_ADDRESS 0x89EA
#define PAGE2_419_ADDRESS 0x89FA
#define PAGE2_420_ADDRESS 0x8A0A
#define PAGE2_421_ADDRESS 0x8A1A
#define PAGE2_422_ADDRESS 0x8A2A
#define PAGE2_423_ADDRESS 0x8A3A
#define PAGE2_424_ADDRESS 0x8A4A
#define PAGE2_425_ADDRESS 0x8A5A
#define PAGE2_426_ADDRESS 0x8A6A
#define PAGE2_427_ADDRESS 0x8A7A
#define PAGE2_428_ADDRESS 0x8A8A
#define PAGE2_429_ADDRESS 0x8A9A
#define PAGE2_430_ADDRESS 0x8AAA
#define PAGE2_431_ADDRESS 0x8ABA
#define PAGE2_432_ADDRESS 0x8ACA
#define PAGE2_433_ADDRESS 0x8ADA
#define PAGE2_434_ADDRESS 0x8AEA
#define PAGE2_435_ADDRESS 0x8AFA
#define PAGE2_436_ADDRESS 0x8B0A
#define PAGE2_437_ADDRESS 0x8B1A
#define PAGE2_438_ADDRESS 0x8B2A
#define PAGE2_439_ADDRESS 0x8B3A
#define PAGE2_440_ADDRESS 0x8B4A
#define PAGE2_441_ADDRESS 0x8B5A
#define PAGE2_442_ADDRESS 0x8B6A
#define PAGE2_443_ADDRESS 0x8B7A
#define PAGE2_444_ADDRESS 0x8B8A
#define PAGE2_445_ADDRESS 0x8B9A
#define PAGE2_446_ADDRESS 0x8BAA
#define PAGE2_447_ADDRESS 0x8BBA
#define PAGE2_448_ADDRESS 0x8BCA
#define PAGE2_449_ADDRESS 0x8BDA
#define PAGE2_450_ADDRESS 0x8BEA
#define PAGE2_451_ADDRESS 0x8BFA
#define PAGE2_452_ADDRESS 0x8C0A
#define PAGE2_453_ADDRESS 0x8C1A
#define PAGE2_454_ADDRESS 0x8C2A
#define PAGE2_455_ADDRESS 0x8C3A
#define PAGE2_456_ADDRESS 0x8C4A
#define PAGE2_457_ADDRESS 0x8C5A
#define PAGE2_458_ADDRESS 0x8C6A
#define PAGE2_459_ADDRESS 0x8C7A
#define PAGE2_460_ADDRESS 0x8C8A
#define PAGE2_461_ADDRESS 0x8C9A
#define PAGE2_462_ADDRESS 0x8CAA
#define PAGE2_463_ADDRESS 0x8CBA
#define PAGE2_464_ADDRESS 0x8CCA
#define PAGE2_465_ADDRESS 0x8CDA
#define PAGE2_466_ADDRESS 0x8CEA
#define PAGE2_467_ADDRESS 0x8CFA
#define PAGE2_468_ADDRESS 0x8D0A
#define PAGE2_469_ADDRESS 0x8D1A
#define PAGE2_470_ADDRESS 0x8D2A
#define PAGE2_471_ADDRESS 0x8D3A
#define PAGE2_472_ADDRESS 0x8D4A
#define PAGE2_473_ADDRESS 0x8D5A
#define PAGE2_474_ADDRESS 0x8D6A
#define PAGE2_475_ADDRESS 0x8D7A
#define PAGE2_476_ADDRESS 0x8D8A
#define PAGE2_477_ADDRESS 0x8D9A
#define PAGE2_478_ADDRESS 0x8DAA
#define PAGE2_479_ADDRESS 0x8DBA
#define PAGE2_480_ADDRESS 0x8DCA
#define PAGE2_481_ADDRESS 0x8DDA
#define PAGE2_482_ADDRESS 0x8DEA
#define PAGE2_483_ADDRESS 0x8DFA
#define PAGE2_484_ADDRESS 0x8E0A
#define PAGE2_485_ADDRESS 0x8E1A
#define PAGE2_486_ADDRESS 0x8E2A
#define PAGE2_487_ADDRESS 0x8E3A
#define PAGE2_488_ADDRESS 0x8E4A
#define PAGE2_489_ADDRESS 0x8E5A
#define PAGE2_490_ADDRESS 0x8E6A
#define PAGE2_491_ADDRESS 0x8E7A
#define PAGE2_492_ADDRESS 0x8E8A
#define PAGE2_493_ADDRESS 0x8E9A
#define PAGE2_494_ADDRESS 0x8EAA
#define PAGE2_495_ADDRESS 0x8EBA
#define PAGE2_496_ADDRESS 0x8ECA
#define PAGE2_497_ADDRESS 0x8EDA
#define PAGE2_498_ADDRESS 0x8EEA
#define PAGE2_499_ADDRESS 0x8EFA
#define PAGE2_500_ADDRESS 0x8F0A
#define PAGE2_501_ADDRESS 0x8F1A
#define PAGE2_502_ADDRESS 0x8F2A
#define PAGE2_503_ADDRESS 0x8F3A
#define PAGE2_504_ADDRESS 0x8F4A
#define PAGE2_505_ADDRESS 0x8F5A
#define PAGE2_506_ADDRESS 0x8F6A
#define PAGE2_507_ADDRESS 0x8F7A
#define PAGE2_508_ADDRESS 0x8F8A
#define PAGE2_509_ADDRESS 0x8F9A
#define PAGE2_510_ADDRESS 0x8FAA
#define PAGE2_511_ADDRESS 0x8FBA
#define PAGE2_512_ADDRESS 0x8FCA
#define PAGE2_513_ADDRESS 0x8FDA
#define PAGE2_514_ADDRESS 0x8FEA
#define PAGE2_515_ADDRESS 0x8FFA
#define PAGE2_516_ADDRESS 0x900A
#define PAGE2_517_ADDRESS 0x901A
#define PAGE2_518_ADDRESS 0x902A
#define PAGE2_519_ADDRESS 0x903A
#define PAGE2_520_ADDRESS 0x904A
#define PAGE2_521_ADDRESS 0x905A
#define PAGE2_522_ADDRESS 0x906A
#define PAGE2_523_ADDRESS 0x907A
#define PAGE2_524_ADDRESS 0x908A
#define PAGE2_525_ADDRESS 0x909A
#define PAGE2_526_ADDRESS 0x90AA
#define PAGE2_527_ADDRESS 0x90BA
#define PAGE2_528_ADDRESS 0x90CA
#define PAGE2_529_ADDRESS 0x90DA
#define PAGE2_530_ADDRESS 0x90EA
#define PAGE2_531_ADDRESS 0x90FA
#define PAGE2_532_ADDRESS 0x910A
#define PAGE2_533_ADDRESS 0x911A
#define PAGE2_534_ADDRESS 0x912A
#define PAGE2_535_ADDRESS 0x913A
#define PAGE2_536_ADDRESS 0x914A
#define PAGE2_537_ADDRESS 0x915A
#define PAGE2_538_ADDRESS 0x916A
#define PAGE2_539_ADDRESS 0x917A
#define PAGE2_540_ADDRESS 0x918A
#define PAGE2_541_ADDRESS 0x919A
#define PAGE2_542_ADDRESS 0x91AA
#define PAGE2_543_ADDRESS 0x91BA
#define PAGE2_544_ADDRESS 0x91CA
#define PAGE2_545_ADDRESS 0x91DA
#define PAGE2_546_ADDRESS 0x91EA
#define PAGE2_547_ADDRESS 0x91FA
#define PAGE2_548_ADDRESS 0x920A
#define PAGE2_549_ADDRESS 0x921A
#define PAGE2_550_ADDRESS 0x922A
#define PAGE2_551_ADDRESS 0x923A
#define PAGE2_552_ADDRESS 0x924A
#define PAGE2_553_ADDRESS 0x925A
#define PAGE2_554_ADDRESS 0x926A
#define PAGE2_555_ADDRESS 0x927A
#define PAGE2_556_ADDRESS 0x928A
#define PAGE2_557_ADDRESS 0x929A
#define PAGE2_558_ADDRESS 0x92AA
#define PAGE2_559_ADDRESS 0x92BA
#define PAGE2_560_ADDRESS 0x92CA
#define PAGE2_561_ADDRESS 0x92DA
#define PAGE2_562_ADDRESS 0x92EA
#define PAGE2_563_ADDRESS 0x92FA
#define PAGE2_564_ADDRESS 0x930A
#define PAGE2_565_ADDRESS 0x931A
#define PAGE2_566_ADDRESS 0x932A
#define PAGE2_567_ADDRESS 0x933A
#define PAGE2_568_ADDRESS 0x934A
#define PAGE2_569_ADDRESS 0x935A
#define PAGE2_570_ADDRESS 0x936A
#define PAGE2_571_ADDRESS 0x937A
#define PAGE2_572_ADDRESS 0x938A
#define PAGE2_573_ADDRESS 0x939A
#define PAGE2_574_ADDRESS 0x93AA
#define PAGE2_575_ADDRESS 0x93BA
#define PAGE2_576_ADDRESS 0x93CA
#define PAGE2_577_ADDRESS 0x93DA
#define PAGE2_578_ADDRESS 0x93EA
#define PAGE2_579_ADDRESS 0x93FA
#define PAGE2_580_ADDRESS 0x940A
#define PAGE2_581_ADDRESS 0x941A
#define PAGE2_582_ADDRESS 0x942A
#define PAGE2_583_ADDRESS 0x943A
#define PAGE2_584_ADDRESS 0x944A
#define PAGE2_585_ADDRESS 0x945A
#define PAGE2_586_ADDRESS 0x946A
#define PAGE2_587_ADDRESS 0x947A
#define PAGE2_588_ADDRESS 0x948A
#define PAGE2_589_ADDRESS 0x949A
#define PAGE2_590_ADDRESS 0x94AA
#define PAGE2_591_ADDRESS 0x94BA
#define PAGE2_592_ADDRESS 0x94CA
#define PAGE2_593_ADDRESS 0x94DA
#define PAGE2_594_ADDRESS 0x94EA
#define PAGE2_595_ADDRESS 0x94FA
#define PAGE2_596_ADDRESS 0x950A
#define PAGE2_597_ADDRESS 0x951A
#define PAGE2_598_ADDRESS 0x952A
#define PAGE2_599_ADDRESS 0x953A
#define PAGE2_600_ADDRESS 0x954A
#define PAGE2_601_ADDRESS 0x955A
#define PAGE2_602_ADDRESS 0x956A
#define PAGE2_603_ADDRESS 0x957A
#define PAGE2_604_ADDRESS 0x958A
#define PAGE2_605_ADDRESS 0x959A
#define PAGE2_606_ADDRESS 0x95AA
#define PAGE2_607_ADDRESS 0x95BA
#define PAGE2_608_ADDRESS 0x95CA
#define PAGE2_609_ADDRESS 0x95DA
#define PAGE2_610_ADDRESS 0x95EA
#define PAGE2_611_ADDRESS 0x95FA
#define PAGE2_612_ADDRESS 0x960A
#define PAGE2_613_ADDRESS 0x961A
#define PAGE2_614_ADDRESS 0x962A
#define PAGE2_615_ADDRESS 0x963A
#define PAGE2_616_ADDRESS 0x964A
#define PAGE2_617_ADDRESS 0x965A
#define PAGE2_618_ADDRESS 0x966A
#define PAGE2_619_ADDRESS 0x967A
#define PAGE2_620_ADDRESS 0x968A
#define PAGE2_621_ADDRESS 0x969A
#define PAGE2_622_ADDRESS 0x96AA
#define PAGE2_623_ADDRESS 0x96BA
#define PAGE2_624_ADDRESS 0x96CA
#define PAGE2_625_ADDRESS 0x96DA
#define PAGE2_626_ADDRESS 0x96EA
#define PAGE2_627_ADDRESS 0x96FA
#define PAGE2_628_ADDRESS 0x970A
#define PAGE2_629_ADDRESS 0x971A
#define PAGE2_630_ADDRESS 0x972A
#define PAGE2_631_ADDRESS 0x973A
#define PAGE2_632_ADDRESS 0x974A
#define PAGE2_633_ADDRESS 0x975A
#define PAGE2_634_ADDRESS 0x976A
#define PAGE2_635_ADDRESS 0x977A
#define PAGE2_636_ADDRESS 0x978A
#define PAGE2_637_ADDRESS 0x979A
#define PAGE2_638_ADDRESS 0x97AA
#define PAGE2_639_ADDRESS 0x97BA
#define PAGE2_640_ADDRESS 0x97CA
#define PAGE2_641_ADDRESS 0x97DA
#define PAGE2_642_ADDRESS 0x97EA
#define PAGE2_643_ADDRESS 0x97FA
#define PAGE2_644_ADDRESS 0x980A
#define PAGE2_645_ADDRESS 0x981A
#define PAGE2_646_ADDRESS 0x982A
#define PAGE2_647_ADDRESS 0x983A
#define PAGE2_648_ADDRESS 0x984A
#define PAGE2_649_ADDRESS 0x985A
#define PAGE2_650_ADDRESS 0x986A
#define PAGE2_651_ADDRESS 0x987A
#define PAGE2_652_ADDRESS 0x988A
#define PAGE2_653_ADDRESS 0x989A
#define PAGE2_654_ADDRESS 0x98AA
#define PAGE2_655_ADDRESS 0x98BA
#define PAGE2_656_ADDRESS 0x98CA
#define PAGE2_657_ADDRESS 0x98DA
#define PAGE2_658_ADDRESS 0x98EA
#define PAGE2_659_ADDRESS 0x98FA
#define PAGE2_660_ADDRESS 0x990A
#define PAGE2_661_ADDRESS 0x991A
#define PAGE2_662_ADDRESS 0x992A
#define PAGE2_663_ADDRESS 0x993A
#define PAGE2_664_ADDRESS 0x994A
#define PAGE2_665_ADDRESS 0x995A
#define PAGE2_666_ADDRESS 0x996A
#define PAGE2_667_ADDRESS 0x997A
#define PAGE2_668_ADDRESS 0x998A
#define PAGE2_669_ADDRESS 0x999A
#define PAGE2_670_ADDRESS 0x99AA
#define PAGE2_671_ADDRESS 0x99BA
#define PAGE2_672_ADDRESS 0x99CA
#define PAGE2_673_ADDRESS 0x99DA
#define PAGE2_674_ADDRESS 0x99EA
#define PAGE2_675_ADDRESS 0x99FA
#define PAGE2_676_ADDRESS 0x9A0A
#define PAGE2_677_ADDRESS 0x9A1A
#define PAGE2_678_ADDRESS 0x9A2A
#define PAGE2_679_ADDRESS 0x9A3A
#define PAGE2_680_ADDRESS 0x9A4A
#define PAGE2_681_ADDRESS 0x9A5A
#define PAGE2_682_ADDRESS 0x9A6A
#define PAGE2_683_ADDRESS 0x9A7A
#define PAGE2_684_ADDRESS 0x9A8A
#define PAGE2_685_ADDRESS 0x9A9A
#define PAGE2_686_ADDRESS 0x9AAA
#define PAGE2_687_ADDRESS 0x9ABA
#define PAGE2_688_ADDRESS 0x9ACA
#define PAGE2_689_ADDRESS 0x9ADA
#define PAGE2_690_ADDRESS 0x9AEA
#define PAGE2_691_ADDRESS 0x9AFA
#define PAGE2_692_ADDRESS 0x9B0A
#define PAGE2_693_ADDRESS 0x9B1A
#define PAGE2_694_ADDRESS 0x9B2A
#define PAGE2_695_ADDRESS 0x9B3A
#define PAGE2_696_ADDRESS 0x9B4A
#define PAGE2_697_ADDRESS 0x9B5A
#define PAGE2_698_ADDRESS 0x9B6A
#define PAGE2_699_ADDRESS 0x9B7A
#define PAGE2_700_ADDRESS 0x9B8A
#define PAGE2_701_ADDRESS 0x9B9A
#define PAGE2_702_ADDRESS 0x9BAA
#define PAGE2_703_ADDRESS 0x9BBA
#define PAGE2_704_ADDRESS 0x9BCA
#define PAGE2_705_ADDRESS 0x9BDA
#define PAGE2_706_ADDRESS 0x9BEA
#define PAGE2_707_ADDRESS 0x9BFA
#define PAGE2_708_ADDRESS 0x9C0A
#define PAGE2_709_ADDRESS 0x9C1A
#define PAGE2_710_ADDRESS 0x9C2A
#define PAGE2_711_ADDRESS 0x9C3A
#define PAGE2_712_ADDRESS 0x9C4A
#define PAGE2_713_ADDRESS 0x9C5A
#define PAGE2_714_ADDRESS 0x9C6A
#define PAGE2_715_ADDRESS 0x9C7A
#define PAGE2_716_ADDRESS 0x9C8A
#define PAGE2_717_ADDRESS 0x9C9A
#define PAGE2_718_ADDRESS 0x9CAA
#define PAGE2_719_ADDRESS 0x9CBA
#define PAGE2_720_ADDRESS 0x9CCA
#define PAGE2_721_ADDRESS 0x9CDA
#define PAGE2_722_ADDRESS 0x9CEA
#define PAGE2_723_ADDRESS 0x9CFA
#define PAGE2_724_ADDRESS 0x9D0A
#define PAGE2_725_ADDRESS 0x9D1A

#define MUSIC_SECTION_C_ADDRESS 0x9D2A
#define MUSIC_SECTION_C_SIZE 2248


extern const u8 comic_c_assets[3734];


#define MUSIC_SECTION_B_ADDRESS 0x5630
#define MUSIC_SECTION_B_SIZE 1923

#define PAGE1_B_ADDRESS 0x5DB3
#define PAGE1_B_SIZE 14144
#define PAGE1_B_FORMAT "tile"
#define PAGE1_B_WIDTH_IN_BYTES 2
#define PAGE1_B_WIDTH 4
#define PAGE1_B_HEIGHT 8
#define PAGE1_B_WIDTH_IN_TILES 52
#define PAGE1_B_HEIGHT_IN_TILES 17
#define PAGE1_B_COUNT 884
#define PAGE1_B_0_ADDRESS 0x5DB3
#define PAGE1_B_1_ADDRESS 0x5DC3
#define PAGE1_B_2_ADDRESS 0x5DD3
#define PAGE1_B_3_ADDRESS 0x5DE3
#define PAGE1_B_4_ADDRESS 0x5DF3
#define PAGE1_B_5_ADDRESS 0x5E03
#define PAGE1_B_6_ADDRESS 0x5E13
#define PAGE1_B_7_ADDRESS 0x5E23
#define PAGE1_B_8_ADDRESS 0x5E33
#define PAGE1_B_9_ADDRESS 0x5E43
#define PAGE1_B_10_ADDRESS 0x5E53
#define PAGE1_B_11_ADDRESS 0x5E63
#define PAGE1_B_12_ADDRESS 0x5E73
#define PAGE1_B_13_ADDRESS 0x5E83
#define PAGE1_B_14_ADDRESS 0x5E93
#define PAGE1_B_15_ADDRESS 0x5EA3
#define PAGE1_B_16_ADDRESS 0x5EB3
#define PAGE1_B_17_ADDRESS 0x5EC3
#define PAGE1_B_18_ADDRESS 0x5ED3
#define PAGE1_B_19_ADDRESS 0x5EE3
#define PAGE1_B_20_ADDRESS 0x5EF3
#define PAGE1_B_21_ADDRESS 0x5F03
#define PAGE1_B_22_ADDRESS 0x5F13
#define PAGE1_B_23_ADDRESS 0x5F23
#define PAGE1_B_24_ADDRESS 0x5F33
#define PAGE1_B_25_ADDRESS 0x5F43
#define PAGE1_B_26_ADDRESS 0x5F53
#define PAGE1_B_27_ADDRESS 0x5F63
#define PAGE1_B_28_ADDRESS 0x5F73
#define PAGE1_B_29_ADDRESS 0x5F83
#define PAGE1_B_30_ADDRESS 0x5F93
#define PAGE1_B_31_ADDRESS 0x5FA3
#define PAGE1_B_32_ADDRESS 0x5FB3
#define PAGE1_B_33_ADDRESS 0x5FC3
#define PAGE1_B_34_ADDRESS 0x5FD3
#define PAGE1_B_35_ADDRESS 0x5FE3
#define PAGE1_B_36_ADDRESS 0x5FF3
#define PAGE1_B_37_ADDRESS 0x6003
#define PAGE1_B_38_ADDRESS 0x6013
#define PAGE1_B_39_ADDRESS 0x6023
#define PAGE1_B_40_ADDRESS 0x6033
#define PAGE1_B_41_ADDRESS 0x6043
#define PAGE1_B_42_ADDRESS 0x6053
#define PAGE1_B_43_ADDRESS 0x6063
#define PAGE1_B_44_ADDRESS 0x6073
#define PAGE1_B_45_ADDRESS 0x6083
#define PAGE1_B_46_ADDRESS 0x6093
#define PAGE1_B_47_ADDRESS 0x60A3
#define PAGE1_B_48_ADDRESS 0x60B3
#define PAGE1_B_49_ADDRESS 0x60C3
#define PAGE1_B_50_ADDRESS 0x60D3
#define PAGE1_B_51_ADDRESS 0x60E3
#define PAGE1_B_52_ADDRESS 0x60F3
#define PAGE1_B_53_ADDRESS 0x6103
#define PAGE1_B_54_ADDRESS 0x6113
#define PAGE1_B_55_ADDRESS 0x6123
#define PAGE1_B_56_ADDRESS 0x6133
#define PAGE1_B_57_ADDRESS 0x6143
#define PAGE1_B_58_ADDRESS 0x6153
#define PAGE1_B_59_ADDRESS 0x6163
#define PAGE1_B_60_ADDRESS 0x6173
#define PAGE1_B_61_ADDRESS 0x6183
#define PAGE1_B_62_ADDRESS 0x6193
#define PAGE1_B_63_ADDRESS 0x61A3
#define PAGE1_B_64_ADDRESS 0x61B3
#define PAGE1_B_65_ADDRESS 0x61C3
#define PAGE1_B_66_ADDRESS 0x61D3
#define PAGE1_B_67_ADDRESS 0x61E3
#define PAGE1_B_68_ADDRESS 0x61F3
#define PAGE1_B_69_ADDRESS 0x6203
#define PAGE1_B_70_ADDRESS 0x6213
#define PAGE1_B_71_ADDRESS 0x6223
#define PAGE1_B_72_ADDRESS 0x6233
#define PAGE1_B_73_ADDRESS 0x6243
#define PAGE1_B_74_ADDRESS 0x6253
#define PAGE1_B_75_ADDRESS 0x6263
#define PAGE1_B_76_ADDRESS 0x6273
#define PAGE1_B_77_ADDRESS 0x6283
#define PAGE1_B_78_ADDRESS 0x6293
#define PAGE1_B_79_ADDRESS 0x62A3
#define PAGE1_B_80_ADDRESS 0x62B3
#define PAGE1_B_81_ADDRESS 0x62C3
#define PAGE1_B_82_ADDRESS 0x62D3
#define PAGE1_B_83_ADDRESS 0x62E3
#define PAGE1_B_84_ADDRESS 0x62F3
#define PAGE1_B_85_ADDRESS 0x6303
#define PAGE1_B_86_ADDRESS 0x6313
#define PAGE1_B_87_ADDRESS 0x6323
#define PAGE1_B_88_ADDRESS 0x6333
#define PAGE1_B_89_ADDRESS 0x6343
#define PAGE1_B_90_ADDRESS 0x6353
#define PAGE1_B_91_ADDRESS 0x6363
#define PAGE1_B_92_ADDRESS 0x6373
#define PAGE1_B_93_ADDRESS 0x6383
#define PAGE1_B_94_ADDRESS 0x6393
#define PAGE1_B_95_ADDRESS 0x63A3
#define PAGE1_B_96_ADDRESS 0x63B3
#define PAGE1_B_97_ADDRESS 0x63C3
#define PAGE1_B_98_ADDRESS 0x63D3
#define PAGE1_B_99_ADDRESS 0x63E3
#define PAGE1_B_100_ADDRESS 0x63F3
#define PAGE1_B_101_ADDRESS 0x6403
#define PAGE1_B_102_ADDRESS 0x6413
#define PAGE1_B_103_ADDRESS 0x6423
#define PAGE1_B_104_ADDRESS 0x6433
#define PAGE1_B_105_ADDRESS 0x6443
#define PAGE1_B_106_ADDRESS 0x6453
#define PAGE1_B_107_ADDRESS 0x6463
#define PAGE1_B_108_ADDRESS 0x6473
#define PAGE1_B_109_ADDRESS 0x6483
#define PAGE1_B_110_ADDRESS 0x6493
#define PAGE1_B_111_ADDRESS 0x64A3
#define PAGE1_B_112_ADDRESS 0x64B3
#define PAGE1_B_113_ADDRESS 0x64C3
#define PAGE1_B_114_ADDRESS 0x64D3
#define PAGE1_B_115_ADDRESS 0x64E3
#define PAGE1_B_116_ADDRESS 0x64F3
#define PAGE1_B_117_ADDRESS 0x6503
#define PAGE1_B_118_ADDRESS 0x6513
#define PAGE1_B_119_ADDRESS 0x6523
#define PAGE1_B_120_ADDRESS 0x6533
#define PAGE1_B_121_ADDRESS 0x6543
#define PAGE1_B_122_ADDRESS 0x6553
#define PAGE1_B_123_ADDRESS 0x6563
#define PAGE1_B_124_ADDRESS 0x6573
#define PAGE1_B_125_ADDRESS 0x6583
#define PAGE1_B_126_ADDRESS 0x6593
#define PAGE1_B_127_ADDRESS 0x65A3
#define PAGE1_B_128_ADDRESS 0x65B3
#define PAGE1_B_129_ADDRESS 0x65C3
#define PAGE1_B_130_ADDRESS 0x65D3
#define PAGE1_B_131_ADDRESS 0x65E3
#define PAGE1_B_132_ADDRESS 0x65F3
#define PAGE1_B_133_ADDRESS 0x6603
#define PAGE1_B_134_ADDRESS 0x6613
#define PAGE1_B_135_ADDRESS 0x6623
#define PAGE1_B_136_ADDRESS 0x6633
#define PAGE1_B_137_ADDRESS 0x6643
#define PAGE1_B_138_ADDRESS 0x6653
#define PAGE1_B_139_ADDRESS 0x6663
#define PAGE1_B_140_ADDRESS 0x6673
#define PAGE1_B_141_ADDRESS 0x6683
#define PAGE1_B_142_ADDRESS 0x6693
#define PAGE1_B_143_ADDRESS 0x66A3
#define PAGE1_B_144_ADDRESS 0x66B3
#define PAGE1_B_145_ADDRESS 0x66C3
#define PAGE1_B_146_ADDRESS 0x66D3
#define PAGE1_B_147_ADDRESS 0x66E3
#define PAGE1_B_148_ADDRESS 0x66F3
#define PAGE1_B_149_ADDRESS 0x6703
#define PAGE1_B_150_ADDRESS 0x6713
#define PAGE1_B_151_ADDRESS 0x6723
#define PAGE1_B_152_ADDRESS 0x6733
#define PAGE1_B_153_ADDRESS 0x6743
#define PAGE1_B_154_ADDRESS 0x6753
#define PAGE1_B_155_ADDRESS 0x6763
#define PAGE1_B_156_ADDRESS 0x6773
#define PAGE1_B_157_ADDRESS 0x6783
#define PAGE1_B_158_ADDRESS 0x6793
#define PAGE1_B_159_ADDRESS 0x67A3
#define PAGE1_B_160_ADDRESS 0x67B3
#define PAGE1_B_161_ADDRESS 0x67C3
#define PAGE1_B_162_ADDRESS 0x67D3
#define PAGE1_B_163_ADDRESS 0x67E3
#define PAGE1_B_164_ADDRESS 0x67F3
#define PAGE1_B_165_ADDRESS 0x6803
#define PAGE1_B_166_ADDRESS 0x6813
#define PAGE1_B_167_ADDRESS 0x6823
#define PAGE1_B_168_ADDRESS 0x6833
#define PAGE1_B_169_ADDRESS 0x6843
#define PAGE1_B_170_ADDRESS 0x6853
#define PAGE1_B_171_ADDRESS 0x6863
#define PAGE1_B_172_ADDRESS 0x6873
#define PAGE1_B_173_ADDRESS 0x6883
#define PAGE1_B_174_ADDRESS 0x6893
#define PAGE1_B_175_ADDRESS 0x68A3
#define PAGE1_B_176_ADDRESS 0x68B3
#define PAGE1_B_177_ADDRESS 0x68C3
#define PAGE1_B_178_ADDRESS 0x68D3
#define PAGE1_B_179_ADDRESS 0x68E3
#define PAGE1_B_180_ADDRESS 0x68F3
#define PAGE1_B_181_ADDRESS 0x6903
#define PAGE1_B_182_ADDRESS 0x6913
#define PAGE1_B_183_ADDRESS 0x6923
#define PAGE1_B_184_ADDRESS 0x6933
#define PAGE1_B_185_ADDRESS 0x6943
#define PAGE1_B_186_ADDRESS 0x6953
#define PAGE1_B_187_ADDRESS 0x6963
#define PAGE1_B_188_ADDRESS 0x6973
#define PAGE1_B_189_ADDRESS 0x6983
#define PAGE1_B_190_ADDRESS 0x6993
#define PAGE1_B_191_ADDRESS 0x69A3
#define PAGE1_B_192_ADDRESS 0x69B3
#define PAGE1_B_193_ADDRESS 0x69C3
#define PAGE1_B_194_ADDRESS 0x69D3
#define PAGE1_B_195_ADDRESS 0x69E3
#define PAGE1_B_196_ADDRESS 0x69F3
#define PAGE1_B_197_ADDRESS 0x6A03
#define PAGE1_B_198_ADDRESS 0x6A13
#define PAGE1_B_199_ADDRESS 0x6A23
#define PAGE1_B_200_ADDRESS 0x6A33
#define PAGE1_B_201_ADDRESS 0x6A43
#define PAGE1_B_202_ADDRESS 0x6A53
#define PAGE1_B_203_ADDRESS 0x6A63
#define PAGE1_B_204_ADDRESS 0x6A73
#define PAGE1_B_205_ADDRESS 0x6A83
#define PAGE1_B_206_ADDRESS 0x6A93
#define PAGE1_B_207_ADDRESS 0x6AA3
#define PAGE1_B_208_ADDRESS 0x6AB3
#define PAGE1_B_209_ADDRESS 0x6AC3
#define PAGE1_B_210_ADDRESS 0x6AD3
#define PAGE1_B_211_ADDRESS 0x6AE3
#define PAGE1_B_212_ADDRESS 0x6AF3
#define PAGE1_B_213_ADDRESS 0x6B03
#define PAGE1_B_214_ADDRESS 0x6B13
#define PAGE1_B_215_ADDRESS 0x6B23
#define PAGE1_B_216_ADDRESS 0x6B33
#define PAGE1_B_217_ADDRESS 0x6B43
#define PAGE1_B_218_ADDRESS 0x6B53
#define PAGE1_B_219_ADDRESS 0x6B63
#define PAGE1_B_220_ADDRESS 0x6B73
#define PAGE1_B_221_ADDRESS 0x6B83
#define PAGE1_B_222_ADDRESS 0x6B93
#define PAGE1_B_223_ADDRESS 0x6BA3
#define PAGE1_B_224_ADDRESS 0x6BB3
#define PAGE1_B_225_ADDRESS 0x6BC3
#define PAGE1_B_226_ADDRESS 0x6BD3
#define PAGE1_B_227_ADDRESS 0x6BE3
#define PAGE1_B_228_ADDRESS 0x6BF3
#define PAGE1_B_229_ADDRESS 0x6C03
#define PAGE1_B_230_ADDRESS 0x6C13
#define PAGE1_B_231_ADDRESS 0x6C23
#define PAGE1_B_232_ADDRESS 0x6C33
#define PAGE1_B_233_ADDRESS 0x6C43
#define PAGE1_B_234_ADDRESS 0x6C53
#define PAGE1_B_235_ADDRESS 0x6C63
#define PAGE1_B_236_ADDRESS 0x6C73
#define PAGE1_B_237_ADDRESS 0x6C83
#define PAGE1_B_238_ADDRESS 0x6C93
#define PAGE1_B_239_ADDRESS 0x6CA3
#define PAGE1_B_240_ADDRESS 0x6CB3
#define PAGE1_B_241_ADDRESS 0x6CC3
#define PAGE1_B_242_ADDRESS 0x6CD3
#define PAGE1_B_243_ADDRESS 0x6CE3
#define PAGE1_B_244_ADDRESS 0x6CF3
#define PAGE1_B_245_ADDRESS 0x6D03
#define PAGE1_B_246_ADDRESS 0x6D13
#define PAGE1_B_247_ADDRESS 0x6D23
#define PAGE1_B_248_ADDRESS 0x6D33
#define PAGE1_B_249_ADDRESS 0x6D43
#define PAGE1_B_250_ADDRESS 0x6D53
#define PAGE1_B_251_ADDRESS 0x6D63
#define PAGE1_B_252_ADDRESS 0x6D73
#define PAGE1_B_253_ADDRESS 0x6D83
#define PAGE1_B_254_ADDRESS 0x6D93
#define PAGE1_B_255_ADDRESS 0x6DA3
#define PAGE1_B_256_ADDRESS 0x6DB3
#define PAGE1_B_257_ADDRESS 0x6DC3
#define PAGE1_B_258_ADDRESS 0x6DD3
#define PAGE1_B_259_ADDRESS 0x6DE3
#define PAGE1_B_260_ADDRESS 0x6DF3
#define PAGE1_B_261_ADDRESS 0x6E03
#define PAGE1_B_262_ADDRESS 0x6E13
#define PAGE1_B_263_ADDRESS 0x6E23
#define PAGE1_B_264_ADDRESS 0x6E33
#define PAGE1_B_265_ADDRESS 0x6E43
#define PAGE1_B_266_ADDRESS 0x6E53
#define PAGE1_B_267_ADDRESS 0x6E63
#define PAGE1_B_268_ADDRESS 0x6E73
#define PAGE1_B_269_ADDRESS 0x6E83
#define PAGE1_B_270_ADDRESS 0x6E93
#define PAGE1_B_271_ADDRESS 0x6EA3
#define PAGE1_B_272_ADDRESS 0x6EB3
#define PAGE1_B_273_ADDRESS 0x6EC3
#define PAGE1_B_274_ADDRESS 0x6ED3
#define PAGE1_B_275_ADDRESS 0x6EE3
#define PAGE1_B_276_ADDRESS 0x6EF3
#define PAGE1_B_277_ADDRESS 0x6F03
#define PAGE1_B_278_ADDRESS 0x6F13
#define PAGE1_B_279_ADDRESS 0x6F23
#define PAGE1_B_280_ADDRESS 0x6F33
#define PAGE1_B_281_ADDRESS 0x6F43
#define PAGE1_B_282_ADDRESS 0x6F53
#define PAGE1_B_283_ADDRESS 0x6F63
#define PAGE1_B_284_ADDRESS 0x6F73
#define PAGE1_B_285_ADDRESS 0x6F83
#define PAGE1_B_286_ADDRESS 0x6F93
#define PAGE1_B_287_ADDRESS 0x6FA3
#define PAGE1_B_288_ADDRESS 0x6FB3
#define PAGE1_B_289_ADDRESS 0x6FC3
#define PAGE1_B_290_ADDRESS 0x6FD3
#define PAGE1_B_291_ADDRESS 0x6FE3
#define PAGE1_B_292_ADDRESS 0x6FF3
#define PAGE1_B_293_ADDRESS 0x7003
#define PAGE1_B_294_ADDRESS 0x7013
#define PAGE1_B_295_ADDRESS 0x7023
#define PAGE1_B_296_ADDRESS 0x7033
#define PAGE1_B_297_ADDRESS 0x7043
#define PAGE1_B_298_ADDRESS 0x7053
#define PAGE1_B_299_ADDRESS 0x7063
#define PAGE1_B_300_ADDRESS 0x7073
#define PAGE1_B_301_ADDRESS 0x7083
#define PAGE1_B_302_ADDRESS 0x7093
#define PAGE1_B_303_ADDRESS 0x70A3
#define PAGE1_B_304_ADDRESS 0x70B3
#define PAGE1_B_305_ADDRESS 0x70C3
#define PAGE1_B_306_ADDRESS 0x70D3
#define PAGE1_B_307_ADDRESS 0x70E3
#define PAGE1_B_308_ADDRESS 0x70F3
#define PAGE1_B_309_ADDRESS 0x7103
#define PAGE1_B_310_ADDRESS 0x7113
#define PAGE1_B_311_ADDRESS 0x7123
#define PAGE1_B_312_ADDRESS 0x7133
#define PAGE1_B_313_ADDRESS 0x7143
#define PAGE1_B_314_ADDRESS 0x7153
#define PAGE1_B_315_ADDRESS 0x7163
#define PAGE1_B_316_ADDRESS 0x7173
#define PAGE1_B_317_ADDRESS 0x7183
#define PAGE1_B_318_ADDRESS 0x7193
#define PAGE1_B_319_ADDRESS 0x71A3
#define PAGE1_B_320_ADDRESS 0x71B3
#define PAGE1_B_321_ADDRESS 0x71C3
#define PAGE1_B_322_ADDRESS 0x71D3
#define PAGE1_B_323_ADDRESS 0x71E3
#define PAGE1_B_324_ADDRESS 0x71F3
#define PAGE1_B_325_ADDRESS 0x7203
#define PAGE1_B_326_ADDRESS 0x7213
#define PAGE1_B_327_ADDRESS 0x7223
#define PAGE1_B_328_ADDRESS 0x7233
#define PAGE1_B_329_ADDRESS 0x7243
#define PAGE1_B_330_ADDRESS 0x7253
#define PAGE1_B_331_ADDRESS 0x7263
#define PAGE1_B_332_ADDRESS 0x7273
#define PAGE1_B_333_ADDRESS 0x7283
#define PAGE1_B_334_ADDRESS 0x7293
#define PAGE1_B_335_ADDRESS 0x72A3
#define PAGE1_B_336_ADDRESS 0x72B3
#define PAGE1_B_337_ADDRESS 0x72C3
#define PAGE1_B_338_ADDRESS 0x72D3
#define PAGE1_B_339_ADDRESS 0x72E3
#define PAGE1_B_340_ADDRESS 0x72F3
#define PAGE1_B_341_ADDRESS 0x7303
#define PAGE1_B_342_ADDRESS 0x7313
#define PAGE1_B_343_ADDRESS 0x7323
#define PAGE1_B_344_ADDRESS 0x7333
#define PAGE1_B_345_ADDRESS 0x7343
#define PAGE1_B_346_ADDRESS 0x7353
#define PAGE1_B_347_ADDRESS 0x7363
#define PAGE1_B_348_ADDRESS 0x7373
#define PAGE1_B_349_ADDRESS 0x7383
#define PAGE1_B_350_ADDRESS 0x7393
#define PAGE1_B_351_ADDRESS 0x73A3
#define PAGE1_B_352_ADDRESS 0x73B3
#define PAGE1_B_353_ADDRESS 0x73C3
#define PAGE1_B_354_ADDRESS 0x73D3
#define PAGE1_B_355_ADDRESS 0x73E3
#define PAGE1_B_356_ADDRESS 0x73F3
#define PAGE1_B_357_ADDRESS 0x7403
#define PAGE1_B_358_ADDRESS 0x7413
#define PAGE1_B_359_ADDRESS 0x7423
#define PAGE1_B_360_ADDRESS 0x7433
#define PAGE1_B_361_ADDRESS 0x7443
#define PAGE1_B_362_ADDRESS 0x7453
#define PAGE1_B_363_ADDRESS 0x7463
#define PAGE1_B_364_ADDRESS 0x7473
#define PAGE1_B_365_ADDRESS 0x7483
#define PAGE1_B_366_ADDRESS 0x7493
#define PAGE1_B_367_ADDRESS 0x74A3
#define PAGE1_B_368_ADDRESS 0x74B3
#define PAGE1_B_369_ADDRESS 0x74C3
#define PAGE1_B_370_ADDRESS 0x74D3
#define PAGE1_B_371_ADDRESS 0x74E3
#define PAGE1_B_372_ADDRESS 0x74F3
#define PAGE1_B_373_ADDRESS 0x7503
#define PAGE1_B_374_ADDRESS 0x7513
#define PAGE1_B_375_ADDRESS 0x7523
#define PAGE1_B_376_ADDRESS 0x7533
#define PAGE1_B_377_ADDRESS 0x7543
#define PAGE1_B_378_ADDRESS 0x7553
#define PAGE1_B_379_ADDRESS 0x7563
#define PAGE1_B_380_ADDRESS 0x7573
#define PAGE1_B_381_ADDRESS 0x7583
#define PAGE1_B_382_ADDRESS 0x7593
#define PAGE1_B_383_ADDRESS 0x75A3
#define PAGE1_B_384_ADDRESS 0x75B3
#define PAGE1_B_385_ADDRESS 0x75C3
#define PAGE1_B_386_ADDRESS 0x75D3
#define PAGE1_B_387_ADDRESS 0x75E3
#define PAGE1_B_388_ADDRESS 0x75F3
#define PAGE1_B_389_ADDRESS 0x7603
#define PAGE1_B_390_ADDRESS 0x7613
#define PAGE1_B_391_ADDRESS 0x7623
#define PAGE1_B_392_ADDRESS 0x7633
#define PAGE1_B_393_ADDRESS 0x7643
#define PAGE1_B_394_ADDRESS 0x7653
#define PAGE1_B_395_ADDRESS 0x7663
#define PAGE1_B_396_ADDRESS 0x7673
#define PAGE1_B_397_ADDRESS 0x7683
#define PAGE1_B_398_ADDRESS 0x7693
#define PAGE1_B_399_ADDRESS 0x76A3
#define PAGE1_B_400_ADDRESS 0x76B3
#define PAGE1_B_401_ADDRESS 0x76C3
#define PAGE1_B_402_ADDRESS 0x76D3
#define PAGE1_B_403_ADDRESS 0x76E3
#define PAGE1_B_404_ADDRESS 0x76F3
#define PAGE1_B_405_ADDRESS 0x7703
#define PAGE1_B_406_ADDRESS 0x7713
#define PAGE1_B_407_ADDRESS 0x7723
#define PAGE1_B_408_ADDRESS 0x7733
#define PAGE1_B_409_ADDRESS 0x7743
#define PAGE1_B_410_ADDRESS 0x7753
#define PAGE1_B_411_ADDRESS 0x7763
#define PAGE1_B_412_ADDRESS 0x7773
#define PAGE1_B_413_ADDRESS 0x7783
#define PAGE1_B_414_ADDRESS 0x7793
#define PAGE1_B_415_ADDRESS 0x77A3
#define PAGE1_B_416_ADDRESS 0x77B3
#define PAGE1_B_417_ADDRESS 0x77C3
#define PAGE1_B_418_ADDRESS 0x77D3
#define PAGE1_B_419_ADDRESS 0x77E3
#define PAGE1_B_420_ADDRESS 0x77F3
#define PAGE1_B_421_ADDRESS 0x7803
#define PAGE1_B_422_ADDRESS 0x7813
#define PAGE1_B_423_ADDRESS 0x7823
#define PAGE1_B_424_ADDRESS 0x7833
#define PAGE1_B_425_ADDRESS 0x7843
#define PAGE1_B_426_ADDRESS 0x7853
#define PAGE1_B_427_ADDRESS 0x7863
#define PAGE1_B_428_ADDRESS 0x7873
#define PAGE1_B_429_ADDRESS 0x7883
#define PAGE1_B_430_ADDRESS 0x7893
#define PAGE1_B_431_ADDRESS 0x78A3
#define PAGE1_B_432_ADDRESS 0x78B3
#define PAGE1_B_433_ADDRESS 0x78C3
#define PAGE1_B_434_ADDRESS 0x78D3
#define PAGE1_B_435_ADDRESS 0x78E3
#define PAGE1_B_436_ADDRESS 0x78F3
#define PAGE1_B_437_ADDRESS 0x7903
#define PAGE1_B_438_ADDRESS 0x7913
#define PAGE1_B_439_ADDRESS 0x7923
#define PAGE1_B_440_ADDRESS 0x7933
#define PAGE1_B_441_ADDRESS 0x7943
#define PAGE1_B_442_ADDRESS 0x7953
#define PAGE1_B_443_ADDRESS 0x7963
#define PAGE1_B_444_ADDRESS 0x7973
#define PAGE1_B_445_ADDRESS 0x7983
#define PAGE1_B_446_ADDRESS 0x7993
#define PAGE1_B_447_ADDRESS 0x79A3
#define PAGE1_B_448_ADDRESS 0x79B3
#define PAGE1_B_449_ADDRESS 0x79C3
#define PAGE1_B_450_ADDRESS 0x79D3
#define PAGE1_B_451_ADDRESS 0x79E3
#define PAGE1_B_452_ADDRESS 0x79F3
#define PAGE1_B_453_ADDRESS 0x7A03
#define PAGE1_B_454_ADDRESS 0x7A13
#define PAGE1_B_455_ADDRESS 0x7A23
#define PAGE1_B_456_ADDRESS 0x7A33
#define PAGE1_B_457_ADDRESS 0x7A43
#define PAGE1_B_458_ADDRESS 0x7A53
#define PAGE1_B_459_ADDRESS 0x7A63
#define PAGE1_B_460_ADDRESS 0x7A73
#define PAGE1_B_461_ADDRESS 0x7A83
#define PAGE1_B_462_ADDRESS 0x7A93
#define PAGE1_B_463_ADDRESS 0x7AA3
#define PAGE1_B_464_ADDRESS 0x7AB3
#define PAGE1_B_465_ADDRESS 0x7AC3
#define PAGE1_B_466_ADDRESS 0x7AD3
#define PAGE1_B_467_ADDRESS 0x7AE3
#define PAGE1_B_468_ADDRESS 0x7AF3
#define PAGE1_B_469_ADDRESS 0x7B03
#define PAGE1_B_470_ADDRESS 0x7B13
#define PAGE1_B_471_ADDRESS 0x7B23
#define PAGE1_B_472_ADDRESS 0x7B33
#define PAGE1_B_473_ADDRESS 0x7B43
#define PAGE1_B_474_ADDRESS 0x7B53
#define PAGE1_B_475_ADDRESS 0x7B63
#define PAGE1_B_476_ADDRESS 0x7B73
#define PAGE1_B_477_ADDRESS 0x7B83
#define PAGE1_B_478_ADDRESS 0x7B93
#define PAGE1_B_479_ADDRESS 0x7BA3
#define PAGE1_B_480_ADDRESS 0x7BB3
#define PAGE1_B_481_ADDRESS 0x7BC3
#define PAGE1_B_482_ADDRESS 0x7BD3
#define PAGE1_B_483_ADDRESS 0x7BE3
#define PAGE1_B_484_ADDRESS 0x7BF3
#define PAGE1_B_485_ADDRESS 0x7C03
#define PAGE1_B_486_ADDRESS 0x7C13
#define PAGE1_B_487_ADDRESS 0x7C23
#define PAGE1_B_488_ADDRESS 0x7C33
#define PAGE1_B_489_ADDRESS 0x7C43
#define PAGE1_B_490_ADDRESS 0x7C53
#define PAGE1_B_491_ADDRESS 0x7C63
#define PAGE1_B_492_ADDRESS 0x7C73
#define PAGE1_B_493_ADDRESS 0x7C83
#define PAGE1_B_494_ADDRESS 0x7C93
#define PAGE1_B_495_ADDRESS 0x7CA3
#define PAGE1_B_496_ADDRESS 0x7CB3
#define PAGE1_B_497_ADDRESS 0x7CC3
#define PAGE1_B_498_ADDRESS 0x7CD3
#define PAGE1_B_499_ADDRESS 0x7CE3
#define PAGE1_B_500_ADDRESS 0x7CF3
#define PAGE1_B_501_ADDRESS 0x7D03
#define PAGE1_B_502_ADDRESS 0x7D13
#define PAGE1_B_503_ADDRESS 0x7D23
#define PAGE1_B_504_ADDRESS 0x7D33
#define PAGE1_B_505_ADDRESS 0x7D43
#define PAGE1_B_506_ADDRESS 0x7D53
#define PAGE1_B_507_ADDRESS 0x7D63
#define PAGE1_B_508_ADDRESS 0x7D73
#define PAGE1_B_509_ADDRESS 0x7D83
#define PAGE1_B_510_ADDRESS 0x7D93
#define PAGE1_B_511_ADDRESS 0x7DA3
#define PAGE1_B_512_ADDRESS 0x7DB3
#define PAGE1_B_513_ADDRESS 0x7DC3
#define PAGE1_B_514_ADDRESS 0x7DD3
#define PAGE1_B_515_ADDRESS 0x7DE3
#define PAGE1_B_516_ADDRESS 0x7DF3
#define PAGE1_B_517_ADDRESS 0x7E03
#define PAGE1_B_518_ADDRESS 0x7E13
#define PAGE1_B_519_ADDRESS 0x7E23
#define PAGE1_B_520_ADDRESS 0x7E33
#define PAGE1_B_521_ADDRESS 0x7E43
#define PAGE1_B_522_ADDRESS 0x7E53
#define PAGE1_B_523_ADDRESS 0x7E63
#define PAGE1_B_524_ADDRESS 0x7E73
#define PAGE1_B_525_ADDRESS 0x7E83
#define PAGE1_B_526_ADDRESS 0x7E93
#define PAGE1_B_527_ADDRESS 0x7EA3
#define PAGE1_B_528_ADDRESS 0x7EB3
#define PAGE1_B_529_ADDRESS 0x7EC3
#define PAGE1_B_530_ADDRESS 0x7ED3
#define PAGE1_B_531_ADDRESS 0x7EE3
#define PAGE1_B_532_ADDRESS 0x7EF3
#define PAGE1_B_533_ADDRESS 0x7F03
#define PAGE1_B_534_ADDRESS 0x7F13
#define PAGE1_B_535_ADDRESS 0x7F23
#define PAGE1_B_536_ADDRESS 0x7F33
#define PAGE1_B_537_ADDRESS 0x7F43
#define PAGE1_B_538_ADDRESS 0x7F53
#define PAGE1_B_539_ADDRESS 0x7F63
#define PAGE1_B_540_ADDRESS 0x7F73
#define PAGE1_B_541_ADDRESS 0x7F83
#define PAGE1_B_542_ADDRESS 0x7F93
#define PAGE1_B_543_ADDRESS 0x7FA3
#define PAGE1_B_544_ADDRESS 0x7FB3
#define PAGE1_B_545_ADDRESS 0x7FC3
#define PAGE1_B_546_ADDRESS 0x7FD3
#define PAGE1_B_547_ADDRESS 0x7FE3
#define PAGE1_B_548_ADDRESS 0x7FF3
#define PAGE1_B_549_ADDRESS 0x8003
#define PAGE1_B_550_ADDRESS 0x8013
#define PAGE1_B_551_ADDRESS 0x8023
#define PAGE1_B_552_ADDRESS 0x8033
#define PAGE1_B_553_ADDRESS 0x8043
#define PAGE1_B_554_ADDRESS 0x8053
#define PAGE1_B_555_ADDRESS 0x8063
#define PAGE1_B_556_ADDRESS 0x8073
#define PAGE1_B_557_ADDRESS 0x8083
#define PAGE1_B_558_ADDRESS 0x8093
#define PAGE1_B_559_ADDRESS 0x80A3
#define PAGE1_B_560_ADDRESS 0x80B3
#define PAGE1_B_561_ADDRESS 0x80C3
#define PAGE1_B_562_ADDRESS 0x80D3
#define PAGE1_B_563_ADDRESS 0x80E3
#define PAGE1_B_564_ADDRESS 0x80F3
#define PAGE1_B_565_ADDRESS 0x8103
#define PAGE1_B_566_ADDRESS 0x8113
#define PAGE1_B_567_ADDRESS 0x8123
#define PAGE1_B_568_ADDRESS 0x8133
#define PAGE1_B_569_ADDRESS 0x8143
#define PAGE1_B_570_ADDRESS 0x8153
#define PAGE1_B_571_ADDRESS 0x8163
#define PAGE1_B_572_ADDRESS 0x8173
#define PAGE1_B_573_ADDRESS 0x8183
#define PAGE1_B_574_ADDRESS 0x8193
#define PAGE1_B_575_ADDRESS 0x81A3
#define PAGE1_B_576_ADDRESS 0x81B3
#define PAGE1_B_577_ADDRESS 0x81C3
#define PAGE1_B_578_ADDRESS 0x81D3
#define PAGE1_B_579_ADDRESS 0x81E3
#define PAGE1_B_580_ADDRESS 0x81F3
#define PAGE1_B_581_ADDRESS 0x8203
#define PAGE1_B_582_ADDRESS 0x8213
#define PAGE1_B_583_ADDRESS 0x8223
#define PAGE1_B_584_ADDRESS 0x8233
#define PAGE1_B_585_ADDRESS 0x8243
#define PAGE1_B_586_ADDRESS 0x8253
#define PAGE1_B_587_ADDRESS 0x8263
#define PAGE1_B_588_ADDRESS 0x8273
#define PAGE1_B_589_ADDRESS 0x8283
#define PAGE1_B_590_ADDRESS 0x8293
#define PAGE1_B_591_ADDRESS 0x82A3
#define PAGE1_B_592_ADDRESS 0x82B3
#define PAGE1_B_593_ADDRESS 0x82C3
#define PAGE1_B_594_ADDRESS 0x82D3
#define PAGE1_B_595_ADDRESS 0x82E3
#define PAGE1_B_596_ADDRESS 0x82F3
#define PAGE1_B_597_ADDRESS 0x8303
#define PAGE1_B_598_ADDRESS 0x8313
#define PAGE1_B_599_ADDRESS 0x8323
#define PAGE1_B_600_ADDRESS 0x8333
#define PAGE1_B_601_ADDRESS 0x8343
#define PAGE1_B_602_ADDRESS 0x8353
#define PAGE1_B_603_ADDRESS 0x8363
#define PAGE1_B_604_ADDRESS 0x8373
#define PAGE1_B_605_ADDRESS 0x8383
#define PAGE1_B_606_ADDRESS 0x8393
#define PAGE1_B_607_ADDRESS 0x83A3
#define PAGE1_B_608_ADDRESS 0x83B3
#define PAGE1_B_609_ADDRESS 0x83C3
#define PAGE1_B_610_ADDRESS 0x83D3
#define PAGE1_B_611_ADDRESS 0x83E3
#define PAGE1_B_612_ADDRESS 0x83F3
#define PAGE1_B_613_ADDRESS 0x8403
#define PAGE1_B_614_ADDRESS 0x8413
#define PAGE1_B_615_ADDRESS 0x8423
#define PAGE1_B_616_ADDRESS 0x8433
#define PAGE1_B_617_ADDRESS 0x8443
#define PAGE1_B_618_ADDRESS 0x8453
#define PAGE1_B_619_ADDRESS 0x8463
#define PAGE1_B_620_ADDRESS 0x8473
#define PAGE1_B_621_ADDRESS 0x8483
#define PAGE1_B_622_ADDRESS 0x8493
#define PAGE1_B_623_ADDRESS 0x84A3
#define PAGE1_B_624_ADDRESS 0x84B3
#define PAGE1_B_625_ADDRESS 0x84C3
#define PAGE1_B_626_ADDRESS 0x84D3
#define PAGE1_B_627_ADDRESS 0x84E3
#define PAGE1_B_628_ADDRESS 0x84F3
#define PAGE1_B_629_ADDRESS 0x8503
#define PAGE1_B_630_ADDRESS 0x8513
#define PAGE1_B_631_ADDRESS 0x8523
#define PAGE1_B_632_ADDRESS 0x8533
#define PAGE1_B_633_ADDRESS 0x8543
#define PAGE1_B_634_ADDRESS 0x8553
#define PAGE1_B_635_ADDRESS 0x8563
#define PAGE1_B_636_ADDRESS 0x8573
#define PAGE1_B_637_ADDRESS 0x8583
#define PAGE1_B_638_ADDRESS 0x8593
#define PAGE1_B_639_ADDRESS 0x85A3
#define PAGE1_B_640_ADDRESS 0x85B3
#define PAGE1_B_641_ADDRESS 0x85C3
#define PAGE1_B_642_ADDRESS 0x85D3
#define PAGE1_B_643_ADDRESS 0x85E3
#define PAGE1_B_644_ADDRESS 0x85F3
#define PAGE1_B_645_ADDRESS 0x8603
#define PAGE1_B_646_ADDRESS 0x8613
#define PAGE1_B_647_ADDRESS 0x8623
#define PAGE1_B_648_ADDRESS 0x8633
#define PAGE1_B_649_ADDRESS 0x8643
#define PAGE1_B_650_ADDRESS 0x8653
#define PAGE1_B_651_ADDRESS 0x8663
#define PAGE1_B_652_ADDRESS 0x8673
#define PAGE1_B_653_ADDRESS 0x8683
#define PAGE1_B_654_ADDRESS 0x8693
#define PAGE1_B_655_ADDRESS 0x86A3
#define PAGE1_B_656_ADDRESS 0x86B3
#define PAGE1_B_657_ADDRESS 0x86C3
#define PAGE1_B_658_ADDRESS 0x86D3
#define PAGE1_B_659_ADDRESS 0x86E3
#define PAGE1_B_660_ADDRESS 0x86F3
#define PAGE1_B_661_ADDRESS 0x8703
#define PAGE1_B_662_ADDRESS 0x8713
#define PAGE1_B_663_ADDRESS 0x8723
#define PAGE1_B_664_ADDRESS 0x8733
#define PAGE1_B_665_ADDRESS 0x8743
#define PAGE1_B_666_ADDRESS 0x8753
#define PAGE1_B_667_ADDRESS 0x8763
#define PAGE1_B_668_ADDRESS 0x8773
#define PAGE1_B_669_ADDRESS 0x8783
#define PAGE1_B_670_ADDRESS 0x8793
#define PAGE1_B_671_ADDRESS 0x87A3
#define PAGE1_B_672_ADDRESS 0x87B3
#define PAGE1_B_673_ADDRESS 0x87C3
#define PAGE1_B_674_ADDRESS 0x87D3
#define PAGE1_B_675_ADDRESS 0x87E3
#define PAGE1_B_676_ADDRESS 0x87F3
#define PAGE1_B_677_ADDRESS 0x8803
#define PAGE1_B_678_ADDRESS 0x8813
#define PAGE1_B_679_ADDRESS 0x8823
#define PAGE1_B_680_ADDRESS 0x8833
#define PAGE1_B_681_ADDRESS 0x8843
#define PAGE1_B_682_ADDRESS 0x8853
#define PAGE1_B_683_ADDRESS 0x8863
#define PAGE1_B_684_ADDRESS 0x8873
#define PAGE1_B_685_ADDRESS 0x8883
#define PAGE1_B_686_ADDRESS 0x8893
#define PAGE1_B_687_ADDRESS 0x88A3
#define PAGE1_B_688_ADDRESS 0x88B3
#define PAGE1_B_689_ADDRESS 0x88C3
#define PAGE1_B_690_ADDRESS 0x88D3
#define PAGE1_B_691_ADDRESS 0x88E3
#define PAGE1_B_692_ADDRESS 0x88F3
#define PAGE1_B_693_ADDRESS 0x8903
#define PAGE1_B_694_ADDRESS 0x8913
#define PAGE1_B_695_ADDRESS 0x8923
#define PAGE1_B_696_ADDRESS 0x8933
#define PAGE1_B_697_ADDRESS 0x8943
#define PAGE1_B_698_ADDRESS 0x8953
#define PAGE1_B_699_ADDRESS 0x8963
#define PAGE1_B_700_ADDRESS 0x8973
#define PAGE1_B_701_ADDRESS 0x8983
#define PAGE1_B_702_ADDRESS 0x8993
#define PAGE1_B_703_ADDRESS 0x89A3
#define PAGE1_B_704_ADDRESS 0x89B3
#define PAGE1_B_705_ADDRESS 0x89C3
#define PAGE1_B_706_ADDRESS 0x89D3
#define PAGE1_B_707_ADDRESS 0x89E3
#define PAGE1_B_708_ADDRESS 0x89F3
#define PAGE1_B_709_ADDRESS 0x8A03
#define PAGE1_B_710_ADDRESS 0x8A13
#define PAGE1_B_711_ADDRESS 0x8A23
#define PAGE1_B_712_ADDRESS 0x8A33
#define PAGE1_B_713_ADDRESS 0x8A43
#define PAGE1_B_714_ADDRESS 0x8A53
#define PAGE1_B_715_ADDRESS 0x8A63
#define PAGE1_B_716_ADDRESS 0x8A73
#define PAGE1_B_717_ADDRESS 0x8A83
#define PAGE1_B_718_ADDRESS 0x8A93
#define PAGE1_B_719_ADDRESS 0x8AA3
#define PAGE1_B_720_ADDRESS 0x8AB3
#define PAGE1_B_721_ADDRESS 0x8AC3
#define PAGE1_B_722_ADDRESS 0x8AD3
#define PAGE1_B_723_ADDRESS 0x8AE3
#define PAGE1_B_724_ADDRESS 0x8AF3
#define PAGE1_B_725_ADDRESS 0x8B03
#define PAGE1_B_726_ADDRESS 0x8B13
#define PAGE1_B_727_ADDRESS 0x8B23
#define PAGE1_B_728_ADDRESS 0x8B33
#define PAGE1_B_729_ADDRESS 0x8B43
#define PAGE1_B_730_ADDRESS 0x8B53
#define PAGE1_B_731_ADDRESS 0x8B63
#define PAGE1_B_732_ADDRESS 0x8B73
#define PAGE1_B_733_ADDRESS 0x8B83
#define PAGE1_B_734_ADDRESS 0x8B93
#define PAGE1_B_735_ADDRESS 0x8BA3
#define PAGE1_B_736_ADDRESS 0x8BB3
#define PAGE1_B_737_ADDRESS 0x8BC3
#define PAGE1_B_738_ADDRESS 0x8BD3
#define PAGE1_B_739_ADDRESS 0x8BE3
#define PAGE1_B_740_ADDRESS 0x8BF3
#define PAGE1_B_741_ADDRESS 0x8C03
#define PAGE1_B_742_ADDRESS 0x8C13
#define PAGE1_B_743_ADDRESS 0x8C23
#define PAGE1_B_744_ADDRESS 0x8C33
#define PAGE1_B_745_ADDRESS 0x8C43
#define PAGE1_B_746_ADDRESS 0x8C53
#define PAGE1_B_747_ADDRESS 0x8C63
#define PAGE1_B_748_ADDRESS 0x8C73
#define PAGE1_B_749_ADDRESS 0x8C83
#define PAGE1_B_750_ADDRESS 0x8C93
#define PAGE1_B_751_ADDRESS 0x8CA3
#define PAGE1_B_752_ADDRESS 0x8CB3
#define PAGE1_B_753_ADDRESS 0x8CC3
#define PAGE1_B_754_ADDRESS 0x8CD3
#define PAGE1_B_755_ADDRESS 0x8CE3
#define PAGE1_B_756_ADDRESS 0x8CF3
#define PAGE1_B_757_ADDRESS 0x8D03
#define PAGE1_B_758_ADDRESS 0x8D13
#define PAGE1_B_759_ADDRESS 0x8D23
#define PAGE1_B_760_ADDRESS 0x8D33
#define PAGE1_B_761_ADDRESS 0x8D43
#define PAGE1_B_762_ADDRESS 0x8D53
#define PAGE1_B_763_ADDRESS 0x8D63
#define PAGE1_B_764_ADDRESS 0x8D73
#define PAGE1_B_765_ADDRESS 0x8D83
#define PAGE1_B_766_ADDRESS 0x8D93
#define PAGE1_B_767_ADDRESS 0x8DA3
#define PAGE1_B_768_ADDRESS 0x8DB3
#define PAGE1_B_769_ADDRESS 0x8DC3
#define PAGE1_B_770_ADDRESS 0x8DD3
#define PAGE1_B_771_ADDRESS 0x8DE3
#define PAGE1_B_772_ADDRESS 0x8DF3
#define PAGE1_B_773_ADDRESS 0x8E03
#define PAGE1_B_774_ADDRESS 0x8E13
#define PAGE1_B_775_ADDRESS 0x8E23
#define PAGE1_B_776_ADDRESS 0x8E33
#define PAGE1_B_777_ADDRESS 0x8E43
#define PAGE1_B_778_ADDRESS 0x8E53
#define PAGE1_B_779_ADDRESS 0x8E63
#define PAGE1_B_780_ADDRESS 0x8E73
#define PAGE1_B_781_ADDRESS 0x8E83
#define PAGE1_B_782_ADDRESS 0x8E93
#define PAGE1_B_783_ADDRESS 0x8EA3
#define PAGE1_B_784_ADDRESS 0x8EB3
#define PAGE1_B_785_ADDRESS 0x8EC3
#define PAGE1_B_786_ADDRESS 0x8ED3
#define PAGE1_B_787_ADDRESS 0x8EE3
#define PAGE1_B_788_ADDRESS 0x8EF3
#define PAGE1_B_789_ADDRESS 0x8F03
#define PAGE1_B_790_ADDRESS 0x8F13
#define PAGE1_B_791_ADDRESS 0x8F23
#define PAGE1_B_792_ADDRESS 0x8F33
#define PAGE1_B_793_ADDRESS 0x8F43
#define PAGE1_B_794_ADDRESS 0x8F53
#define PAGE1_B_795_ADDRESS 0x8F63
#define PAGE1_B_796_ADDRESS 0x8F73
#define PAGE1_B_797_ADDRESS 0x8F83
#define PAGE1_B_798_ADDRESS 0x8F93
#define PAGE1_B_799_ADDRESS 0x8FA3
#define PAGE1_B_800_ADDRESS 0x8FB3
#define PAGE1_B_801_ADDRESS 0x8FC3
#define PAGE1_B_802_ADDRESS 0x8FD3
#define PAGE1_B_803_ADDRESS 0x8FE3
#define PAGE1_B_804_ADDRESS 0x8FF3
#define PAGE1_B_805_ADDRESS 0x9003
#define PAGE1_B_806_ADDRESS 0x9013
#define PAGE1_B_807_ADDRESS 0x9023
#define PAGE1_B_808_ADDRESS 0x9033
#define PAGE1_B_809_ADDRESS 0x9043
#define PAGE1_B_810_ADDRESS 0x9053
#define PAGE1_B_811_ADDRESS 0x9063
#define PAGE1_B_812_ADDRESS 0x9073
#define PAGE1_B_813_ADDRESS 0x9083
#define PAGE1_B_814_ADDRESS 0x9093
#define PAGE1_B_815_ADDRESS 0x90A3
#define PAGE1_B_816_ADDRESS 0x90B3
#define PAGE1_B_817_ADDRESS 0x90C3
#define PAGE1_B_818_ADDRESS 0x90D3
#define PAGE1_B_819_ADDRESS 0x90E3
#define PAGE1_B_820_ADDRESS 0x90F3
#define PAGE1_B_821_ADDRESS 0x9103
#define PAGE1_B_822_ADDRESS 0x9113
#define PAGE1_B_823_ADDRESS 0x9123
#define PAGE1_B_824_ADDRESS 0x9133
#define PAGE1_B_825_ADDRESS 0x9143
#define PAGE1_B_826_ADDRESS 0x9153
#define PAGE1_B_827_ADDRESS 0x9163
#define PAGE1_B_828_ADDRESS 0x9173
#define PAGE1_B_829_ADDRESS 0x9183
#define PAGE1_B_830_ADDRESS 0x9193
#define PAGE1_B_831_ADDRESS 0x91A3
#define PAGE1_B_832_ADDRESS 0x91B3
#define PAGE1_B_833_ADDRESS 0x91C3
#define PAGE1_B_834_ADDRESS 0x91D3
#define PAGE1_B_835_ADDRESS 0x91E3
#define PAGE1_B_836_ADDRESS 0x91F3
#define PAGE1_B_837_ADDRESS 0x9203
#define PAGE1_B_838_ADDRESS 0x9213
#define PAGE1_B_839_ADDRESS 0x9223
#define PAGE1_B_840_ADDRESS 0x9233
#define PAGE1_B_841_ADDRESS 0x9243
#define PAGE1_B_842_ADDRESS 0x9253
#define PAGE1_B_843_ADDRESS 0x9263
#define PAGE1_B_844_ADDRESS 0x9273
#define PAGE1_B_845_ADDRESS 0x9283
#define PAGE1_B_846_ADDRESS 0x9293
#define PAGE1_B_847_ADDRESS 0x92A3
#define PAGE1_B_848_ADDRESS 0x92B3
#define PAGE1_B_849_ADDRESS 0x92C3
#define PAGE1_B_850_ADDRESS 0x92D3
#define PAGE1_B_851_ADDRESS 0x92E3
#define PAGE1_B_852_ADDRESS 0x92F3
#define PAGE1_B_853_ADDRESS 0x9303
#define PAGE1_B_854_ADDRESS 0x9313
#define PAGE1_B_855_ADDRESS 0x9323
#define PAGE1_B_856_ADDRESS 0x9333
#define PAGE1_B_857_ADDRESS 0x9343
#define PAGE1_B_858_ADDRESS 0x9353
#define PAGE1_B_859_ADDRESS 0x9363
#define PAGE1_B_860_ADDRESS 0x9373
#define PAGE1_B_861_ADDRESS 0x9383
#define PAGE1_B_862_ADDRESS 0x9393
#define PAGE1_B_863_ADDRESS 0x93A3
#define PAGE1_B_864_ADDRESS 0x93B3
#define PAGE1_B_865_ADDRESS 0x93C3
#define PAGE1_B_866_ADDRESS 0x93D3
#define PAGE1_B_867_ADDRESS 0x93E3
#define PAGE1_B_868_ADDRESS 0x93F3
#define PAGE1_B_869_ADDRESS 0x9403
#define PAGE1_B_870_ADDRESS 0x9413
#define PAGE1_B_871_ADDRESS 0x9423
#define PAGE1_B_872_ADDRESS 0x9433
#define PAGE1_B_873_ADDRESS 0x9443
#define PAGE1_B_874_ADDRESS 0x9453
#define PAGE1_B_875_ADDRESS 0x9463
#define PAGE1_B_876_ADDRESS 0x9473
#define PAGE1_B_877_ADDRESS 0x9483
#define PAGE1_B_878_ADDRESS 0x9493
#define PAGE1_B_879_ADDRESS 0x94A3
#define PAGE1_B_880_ADDRESS 0x94B3
#define PAGE1_B_881_ADDRESS 0x94C3
#define PAGE1_B_882_ADDRESS 0x94D3
#define PAGE1_B_883_ADDRESS 0x94E3

#define GRRR_ADDRESS 0x94F3
#define GRRR_SIZE 450
#define GRRR_FORMAT "raw"
#define GRRR_WIDTH_IN_BYTES 8
#define GRRR_WIDTH 16
#define GRRR_HEIGHT 56
#define GRRR_COUNT 1
#define GRRR_0_ADDRESS 0x94F3

#define BLIP_ADDRESS 0x96B5
#define BLIP_SIZE 44
#define BLIP_FORMAT "raw"
#define BLIP_WIDTH_IN_BYTES 6
#define BLIP_WIDTH 12
#define BLIP_HEIGHT 7
#define BLIP_COUNT 1
#define BLIP_0_ADDRESS 0x96B5

#define PAGE1_B_TEXT_01_ADDRESS 0x96E1
#define PAGE1_B_TEXT_01_SIZE 134
#define PAGE1_B_TEXT_01_FORMAT "raw"
#define PAGE1_B_TEXT_01_WIDTH_IN_BYTES 22
#define PAGE1_B_TEXT_01_WIDTH 44
#define PAGE1_B_TEXT_01_HEIGHT 6
#define PAGE1_B_TEXT_01_COUNT 1
#define PAGE1_B_TEXT_01_0_ADDRESS 0x96E1

#define PAGE1_B_TEXT_02_ADDRESS 0x9767
#define PAGE1_B_TEXT_02_SIZE 128
#define PAGE1_B_TEXT_02_FORMAT "raw"
#define PAGE1_B_TEXT_02_WIDTH_IN_BYTES 21
#define PAGE1_B_TEXT_02_WIDTH 42
#define PAGE1_B_TEXT_02_HEIGHT 6
#define PAGE1_B_TEXT_02_COUNT 1
#define PAGE1_B_TEXT_02_0_ADDRESS 0x9767

#define PAGE1_B_TEXT_03_ADDRESS 0x97E7
#define PAGE1_B_TEXT_03_SIZE 86
#define PAGE1_B_TEXT_03_FORMAT "raw"
#define PAGE1_B_TEXT_03_WIDTH_IN_BYTES 14
#define PAGE1_B_TEXT_03_WIDTH 28
#define PAGE1_B_TEXT_03_HEIGHT 6
#define PAGE1_B_TEXT_03_COUNT 1
#define PAGE1_B_TEXT_03_0_ADDRESS 0x97E7

#define PAGE1_B_TEXT_04_ADDRESS 0x983D
#define PAGE1_B_TEXT_04_SIZE 50
#define PAGE1_B_TEXT_04_FORMAT "raw"
#define PAGE1_B_TEXT_04_WIDTH_IN_BYTES 8
#define PAGE1_B_TEXT_04_WIDTH 16
#define PAGE1_B_TEXT_04_HEIGHT 6
#define PAGE1_B_TEXT_04_COUNT 1
#define PAGE1_B_TEXT_04_0_ADDRESS 0x983D

#define PAGE1_B_TEXT_05_ADDRESS 0x986F
#define PAGE1_B_TEXT_05_SIZE 98
#define PAGE1_B_TEXT_05_FORMAT "raw"
#define PAGE1_B_TEXT_05_WIDTH_IN_BYTES 16
#define PAGE1_B_TEXT_05_WIDTH 32
#define PAGE1_B_TEXT_05_HEIGHT 6
#define PAGE1_B_TEXT_05_COUNT 1
#define PAGE1_B_TEXT_05_0_ADDRESS 0x986F

#define PAGE1_B_TEXT_06_ADDRESS 0x98D1
#define PAGE1_B_TEXT_06_SIZE 206
#define PAGE1_B_TEXT_06_FORMAT "raw"
#define PAGE1_B_TEXT_06_WIDTH_IN_BYTES 34
#define PAGE1_B_TEXT_06_WIDTH 68
#define PAGE1_B_TEXT_06_HEIGHT 6
#define PAGE1_B_TEXT_06_COUNT 1
#define PAGE1_B_TEXT_06_0_ADDRESS 0x98D1

#define PAGE1_B_TEXT_07_ADDRESS 0x999F
#define PAGE1_B_TEXT_07_SIZE 194
#define PAGE1_B_TEXT_07_FORMAT "raw"
#define PAGE1_B_TEXT_07_WIDTH_IN_BYTES 32
#define PAGE1_B_TEXT_07_WIDTH 64
#define PAGE1_B_TEXT_07_HEIGHT 6
#define PAGE1_B_TEXT_07_COUNT 1
#define PAGE1_B_TEXT_07_0_ADDRESS 0x999F


extern const u8 comic_b_assets[5566];


#define PAGE1_A_TOP_ADDRESS 0x5E00
#define PAGE1_A_TOP_SIZE 9984
#define PAGE1_A_TOP_FORMAT "tile"
#define PAGE1_A_TOP_WIDTH_IN_BYTES 2
#define PAGE1_A_TOP_WIDTH 4
#define PAGE1_A_TOP_HEIGHT 8
#define PAGE1_A_TOP_WIDTH_IN_TILES 52
#define PAGE1_A_TOP_HEIGHT_IN_TILES 12
#define PAGE1_A_TOP_COUNT 624
#define PAGE1_A_TOP_0_ADDRESS 0x5E00
#define PAGE1_A_TOP_1_ADDRESS 0x5E10
#define PAGE1_A_TOP_2_ADDRESS 0x5E20
#define PAGE1_A_TOP_3_ADDRESS 0x5E30
#define PAGE1_A_TOP_4_ADDRESS 0x5E40
#define PAGE1_A_TOP_5_ADDRESS 0x5E50
#define PAGE1_A_TOP_6_ADDRESS 0x5E60
#define PAGE1_A_TOP_7_ADDRESS 0x5E70
#define PAGE1_A_TOP_8_ADDRESS 0x5E80
#define PAGE1_A_TOP_9_ADDRESS 0x5E90
#define PAGE1_A_TOP_10_ADDRESS 0x5EA0
#define PAGE1_A_TOP_11_ADDRESS 0x5EB0
#define PAGE1_A_TOP_12_ADDRESS 0x5EC0
#define PAGE1_A_TOP_13_ADDRESS 0x5ED0
#define PAGE1_A_TOP_14_ADDRESS 0x5EE0
#define PAGE1_A_TOP_15_ADDRESS 0x5EF0
#define PAGE1_A_TOP_16_ADDRESS 0x5F00
#define PAGE1_A_TOP_17_ADDRESS 0x5F10
#define PAGE1_A_TOP_18_ADDRESS 0x5F20
#define PAGE1_A_TOP_19_ADDRESS 0x5F30
#define PAGE1_A_TOP_20_ADDRESS 0x5F40
#define PAGE1_A_TOP_21_ADDRESS 0x5F50
#define PAGE1_A_TOP_22_ADDRESS 0x5F60
#define PAGE1_A_TOP_23_ADDRESS 0x5F70
#define PAGE1_A_TOP_24_ADDRESS 0x5F80
#define PAGE1_A_TOP_25_ADDRESS 0x5F90
#define PAGE1_A_TOP_26_ADDRESS 0x5FA0
#define PAGE1_A_TOP_27_ADDRESS 0x5FB0
#define PAGE1_A_TOP_28_ADDRESS 0x5FC0
#define PAGE1_A_TOP_29_ADDRESS 0x5FD0
#define PAGE1_A_TOP_30_ADDRESS 0x5FE0
#define PAGE1_A_TOP_31_ADDRESS 0x5FF0
#define PAGE1_A_TOP_32_ADDRESS 0x6000
#define PAGE1_A_TOP_33_ADDRESS 0x6010
#define PAGE1_A_TOP_34_ADDRESS 0x6020
#define PAGE1_A_TOP_35_ADDRESS 0x6030
#define PAGE1_A_TOP_36_ADDRESS 0x6040
#define PAGE1_A_TOP_37_ADDRESS 0x6050
#define PAGE1_A_TOP_38_ADDRESS 0x6060
#define PAGE1_A_TOP_39_ADDRESS 0x6070
#define PAGE1_A_TOP_40_ADDRESS 0x6080
#define PAGE1_A_TOP_41_ADDRESS 0x6090
#define PAGE1_A_TOP_42_ADDRESS 0x60A0
#define PAGE1_A_TOP_43_ADDRESS 0x60B0
#define PAGE1_A_TOP_44_ADDRESS 0x60C0
#define PAGE1_A_TOP_45_ADDRESS 0x60D0
#define PAGE1_A_TOP_46_ADDRESS 0x60E0
#define PAGE1_A_TOP_47_ADDRESS 0x60F0
#define PAGE1_A_TOP_48_ADDRESS 0x6100
#define PAGE1_A_TOP_49_ADDRESS 0x6110
#define PAGE1_A_TOP_50_ADDRESS 0x6120
#define PAGE1_A_TOP_51_ADDRESS 0x6130
#define PAGE1_A_TOP_52_ADDRESS 0x6140
#define PAGE1_A_TOP_53_ADDRESS 0x6150
#define PAGE1_A_TOP_54_ADDRESS 0x6160
#define PAGE1_A_TOP_55_ADDRESS 0x6170
#define PAGE1_A_TOP_56_ADDRESS 0x6180
#define PAGE1_A_TOP_57_ADDRESS 0x6190
#define PAGE1_A_TOP_58_ADDRESS 0x61A0
#define PAGE1_A_TOP_59_ADDRESS 0x61B0
#define PAGE1_A_TOP_60_ADDRESS 0x61C0
#define PAGE1_A_TOP_61_ADDRESS 0x61D0
#define PAGE1_A_TOP_62_ADDRESS 0x61E0
#define PAGE1_A_TOP_63_ADDRESS 0x61F0
#define PAGE1_A_TOP_64_ADDRESS 0x6200
#define PAGE1_A_TOP_65_ADDRESS 0x6210
#define PAGE1_A_TOP_66_ADDRESS 0x6220
#define PAGE1_A_TOP_67_ADDRESS 0x6230
#define PAGE1_A_TOP_68_ADDRESS 0x6240
#define PAGE1_A_TOP_69_ADDRESS 0x6250
#define PAGE1_A_TOP_70_ADDRESS 0x6260
#define PAGE1_A_TOP_71_ADDRESS 0x6270
#define PAGE1_A_TOP_72_ADDRESS 0x6280
#define PAGE1_A_TOP_73_ADDRESS 0x6290
#define PAGE1_A_TOP_74_ADDRESS 0x62A0
#define PAGE1_A_TOP_75_ADDRESS 0x62B0
#define PAGE1_A_TOP_76_ADDRESS 0x62C0
#define PAGE1_A_TOP_77_ADDRESS 0x62D0
#define PAGE1_A_TOP_78_ADDRESS 0x62E0
#define PAGE1_A_TOP_79_ADDRESS 0x62F0
#define PAGE1_A_TOP_80_ADDRESS 0x6300
#define PAGE1_A_TOP_81_ADDRESS 0x6310
#define PAGE1_A_TOP_82_ADDRESS 0x6320
#define PAGE1_A_TOP_83_ADDRESS 0x6330
#define PAGE1_A_TOP_84_ADDRESS 0x6340
#define PAGE1_A_TOP_85_ADDRESS 0x6350
#define PAGE1_A_TOP_86_ADDRESS 0x6360
#define PAGE1_A_TOP_87_ADDRESS 0x6370
#define PAGE1_A_TOP_88_ADDRESS 0x6380
#define PAGE1_A_TOP_89_ADDRESS 0x6390
#define PAGE1_A_TOP_90_ADDRESS 0x63A0
#define PAGE1_A_TOP_91_ADDRESS 0x63B0
#define PAGE1_A_TOP_92_ADDRESS 0x63C0
#define PAGE1_A_TOP_93_ADDRESS 0x63D0
#define PAGE1_A_TOP_94_ADDRESS 0x63E0
#define PAGE1_A_TOP_95_ADDRESS 0x63F0
#define PAGE1_A_TOP_96_ADDRESS 0x6400
#define PAGE1_A_TOP_97_ADDRESS 0x6410
#define PAGE1_A_TOP_98_ADDRESS 0x6420
#define PAGE1_A_TOP_99_ADDRESS 0x6430
#define PAGE1_A_TOP_100_ADDRESS 0x6440
#define PAGE1_A_TOP_101_ADDRESS 0x6450
#define PAGE1_A_TOP_102_ADDRESS 0x6460
#define PAGE1_A_TOP_103_ADDRESS 0x6470
#define PAGE1_A_TOP_104_ADDRESS 0x6480
#define PAGE1_A_TOP_105_ADDRESS 0x6490
#define PAGE1_A_TOP_106_ADDRESS 0x64A0
#define PAGE1_A_TOP_107_ADDRESS 0x64B0
#define PAGE1_A_TOP_108_ADDRESS 0x64C0
#define PAGE1_A_TOP_109_ADDRESS 0x64D0
#define PAGE1_A_TOP_110_ADDRESS 0x64E0
#define PAGE1_A_TOP_111_ADDRESS 0x64F0
#define PAGE1_A_TOP_112_ADDRESS 0x6500
#define PAGE1_A_TOP_113_ADDRESS 0x6510
#define PAGE1_A_TOP_114_ADDRESS 0x6520
#define PAGE1_A_TOP_115_ADDRESS 0x6530
#define PAGE1_A_TOP_116_ADDRESS 0x6540
#define PAGE1_A_TOP_117_ADDRESS 0x6550
#define PAGE1_A_TOP_118_ADDRESS 0x6560
#define PAGE1_A_TOP_119_ADDRESS 0x6570
#define PAGE1_A_TOP_120_ADDRESS 0x6580
#define PAGE1_A_TOP_121_ADDRESS 0x6590
#define PAGE1_A_TOP_122_ADDRESS 0x65A0
#define PAGE1_A_TOP_123_ADDRESS 0x65B0
#define PAGE1_A_TOP_124_ADDRESS 0x65C0
#define PAGE1_A_TOP_125_ADDRESS 0x65D0
#define PAGE1_A_TOP_126_ADDRESS 0x65E0
#define PAGE1_A_TOP_127_ADDRESS 0x65F0
#define PAGE1_A_TOP_128_ADDRESS 0x6600
#define PAGE1_A_TOP_129_ADDRESS 0x6610
#define PAGE1_A_TOP_130_ADDRESS 0x6620
#define PAGE1_A_TOP_131_ADDRESS 0x6630
#define PAGE1_A_TOP_132_ADDRESS 0x6640
#define PAGE1_A_TOP_133_ADDRESS 0x6650
#define PAGE1_A_TOP_134_ADDRESS 0x6660
#define PAGE1_A_TOP_135_ADDRESS 0x6670
#define PAGE1_A_TOP_136_ADDRESS 0x6680
#define PAGE1_A_TOP_137_ADDRESS 0x6690
#define PAGE1_A_TOP_138_ADDRESS 0x66A0
#define PAGE1_A_TOP_139_ADDRESS 0x66B0
#define PAGE1_A_TOP_140_ADDRESS 0x66C0
#define PAGE1_A_TOP_141_ADDRESS 0x66D0
#define PAGE1_A_TOP_142_ADDRESS 0x66E0
#define PAGE1_A_TOP_143_ADDRESS 0x66F0
#define PAGE1_A_TOP_144_ADDRESS 0x6700
#define PAGE1_A_TOP_145_ADDRESS 0x6710
#define PAGE1_A_TOP_146_ADDRESS 0x6720
#define PAGE1_A_TOP_147_ADDRESS 0x6730
#define PAGE1_A_TOP_148_ADDRESS 0x6740
#define PAGE1_A_TOP_149_ADDRESS 0x6750
#define PAGE1_A_TOP_150_ADDRESS 0x6760
#define PAGE1_A_TOP_151_ADDRESS 0x6770
#define PAGE1_A_TOP_152_ADDRESS 0x6780
#define PAGE1_A_TOP_153_ADDRESS 0x6790
#define PAGE1_A_TOP_154_ADDRESS 0x67A0
#define PAGE1_A_TOP_155_ADDRESS 0x67B0
#define PAGE1_A_TOP_156_ADDRESS 0x67C0
#define PAGE1_A_TOP_157_ADDRESS 0x67D0
#define PAGE1_A_TOP_158_ADDRESS 0x67E0
#define PAGE1_A_TOP_159_ADDRESS 0x67F0
#define PAGE1_A_TOP_160_ADDRESS 0x6800
#define PAGE1_A_TOP_161_ADDRESS 0x6810
#define PAGE1_A_TOP_162_ADDRESS 0x6820
#define PAGE1_A_TOP_163_ADDRESS 0x6830
#define PAGE1_A_TOP_164_ADDRESS 0x6840
#define PAGE1_A_TOP_165_ADDRESS 0x6850
#define PAGE1_A_TOP_166_ADDRESS 0x6860
#define PAGE1_A_TOP_167_ADDRESS 0x6870
#define PAGE1_A_TOP_168_ADDRESS 0x6880
#define PAGE1_A_TOP_169_ADDRESS 0x6890
#define PAGE1_A_TOP_170_ADDRESS 0x68A0
#define PAGE1_A_TOP_171_ADDRESS 0x68B0
#define PAGE1_A_TOP_172_ADDRESS 0x68C0
#define PAGE1_A_TOP_173_ADDRESS 0x68D0
#define PAGE1_A_TOP_174_ADDRESS 0x68E0
#define PAGE1_A_TOP_175_ADDRESS 0x68F0
#define PAGE1_A_TOP_176_ADDRESS 0x6900
#define PAGE1_A_TOP_177_ADDRESS 0x6910
#define PAGE1_A_TOP_178_ADDRESS 0x6920
#define PAGE1_A_TOP_179_ADDRESS 0x6930
#define PAGE1_A_TOP_180_ADDRESS 0x6940
#define PAGE1_A_TOP_181_ADDRESS 0x6950
#define PAGE1_A_TOP_182_ADDRESS 0x6960
#define PAGE1_A_TOP_183_ADDRESS 0x6970
#define PAGE1_A_TOP_184_ADDRESS 0x6980
#define PAGE1_A_TOP_185_ADDRESS 0x6990
#define PAGE1_A_TOP_186_ADDRESS 0x69A0
#define PAGE1_A_TOP_187_ADDRESS 0x69B0
#define PAGE1_A_TOP_188_ADDRESS 0x69C0
#define PAGE1_A_TOP_189_ADDRESS 0x69D0
#define PAGE1_A_TOP_190_ADDRESS 0x69E0
#define PAGE1_A_TOP_191_ADDRESS 0x69F0
#define PAGE1_A_TOP_192_ADDRESS 0x6A00
#define PAGE1_A_TOP_193_ADDRESS 0x6A10
#define PAGE1_A_TOP_194_ADDRESS 0x6A20
#define PAGE1_A_TOP_195_ADDRESS 0x6A30
#define PAGE1_A_TOP_196_ADDRESS 0x6A40
#define PAGE1_A_TOP_197_ADDRESS 0x6A50
#define PAGE1_A_TOP_198_ADDRESS 0x6A60
#define PAGE1_A_TOP_199_ADDRESS 0x6A70
#define PAGE1_A_TOP_200_ADDRESS 0x6A80
#define PAGE1_A_TOP_201_ADDRESS 0x6A90
#define PAGE1_A_TOP_202_ADDRESS 0x6AA0
#define PAGE1_A_TOP_203_ADDRESS 0x6AB0
#define PAGE1_A_TOP_204_ADDRESS 0x6AC0
#define PAGE1_A_TOP_205_ADDRESS 0x6AD0
#define PAGE1_A_TOP_206_ADDRESS 0x6AE0
#define PAGE1_A_TOP_207_ADDRESS 0x6AF0
#define PAGE1_A_TOP_208_ADDRESS 0x6B00
#define PAGE1_A_TOP_209_ADDRESS 0x6B10
#define PAGE1_A_TOP_210_ADDRESS 0x6B20
#define PAGE1_A_TOP_211_ADDRESS 0x6B30
#define PAGE1_A_TOP_212_ADDRESS 0x6B40
#define PAGE1_A_TOP_213_ADDRESS 0x6B50
#define PAGE1_A_TOP_214_ADDRESS 0x6B60
#define PAGE1_A_TOP_215_ADDRESS 0x6B70
#define PAGE1_A_TOP_216_ADDRESS 0x6B80
#define PAGE1_A_TOP_217_ADDRESS 0x6B90
#define PAGE1_A_TOP_218_ADDRESS 0x6BA0
#define PAGE1_A_TOP_219_ADDRESS 0x6BB0
#define PAGE1_A_TOP_220_ADDRESS 0x6BC0
#define PAGE1_A_TOP_221_ADDRESS 0x6BD0
#define PAGE1_A_TOP_222_ADDRESS 0x6BE0
#define PAGE1_A_TOP_223_ADDRESS 0x6BF0
#define PAGE1_A_TOP_224_ADDRESS 0x6C00
#define PAGE1_A_TOP_225_ADDRESS 0x6C10
#define PAGE1_A_TOP_226_ADDRESS 0x6C20
#define PAGE1_A_TOP_227_ADDRESS 0x6C30
#define PAGE1_A_TOP_228_ADDRESS 0x6C40
#define PAGE1_A_TOP_229_ADDRESS 0x6C50
#define PAGE1_A_TOP_230_ADDRESS 0x6C60
#define PAGE1_A_TOP_231_ADDRESS 0x6C70
#define PAGE1_A_TOP_232_ADDRESS 0x6C80
#define PAGE1_A_TOP_233_ADDRESS 0x6C90
#define PAGE1_A_TOP_234_ADDRESS 0x6CA0
#define PAGE1_A_TOP_235_ADDRESS 0x6CB0
#define PAGE1_A_TOP_236_ADDRESS 0x6CC0
#define PAGE1_A_TOP_237_ADDRESS 0x6CD0
#define PAGE1_A_TOP_238_ADDRESS 0x6CE0
#define PAGE1_A_TOP_239_ADDRESS 0x6CF0
#define PAGE1_A_TOP_240_ADDRESS 0x6D00
#define PAGE1_A_TOP_241_ADDRESS 0x6D10
#define PAGE1_A_TOP_242_ADDRESS 0x6D20
#define PAGE1_A_TOP_243_ADDRESS 0x6D30
#define PAGE1_A_TOP_244_ADDRESS 0x6D40
#define PAGE1_A_TOP_245_ADDRESS 0x6D50
#define PAGE1_A_TOP_246_ADDRESS 0x6D60
#define PAGE1_A_TOP_247_ADDRESS 0x6D70
#define PAGE1_A_TOP_248_ADDRESS 0x6D80
#define PAGE1_A_TOP_249_ADDRESS 0x6D90
#define PAGE1_A_TOP_250_ADDRESS 0x6DA0
#define PAGE1_A_TOP_251_ADDRESS 0x6DB0
#define PAGE1_A_TOP_252_ADDRESS 0x6DC0
#define PAGE1_A_TOP_253_ADDRESS 0x6DD0
#define PAGE1_A_TOP_254_ADDRESS 0x6DE0
#define PAGE1_A_TOP_255_ADDRESS 0x6DF0
#define PAGE1_A_TOP_256_ADDRESS 0x6E00
#define PAGE1_A_TOP_257_ADDRESS 0x6E10
#define PAGE1_A_TOP_258_ADDRESS 0x6E20
#define PAGE1_A_TOP_259_ADDRESS 0x6E30
#define PAGE1_A_TOP_260_ADDRESS 0x6E40
#define PAGE1_A_TOP_261_ADDRESS 0x6E50
#define PAGE1_A_TOP_262_ADDRESS 0x6E60
#define PAGE1_A_TOP_263_ADDRESS 0x6E70
#define PAGE1_A_TOP_264_ADDRESS 0x6E80
#define PAGE1_A_TOP_265_ADDRESS 0x6E90
#define PAGE1_A_TOP_266_ADDRESS 0x6EA0
#define PAGE1_A_TOP_267_ADDRESS 0x6EB0
#define PAGE1_A_TOP_268_ADDRESS 0x6EC0
#define PAGE1_A_TOP_269_ADDRESS 0x6ED0
#define PAGE1_A_TOP_270_ADDRESS 0x6EE0
#define PAGE1_A_TOP_271_ADDRESS 0x6EF0
#define PAGE1_A_TOP_272_ADDRESS 0x6F00
#define PAGE1_A_TOP_273_ADDRESS 0x6F10
#define PAGE1_A_TOP_274_ADDRESS 0x6F20
#define PAGE1_A_TOP_275_ADDRESS 0x6F30
#define PAGE1_A_TOP_276_ADDRESS 0x6F40
#define PAGE1_A_TOP_277_ADDRESS 0x6F50
#define PAGE1_A_TOP_278_ADDRESS 0x6F60
#define PAGE1_A_TOP_279_ADDRESS 0x6F70
#define PAGE1_A_TOP_280_ADDRESS 0x6F80
#define PAGE1_A_TOP_281_ADDRESS 0x6F90
#define PAGE1_A_TOP_282_ADDRESS 0x6FA0
#define PAGE1_A_TOP_283_ADDRESS 0x6FB0
#define PAGE1_A_TOP_284_ADDRESS 0x6FC0
#define PAGE1_A_TOP_285_ADDRESS 0x6FD0
#define PAGE1_A_TOP_286_ADDRESS 0x6FE0
#define PAGE1_A_TOP_287_ADDRESS 0x6FF0
#define PAGE1_A_TOP_288_ADDRESS 0x7000
#define PAGE1_A_TOP_289_ADDRESS 0x7010
#define PAGE1_A_TOP_290_ADDRESS 0x7020
#define PAGE1_A_TOP_291_ADDRESS 0x7030
#define PAGE1_A_TOP_292_ADDRESS 0x7040
#define PAGE1_A_TOP_293_ADDRESS 0x7050
#define PAGE1_A_TOP_294_ADDRESS 0x7060
#define PAGE1_A_TOP_295_ADDRESS 0x7070
#define PAGE1_A_TOP_296_ADDRESS 0x7080
#define PAGE1_A_TOP_297_ADDRESS 0x7090
#define PAGE1_A_TOP_298_ADDRESS 0x70A0
#define PAGE1_A_TOP_299_ADDRESS 0x70B0
#define PAGE1_A_TOP_300_ADDRESS 0x70C0
#define PAGE1_A_TOP_301_ADDRESS 0x70D0
#define PAGE1_A_TOP_302_ADDRESS 0x70E0
#define PAGE1_A_TOP_303_ADDRESS 0x70F0
#define PAGE1_A_TOP_304_ADDRESS 0x7100
#define PAGE1_A_TOP_305_ADDRESS 0x7110
#define PAGE1_A_TOP_306_ADDRESS 0x7120
#define PAGE1_A_TOP_307_ADDRESS 0x7130
#define PAGE1_A_TOP_308_ADDRESS 0x7140
#define PAGE1_A_TOP_309_ADDRESS 0x7150
#define PAGE1_A_TOP_310_ADDRESS 0x7160
#define PAGE1_A_TOP_311_ADDRESS 0x7170
#define PAGE1_A_TOP_312_ADDRESS 0x7180
#define PAGE1_A_TOP_313_ADDRESS 0x7190
#define PAGE1_A_TOP_314_ADDRESS 0x71A0
#define PAGE1_A_TOP_315_ADDRESS 0x71B0
#define PAGE1_A_TOP_316_ADDRESS 0x71C0
#define PAGE1_A_TOP_317_ADDRESS 0x71D0
#define PAGE1_A_TOP_318_ADDRESS 0x71E0
#define PAGE1_A_TOP_319_ADDRESS 0x71F0
#define PAGE1_A_TOP_320_ADDRESS 0x7200
#define PAGE1_A_TOP_321_ADDRESS 0x7210
#define PAGE1_A_TOP_322_ADDRESS 0x7220
#define PAGE1_A_TOP_323_ADDRESS 0x7230
#define PAGE1_A_TOP_324_ADDRESS 0x7240
#define PAGE1_A_TOP_325_ADDRESS 0x7250
#define PAGE1_A_TOP_326_ADDRESS 0x7260
#define PAGE1_A_TOP_327_ADDRESS 0x7270
#define PAGE1_A_TOP_328_ADDRESS 0x7280
#define PAGE1_A_TOP_329_ADDRESS 0x7290
#define PAGE1_A_TOP_330_ADDRESS 0x72A0
#define PAGE1_A_TOP_331_ADDRESS 0x72B0
#define PAGE1_A_TOP_332_ADDRESS 0x72C0
#define PAGE1_A_TOP_333_ADDRESS 0x72D0
#define PAGE1_A_TOP_334_ADDRESS 0x72E0
#define PAGE1_A_TOP_335_ADDRESS 0x72F0
#define PAGE1_A_TOP_336_ADDRESS 0x7300
#define PAGE1_A_TOP_337_ADDRESS 0x7310
#define PAGE1_A_TOP_338_ADDRESS 0x7320
#define PAGE1_A_TOP_339_ADDRESS 0x7330
#define PAGE1_A_TOP_340_ADDRESS 0x7340
#define PAGE1_A_TOP_341_ADDRESS 0x7350
#define PAGE1_A_TOP_342_ADDRESS 0x7360
#define PAGE1_A_TOP_343_ADDRESS 0x7370
#define PAGE1_A_TOP_344_ADDRESS 0x7380
#define PAGE1_A_TOP_345_ADDRESS 0x7390
#define PAGE1_A_TOP_346_ADDRESS 0x73A0
#define PAGE1_A_TOP_347_ADDRESS 0x73B0
#define PAGE1_A_TOP_348_ADDRESS 0x73C0
#define PAGE1_A_TOP_349_ADDRESS 0x73D0
#define PAGE1_A_TOP_350_ADDRESS 0x73E0
#define PAGE1_A_TOP_351_ADDRESS 0x73F0
#define PAGE1_A_TOP_352_ADDRESS 0x7400
#define PAGE1_A_TOP_353_ADDRESS 0x7410
#define PAGE1_A_TOP_354_ADDRESS 0x7420
#define PAGE1_A_TOP_355_ADDRESS 0x7430
#define PAGE1_A_TOP_356_ADDRESS 0x7440
#define PAGE1_A_TOP_357_ADDRESS 0x7450
#define PAGE1_A_TOP_358_ADDRESS 0x7460
#define PAGE1_A_TOP_359_ADDRESS 0x7470
#define PAGE1_A_TOP_360_ADDRESS 0x7480
#define PAGE1_A_TOP_361_ADDRESS 0x7490
#define PAGE1_A_TOP_362_ADDRESS 0x74A0
#define PAGE1_A_TOP_363_ADDRESS 0x74B0
#define PAGE1_A_TOP_364_ADDRESS 0x74C0
#define PAGE1_A_TOP_365_ADDRESS 0x74D0
#define PAGE1_A_TOP_366_ADDRESS 0x74E0
#define PAGE1_A_TOP_367_ADDRESS 0x74F0
#define PAGE1_A_TOP_368_ADDRESS 0x7500
#define PAGE1_A_TOP_369_ADDRESS 0x7510
#define PAGE1_A_TOP_370_ADDRESS 0x7520
#define PAGE1_A_TOP_371_ADDRESS 0x7530
#define PAGE1_A_TOP_372_ADDRESS 0x7540
#define PAGE1_A_TOP_373_ADDRESS 0x7550
#define PAGE1_A_TOP_374_ADDRESS 0x7560
#define PAGE1_A_TOP_375_ADDRESS 0x7570
#define PAGE1_A_TOP_376_ADDRESS 0x7580
#define PAGE1_A_TOP_377_ADDRESS 0x7590
#define PAGE1_A_TOP_378_ADDRESS 0x75A0
#define PAGE1_A_TOP_379_ADDRESS 0x75B0
#define PAGE1_A_TOP_380_ADDRESS 0x75C0
#define PAGE1_A_TOP_381_ADDRESS 0x75D0
#define PAGE1_A_TOP_382_ADDRESS 0x75E0
#define PAGE1_A_TOP_383_ADDRESS 0x75F0
#define PAGE1_A_TOP_384_ADDRESS 0x7600
#define PAGE1_A_TOP_385_ADDRESS 0x7610
#define PAGE1_A_TOP_386_ADDRESS 0x7620
#define PAGE1_A_TOP_387_ADDRESS 0x7630
#define PAGE1_A_TOP_388_ADDRESS 0x7640
#define PAGE1_A_TOP_389_ADDRESS 0x7650
#define PAGE1_A_TOP_390_ADDRESS 0x7660
#define PAGE1_A_TOP_391_ADDRESS 0x7670
#define PAGE1_A_TOP_392_ADDRESS 0x7680
#define PAGE1_A_TOP_393_ADDRESS 0x7690
#define PAGE1_A_TOP_394_ADDRESS 0x76A0
#define PAGE1_A_TOP_395_ADDRESS 0x76B0
#define PAGE1_A_TOP_396_ADDRESS 0x76C0
#define PAGE1_A_TOP_397_ADDRESS 0x76D0
#define PAGE1_A_TOP_398_ADDRESS 0x76E0
#define PAGE1_A_TOP_399_ADDRESS 0x76F0
#define PAGE1_A_TOP_400_ADDRESS 0x7700
#define PAGE1_A_TOP_401_ADDRESS 0x7710
#define PAGE1_A_TOP_402_ADDRESS 0x7720
#define PAGE1_A_TOP_403_ADDRESS 0x7730
#define PAGE1_A_TOP_404_ADDRESS 0x7740
#define PAGE1_A_TOP_405_ADDRESS 0x7750
#define PAGE1_A_TOP_406_ADDRESS 0x7760
#define PAGE1_A_TOP_407_ADDRESS 0x7770
#define PAGE1_A_TOP_408_ADDRESS 0x7780
#define PAGE1_A_TOP_409_ADDRESS 0x7790
#define PAGE1_A_TOP_410_ADDRESS 0x77A0
#define PAGE1_A_TOP_411_ADDRESS 0x77B0
#define PAGE1_A_TOP_412_ADDRESS 0x77C0
#define PAGE1_A_TOP_413_ADDRESS 0x77D0
#define PAGE1_A_TOP_414_ADDRESS 0x77E0
#define PAGE1_A_TOP_415_ADDRESS 0x77F0
#define PAGE1_A_TOP_416_ADDRESS 0x7800
#define PAGE1_A_TOP_417_ADDRESS 0x7810
#define PAGE1_A_TOP_418_ADDRESS 0x7820
#define PAGE1_A_TOP_419_ADDRESS 0x7830
#define PAGE1_A_TOP_420_ADDRESS 0x7840
#define PAGE1_A_TOP_421_ADDRESS 0x7850
#define PAGE1_A_TOP_422_ADDRESS 0x7860
#define PAGE1_A_TOP_423_ADDRESS 0x7870
#define PAGE1_A_TOP_424_ADDRESS 0x7880
#define PAGE1_A_TOP_425_ADDRESS 0x7890
#define PAGE1_A_TOP_426_ADDRESS 0x78A0
#define PAGE1_A_TOP_427_ADDRESS 0x78B0
#define PAGE1_A_TOP_428_ADDRESS 0x78C0
#define PAGE1_A_TOP_429_ADDRESS 0x78D0
#define PAGE1_A_TOP_430_ADDRESS 0x78E0
#define PAGE1_A_TOP_431_ADDRESS 0x78F0
#define PAGE1_A_TOP_432_ADDRESS 0x7900
#define PAGE1_A_TOP_433_ADDRESS 0x7910
#define PAGE1_A_TOP_434_ADDRESS 0x7920
#define PAGE1_A_TOP_435_ADDRESS 0x7930
#define PAGE1_A_TOP_436_ADDRESS 0x7940
#define PAGE1_A_TOP_437_ADDRESS 0x7950
#define PAGE1_A_TOP_438_ADDRESS 0x7960
#define PAGE1_A_TOP_439_ADDRESS 0x7970
#define PAGE1_A_TOP_440_ADDRESS 0x7980
#define PAGE1_A_TOP_441_ADDRESS 0x7990
#define PAGE1_A_TOP_442_ADDRESS 0x79A0
#define PAGE1_A_TOP_443_ADDRESS 0x79B0
#define PAGE1_A_TOP_444_ADDRESS 0x79C0
#define PAGE1_A_TOP_445_ADDRESS 0x79D0
#define PAGE1_A_TOP_446_ADDRESS 0x79E0
#define PAGE1_A_TOP_447_ADDRESS 0x79F0
#define PAGE1_A_TOP_448_ADDRESS 0x7A00
#define PAGE1_A_TOP_449_ADDRESS 0x7A10
#define PAGE1_A_TOP_450_ADDRESS 0x7A20
#define PAGE1_A_TOP_451_ADDRESS 0x7A30
#define PAGE1_A_TOP_452_ADDRESS 0x7A40
#define PAGE1_A_TOP_453_ADDRESS 0x7A50
#define PAGE1_A_TOP_454_ADDRESS 0x7A60
#define PAGE1_A_TOP_455_ADDRESS 0x7A70
#define PAGE1_A_TOP_456_ADDRESS 0x7A80
#define PAGE1_A_TOP_457_ADDRESS 0x7A90
#define PAGE1_A_TOP_458_ADDRESS 0x7AA0
#define PAGE1_A_TOP_459_ADDRESS 0x7AB0
#define PAGE1_A_TOP_460_ADDRESS 0x7AC0
#define PAGE1_A_TOP_461_ADDRESS 0x7AD0
#define PAGE1_A_TOP_462_ADDRESS 0x7AE0
#define PAGE1_A_TOP_463_ADDRESS 0x7AF0
#define PAGE1_A_TOP_464_ADDRESS 0x7B00
#define PAGE1_A_TOP_465_ADDRESS 0x7B10
#define PAGE1_A_TOP_466_ADDRESS 0x7B20
#define PAGE1_A_TOP_467_ADDRESS 0x7B30
#define PAGE1_A_TOP_468_ADDRESS 0x7B40
#define PAGE1_A_TOP_469_ADDRESS 0x7B50
#define PAGE1_A_TOP_470_ADDRESS 0x7B60
#define PAGE1_A_TOP_471_ADDRESS 0x7B70
#define PAGE1_A_TOP_472_ADDRESS 0x7B80
#define PAGE1_A_TOP_473_ADDRESS 0x7B90
#define PAGE1_A_TOP_474_ADDRESS 0x7BA0
#define PAGE1_A_TOP_475_ADDRESS 0x7BB0
#define PAGE1_A_TOP_476_ADDRESS 0x7BC0
#define PAGE1_A_TOP_477_ADDRESS 0x7BD0
#define PAGE1_A_TOP_478_ADDRESS 0x7BE0
#define PAGE1_A_TOP_479_ADDRESS 0x7BF0
#define PAGE1_A_TOP_480_ADDRESS 0x7C00
#define PAGE1_A_TOP_481_ADDRESS 0x7C10
#define PAGE1_A_TOP_482_ADDRESS 0x7C20
#define PAGE1_A_TOP_483_ADDRESS 0x7C30
#define PAGE1_A_TOP_484_ADDRESS 0x7C40
#define PAGE1_A_TOP_485_ADDRESS 0x7C50
#define PAGE1_A_TOP_486_ADDRESS 0x7C60
#define PAGE1_A_TOP_487_ADDRESS 0x7C70
#define PAGE1_A_TOP_488_ADDRESS 0x7C80
#define PAGE1_A_TOP_489_ADDRESS 0x7C90
#define PAGE1_A_TOP_490_ADDRESS 0x7CA0
#define PAGE1_A_TOP_491_ADDRESS 0x7CB0
#define PAGE1_A_TOP_492_ADDRESS 0x7CC0
#define PAGE1_A_TOP_493_ADDRESS 0x7CD0
#define PAGE1_A_TOP_494_ADDRESS 0x7CE0
#define PAGE1_A_TOP_495_ADDRESS 0x7CF0
#define PAGE1_A_TOP_496_ADDRESS 0x7D00
#define PAGE1_A_TOP_497_ADDRESS 0x7D10
#define PAGE1_A_TOP_498_ADDRESS 0x7D20
#define PAGE1_A_TOP_499_ADDRESS 0x7D30
#define PAGE1_A_TOP_500_ADDRESS 0x7D40
#define PAGE1_A_TOP_501_ADDRESS 0x7D50
#define PAGE1_A_TOP_502_ADDRESS 0x7D60
#define PAGE1_A_TOP_503_ADDRESS 0x7D70
#define PAGE1_A_TOP_504_ADDRESS 0x7D80
#define PAGE1_A_TOP_505_ADDRESS 0x7D90
#define PAGE1_A_TOP_506_ADDRESS 0x7DA0
#define PAGE1_A_TOP_507_ADDRESS 0x7DB0
#define PAGE1_A_TOP_508_ADDRESS 0x7DC0
#define PAGE1_A_TOP_509_ADDRESS 0x7DD0
#define PAGE1_A_TOP_510_ADDRESS 0x7DE0
#define PAGE1_A_TOP_511_ADDRESS 0x7DF0
#define PAGE1_A_TOP_512_ADDRESS 0x7E00
#define PAGE1_A_TOP_513_ADDRESS 0x7E10
#define PAGE1_A_TOP_514_ADDRESS 0x7E20
#define PAGE1_A_TOP_515_ADDRESS 0x7E30
#define PAGE1_A_TOP_516_ADDRESS 0x7E40
#define PAGE1_A_TOP_517_ADDRESS 0x7E50
#define PAGE1_A_TOP_518_ADDRESS 0x7E60
#define PAGE1_A_TOP_519_ADDRESS 0x7E70
#define PAGE1_A_TOP_520_ADDRESS 0x7E80
#define PAGE1_A_TOP_521_ADDRESS 0x7E90
#define PAGE1_A_TOP_522_ADDRESS 0x7EA0
#define PAGE1_A_TOP_523_ADDRESS 0x7EB0
#define PAGE1_A_TOP_524_ADDRESS 0x7EC0
#define PAGE1_A_TOP_525_ADDRESS 0x7ED0
#define PAGE1_A_TOP_526_ADDRESS 0x7EE0
#define PAGE1_A_TOP_527_ADDRESS 0x7EF0
#define PAGE1_A_TOP_528_ADDRESS 0x7F00
#define PAGE1_A_TOP_529_ADDRESS 0x7F10
#define PAGE1_A_TOP_530_ADDRESS 0x7F20
#define PAGE1_A_TOP_531_ADDRESS 0x7F30
#define PAGE1_A_TOP_532_ADDRESS 0x7F40
#define PAGE1_A_TOP_533_ADDRESS 0x7F50
#define PAGE1_A_TOP_534_ADDRESS 0x7F60
#define PAGE1_A_TOP_535_ADDRESS 0x7F70
#define PAGE1_A_TOP_536_ADDRESS 0x7F80
#define PAGE1_A_TOP_537_ADDRESS 0x7F90
#define PAGE1_A_TOP_538_ADDRESS 0x7FA0
#define PAGE1_A_TOP_539_ADDRESS 0x7FB0
#define PAGE1_A_TOP_540_ADDRESS 0x7FC0
#define PAGE1_A_TOP_541_ADDRESS 0x7FD0
#define PAGE1_A_TOP_542_ADDRESS 0x7FE0
#define PAGE1_A_TOP_543_ADDRESS 0x7FF0
#define PAGE1_A_TOP_544_ADDRESS 0x8000
#define PAGE1_A_TOP_545_ADDRESS 0x8010
#define PAGE1_A_TOP_546_ADDRESS 0x8020
#define PAGE1_A_TOP_547_ADDRESS 0x8030
#define PAGE1_A_TOP_548_ADDRESS 0x8040
#define PAGE1_A_TOP_549_ADDRESS 0x8050
#define PAGE1_A_TOP_550_ADDRESS 0x8060
#define PAGE1_A_TOP_551_ADDRESS 0x8070
#define PAGE1_A_TOP_552_ADDRESS 0x8080
#define PAGE1_A_TOP_553_ADDRESS 0x8090
#define PAGE1_A_TOP_554_ADDRESS 0x80A0
#define PAGE1_A_TOP_555_ADDRESS 0x80B0
#define PAGE1_A_TOP_556_ADDRESS 0x80C0
#define PAGE1_A_TOP_557_ADDRESS 0x80D0
#define PAGE1_A_TOP_558_ADDRESS 0x80E0
#define PAGE1_A_TOP_559_ADDRESS 0x80F0
#define PAGE1_A_TOP_560_ADDRESS 0x8100
#define PAGE1_A_TOP_561_ADDRESS 0x8110
#define PAGE1_A_TOP_562_ADDRESS 0x8120
#define PAGE1_A_TOP_563_ADDRESS 0x8130
#define PAGE1_A_TOP_564_ADDRESS 0x8140
#define PAGE1_A_TOP_565_ADDRESS 0x8150
#define PAGE1_A_TOP_566_ADDRESS 0x8160
#define PAGE1_A_TOP_567_ADDRESS 0x8170
#define PAGE1_A_TOP_568_ADDRESS 0x8180
#define PAGE1_A_TOP_569_ADDRESS 0x8190
#define PAGE1_A_TOP_570_ADDRESS 0x81A0
#define PAGE1_A_TOP_571_ADDRESS 0x81B0
#define PAGE1_A_TOP_572_ADDRESS 0x81C0
#define PAGE1_A_TOP_573_ADDRESS 0x81D0
#define PAGE1_A_TOP_574_ADDRESS 0x81E0
#define PAGE1_A_TOP_575_ADDRESS 0x81F0
#define PAGE1_A_TOP_576_ADDRESS 0x8200
#define PAGE1_A_TOP_577_ADDRESS 0x8210
#define PAGE1_A_TOP_578_ADDRESS 0x8220
#define PAGE1_A_TOP_579_ADDRESS 0x8230
#define PAGE1_A_TOP_580_ADDRESS 0x8240
#define PAGE1_A_TOP_581_ADDRESS 0x8250
#define PAGE1_A_TOP_582_ADDRESS 0x8260
#define PAGE1_A_TOP_583_ADDRESS 0x8270
#define PAGE1_A_TOP_584_ADDRESS 0x8280
#define PAGE1_A_TOP_585_ADDRESS 0x8290
#define PAGE1_A_TOP_586_ADDRESS 0x82A0
#define PAGE1_A_TOP_587_ADDRESS 0x82B0
#define PAGE1_A_TOP_588_ADDRESS 0x82C0
#define PAGE1_A_TOP_589_ADDRESS 0x82D0
#define PAGE1_A_TOP_590_ADDRESS 0x82E0
#define PAGE1_A_TOP_591_ADDRESS 0x82F0
#define PAGE1_A_TOP_592_ADDRESS 0x8300
#define PAGE1_A_TOP_593_ADDRESS 0x8310
#define PAGE1_A_TOP_594_ADDRESS 0x8320
#define PAGE1_A_TOP_595_ADDRESS 0x8330
#define PAGE1_A_TOP_596_ADDRESS 0x8340
#define PAGE1_A_TOP_597_ADDRESS 0x8350
#define PAGE1_A_TOP_598_ADDRESS 0x8360
#define PAGE1_A_TOP_599_ADDRESS 0x8370
#define PAGE1_A_TOP_600_ADDRESS 0x8380
#define PAGE1_A_TOP_601_ADDRESS 0x8390
#define PAGE1_A_TOP_602_ADDRESS 0x83A0
#define PAGE1_A_TOP_603_ADDRESS 0x83B0
#define PAGE1_A_TOP_604_ADDRESS 0x83C0
#define PAGE1_A_TOP_605_ADDRESS 0x83D0
#define PAGE1_A_TOP_606_ADDRESS 0x83E0
#define PAGE1_A_TOP_607_ADDRESS 0x83F0
#define PAGE1_A_TOP_608_ADDRESS 0x8400
#define PAGE1_A_TOP_609_ADDRESS 0x8410
#define PAGE1_A_TOP_610_ADDRESS 0x8420
#define PAGE1_A_TOP_611_ADDRESS 0x8430
#define PAGE1_A_TOP_612_ADDRESS 0x8440
#define PAGE1_A_TOP_613_ADDRESS 0x8450
#define PAGE1_A_TOP_614_ADDRESS 0x8460
#define PAGE1_A_TOP_615_ADDRESS 0x8470
#define PAGE1_A_TOP_616_ADDRESS 0x8480
#define PAGE1_A_TOP_617_ADDRESS 0x8490
#define PAGE1_A_TOP_618_ADDRESS 0x84A0
#define PAGE1_A_TOP_619_ADDRESS 0x84B0
#define PAGE1_A_TOP_620_ADDRESS 0x84C0
#define PAGE1_A_TOP_621_ADDRESS 0x84D0
#define PAGE1_A_TOP_622_ADDRESS 0x84E0
#define PAGE1_A_TOP_623_ADDRESS 0x84F0

#define PAGE1_A_BOTTOM_ADDRESS 0x8500
#define PAGE1_A_BOTTOM_SIZE 3328
#define PAGE1_A_BOTTOM_FORMAT "tile"
#define PAGE1_A_BOTTOM_WIDTH_IN_BYTES 2
#define PAGE1_A_BOTTOM_WIDTH 4
#define PAGE1_A_BOTTOM_HEIGHT 8
#define PAGE1_A_BOTTOM_WIDTH_IN_TILES 52
#define PAGE1_A_BOTTOM_HEIGHT_IN_TILES 4
#define PAGE1_A_BOTTOM_COUNT 208
#define PAGE1_A_BOTTOM_0_ADDRESS 0x8500
#define PAGE1_A_BOTTOM_1_ADDRESS 0x8510
#define PAGE1_A_BOTTOM_2_ADDRESS 0x8520
#define PAGE1_A_BOTTOM_3_ADDRESS 0x8530
#define PAGE1_A_BOTTOM_4_ADDRESS 0x8540
#define PAGE1_A_BOTTOM_5_ADDRESS 0x8550
#define PAGE1_A_BOTTOM_6_ADDRESS 0x8560
#define PAGE1_A_BOTTOM_7_ADDRESS 0x8570
#define PAGE1_A_BOTTOM_8_ADDRESS 0x8580
#define PAGE1_A_BOTTOM_9_ADDRESS 0x8590
#define PAGE1_A_BOTTOM_10_ADDRESS 0x85A0
#define PAGE1_A_BOTTOM_11_ADDRESS 0x85B0
#define PAGE1_A_BOTTOM_12_ADDRESS 0x85C0
#define PAGE1_A_BOTTOM_13_ADDRESS 0x85D0
#define PAGE1_A_BOTTOM_14_ADDRESS 0x85E0
#define PAGE1_A_BOTTOM_15_ADDRESS 0x85F0
#define PAGE1_A_BOTTOM_16_ADDRESS 0x8600
#define PAGE1_A_BOTTOM_17_ADDRESS 0x8610
#define PAGE1_A_BOTTOM_18_ADDRESS 0x8620
#define PAGE1_A_BOTTOM_19_ADDRESS 0x8630
#define PAGE1_A_BOTTOM_20_ADDRESS 0x8640
#define PAGE1_A_BOTTOM_21_ADDRESS 0x8650
#define PAGE1_A_BOTTOM_22_ADDRESS 0x8660
#define PAGE1_A_BOTTOM_23_ADDRESS 0x8670
#define PAGE1_A_BOTTOM_24_ADDRESS 0x8680
#define PAGE1_A_BOTTOM_25_ADDRESS 0x8690
#define PAGE1_A_BOTTOM_26_ADDRESS 0x86A0
#define PAGE1_A_BOTTOM_27_ADDRESS 0x86B0
#define PAGE1_A_BOTTOM_28_ADDRESS 0x86C0
#define PAGE1_A_BOTTOM_29_ADDRESS 0x86D0
#define PAGE1_A_BOTTOM_30_ADDRESS 0x86E0
#define PAGE1_A_BOTTOM_31_ADDRESS 0x86F0
#define PAGE1_A_BOTTOM_32_ADDRESS 0x8700
#define PAGE1_A_BOTTOM_33_ADDRESS 0x8710
#define PAGE1_A_BOTTOM_34_ADDRESS 0x8720
#define PAGE1_A_BOTTOM_35_ADDRESS 0x8730
#define PAGE1_A_BOTTOM_36_ADDRESS 0x8740
#define PAGE1_A_BOTTOM_37_ADDRESS 0x8750
#define PAGE1_A_BOTTOM_38_ADDRESS 0x8760
#define PAGE1_A_BOTTOM_39_ADDRESS 0x8770
#define PAGE1_A_BOTTOM_40_ADDRESS 0x8780
#define PAGE1_A_BOTTOM_41_ADDRESS 0x8790
#define PAGE1_A_BOTTOM_42_ADDRESS 0x87A0
#define PAGE1_A_BOTTOM_43_ADDRESS 0x87B0
#define PAGE1_A_BOTTOM_44_ADDRESS 0x87C0
#define PAGE1_A_BOTTOM_45_ADDRESS 0x87D0
#define PAGE1_A_BOTTOM_46_ADDRESS 0x87E0
#define PAGE1_A_BOTTOM_47_ADDRESS 0x87F0
#define PAGE1_A_BOTTOM_48_ADDRESS 0x8800
#define PAGE1_A_BOTTOM_49_ADDRESS 0x8810
#define PAGE1_A_BOTTOM_50_ADDRESS 0x8820
#define PAGE1_A_BOTTOM_51_ADDRESS 0x8830
#define PAGE1_A_BOTTOM_52_ADDRESS 0x8840
#define PAGE1_A_BOTTOM_53_ADDRESS 0x8850
#define PAGE1_A_BOTTOM_54_ADDRESS 0x8860
#define PAGE1_A_BOTTOM_55_ADDRESS 0x8870
#define PAGE1_A_BOTTOM_56_ADDRESS 0x8880
#define PAGE1_A_BOTTOM_57_ADDRESS 0x8890
#define PAGE1_A_BOTTOM_58_ADDRESS 0x88A0
#define PAGE1_A_BOTTOM_59_ADDRESS 0x88B0
#define PAGE1_A_BOTTOM_60_ADDRESS 0x88C0
#define PAGE1_A_BOTTOM_61_ADDRESS 0x88D0
#define PAGE1_A_BOTTOM_62_ADDRESS 0x88E0
#define PAGE1_A_BOTTOM_63_ADDRESS 0x88F0
#define PAGE1_A_BOTTOM_64_ADDRESS 0x8900
#define PAGE1_A_BOTTOM_65_ADDRESS 0x8910
#define PAGE1_A_BOTTOM_66_ADDRESS 0x8920
#define PAGE1_A_BOTTOM_67_ADDRESS 0x8930
#define PAGE1_A_BOTTOM_68_ADDRESS 0x8940
#define PAGE1_A_BOTTOM_69_ADDRESS 0x8950
#define PAGE1_A_BOTTOM_70_ADDRESS 0x8960
#define PAGE1_A_BOTTOM_71_ADDRESS 0x8970
#define PAGE1_A_BOTTOM_72_ADDRESS 0x8980
#define PAGE1_A_BOTTOM_73_ADDRESS 0x8990
#define PAGE1_A_BOTTOM_74_ADDRESS 0x89A0
#define PAGE1_A_BOTTOM_75_ADDRESS 0x89B0
#define PAGE1_A_BOTTOM_76_ADDRESS 0x89C0
#define PAGE1_A_BOTTOM_77_ADDRESS 0x89D0
#define PAGE1_A_BOTTOM_78_ADDRESS 0x89E0
#define PAGE1_A_BOTTOM_79_ADDRESS 0x89F0
#define PAGE1_A_BOTTOM_80_ADDRESS 0x8A00
#define PAGE1_A_BOTTOM_81_ADDRESS 0x8A10
#define PAGE1_A_BOTTOM_82_ADDRESS 0x8A20
#define PAGE1_A_BOTTOM_83_ADDRESS 0x8A30
#define PAGE1_A_BOTTOM_84_ADDRESS 0x8A40
#define PAGE1_A_BOTTOM_85_ADDRESS 0x8A50
#define PAGE1_A_BOTTOM_86_ADDRESS 0x8A60
#define PAGE1_A_BOTTOM_87_ADDRESS 0x8A70
#define PAGE1_A_BOTTOM_88_ADDRESS 0x8A80
#define PAGE1_A_BOTTOM_89_ADDRESS 0x8A90
#define PAGE1_A_BOTTOM_90_ADDRESS 0x8AA0
#define PAGE1_A_BOTTOM_91_ADDRESS 0x8AB0
#define PAGE1_A_BOTTOM_92_ADDRESS 0x8AC0
#define PAGE1_A_BOTTOM_93_ADDRESS 0x8AD0
#define PAGE1_A_BOTTOM_94_ADDRESS 0x8AE0
#define PAGE1_A_BOTTOM_95_ADDRESS 0x8AF0
#define PAGE1_A_BOTTOM_96_ADDRESS 0x8B00
#define PAGE1_A_BOTTOM_97_ADDRESS 0x8B10
#define PAGE1_A_BOTTOM_98_ADDRESS 0x8B20
#define PAGE1_A_BOTTOM_99_ADDRESS 0x8B30
#define PAGE1_A_BOTTOM_100_ADDRESS 0x8B40
#define PAGE1_A_BOTTOM_101_ADDRESS 0x8B50
#define PAGE1_A_BOTTOM_102_ADDRESS 0x8B60
#define PAGE1_A_BOTTOM_103_ADDRESS 0x8B70
#define PAGE1_A_BOTTOM_104_ADDRESS 0x8B80
#define PAGE1_A_BOTTOM_105_ADDRESS 0x8B90
#define PAGE1_A_BOTTOM_106_ADDRESS 0x8BA0
#define PAGE1_A_BOTTOM_107_ADDRESS 0x8BB0
#define PAGE1_A_BOTTOM_108_ADDRESS 0x8BC0
#define PAGE1_A_BOTTOM_109_ADDRESS 0x8BD0
#define PAGE1_A_BOTTOM_110_ADDRESS 0x8BE0
#define PAGE1_A_BOTTOM_111_ADDRESS 0x8BF0
#define PAGE1_A_BOTTOM_112_ADDRESS 0x8C00
#define PAGE1_A_BOTTOM_113_ADDRESS 0x8C10
#define PAGE1_A_BOTTOM_114_ADDRESS 0x8C20
#define PAGE1_A_BOTTOM_115_ADDRESS 0x8C30
#define PAGE1_A_BOTTOM_116_ADDRESS 0x8C40
#define PAGE1_A_BOTTOM_117_ADDRESS 0x8C50
#define PAGE1_A_BOTTOM_118_ADDRESS 0x8C60
#define PAGE1_A_BOTTOM_119_ADDRESS 0x8C70
#define PAGE1_A_BOTTOM_120_ADDRESS 0x8C80
#define PAGE1_A_BOTTOM_121_ADDRESS 0x8C90
#define PAGE1_A_BOTTOM_122_ADDRESS 0x8CA0
#define PAGE1_A_BOTTOM_123_ADDRESS 0x8CB0
#define PAGE1_A_BOTTOM_124_ADDRESS 0x8CC0
#define PAGE1_A_BOTTOM_125_ADDRESS 0x8CD0
#define PAGE1_A_BOTTOM_126_ADDRESS 0x8CE0
#define PAGE1_A_BOTTOM_127_ADDRESS 0x8CF0
#define PAGE1_A_BOTTOM_128_ADDRESS 0x8D00
#define PAGE1_A_BOTTOM_129_ADDRESS 0x8D10
#define PAGE1_A_BOTTOM_130_ADDRESS 0x8D20
#define PAGE1_A_BOTTOM_131_ADDRESS 0x8D30
#define PAGE1_A_BOTTOM_132_ADDRESS 0x8D40
#define PAGE1_A_BOTTOM_133_ADDRESS 0x8D50
#define PAGE1_A_BOTTOM_134_ADDRESS 0x8D60
#define PAGE1_A_BOTTOM_135_ADDRESS 0x8D70
#define PAGE1_A_BOTTOM_136_ADDRESS 0x8D80
#define PAGE1_A_BOTTOM_137_ADDRESS 0x8D90
#define PAGE1_A_BOTTOM_138_ADDRESS 0x8DA0
#define PAGE1_A_BOTTOM_139_ADDRESS 0x8DB0
#define PAGE1_A_BOTTOM_140_ADDRESS 0x8DC0
#define PAGE1_A_BOTTOM_141_ADDRESS 0x8DD0
#define PAGE1_A_BOTTOM_142_ADDRESS 0x8DE0
#define PAGE1_A_BOTTOM_143_ADDRESS 0x8DF0
#define PAGE1_A_BOTTOM_144_ADDRESS 0x8E00
#define PAGE1_A_BOTTOM_145_ADDRESS 0x8E10
#define PAGE1_A_BOTTOM_146_ADDRESS 0x8E20
#define PAGE1_A_BOTTOM_147_ADDRESS 0x8E30
#define PAGE1_A_BOTTOM_148_ADDRESS 0x8E40
#define PAGE1_A_BOTTOM_149_ADDRESS 0x8E50
#define PAGE1_A_BOTTOM_150_ADDRESS 0x8E60
#define PAGE1_A_BOTTOM_151_ADDRESS 0x8E70
#define PAGE1_A_BOTTOM_152_ADDRESS 0x8E80
#define PAGE1_A_BOTTOM_153_ADDRESS 0x8E90
#define PAGE1_A_BOTTOM_154_ADDRESS 0x8EA0
#define PAGE1_A_BOTTOM_155_ADDRESS 0x8EB0
#define PAGE1_A_BOTTOM_156_ADDRESS 0x8EC0
#define PAGE1_A_BOTTOM_157_ADDRESS 0x8ED0
#define PAGE1_A_BOTTOM_158_ADDRESS 0x8EE0
#define PAGE1_A_BOTTOM_159_ADDRESS 0x8EF0
#define PAGE1_A_BOTTOM_160_ADDRESS 0x8F00
#define PAGE1_A_BOTTOM_161_ADDRESS 0x8F10
#define PAGE1_A_BOTTOM_162_ADDRESS 0x8F20
#define PAGE1_A_BOTTOM_163_ADDRESS 0x8F30
#define PAGE1_A_BOTTOM_164_ADDRESS 0x8F40
#define PAGE1_A_BOTTOM_165_ADDRESS 0x8F50
#define PAGE1_A_BOTTOM_166_ADDRESS 0x8F60
#define PAGE1_A_BOTTOM_167_ADDRESS 0x8F70
#define PAGE1_A_BOTTOM_168_ADDRESS 0x8F80
#define PAGE1_A_BOTTOM_169_ADDRESS 0x8F90
#define PAGE1_A_BOTTOM_170_ADDRESS 0x8FA0
#define PAGE1_A_BOTTOM_171_ADDRESS 0x8FB0
#define PAGE1_A_BOTTOM_172_ADDRESS 0x8FC0
#define PAGE1_A_BOTTOM_173_ADDRESS 0x8FD0
#define PAGE1_A_BOTTOM_174_ADDRESS 0x8FE0
#define PAGE1_A_BOTTOM_175_ADDRESS 0x8FF0
#define PAGE1_A_BOTTOM_176_ADDRESS 0x9000
#define PAGE1_A_BOTTOM_177_ADDRESS 0x9010
#define PAGE1_A_BOTTOM_178_ADDRESS 0x9020
#define PAGE1_A_BOTTOM_179_ADDRESS 0x9030
#define PAGE1_A_BOTTOM_180_ADDRESS 0x9040
#define PAGE1_A_BOTTOM_181_ADDRESS 0x9050
#define PAGE1_A_BOTTOM_182_ADDRESS 0x9060
#define PAGE1_A_BOTTOM_183_ADDRESS 0x9070
#define PAGE1_A_BOTTOM_184_ADDRESS 0x9080
#define PAGE1_A_BOTTOM_185_ADDRESS 0x9090
#define PAGE1_A_BOTTOM_186_ADDRESS 0x90A0
#define PAGE1_A_BOTTOM_187_ADDRESS 0x90B0
#define PAGE1_A_BOTTOM_188_ADDRESS 0x90C0
#define PAGE1_A_BOTTOM_189_ADDRESS 0x90D0
#define PAGE1_A_BOTTOM_190_ADDRESS 0x90E0
#define PAGE1_A_BOTTOM_191_ADDRESS 0x90F0
#define PAGE1_A_BOTTOM_192_ADDRESS 0x9100
#define PAGE1_A_BOTTOM_193_ADDRESS 0x9110
#define PAGE1_A_BOTTOM_194_ADDRESS 0x9120
#define PAGE1_A_BOTTOM_195_ADDRESS 0x9130
#define PAGE1_A_BOTTOM_196_ADDRESS 0x9140
#define PAGE1_A_BOTTOM_197_ADDRESS 0x9150
#define PAGE1_A_BOTTOM_198_ADDRESS 0x9160
#define PAGE1_A_BOTTOM_199_ADDRESS 0x9170
#define PAGE1_A_BOTTOM_200_ADDRESS 0x9180
#define PAGE1_A_BOTTOM_201_ADDRESS 0x9190
#define PAGE1_A_BOTTOM_202_ADDRESS 0x91A0
#define PAGE1_A_BOTTOM_203_ADDRESS 0x91B0
#define PAGE1_A_BOTTOM_204_ADDRESS 0x91C0
#define PAGE1_A_BOTTOM_205_ADDRESS 0x91D0
#define PAGE1_A_BOTTOM_206_ADDRESS 0x91E0
#define PAGE1_A_BOTTOM_207_ADDRESS 0x91F0

#define NARRATION_TEXT_01_ADDRESS 0x9200
#define NARRATION_TEXT_01_SIZE 122
#define NARRATION_TEXT_01_FORMAT "raw"
#define NARRATION_TEXT_01_WIDTH_IN_BYTES 20
#define NARRATION_TEXT_01_WIDTH 40
#define NARRATION_TEXT_01_HEIGHT 6
#define NARRATION_TEXT_01_COUNT 1
#define NARRATION_TEXT_01_0_ADDRESS 0x9200

#define NARRATION_TEXT_02_ADDRESS 0x927A
#define NARRATION_TEXT_02_SIZE 152
#define NARRATION_TEXT_02_FORMAT "raw"
#define NARRATION_TEXT_02_WIDTH_IN_BYTES 25
#define NARRATION_TEXT_02_WIDTH 50
#define NARRATION_TEXT_02_HEIGHT 6
#define NARRATION_TEXT_02_COUNT 1
#define NARRATION_TEXT_02_0_ADDRESS 0x927A

#define PAGE1_A_TEXT_01_ADDRESS 0x9312
#define PAGE1_A_TEXT_01_SIZE 104
#define PAGE1_A_TEXT_01_FORMAT "raw"
#define PAGE1_A_TEXT_01_WIDTH_IN_BYTES 17
#define PAGE1_A_TEXT_01_WIDTH 34
#define PAGE1_A_TEXT_01_HEIGHT 6
#define PAGE1_A_TEXT_01_COUNT 1
#define PAGE1_A_TEXT_01_0_ADDRESS 0x9312

#define PAGE1_A_TEXT_02_ADDRESS 0x937A
#define PAGE1_A_TEXT_02_SIZE 200
#define PAGE1_A_TEXT_02_FORMAT "raw"
#define PAGE1_A_TEXT_02_WIDTH_IN_BYTES 33
#define PAGE1_A_TEXT_02_WIDTH 66
#define PAGE1_A_TEXT_02_HEIGHT 6
#define PAGE1_A_TEXT_02_COUNT 1
#define PAGE1_A_TEXT_02_0_ADDRESS 0x937A

#define PAGE1_A_TEXT_03_ADDRESS 0x9442
#define PAGE1_A_TEXT_03_SIZE 164
#define PAGE1_A_TEXT_03_FORMAT "raw"
#define PAGE1_A_TEXT_03_WIDTH_IN_BYTES 27
#define PAGE1_A_TEXT_03_WIDTH 54
#define PAGE1_A_TEXT_03_HEIGHT 6
#define PAGE1_A_TEXT_03_COUNT 1
#define PAGE1_A_TEXT_03_0_ADDRESS 0x9442

#define PAGE1_A_TEXT_04_ADDRESS 0x94E6
#define PAGE1_A_TEXT_04_SIZE 116
#define PAGE1_A_TEXT_04_FORMAT "raw"
#define PAGE1_A_TEXT_04_WIDTH_IN_BYTES 19
#define PAGE1_A_TEXT_04_WIDTH 38
#define PAGE1_A_TEXT_04_HEIGHT 6
#define PAGE1_A_TEXT_04_COUNT 1
#define PAGE1_A_TEXT_04_0_ADDRESS 0x94E6

#define PAGE1_A_TEXT_05_ADDRESS 0x955A
#define PAGE1_A_TEXT_05_SIZE 146
#define PAGE1_A_TEXT_05_FORMAT "raw"
#define PAGE1_A_TEXT_05_WIDTH_IN_BYTES 24
#define PAGE1_A_TEXT_05_WIDTH 48
#define PAGE1_A_TEXT_05_HEIGHT 6
#define PAGE1_A_TEXT_05_COUNT 1
#define PAGE1_A_TEXT_05_0_ADDRESS 0x955A

#define PAGE1_A_TEXT_06_ADDRESS 0x95EC
#define PAGE1_A_TEXT_06_SIZE 56
#define PAGE1_A_TEXT_06_FORMAT "raw"
#define PAGE1_A_TEXT_06_WIDTH_IN_BYTES 9
#define PAGE1_A_TEXT_06_WIDTH 18
#define PAGE1_A_TEXT_06_HEIGHT 6
#define PAGE1_A_TEXT_06_COUNT 1
#define PAGE1_A_TEXT_06_0_ADDRESS 0x95EC

#define PAGE1_A_TEXT_07_ADDRESS 0x9624
#define PAGE1_A_TEXT_07_SIZE 56
#define PAGE1_A_TEXT_07_FORMAT "raw"
#define PAGE1_A_TEXT_07_WIDTH_IN_BYTES 9
#define PAGE1_A_TEXT_07_WIDTH 18
#define PAGE1_A_TEXT_07_HEIGHT 6
#define PAGE1_A_TEXT_07_COUNT 1
#define PAGE1_A_TEXT_07_0_ADDRESS 0x9624

#define PAGE1_A_TEXT_08_ADDRESS 0x965C
#define PAGE1_A_TEXT_08_SIZE 122
#define PAGE1_A_TEXT_08_FORMAT "raw"
#define PAGE1_A_TEXT_08_WIDTH_IN_BYTES 24
#define PAGE1_A_TEXT_08_WIDTH 48
#define PAGE1_A_TEXT_08_HEIGHT 5
#define PAGE1_A_TEXT_08_COUNT 1
#define PAGE1_A_TEXT_08_0_ADDRESS 0x965C

#define PAGE1_A_TEXT_09_ADDRESS 0x96D6
#define PAGE1_A_TEXT_09_SIZE 158
#define PAGE1_A_TEXT_09_FORMAT "raw"
#define PAGE1_A_TEXT_09_WIDTH_IN_BYTES 26
#define PAGE1_A_TEXT_09_WIDTH 52
#define PAGE1_A_TEXT_09_HEIGHT 6
#define PAGE1_A_TEXT_09_COUNT 1
#define PAGE1_A_TEXT_09_0_ADDRESS 0x96D6

#define PAGE1_A_TEXT_10_ADDRESS 0x9774
#define PAGE1_A_TEXT_10_SIZE 230
#define PAGE1_A_TEXT_10_FORMAT "raw"
#define PAGE1_A_TEXT_10_WIDTH_IN_BYTES 38
#define PAGE1_A_TEXT_10_WIDTH 76
#define PAGE1_A_TEXT_10_HEIGHT 6
#define PAGE1_A_TEXT_10_COUNT 1
#define PAGE1_A_TEXT_10_0_ADDRESS 0x9774

#define PAGE1_A_TEXT_11_ADDRESS 0x985A
#define PAGE1_A_TEXT_11_SIZE 170
#define PAGE1_A_TEXT_11_FORMAT "raw"
#define PAGE1_A_TEXT_11_WIDTH_IN_BYTES 28
#define PAGE1_A_TEXT_11_WIDTH 56
#define PAGE1_A_TEXT_11_HEIGHT 6
#define PAGE1_A_TEXT_11_COUNT 1
#define PAGE1_A_TEXT_11_0_ADDRESS 0x985A

#define PAGE1_A_TEXT_12_ADDRESS 0x9904
#define PAGE1_A_TEXT_12_SIZE 140
#define PAGE1_A_TEXT_12_FORMAT "raw"
#define PAGE1_A_TEXT_12_WIDTH_IN_BYTES 23
#define PAGE1_A_TEXT_12_WIDTH 46
#define PAGE1_A_TEXT_12_HEIGHT 6
#define PAGE1_A_TEXT_12_COUNT 1
#define PAGE1_A_TEXT_12_0_ADDRESS 0x9904

#define PAGE1_A_TEXT_13_ADDRESS 0x9990
#define PAGE1_A_TEXT_13_SIZE 224
#define PAGE1_A_TEXT_13_FORMAT "raw"
#define PAGE1_A_TEXT_13_WIDTH_IN_BYTES 37
#define PAGE1_A_TEXT_13_WIDTH 74
#define PAGE1_A_TEXT_13_HEIGHT 6
#define PAGE1_A_TEXT_13_COUNT 1
#define PAGE1_A_TEXT_13_0_ADDRESS 0x9990

#define MUSIC_SECTION_A_ADDRESS 0x9A70
#define MUSIC_SECTION_A_SIZE 2924


extern const u8 comic_a_assets[6021];






#endif // _COMIC_ASSETS_H_
